﻿using System;
using System.Threading.Tasks;
using System.Web.Http;
using WebAppSearch.Infrastructure;
using WebAppSearch.Models;

namespace WebAppSearch.Controllers
{
    [RoutePrefix("api")]
    public class EsTestApiController : BaseApiController
    {
        [Route("estest")]
        [HttpGet]
        public object Search()
        {
            //1 搜索数据
            string key = GetStringRequest("Key");
            int? from = GetIntRequest("from");
            int? size = GetIntRequest("size");

            return ElasticSearchHelper.Intance.Search<person>("db_test", "person", key ?? "方鸿渐", from ?? 0, size ?? 20);
        }

        [Route("estest/SearchFullFileds")]
        [HttpGet]
        public object SearchFullFileds()
        {
            //1 搜索数据
            string key = GetStringRequest("Key");
            int? from = GetIntRequest("from");
            int? size = GetIntRequest("size");
            return ElasticSearchHelper.Intance.SearchFullFileds<person>("db_test", "person", key ?? "方鸿渐", from ?? 0, size ?? 20);
        }

        [Route("estest/SearchFullFiledss")]
        [HttpGet]
        public object SearchFullFiledss()
        {
            //1 搜索数据
            string key = GetStringRequest("Key");
            int? from = GetIntRequest("from");
            int? size = GetIntRequest("size");
            return ElasticSearchHelper.Intance.SearchFullFiledss<person>("db_test", "person", key ?? "方鸿渐", from ?? 0, size ?? 20);
        }

        /// <summary>
        /// 索引数据
        /// </summary>
        /// <returns></returns>
        [Route("estest/init")]
        [HttpGet]
        public object index()
        {
            Random rd = new Random();

            ParallelOptions po = new ParallelOptions
            {
                MaxDegreeOfParallelism = 4
            };
            Parallel.For(0, 20, po, c =>
            {
                var start = rd.Next(0, S.Test.Length - 700);
                var startName = rd.Next(0, S.Test.Length - 30);
                person p = new person() { age = DateTime.Now.Millisecond, birthday = DateTime.Now, id = Guid.NewGuid().ToString(), intro = S.Test.Substring(start, 629) + c, name = S.Test.Substring(startName, 29) + c, sex = true };
                ElasticSearchHelper.Intance.Index("db_test", "person", Guid.NewGuid().ToString(), p);
            });
            return 1;
        }
    }

    public class S
    {
        public static string Test = @"　　　　　　　　　　　　　　钱钟书《围城》
　　序在这本书里，我想写现代中国某一部分社会、某一类人物。写这类人，我没忘记他们是人类，只是人类，具有无毛两足动物的基本根性。角色当然是虚构的，但是有考据癖的人也当然不肯错过索隐的杨会、放弃附会的权利的。
　　这本书整整写了两年。两年里忧世伤生，屡想中止。由于杨绛女士不断的督促，替我挡了许多事，省出时间来，得以锱铢积累地写完。照例这本书该献给她。不过，近来觉得献书也像“致身于国”、“还政于民”等等佳话，只是语言幻成的空花泡影，名说交付出去，其实只仿佛魔术家玩的飞刀，放手而并没有脱手。随你怎样把作品奉献给人，作品总是作者自已的。大不了一本书，还不值得这样精巧地不老实，因此罢了。
　　三十五年【一九四九年】十二月十五日
　　重印前记《围城》一九四七年在上海初版，一九四八年再版，一九四九年三版，以后国内没有重印过。偶然碰见它的新版，那都是香港的“盗印”本。没有看到台湾的“盗印”，据说在那里它是禁书。美国哥伦比亚大学夏志清教授的英文著作里对它作了过高的评价，导致了一些西方语言的译本。日本京都大学荒井健教授很久以前就通知我他要翻译，近年来也陆续在刊物上发表了译文。现在，人民文学出版社建议重新排印，以便原著在国内较易找着，我感到意外和忻辛。
　　我写完《围城》，就对它不很满意。出版了我现在更不满意的一本文学批评以后，我抽空又长篇小说，命名《百合心》，也脱胎于法文成语（Iecoeurd“artichaut），中心人物是一个女角。大约已写成了两万字。一九四九年夏天，全家从上海迁居北京，手忙脚乱中，我把一叠看来像乱纸的草稿扔到不知哪里去了。兴致大扫，一直没有再鼓起来，倒也从此省心省事。年复一年，创作的冲动随年衰减，创作的能力逐渐消失——也许两者根本上是一回事，我们常把自己的写作冲动误认为自己的写作才能，自以为要写就意味着会写。相传幸运女神偏向着年轻小伙子，料想文艺女神也不会喜欢老头儿的；不用说有些例外，而有例外正因为有公例。我慢慢地从省心进而收心，不作再写小说的打算。事隔三十余年，我也记不清楚当时腹稿里的人物和情节。就是追忆清楚了，也还算不得数，因为开得出菜单并不等于摆得成酒席，要不然，谁都可以马上称为善做菜的名厨师又兼大请客的阔东道主了，秉承曹雪芹遗志而拟定”后四十回“提纲的学者们也就可以凑得成和的得上一个或半个高鹗了。剩下来的只是一个顽固的信念：假如《百合心》写得成，它会比《围城》好一点。事情没有做成的人老有这类根据不充分的信念；我们对采摘不到的葡萄，不但想像它酸，也很可能想像它是分外地甜。
　　这部书禄版时的校读很草率，留下不少字句和标点的脱误，就无意中为翻译者安置了拦路石和陷阱。我乘重印的机会，校看一遍，也顺手有节制地修必了一些字句。《序》里删去一节，这一节原是郑西谛先生要我添进去的。在去年美国出版的珍妮·凯利（JeanneKelly）女士和茅国权（NathanK.Mao）先生的英译本里，那一节已省去了。
　　一九八0年二月这本书第二次印刷，我又改正了几个错字。两次印刷中，江秉祥同志给了技术上和艺术上的帮助，特此志谢。
　　一九八一年二月我乘第三次印刷的机会，修订了一些文字。有两处多年朦混过去的讹误，是这本书的德译者莫妮克（MonikaMotsch）博士发觉的。
　　一九八二年十二月为了塞尔望——许来伯（SylvieServan-Schreiber）女士的法语译本，我去年在原书里又校正了几外错漏，也修改了几处词句。恰好这本书又要第次印刷，那些改正就可以安插了。苏联索洛金（V.Sorokin）先生去年提醒我，他的俄译本比原著第一次重印本早问世五个月，我也借此带便提一下。
　　一九八四年十一月
　　第一章红海早过了，船在印度洋面上开驶着，但是太阳依然不饶人地迟落早起，侵占去大部分的夜。夜仿佛纸浸了油变成半透明体；它给太阳拥抱住了，分不出身来，也许是给太阳陶醉了，所以夕照晚霞褪后的夜色也带着酡红。到红消醉醒，船舱里的睡人也一身腻汗地醒来，洗了澡赶到甲板上吹海风，又是一天开始。这是七月下旬，合中国旧历的三伏，一年最热的时候。在中国热得更比常年利害，事后大家都说是兵戈之象，因为这就是民国二十六年【一九三七年】。
　　这条法国邮船白拉日隆子爵号（VicomtedeBragelonne）正向中国开来。早晨八点多钟，冲洗过的三等舱甲板湿意未干，但已坐满了人，法国人、德国流亡出来的犹太人、印度人、安南人，不用说还有中国人。海风里早含着燥热，胖人身体给炎风吹干了，上一层汗结的盐霜，仿佛刚在巴勒斯坦的死海里洗过澡。毕竟是清晨，人的兴致还没给太阳晒萎，烘懒，说话做事都很起劲。那几个新派到安南或中国租界当警察的法国人，正围了那年轻善撒娇的犹太女人在调情。俾斯麦曾说过，法国公使大使的特点，就是一句外国话不会讲；这几位警察并不懂德文，居然传情达意，引得犹太女人格格地笑，比他们的外交官强多了。这女人的漂亮丈夫，在旁顾而乐之，因为他几天来，香烟、啤酒、柠檬水沾光了不少。红海已过，不怕热极引火，所以等一会甲板上零星果皮、纸片、瓶塞之外，香烟头定又遍处皆是。法国人的思想是有名的清楚，他的文章也明白干净，但是他的做事，无不混乱、肮脏、喧哗，但看这船上的乱糟糟。这船，倚仗人的机巧，载满人的扰攘，寄满人的希望，热闹地行着，每分钟把沾污了人气的一小方小面，还给那无情、无尽、无际的大海。
　　照例每年夏天有一批中国留学生学成回国。这船上也有十来个人。大多数是职业尚无着落的青年，直在暑假初回中国，可以从容找事。那些不悉没事的学生要到秋凉才慢慢地肯动身回国。船上这几们，有在法国留学的，有在英国、德国、比国等读书，到巴黎去增长夜生活经险，因此也坐法国船的，他们天涯相遇，一见如故，谈起外患内乱的祖国，都恨不得立刻就回去为它服务。船走得这样慢，大家一片乡心，正愁无处寄托，不知哪里忽来了两副麻将牌。麻将当然是国技，又听说在美国风行；打牌不但有故乡风味，并且适合世界潮流。妙得很人数可凑成两桌而有余，所以除掉吃饭睡觉以外，他们成天赌钱消遣。早餐刚过，下面餐室里已忙打第一圈牌，甲板上只看得见两个中国女人，一个算不得人的小孩子——至少船公司没当他是人，没要他父母为他补买船票。那个戴太阳眼镜、身上摊本小说的女人，衣服极斯文讲究。皮肤在东方人里，要算得白，可惜这白色不顶新鲜，带些干滞。她去掉了黑眼镜，眉清目秀，只是嘴唇嫌薄，擦了口红还不够丰厚。假使她从帆布躺椅上站起来，会见得身段瘦削，也许轮廓的线条太硬，像方头钢笔划成的，年龄看上去有二十五六，不过新派女人的年龄好比旧式女人婚帖上的年庚，需要考订学家所谓外证据来断定真确性，本身是看不出的。那男孩子的母亲已有三十开外，穿件半旧的黑纱旗袍，满面劳碌困倦，加上天生的倒挂眉毛，愈觉愁苦可怜。孩子不足两岁，塌鼻子，眼睛两条斜缝，眉毛高高在上，跟眼睛远隔得彼此要害相思病，活像报上讽刺画里的中国人的脸。他刚会走路，一刻不停地要乱跑；母亲怕热，拉得手累心烦，又惦记着丈夫在下面的输赢，不住骂这孩子讨厌。这孩子跑不到哪里去便改变宗旨，扑向看书的女人身上。那女人平日就有一种孤芳自赏、落落难合的神情——大宴会上没人敷衍的来宾或喜酒席上过时未嫁的少女所常有的神情——此刻更流露出嫌恶，黑眼镜也遮盖不了。孩子的母亲有些觉得，抱歉地拉皮带道：“你这淘气的孩子，去跟苏小姐捣乱！快回来。——苏小姐，你真用功！学问那么好，还成天看书。孙先生常跟我说，女学生像苏小姐才算替中国争面子，人又美，又是博士，这样的人哪里去找呢？像我们白来了外国一次，没读过半句书，一辈子做管家婆子，在国内念的书，生小孩儿全忘了——吓！死讨厌！我叫你别去你不干好事，准弄脏了苏小姐的衣服。”苏小姐一向瞧不起这位寒碜的孙太太，而且最不喜欢小孩子，可是听了这些话，心上高兴，倒和气地笑道：“让他来，我最喜欢小孩子。”她脱下太阳眼镜，合上对着出神的书，小心翼翼地握拄池孩子的手腕，免得在自己衣服上乱擦，问他道：“爸爸呢？”小孩子不回答，睁大了眼，向苏小姐“波！波！”吹唾沫，学餐室里养的金鱼吹气泡。苏小姐慌得忪了手，掏出手帕来自卫。母亲忙使劲拉他，嚷着要打他嘴巴，一面叹气道：“他爸爸在下面赌钱，还用说么！我不懂为什么男人全爱赌，你看咱们同船的几位，没一个不赌得错天黑地。赢几个钱回来，还说得过。像我们孙先生输了不少钱，还要赌，恨死我了！”苏小姐听了最后几句小家子气的话，不由心里又对孙太太鄙夷，冷冷说道：“方先生倒不赌。”孙太太鼻孔朝天，出冷气道：“方先生！他下船的时候也打过牌。现在他忙着追求鲍小姐，当然分不出工夫来。人家终身大事，比赌钱要紧得多呢。我就看不出鲍小姐又黑又粗，有什么美，会引得方先生好好二等客人不做，换到三等舱来受罪。我看他们俩要好得很，也许到香港，就会订婚。这真是”有缘千里来相会“了。”苏小姐听了，心里直刺痛，回答孙太太同时安慰自己道：“那绝不可能！鲍小姐有未婚夫，她自己跟我讲过。她留学的钱还是她未婚夫出的。”孙太太道：“有未婚夫还那样浪漫么？我们是老古董了，总算这次学个新鲜。苏小姐，我告诉你句笑话，方先生跟你在中国是老同学，他是不是一向说话随便的？昨天孙先生跟他讲赌钱手运不好，他还笑呢。他说孙先生在法国这许多年，全不知道法国人的迷信：太太不忠实，偷人，丈夫做了乌龟，买彩票准　中头奖，赌钱准赢，所以，他说，男人赌钱输了，该引以自慰。孙先生告诉我，我怪他当时没质问姓方的，这话什么意思。现在看来，鲍小姐那位未婚夫一定会中航空奖券头奖，假如他做了方太太，方先生赌钱的手气非好不可。”忠厚老实人的恶毒，像饭里的砂砾或者出鱼片里示净的刺，会给人一种不期待的伤痛。
　　苏小姐道：“鲍小姐行为太不像妇学生，打扮也够丢人——”那小孩子忽然向她们背后伸了双手，大笑大跳。两人回头看，正是鲍小姐走向这儿来，手里拿一块糖，远远地逗着那孩子。她只穿绯霞色抹胸，海蓝色巾肉短裤，漏空白皮鞋里露出涂红的指甲。在热带热天，也话这是最合理的妆束，船上有一两个外国女人就这样打扮。可是苏小姐沉得鲍小姐赤身露体，伤害及中国国体。那些男学生看得心头起火。口角流水，背着鲍小姐说笑个不了。有人叫她“熟食铺子”（charcuterie），因为只有熟食店会把那许多颜色暖热的肉公开陈列；又有人叫她“真理”，因为据说“真理”是赤裸裸的“。鲍小姐并未一丝不挂，所以他们修正为”局部的真理“。
　　鲍小姐走来了，招呼她们俩说：“你们起得真早呀，我大热天还喜欢懒在床上。令天苏小姐起身我都不知道，睡得像木头。”鲍小姐本想说“睡重像猪”，一转念想说“像死人”，终觉得死人比猪好不了多少，所以向英文里借来那个比喻。好忙解释一句道：“这船走着真像个摇篮，人给它摆得迷迷糊糊只想睡。”“那么，你就是摇篮里睡着的小宝贝了。瞧，多可爱！”苏小姐说。
　　鲍小姐打她一下道：“你！苏东坡的妹妹，才女！”——“苏小妹”是同船男学生为苏小姐起的个号。“东坡”两个字给鲍小姐南洋口音念得好像法国话里的“坟墓”（tombeau）。
　　苏小姐跟鲍小姐同舱，睡的是下铺，比鲍小姐方便得多，不必每天爬上爬下。可是这几天她嫌恶着鲍小姐，觉得她什么都妨害了自己：打鼾太响，闹得自己睡不熟，翻身太重，上铺像要塌上来。给鲍小组打了一下，她便说：“孙太太，你评评理。叫她”小宝贝“，还要挨打！睡得着就是福气。我知道你爱睡，所以从来不不响，免重吵醒你。你跟我廛怕发胖，可是你在般上这样爱睡，我想你又该添好几磅了。”小孩吵着要糖，到手便咬，他母亲叫他谢鲍小姐，他不瞅睬，孙太太只好自己跟鲍小姐甫衍。苏小姐早看见这粮惠而不费，就是船上早餐喝咖啡用的方糖。她鄙薄鲍小姐这种作风，不愿意跟她多讲，又打开书来，眼梢却瞟　见鲍小姐把两张帆布椅子拉到距离较远的空处并放着，心里骂她列耻，同时自恨为什么去看她。那时候方鸿渐也到甲板上来，在她们前面走过，停步应酬几句，问“小弟弟好”。孙太太爱理不理地应一声。苏小姐笑道：“快去罢，不怕人等得心焦么？”方鸿渐红了脸傻傻便撇了苏小姐走去。苏小姐明知留不住他，可是他真去了，倒怅然有失。书上一字没看进去耳听得鲍小姐娇声说笑，她忍不住一看，方鸿渐正抽着烟，鲍小姐向他抻手，他掏出香烟匣来给她一支，鲍小姐衔在嘴里，他手指在打火匣上作势要为她点烟，她忽然嘴迎上去把衔的烟头凑在他抽的烟头上一吸，那支烟点着了，鲍小姐得间地吐口烟出来。苏小姐气得身上发伶，想这两个人真不要脸，大庭广从竟借烟卷来接吻。再看不过了，站起来，说要下面去。其实她知道下面没有地方可去，餐室里有人打牌，卧舱里太闷。孙太太也想下去问问男人今天输了多少钱，但怕男人输急了，一问反在自己身上出气，回房舱又有半天吵嘴；因此不敢冒昧起身，只问小孩子要不要下去撒尿。
　　苏小姐骂方鸿渐无耻，实在是冤枉。他那时候窘得似乎甲板上人都在注意他，心里怪鲍小姐太做得出，恨不能说她几句。他虽然现在二十七岁，早订过婚，却没有恋爱训练。父亲是前清举人，在本乡江南一个小县里做大绅士。他们那县里人侨居在大都市的，干三种行业的十居其九：打铁，磨豆腐，抬轿子。土产中艺术品以泥娃娃最出名；年轻人时大学，以学土木为最多。铁的硬，豆腐的淡而无味，轿子的容量狭小，还加上泥土气，这算他们的民风。就是发财做官的人，也欠大方，这县有个姓周的在上海开铁铺子财，又跟同业的同乡组织一家小银行，名叫“点金银行”，自己荣任经理，他记起衣锦还乡那句成语，有一年乘清明节回县去祭祠扫墓，结识本地人士。方鸿渐的父亲是一乡之望，周经理少不得上门拜访，因此成了朋友，从朋友攀为亲家。鸿渐还在高中读书，随家里作主订了婚。未婚妻并没见面，只瞻爷过一张半身照相，也漠不关心。两年后到北平进大学，第一次经历男女同学的风味，看人家一对对谈情说爱，好不眼红。想起未婚妻高中读了一年书，便不进学校，在家实习家务，等嫁过来做能干媳妇，不由自主地对她厌恨。这样怨命，怨父亲，发了几天呆，忽然醒悟，壮着胆写信到家里要求解约。他国文曾得老子指授，大中学会考考过第二，所以这信文绉绉，没把之乎者也用错。信上说什么：“迩来触绪善感，欢寡悉殷，怀抱剧有秋气。每揽镜自照，神寒形削，清癯非寿者相。窃恐我躬不阅，周女士或将贻误终身。尚望大人垂体下情，善为解铃，毋小不忍而成终天之恨。”他自以为这信措词凄婉，打得动铁石心肠。谁知道父亲信来痛骂一顿：“吾不惜重资，命汝千里负笈，汝埋头攻读之不暇，而有余闲照镜耶？汝非妇人女子，何须置镜？惟梨园子弟，身为丈夫而对镜顾影，为世所贱。吾不图汝甫离漆下，已渝染恶习，可叹可恨！且父母在，不言老，汝不善体高堂念远之情，以死相吓，丧心不孝，于斯而极！当是汝校男女同学，汝睹色起意，见异思迁；汝拖词悲秋，吾知汝实为怀春，难逃老夫洞鉴也。若执迷不悔，吾将停止寄款，命汝休学回家，明年与汝弟同时结婚。细思吾言，慎之切切！”方鸿渐吓矮了半截，想不到老头子这样精明。忙写回信讨饶和解释，说：镜子是同室学生的，他并没有买：这几天吃美国鱼肝油丸、德国维他命片，身体精神好转，脸也丰满起来，只可惜药价太贵，舍不得钱；至于结婚一节，务请到到毕业后举行，一来妨碍学业，二来他还不能养家，添他父亲负担，于心不安。他父亲收到这信，证明自己的威严远及于几千里外，得意非凡，兴头上汇给儿子一笔钱，让他买补药。方鸿渐从此死心不散妄想，开始读叔本华，常聪明地对同学们说：“世间哪有恋爱？压根儿是生殖冲动。”转眼已到大学第四年，只等明年毕业结婚。一天，父亲来封快信，上面说：“顷得汝岳丈电报，骇悉淑英伤寒，为西医所误，遂于本有十日下午四时长逝，殊堪痛惜。过门在即，好事多磨，皆汝无福所臻也。”信后又添几句道：“塞翁失马，安知非福，使三年前结婚，则此番吾家破费不赀矣。然吾家积德之门，苟婚事早完，淑媳或可脱灾延寿。姻缘前定，勿必过悲。但汝岳父处应去一信唁之。”鸿渐看了有犯人蒙赦的快活，但对那短命的女孩子，也稍微怜悯。自己既享自由之乐，愿意旁人减去悲哀，于是向未过门丈人处真去了一封慰唁的长信。周经理收到信，觉得这孩子知礼，便分付银行文书科王主任作复，文书科主任看见原信，向东家大大恭维这位未过门姑爷文理书法好，并且对死者情词深挚，想见天性极厚，定是个远到之器，周经理听得开心，叫主任回信说：女儿虽没过门翁婿名分不改，生平只有一个女儿，本想好好热闹一下，现在把陪嫁办喜事的那笔款子加上方家聘金为女儿做生意所得利息，一共两万块钱，折合外汇一千三百镑，给方鸿渐明年毕业了做留学费，方鸿渐做梦都没想到这样的好运气，对他死去的未婚妻十分感激，他是个无用之人，学不了土木工程，在大学里从社会学系转哲学系，最后转入中国文学系毕业。学国文的人出洋“深造”听来有些滑稽。事实上，惟有学中国文学的人非到外国留学不可。因为一切其他科目像数学、物理、哲学。心理。经济，法律等等都是从外国港灌输进来的，早已洋气扑鼻；只有国文是国货土产，还需要处国招牌，方可维持地位，正好像中国官吏，商人在本国剥削来的钱要换外汇，才能保持国币的原来价值。
　　方鸿渐到了欧洲，既不钞敦煌卷子，又不访《永乐大典》，也不找太平天国文献，更不学蒙古文、西藏文或梵文。四年中倒换了三个大学，伦敦、巴黎、柏林；随　便听几门功课，兴趣颇广，心得全无，生活尤其懒散。第四年春天，他看银行里只剩四百多镑，就计划夏天回国。方老先生也写信问他是否已得博士学位，何日东归，他回信大发议论，痛骂博士头衔的毫无实际。方老先生大不谓然，可是儿子大了，不敢再把父亲的尊严去威胁他；便信上说，自己深知道头衔无用，决不勉强儿子，但周经理出钱不少，终得对他有个交代。过几天，方鸿渐又收到丈人的信，说什么：“贤婿才高学富，名满五洲，本不须以博士为夸耀。然令尊大人乃前清孝廉公，贤婿似宜举洋进士，庶几克绍箕裘，后来居上，愚亦与有荣焉。”方鸿渐受到两面夹攻，才知道留学文凭的重要。这一张文凭，仿佛有亚当、夏娃下身那片树叶的功用，可以遮羞包丑；小小一方纸能把一个人的空疏、寡陋、愚笨都掩盖起来。自己没有文凭，好像精神上赤条条的，没有包裹。可是现在要弄个学位。无论自己去读或雇枪手代做论文，时间经济都不够。就近汉堡大学的博士学位，算最容易混得了，但也需要六个月，干脆骗家里人说是博士罢，只怕哄父亲和丈人不过；父亲是科举中人，要看“报条”，丈人是商人，要看契据。他想不出办法，准备回家老着脸说没得到学位，一天，他到柏林图书馆中国书编目室去看一位德国朋友，瞧见地板上一大堆民国初年上海出的期刊，《东方杂志》、《小说月报》、《大中华》、《妇女杂志》全有。信手翻着一张中英文对照的广告，是美国纽约什么“克莱登法商专门学校函授班，将来毕业，给予相当于学士、硕士或博士之证书，章程函索即寄，通讯处纽约第几街几号几之几，方鸿渐心里一运，想事隔二十多年，这学校不知是否存在，反正去封信问问，不费多少钱。那登广告的人，原是个骗子，因为中国人不来上当，改行不干了，人也早死了。他住的那间公寓房间现在租给一个爱尔兰人，具有爱尔兰人的不负责、爱尔兰人的急智、还有爱尔兰人的穷。相传爱尔人的不动产（Irish　fortune）是奶和屁股；这位是个萧伯纳式既高且瘦的男人，那两项财产的分量又得打折扣。他当时在信箱里拿到鸿渐来信，以为邮差寄错了，但地址明明是自己的，好奇拆开一看，莫名其妙，想了半天，快活得跳起来，忙向邻室小报记者借个打字机，打了一封回信，说先生既在欧洲大学读书，程度想必高深，无庸再经函授手续，只要寄一万字论文一篇附缴美金五百元，审查及格，立即寄上哲学博士文凭，回信可寄本人，不必写学术名字。署名Patric　Mahoney，后面自赠了四五个博士头衔。方鸿渐看信纸是普通用的，上面并没刻学校名字，信的内容分明更是骗局，搁下不理。爱尔兰人等急了，又来封信，说如果价钱嫌贵，可以从长商议，本人素爱中国，办教育的人尤其不愿牟利。方鸿渐盘算一下，想爱尔兰人无疑在捣鬼，自己买张假文凭回去哄人，岂非也成了骗子？可是——记着，方鸿渐进过哲学系的——撒谎欺骗有时并非不道德。柏拉图《理想国》里就说兵士对敌人，医生对病人，官吏对民众都应哄骗。圣如孔子，还假装生病，哄走了儒悲，孟子甚至对齐宣王也撒谎装病。父亲和丈人希望自己是个博士，做儿子女婿的人好意思教他们失望么？买张文凭去哄他们，好比前清时代花钱捐个官，或英国殖民地商人向帝国府库报效几万镑换个爵士头衔，光耀门楣，也是孝子贤婿应有的承欢养志。反正自己将来找事时，履历上决不开这个学位。索性把价钱杀得极低，假如爱尔兰人不肯，这事就算吹了，自己也免做骗子，便复信说：至多出一百美金，先寄三十，文凭到手，再寄余款；此间尚有中国同学三十余人，皆愿照此办法向贵校接洽。爱尔兰人起初不想答应，后来看方鸿渐语气坚决，又就近打听出来美国博士头衔确在中国时髦，渐渐相信欧洲真有三十多条中国糊涂虫，要向他买文凭。他并且探出来做这种买卖的同行很多，例如东方大学、东美合众国大学，联合大学（Intercollegiae　University）、真理大学等等，便宜的可以十块美金出买硕士文凭，神玄大学（College　of　Divine　Metaphsics）廉价一起奉送三种博士文凭；这都是堂堂立案注册的学校，自己万万比不上。于是他抱薄利畅销的宗旨，跟鸿渐生意成交。他收到三十美金，印了四五十张空白文赁填好一张，寄给鸿渐，附信催他缴款和通知其他学生来接洽。鸿渐回信道，经详细调查，美国并无这个学校，文凭等于废纸，姑念初犯，不予追究，希望悔过自新，汇上十美金聊充改行的本钱，爱尔兰人气得咒骂个不停，喝醉酒，红着眼要找中国人打架，这事也许是中国自有外交或订商约以来唯一的胜利。
　　鸿渐先到照相馆里穿上德国大学博士的制服，照了张四寸相。父亲和丈人处各寄一张，信上千叮万嘱说，生平最恨“博士”之称，此番未能免俗，不足为外人道。回法国玩了几星期，买二等舱票回国。马赛上船以后，发见二等舱只有他一个中国人，寂寞无聊得很，三等的中国学生觉得他也是学生而摆阔坐二等，对他有点儿敌视。他打听出三等一个安南人舱里有张空铺，便跟船上管事商量，自愿放弃本来的舱位搬下来睡，饭还在二等吃。这些同船的中国人里，只有苏小姐是中国旧相识，在里昂研究法国文学，做了一篇《中国十八家白话诗人》的论文，新授博士。在大学同学的时候，她眼睛里未必有方鸿渐这小子。那时苏小姐把自己的爱情看得太名贵了，不肯随便施与。现在呢，宛如做了好衣服，舍不得穿，锁在箱里，过一两年忽然发见这衣服的样子和花色都不时髦了，有些自怅自悔。从前她一心要留学，嫌那几个追求自己的人没有前程，大不了是大学毕业生。而今她身为女博士，反觉得崇高的孤独，没有人敢攀上来，她对方鸿渐的家世略有所知，见他人不讨厌，似乎钱也充足，颇有意利用这航行期间，给他一个亲近的机会。没提防她同舱的鲍小姐抢了个先去。鲍小姐生长澳门，据说身体里有葡萄牙人的血。“葡萄牙人的血”这句话等于日本人说有本位文化，或私行改编外国剧本的作者声明他改本“有著作权，不许翻译”。因为葡萄牙人血里根本就混有中国成分。而照鲍小姐的身材估量，她那位葡萄牙母亲也许还间接从西班牙传来阿拉伯人的血胤。鲍小姐纤腰一束，正合《天方夜谭》里阿拉伯诗人所歌颂的美人条件：“身围瘦，后部重，站立的时候沉得腰肢酸痛。”长睫毛上一双欲眠似醉、含笑、带梦的大眼睛，圆满的上嘴唇好像鼓着在跟爱人使性子。她那位未婚夫李医生不知珍重，出钱让她一个人到伦敦学产科。葡萄牙人有句谚语说：“运气好的人生孩子第一胎准是女的。”因为女孩子长大了，可以打杂，看护弟弟妹妹，在未嫁之前，她父母省得下一个女佣人的工钱。鲍小姐从小被父母差唤惯了，心眼伶俐，明白机会要自己找，快乐要自己寻。所以她宁可跟一个比自己年龄长十二岁的人订婚，有机会出洋。英国人看惯白皮肤，瞧见她暗而不黑的颜色、肥腻辛辣的引力，以为这是道地的东方美人。她自信很能引诱人，所以极快、极容易地给人引诱了。好在她是学医的，并不当什么一回事，也没出什么乱子。她在英国过了两年，这次回去结婚，跟丈夫一同挂牌。上船以后，中国学生打咱出她领香港政府发给的“大不列颠子民”护照，算不得中国国籍，不大去亲近她。她不会讲法文，又不屑跟三等舱的广东侍者打乡谈，甚觉无聊。她看方鸿渐是坐二等的，人还过得去，不失为旅行中消遣的伴侣。苏小姐理想的自己是：“艳如桃李，冷若冰霜，”让方鸿渐卑逊地仰慕而后屈伏地求爱。谁知道气候虽然每天华氏一百度左右，这种又甜又冷的冰淇淋作风全行不通。鲍小姐只轻松一句话就把方鸿渐钩住了。鸿渐搬到三等的明天，上甲板散步，无意中碰见鲍小姐一个人背靠着船栏杆在吹风，便招呼攀谈起来。讲不到几句话，鲍小姐生说：“方先生，你教我想起了我的fiance，你相貌和他像极了！”方鸿渐听了，又害羞，又得意。一个可爱的女人说你像她的未婚夫，等于表示假使她没订婚，你有资格得她的爱。刻薄鬼也许要这样解释，她已经另有未婚夫了，你可以享受她未婚夫的权利而不必履行跟她结婚的义务。无论如何，从此他们俩的交情像热带植物那样飞快的生长，其他中国男学生都跟方鸿渐开玩笑，逼他请大家喝了一次冰咖啡和啤酒。
　　方鸿渐那时候心上虽怪鲍小姐行动不检，也觉兴奋，回头看见苏小姐孙太太两张空椅子，侥幸方才烟卷的事没落在她们眼里，当天晚上，起了海风，船有点颠簸。十点钟后，甲板上只有三五对男女，都躲在灯光照不到的黑影里喁喁情话。方鸿渐和鲍小姐不说话，并肩踱着。一个大浪把船身晃得利害，鲍小姐也站不稳，方鸿渐勾住她腰，傍了栏杆不走，馋嘴似地吻她。鲍小姐的嘴唇暗示着，身体依须着，这个急忙、粗率的抢吻渐渐稳定下来，长得妥贴完密。鲍小姐顶灵便地推脱方鸿渐的手臂，嘴里深深呼吸口气，道：“我给你闷死了！我在伤风，鼻子里透不过气来——太便宜你，你还没求我爱你！”“我现在向你补求，行不行？”好像一切没恋爱过的男人，方鸿渐把“爱”字看得太尊贵和严重，不肯随便应用在女人身上；他只觉得自己要鲍小姐，并不爱她，所以这样语言支吾。
　　“反正没好活说，逃不了那几句老套儿。”“你嘴凑上来，我对你说，这话就一直钻到你心里，省得走远路，拐了弯从耳朵里进去。”“我才不上你的当！有话斯斯文文的说。今天够了，要是你不跟我胡闹，我明天……”方鸿渐不理会，又把手勾她腰。船身忽然一侧，他没拉住栏杆，险的带累鲍小姐摔一交。同时黑影里其余的女人也尖声叫：“啊哟！”鲍小姐借势脱身，道：“我觉得冷，先下去了。明天见。”撇下方鸿渐在甲板上。天空早起了黑云，漏出疏疏几颗星，风浪像饕餮吞吃的声音，白天的汪洋大海，这时候全消化在更广大的昏夜里。衬了这背景，一个人身心的搅动也缩小以至于无，只心里一团明天的希望，还未落入渺茫，在广漠澎拜的黑暗深处，一点萤火似的自照着。
　　从那天起，方鸿渐饭也常在三等吃。苏小姐对他的态度显著地冷淡，他私上问鲍小姐，为什么苏小姐近来爱理不理。鲍小姐笑他是傻瓜，还说：“我猜想得出为什么，可是我不告诉你，免得你骄气。”方鸿渐说她神经过敏，但此后碰见苏小姐愈觉得局促不安。船又过了锡兰和新加坡，不日到西贡，这是法国船一路走来第一个可夸傲的本国殖民地。船上的法国人像狗望见了家，气势顿长，举动和声音也高亢好些。船在下午傍岸，要停泊两夜。苏小姐有亲戚在这儿中国领事馆做事，派汽车到码头来接她吃晚饭，在大家羡慕的眼光里，一个人先下船了，其余的学生决议上中国馆子聚餐。方鸿渐想跟鲍小姐两个人另去吃饭，在大家面前不好意思讲出口，只得随他们走。吃完饭，孙氏夫妇带小孩子先回船。余人坐了一回咖啡馆，鲍小姐提议上跳舞厅。方鸿渐虽在法国花钱学过两课跳舞，本领并不到家，跟鲍小姐跳了一次，只好藏拙坐着，看她和旁人跳。十二点多钟，大家兴尽回船睡觉。到码头下车，方鸿渐和鲍小姐落在后面。鲍小姐道：“今天苏小姐不回来了。”“我同舱的安南人也上岸了，他的铺位听说又卖给一个从西贡到香港去的中国商人了。”“咱们俩今天都是一个人睡，”鲍小姐好像不经意地说。
　　方鸿渐心中电光瞥过似的，忽然照彻，可是射眼得不敢逼视，周身的血都升上脸来，他正想说话，前面走的同伴回头叫道：“你们怎么话讲不完！走得慢吞吞的，怕我们听见，是不是？”两人没说什么，直上船，大家道声“晚安”散去。方鸿渐洗了澡，回到舱里，躺下又坐起来，打消已起的念头仿佛跟女人怀孕要打胎一样的难受，也许鲍小姐那句话并无用意，去了自讨没趣；甲板上在装货，走廊里有两个巡逻的侍者防闲人混下来，难保不给他们瞧见。自己拿不定文章，又不肯死心，忽听得轻快的脚步声，像从鲍小姐卧舱那面来的。鸿渐心直跳起来。又给那脚步捺下去，仿佛一步步都踏在心上，那脚步半路停止，心也给它踏住不敢动，好一会心被压得不能更忍了，幸而那脚步继续加快的走近来。鸿渐不再疑惑，心也按束不住了，快活得要大叫，跳下铺，没套好拖鞋，就打开门帘，先闻到一阵鲍小姐惯用的爽身粉的香味。
　　明天早晨方鸿渐起来，太阳满窗，表上九点多了。他想这一晚的睡好甜，充实得梦都没做，无怪睡叫“黑甜乡”，又想到鲍小姐皮肤暗，笑起来甜甜的，等会见面可叫他“黑甜”，又联想到黑而甜的朱古力糖，只可惜法国出品的朱古力糖不好，天气又热，不吃这个东西，否则买一匣请她。正懒在床上胡想，鲍小姐外面弹舱壁，骂他“懒虫”叫他快起来，同上岸去玩。方鸿渐梳洗完毕，到鲍小姐舱外等了半天，她才打扮好。餐室里早点早开过，另花钱叫了两客早餐。那伺候他们这一桌的侍者就是管方鸿渐房舱的阿刘。两人吃完想走，阿刘不先收拾桌子上东西，笑嘻嘻看着他们俩伸手来，手心里三只女人夹头发的钗，打广东官话拖泥带水地说：“方先生，这是我刚才铺你的床捡到的。”鲍小姐脸飞红，大眼睛像要撑破眼眶。方鸿渐急得暗骂自己湖涂，起身时没检点一下，同时掏出三百法郎对阿刘道：“拿去！那东西还给我。”阿刘道谢，还说他这人最靠得住，决不乱讲。鲍小姐眼望别处，只做不知道。出了餐室，方鸿渐抱着歉把发钗还给鲍小姐，鲍小姐生气地掷在地下，说：“谁还要这东西！经过了那家伙的脏手！”这事把他们整天的运气毁了，什么事都别扭。坐洋车拉错了地方，买东西错付了钱，两人都没好运气。方鸿渐还想到昨晚那中国馆子吃午饭，鲍小姐定要吃西菜，就不愿意碰见同船的熟人。便找到一家门面还像样的西菜馆。谁知道从冷盘到咖啡，没有一样东西可口：上来的汤是凉的，冰淇淋倒是热的；鱼像海军陆战队，已登陆了好几天；肉像潜水艇士兵，会长时期伏在水里；除醋以外，面包、牛油、红酒无一不酸。两人吃得倒尽胃口，谈话也不投机。方鸿渐要博鲍小姐欢心，便把“黑甜”、“朱古力小姐”那些亲昵的称呼告诉她。鲍小姐怫道：“我就那样黑么？”方鸿渐固执地申辩道：“我就爱你这颜色。我今年在西班牙，看见一个有名的美人跳舞，她皮肤只比外国熏火腿的颜色淡一点儿。”鲍小姐的回答毫不合逻辑：“也许你喜欢苏小姐死鱼肚那样的白。你自已就是扫烟囱的小黑炭，不照照镜子！”说着胜利地笑。
　　方鸿渐给鲍小姐喷了一身黑，不好再讲。待者上了鸡，碟子里一块像礼拜堂定风针上铁公鸡施舍下来的肉，鲍小姐用力割不动，放下刀叉道：“我没牙齿咬这东西！这馆子糟透了。”方鸿渐再接再厉的斗鸡，咬着牙说：“你不听我话，要吃西菜。”“我要吃西菜，没叫上这个倒霉馆子呀！做错了事，事后怪人，你们男人的脾气全这样！”鲍小姐说时，好像全世界每个男人的性格都经她试验过的。
　　过一会，不知怎样鲍小姐又讲起她未婚夫李医生，说他也是虔诚的基督教徒。方鸿渐正满肚子委屈，听到这话，心里作恶，想信教在鲍小姐的行为上全没影响，只好借李医生来讽刺，便说：“信基督教的人，怎样做医生？”鲍小姐不明白这话，睁眼看着他。
　　鸿渐替鲍小姐面前搀焦豆皮的咖啡里，加上冲米泔水的牛奶，说：“基督教十诫里一条是”别杀人“，可是医生除掉职业化的杀人以外，还干什么？”鲍小姐毫无幽默地生气道：“胡说！医生是救人生命的。”鸿渐看她怒得可爱，有意撩拨她道：“救人生命也不能信教。医生要人活，救人的肉体；宗教救人的灵魂，要人不怕死。所以病人怕死，就得请大夫，吃药；医药无效，逃不了一死，就找牧师和神父来送终。学医兼信教，那等于说：假如我不能教病人好好的活，至少我还能教他好好的死，反正他请我不会错。这仿佛药房掌柜带开棺材铺子，太便宜了！”鲍小姐动了真气：“瞧你一辈子不生病，不要请教医生。你只靠一张油嘴，胡说八道。我也是学医的，你凭空为什么损人？”方鸿渐慌得歉，鲍小姐嚷头痛，要回船休息。鸿渐一路上赔小心，鲍小姐只无精打采。送她回舱后，鸿渐也睡了两个钟点。一起身就去鲍小姐舱外弹壁唤她名字，问她好了没有。想不到门帘开处，苏小姐出来，说鲍小姐病了，吐过两次，刚睡着呢。鸿渐又羞又窘，敷衍一句，急忙逃走。晚饭时，大家见桌上没鲍小姐，向方鸿渐打趣要人。鸿渐含含糊糊说：“她累了，身子不大舒服。”苏小姐面有得色道：“她跟方先生吃饭回来害肚子，这时候什么都吃不进。我只担心她别生了痢疾呢！”那些全无心肝的男学生哈哈大笑，七嘴八舌道：“谁教她背了我们跟小方两口儿吃饭？”“小方真丢人哪！请女朋友吃饭为什么不挑干净馆子？”“馆子不会错，也许鲍小姐太高兴，贪嘴吃得消化不了。小方，对不对？”“小方，你倒没生病？哦，我明白了！鲍小姐秀色可餐，你看饱了不用吃饭了。”“只怕餐的不是秀色，是——”那人本要说“熟肉”，忽想当了苏小姐，这话讲出来不雅，也许会传给鲍小姐知道，便摘块面包塞在自己嘴里嚼着。
　　方鸿渐午饭本没吃饱，这时候受不住大家的玩笑，不等菜上齐就跑了，余人笑得更利害。他立起来转身，看见背后站着侍候的阿刘，对自己心照不宣似的眨眼。
　　鲍小姐睡了一天多才起床，虽和方鸿渐在一起玩，不像以前那样的脱略形骸，也许因为不日到香港，先得把身心收拾整洁，作为见未婚夫的准备。孙氏一家和其他三四个学生也要在九龙下船，搭粤汉铁路的车；分别在即，拚命赌钱，只恨晚上十二点后餐室里不许开电灯。到香港前一天下午，大家回国后的通信地址都交换过了，彼此再会的话也反复说了好几遍，仿佛这同舟之谊永远忘不掉似的。鸿渐正要上甲板找鲍小姐，阿刘鬼鬼祟祟地叫“方先生”。鸿渐自从那天给他三百法郎以后，看见这家伙就心慌，板着脸问他有什么事。阿刘说他管的房舱，有一间没客人，问鸿渐今晚要不要，只讨六百法郎。鸿渐挥手道：“我要它干吗？”三脚两步上楼梯去，只听得阿刘在背后冷笑。他忽然省悟阿刘的用意，脸都羞热了。上去吞吞吐吐把这事告诉鲍小姐，还骂阿刘浑蛋。她哼一声，没讲别的。旁人来了，不便再谈。吃晚饭的时候，孙先生道：“今天临别纪念，咱们得痛痛快快打个通宵。阿刘有个舱，我已经二百法郎定下来了。”鲍小姐对鸿渐轻藐地瞧了一眼，立刻又注视碟子喝汤。
　　孙太太把匙儿喂小孩子，懦怯地说：“明天要下船啦，不怕累么？”孙先生道：“明天找个旅馆，睡它个几天几晚不醒，船上的机器闹得很，我睡不舒服。”方鸿渐给鲍小姐一眼看得自尊心像泄尽气的橡皮车胎。晚饭后，鲍小姐和苏小姐异常亲热，勾着手寸步不离。他全志气，跟上甲板，看她们有说有笑，不容许自己插口，把话压扁了都挤不进去；自觉没趣丢脸，像赶在洋车后面的叫化子，跑了好些路，没讨到一个小钱，要停下来却又不甘心。鲍小姐看手表道：“我要下去睡了。明天天不亮船就靠岸，早晨不能好好的睡。今天不早睡，明天上岸的时候人萎靡没有精神，难看死了。”苏小姐道：“你这人就这样爱美，怕李先生还会不爱你！带几分憔悴，更教人疼呢！”鲍小姐道：“那是你经验之谈罢？——好了，明天到家了！我兴奋得很，只怕下去睡不熟。苏小姐，咱们下去罢，到舱里舒舒服服地躺着讲话。”对鸿渐一点头，两人下去了。鸿渐气得心头火直冒，仿佛会把嘴里香烟衔着的一头都烧红了。他想不出为什么鲍小姐突然改变态度。他们的关系就算这样了结了么？他在柏林大学，听过名闻日本的斯泼朗格教授（EdSpranger）的爱情（Eros）演讲，明白爱情跟性欲一胞双生，类而不同，性欲并非爱情的基本，爱情也不是性欲的升华。他也看过爱情指南那一类的书，知道有什么肉的相爱、心的相爱种种分别。鲍小姐谈不上心和灵魂。她不是变心，因为她没有心；只能　算日子久了，肉会变味。反正自己并没吃亏，也许还占了便宜，没得什么可怨。方鸿渐把这种巧妙的词句和精密的计算来抚慰自己，可是失望、遭欺骗的情欲、被损伤的骄傲，都不肯平伏，像不倒翁，捺下去又竖起来，反而摇摆得利害。
　　明天东方才白，船的速度减低，机器的声音也换了节奏。方鸿渐同舱的客人早收拾好东西，鸿渐还躺着，想跟鲍小姐后会无期，无论如何，要礼貌周到地送行。阿刘忽然进来，哭丧着脸向他讨小费。鸿渐生气道：“为什么这时就要钱？到上海还有好几天呢。”阿刘哑声告诉，姓孙的那几个人打牌，声音太闹，给法国管事查到了，大吵其架，自己的饭碗也砸破了，等会就得卷铺盖下船。鸿渐听着，暗唤侥幸，便打发了他。吃早饭饭今天下船的那几位都垂丧气。孙太太眼睛红肿，眼眶似乎饱和着眼泪，像夏天早晨花瓣上的露水，手指那么轻轻一碰就会掉下来。鲍小姐瞧见伺候吃饭的换了人，问阿刘哪里去了，没人回答她。方鸿渐问鲍小姐：“你行李多，要不要我送你下船？”鲍小姐疏远地说：“谢谢你！不用劳你驾，李先生会上船来接我。”苏小姐道：“你可以把方先生跟李先生介绍介绍。”方鸿渐恨不得把苏小姐瘦身体里每根骨头都捏为石灰粉。鲍小姐也没理她，喝了一杯牛奶，匆匆起身，说东西还没拾完。方鸿渐顾不得人家笑话，放下杯子跟出去。鲍小姐头也不回，方鸿渐唤她，她不耐烦地说：“我忙着呢，没工夫跟你说话。”方鸿渐正不知怎样发脾气才好，阿刘鬼魂似地出现了，向鲍小姐要酒钱。鲍小姐眼迸火星道：“伺候吃饭的赏钱，昨天早给了。你还要什么赏？我房舱又不是你管的。”阿刘不讲话，手向口袋里半天掏出来一只发钗，就是那天鲍小姐掷掉的，他擦地板，三只只捡到一只。鸿渐本想骂阿刘，但看见他郑重其事地拿出这么一件法宝，忍不住大笑。鲍小姐恨道：“你还乐？你乐，你给他钱，我半个子儿没有！”回身走了。
　　鸿渐防阿刘不甘心，见了李医生胡说，自认晦气，又给他些钱。一个人上甲板，闷闷地看船靠傍九龙码头。下船的中外乘客也来了，鸿渐躲得老远，不愿意见鲍小姐。友头上警察、脚夫、旅馆的接客扰嚷着，还有一群人向船上挥手巾，做手势。鸿渐想准有李医生在内，倒要仔细认认。好容易，扶梯靠岸，进港手续完毕，接客的冲上船来。鲍小姐扑向一个半秃顶，戴大眼镜的黑胖子怀里。这就是她所说跟自己相像的未婚夫！自己就像他？吓，真是侮辱！现在全明白了，她那句话根本是引诱。一向还自鸣得意，以为她有点看中自己，谁知道由她摆布玩弄了，还要给她暗笑。除掉那句古老得长白胡子、陈腐得发霉的话：“女人是最可怕的！”还有什么可说！鸿渐在凭栏发呆，料不到背后苏小姐柔声道：“方先生不下船，在想心思？人家撇了方先生去啦！没人陪啦。”鸿渐回身，看见苏小姐装扮得娆娆婷婷，不知道什么鬼指使自己说：“要奉陪你，就怕没福气呀，没资格呀！”他说这冒昧话，准备碰个软钉子。苏小姐双颊涂的淡胭脂下面忽然晕出红来，像纸上沁的油渍，顷刻布到满脸，腼腆得迷人。她眼皮有些抬不起似地说：“我们没有那么大的面子呀！”鸿渐摊手道：“我原说，人家不肯赏脸呀！”苏小姐道：“我要找家剃头店洗头发去，你肯陪么？”鸿渐道：“妙极了！我正要去理发。咱们理完发，摆渡到香港上山瞧瞧，下了山我请你吃饭，饭后到浅水湾喝茶，晚上看电影，好不好？”苏小姐笑道：“方先生，想得真周到！一天的事全计划好了。”她不知道方鸿渐只在出国时船过香港一次，现在方向都记不得了。
　　二十分钟后，阿刘带了衣包在室里等法国总管来查过好上岸，舱洞口瞥见方鸿渐在苏小姐后面，手傍着她腰走下扶梯，不禁又诧异，又佩服，又瞧不起，无法表示这种复杂的情绪，便“啐”的一声向痰盂里射出一口浓浓的唾潮沫。
　　第二章据说“女朋友”就是“情人”的学名，说起来庄严些，正像玫瑰在生物学上叫“蔷薇科木本复叶植物”，或者休妻的法律术语是“协议离婚”。方鸿渐陪苏小姐在香港玩了两天，才明白女朋友跟情人事实上绝然不同。苏小姐是最理想的女朋友，有头脑，有身分，态度相貌算得上大家闺秀，和她同上饭馆戏院并不失自己的面子。他们俩虽然十分亲密，方鸿渐自信对她的情谊到此而止，好比两条平行的直线，无论彼此距离怎么近，拉得怎么长，终合不拢来成为一体。只有九龙上岸前看她害羞脸红的一刹那，心忽然软得没力量跳跃，以后便没有这个感觉。他发现苏小姐有不少小孩子脾气，她会顽皮，会娇痴，这是仇一向没想到的。可是不知怎样，他老觉得这种小妞儿腔跟苏小姐不顶配。并非因为她年龄大了；她比鲍小姐大不了多少，并且当着心爱的男人，每个女人都有返老还童的绝技。只能说是品格上的不相宜；譬如小猫打圈儿追自己的尾巴，我们看着好玩儿，而小狗也追寻过去地回头跟着那短尾巴橛乱转，说风趣减少了。那几个一路同船的学生看小方才去了鲍小姐，早换上苏小姐，对他打趣个不亦乐乎。
　　苏小姐做人极大方；船到上海前那五六天里，一个字没提到鲍小姐。她待人接物也温和了许多。方鸿渐并未向她谈情说爱，除掉上船下船走跳板时扶她一把，也没拉过她手。可是苏小姐偶然的举动，好像和他有比求婚、订婚、新婚更深远悠久的关系。她的平淡，更使鸿渐疑惧，觉得这是爱情热烈的安稳，仿佛飓风后的海洋波平浪静，而底下随时潜伏着汹涌翻腾的力量。香港开船以后，他和苏小姐同在甲板上吃香港买的水果。他吃水蜜桃，耐心地撕皮，还说：“桃子为什么不生得像香蕉，剥皮多容易！或者干脆像苹果，用手帕擦一擦，就能连皮吃。”苏小姐剥几个鲜荔枝吃了，不再吃什么，愿意替他剥桃子，他无论如何不答应。桃子吃完，他两脸两手都持了幌子，苏小姐看着他笑。他怕桃子汁弄脏裤子，只伸小指头到袋里去勾手帕，勾了两次，好容易拉出来，正在擦手，苏小姐声音含着惊怕嫌恶道：“啊哟！你的手帕怎么那么脏！真亏你——哙！这东西擦不得嘴，拿我的去拿去，别推，我最不喜欢推。”方鸿渐涨红脸，接苏小姐的手帕，在嘴上浮着抹了抹，说：“我买了一打新手帕上船，给船上洗衣服的人丢了一半。我因为这小东西容易遗，他们洗得又慢，只好自己洗。这两天上岸玩儿没工夫洗，所有的手帕都脏了，回头洗去。你这块手帕，也让我洗了还你。”苏小姐道：“谁要你洗？你洗也不会干净！我看你的手帕根本就没洗干净，上面的油腻斑点，怕是马塞一路来留下的纪念。不知道你怎么洗的。”说时，吃吃笑了。
　　等一会，两人下去。苏小姐捡一块己的手帕给方鸿渐道：“你暂时用着，你的手帕交给我去洗。”方鸿渐慌得连说：“没有这个道理！”苏小姐努嘴道：“你真不爽气！这有什么大了不得？快给我。”鸿渐没法，回房舱拿了一团皱手帕出来，求饶恕似的说：“我自己会洗呀！脏得很你看了要嫌的。”苏小姐夺过来，摇头道：“你这人怎么邋遢到这个地步。你就把东西擦苹果吃么？”方鸿渐为这事整天惶恐不安，向苏小姐谢了又谢，反给她说“婆婆妈妈”。明天，他替苏小姐搬帆布椅子，用了些力，衬衫上迸脱两个钮子，苏小姐笑他“小胖子”，叫他回头把衬衫换下来交给她钉钮子。他抗议无用，苏小姐说什么就要什么，他只好服从她善意的独裁。
　　方鸿渐看大势不佳，起了恐慌。洗手帕，补袜子，缝钮扣，都是太太对丈夫尽的小义务。自己凭什么受这些权利呢？受了丈夫的权利当然正名定分，该是她的丈夫，否则她为什么肯尽这些义务呢？难道自己言动有可以给她误认为丈夫的地方么？想到这里，方鸿渐毛骨悚然。假使订婚戒指是落入圈套的象征，钮扣也是扣留不放的预兆。自己得留点儿神！幸而明后天就到上海，以后便没有这样接近的机会，危险可以减少。可是这一两天内，他和苏小姐在一起，不是怕袜子忽然磨穿了洞，就是担心什么地方的钮子脱了线。他知道苏小姐的效劳是不好随便领情的；她每钉一个钮扣或补一个洞，自己良心上就增一分向她求婚的责任。
　　中日关系一天坏似一天，船上无线电的报告使他们忧虑。八月九日下午，船到上海，侥幸战事并没发生。苏小姐把地址给方鸿渐，要他去玩。他满嘴答应，回老乡望了父母，一定到上海来拜访她。苏小姐的哥哥上船来接，方鸿渐躲不了，苏小姐把他向她哥哥介绍。她哥哥把鸿渐打量一下，极客气地拉手道：“久仰！久仰！”鸿渐心里想，糟了！糟了！这一介绍就算经她家庭代表审定批准做候补女婿了！同时奇怪她哥哥说“久仰”，准是苏小姐从前常向她家里人说起自己了，又有些高兴。他辞了苏氏兄妹去捡点行李，走不到几步，回头看见哥哥对妹妹笑，妹妹红了脸，又像喜欢，又像生气，知道在讲自己，一阵不好意思。忽然碰见他兄弟鹏图，原来上二等找他去了。苏小姐海关有熟人，行李免查放行。方氏兄弟等着检查呢，苏小姐特来跟鸿渐拉手叮嘱“再会”。鹏图问是谁，鸿渐说姓苏。鹏图道：“唉，就是法国的博士，报上见过的。”鸿渐冷笑一声，鄙视女人们的虚荣。草草把查过的箱子理好，叫了汽车准备到周经理家去住一夜，明天回乡。鹏图在什么银行里做行员，这两天风声不好，忙着搬仓库，所以半路下车去了。鸿渐叫打个电报到家里，告诉明天搭第几班火车。鹏图觉得这钱浪费得无谓，只打了个长途电话。
　　他丈人丈母见他，欢喜得了不得。他送丈人一根在锡兰买的象牙柄藤手杖，送爱打牌而信佛的丈母一只法国货女人手提袋和两张锡兰的贝叶，送他十五六岁的小舅子一支德国货自来水笔。丈母又想到死去五年的女儿，伤心落泪道：“淑英假如活着，你今天留洋博士回来，她才高兴呢！”周经理哽着嗓子说他太太老糊涂了，怎么今天乐日子讲那些话。鸿渐脸上严肃沉郁，可是满心惭愧，因为这四年里他从未想起那位未婚妻，出洋时丈人给他做纪念的那张未婚妻大照相，也搁在箱子底，不知退了颜色没有。他想赎罪补过，反正明天搭十一点半特别快车，来得及去万国公墓一次，便说：“我原想明天一早上她的坟。”周经理夫妇对鸿渐的感想更好了。周太太领他去看今晚睡的屋子，就是淑英生前的房。梳妆桌子上并放两张照相：一张是淑英的遗容，一张是自己的博士照。方鸿渐看着发呆，觉得也陪淑英双双死了，萧条黯淡，不胜身后魂归之感。
　　吃晚饭时，丈人知道鸿渐下半年职业沿尚无着，安慰他说：“这不成问题。我想你还是在上海或南京找个事，北平形势凶险，你去不得。你回家两个礼拜，就出来住在我这儿我银行里为你挂个名，你白天去走走，晚上教教我儿子，一面找机会。好不好？你行李也不必带走，天气这样热，回家反正得穿中国衣服。”鸿渐真心感激，谢了丈人。丈母提起他婚事，问他有女朋友没有。他忙说没有。丈人说：“我知道你不会有。你老太爷家教好，你做人规矩，不会闹什么自由恋爱，自由恋爱没有一个好结果的。”丈母道：“鸿渐这样老实，是找不到女人的。让我为他留心做个媒罢。”丈人道：“你又来了！他老太爷、老太太怕不会作主。咱们管不着。”丈母道：“鸿渐出洋花的是咱们的钱，他娶媳妇，当然不能撇开咱们周家。鸿渐，对不对？你将来新太太，一定要做我的干女儿。我这话说在你耳里，不要有了新亲，把旧亲忘个干净！这种没良心的人我见得多了。”鸿渐只好苦笑道：“放心，决不会。”心里对苏小姐影子说：“听听！你肯拜这位太太做干妈么？亏得我不要娶你。”他小舅子好像接着他心上的话说：“鸿渐哥，有个姓苏的女留学生，你认识她么？”方鸿渐惊骇得几乎饭碗脱手，想美国的行为心理学家只证明“思想是不出声的语言”，这小子的招风耳朵是什么构造，怎么心头无声的密语全给他听到！他还没有回答，丈人说：“是啊！我忘了——效成，你去拿那张报来——我收到你的照相，就文书科王主任起个稿子去登报。我知道你不爱出风头，可是这是有面子的事，不必隐瞒。”最后几句话是因为鸿渐变了脸色而说的。
　　丈母道：“这话对。赔了这许多本钱，为什么不体面一下！”鸿渐已经羞愤得脸红了，到小舅子把报拿来，接过一看，夹耳根、连脖子、经背脊红下去直到脚跟。那张是七月初的《沪报》，教育消息栏里印着两张小照，铜版模糊，很像乩坛上拍的鬼魂照相。前面一张昭的新闻说，政务院参事苏鸿业女公子文纨在里昂大学得博士回国。后面那张照的新闻字数要多一倍，说本埠商界闻人点金银行经理周厚卿快婿方鸿渐，由周君资送出洋深造，留学英国伦敦、法国巴黎、德国柏林各大学，精研政治、经济、历史、社会等科，莫不成绩优良，名列前茅，顷由德国克莱登大学授哲学博士，将赴各国游历考察，秋凉回国，闻各大机关正争相礼聘云。鸿渐恨不能把报一撕两半，把那王什么主任的喉咙扼着，看还挤得出多少开履历用的肉麻公式。怪不得苏小姐哥哥见面了要说：“久仰”，怪不得鹏图听说姓苏便知道是留学博士。当时还笑她俗套呢！自己这段新闻才是登极加冕的恶俗，臭气熏得读者要按住鼻子。况且人家是真正的博士，自己算什么？在船上从没跟苏小姐谈起学的事，她看到这新闻会断定自己吹牛骗人。国哪里有克莱登大学？写信时含混地说得了学位，丈人看信从德国寄出，武断是个德国大学，给内行人知道，岂不笑歪了嘴？自己就成了骗子，从此无面目人！
　　周太太看方鸿渐捧报老遮着脸，笑对丈夫说：“你瞧鸿渐多得意，那条新闻看了几遍不放手。”效成顽皮道：“鸿渐哥在仔细认那位苏文纨，想娶她来代替姐姐呢。”方鸿渐忍不住道：“别胡说！”好容易克制自己，没把报纸掷在地下，没让羞愤露在脸上，可是嗓子都沙了。
　　周氏夫妇看鸿渐笑容全无，脸色发白，有点奇怪，忽然彼此做个眼色，似乎了解鸿渐的心理，异口同声骂效成道：“你这孩打。大人讲话，谁要你来插嘴？鸿渐哥今天才回来，当然想起你姐姐，心上不快活。你说笑话也得有个分寸，以后不许你开口——鸿　渐，我们知道你天性生得厚，小孩子胡说，不用理他。”鸿渐脸又泛红，效成骨朵了嘴，心里怨道：“别妆假！你有本领一辈子不娶老婆。我不希罕你的笔，拿回去得了。”方鸿　渐到房睡觉的时候，发现淑英的照相不在桌子上了，想是丈母怕自己对物思人，伤心失眠，特来拿走的。下船不过六七个钟点，可是船上的一切已如隔世。上岸时的兴奋，都蒸发了，觉得懦弱、渺小，职业不容易找，恋爱不容易成就。理想中的留学回国，好像地面的水，化气升上天空，又变雨回到地面，一世的人都望着、说着。现在万里回乡，祖国的人海里，泡个大肥皂泡，未破时五光十色，经不起人一搠就不知去向。他靠纱窗望出去。满天的星又密又忙，它们声息全无，而看来只觉得天上热闹。一梳月亮像形容未长成的女孩子，但见人己不羞缩，光明和轮廓都清新露，渐渐可烘衬夜景。小园草地里的小虫琐琐屑屑地在夜谈。不知那里的蛙群齐心协力地干号，像声浪给火煮得发沸。几星萤火优游来去，不像飞行，像在厚密的空气里漂浮；月光不到的阴黑处，一点萤火忽明，像夏夜的一只微绿的小眼睛。这景色是鸿渐出国前看惯的，可是这时候见了，忽然心挤紧作痛，眼酸得要流泪。他才领会到生命的美善、回国的快乐，《沪报》上的新闻和纱窗外的嗡嗡蚊声一样不足介怀。鸿渐舒服地叹口气，又打个大呵欠。
　　方鸿渐在本县火车站，方老先生、鸿渐的三弟凤仪，还有七八个堂房叔伯兄弟和方老先生的朋友们，都在月台上迎接。他十分过意不去，一个个上前招呼，说：“这样大热天，真对不住！”看父亲胡子又花白了好些，说：“爸爸，你何必来呢！”方豚翁把手里的折扇给鸿渐道：“你们西装朋友是不用这老古董的，可是总比拿草帽扇好些。”又看儿子坐的是二等车，夸奖他道：“这孩子不错！他回国船坐二等，我以为他火车一定坐头等，他还是坐二等车，不志高气满，改变本色，他已经懂做人的道理了。”大家也附和赞美一阵。前簇后拥，出了查票口，忽然一个戴蓝眼镜穿西装的人拉住鸿渐道：“请别动！照个相。”鸿渐莫名其妙，正要问他缘故，只听得照相机咯嗒声，蓝眼镜放松手，原来迎面还有一个人把快镜对着自己。蓝眼镜一面掏名片说：“方博士天回到祖国的？”拿快镜的人走来了，也掏出张名片，鸿渐一瞧，是本县两张地方日报的记者。那两位记者都说：“今天方博士舟车劳顿，明天早晨到府聆教。”便转身向方老先生恭维，陪着一路出车站。凤仪对鸿渐笑道：“大哥，你是本县的名人了。”鸿渐虽然嫌那两位记者口口声声叫“方博士”，刺耳得很但看人家这样郑重地当自己是一尊人物，身心庞然膨胀，人格伟大了好些。他才知道住小地方的便宜，只恨今天没换身比较新的西装，没拿根手杖，手里又挥着大折扇，满脸的汗，照相怕不会好。
　　到家见过母亲和两位弟媳妇，把带回来的礼物送了。母亲笑说：“是要出洋的，学得这样周到，女人用的东西都会买了。”父亲道：“鹏图昨天电话里说起一位苏小姐，是怎么一回事？”方鸿渐恼道：“不过是同坐一条船，全没有什么。鹏图总——喜欢多嘴。”他本要骂鹏图好搬是非，但当着鹏图太太的面，所以没讲出来。
　　父亲道：“你的婚事也该上劲了，两个史弟都早娶了媳妇，孩子都有了。做媒的有好几起，可是，你现在不用我们这种老厌物来替你作主了。苏鸿业呢，人倒有点名望，从前好像做过几任实缺官——”鸿渐暗想，为什么可爱的女孩子全有父亲呢？她孤独的一个人可以藏匿在心里温存，拖泥带水地牵上了交亲、叔父、兄弟之类，这女孩子就不伶俐洒脱，心里不便窝藏她了，她的可爱里也就搀和渣滓了。许多人谈婚姻，语气仿佛是同性恋爱，不是看中女孩子本人，是羡慕她的老子或她的哥哥。
　　母亲道：“我不赞成！官小姐是娶不得的，要你服侍她，她不会服侍你。并且娶媳妇要同乡人才好，外县人脾气总有点不合式，你娶了不受用。这位苏小姐是留学生，年龄怕不小了。”她那两位中学没毕业，而且本县生长的媳妇都有赞和的表情。
　　父亲道：“人家不但留学，而且是博士呢。所以我怕鸿渐吃不消她。”——好像苏小姐是砖石一类的硬东西，非鸵鸟或者火鸡的胃消化不掉的。
　　母亲不服气道：“咱们鸿渐也是个博士，不输给她，为直么配不过她？”父亲捻着胡子笑道：“鸿渐，这道理你娘不会懂了——女人念了几句书最难驾驭。男人非比她高一层，不能和她平等匹配。所以大学毕业生才娶中学女生，留学生娶大学女生。女人留洋得了博士，只有洋人才敢娶他，否则男人至少是双料博士。鸿渐，我这话没说错罢？这跟”嫁女必须胜吾家，娶妇必须不若吾家“一个道理。”母亲道：“做媒的几起里，许家的二女儿最好，回头我给你看照相。”方鸿渐想这事严重了。生平最恨小城市的摩登姑娘，落伍的时髦，乡气的都市化，活像那第一套中国裁缝仿制的西装，把做样子的外国人旧衣服上两方补钉，也照式在衣袖和裤子上做了。现在不必抗议，过几天向上海溜之大吉。方老先生又说，接风的人很多，天气太热，叫鸿渐小心别贪嘴，亲近的尊长家里都得去拜访一下，自己的包车让给他坐，等天气稍凉，亲带他到祖父坟上行礼。方老太太说，明天叫裁缝来做他的纺绸大褂和里衣裤，凤仪有两件大褂，暂时借一件穿了出门拜客。吃晚饭的时候，有方老太太亲手做的煎鳝鱼丝、酱鸡翅、西瓜煨鸡、洒煮虾，都是大儿子爱吃的乡味。方老太太挑好的送到他饭碗上，说：“我想你在外国四年可怜，什么都没得吃！”大家都笑说她又来了，在外国不吃东西，岂不饿死。她道：“我就不懂洋鬼子怎样活的！什么面包、牛奶，送给我都不要吃。”鸿渐忽然觉得，在这种家庭空气里，战争是不可相信的事，好比光天化日之下没人想到有鬼。父亲母亲的计划和希望，丝毫没为意外事故留个余地。看他们这样稳定地支配着未来，自己也胆壮起来，想上海的局势也许会和缓，战事不会发生，真发生了也可以置之不理。
　　明天方鸿渐才起床，那两位记者早上门了。鸿渐看到他们带来的报上，有方博士回乡的新闻，嵌着昨天照的全身像，可怕得自惭形秽。蓝眼镜拉自己右臂的那只手也清清楚楚地照进去了，加上自己侧脸惊愕的神情，宛如小偷给人捉住的摄影。那蓝眼镜是个博闻多识之士，说久闻克莱登大学是全世界最有名的学府，仿佛清华大学。那背照相机的记者问鸿渐对世界大势有什么观察、中日战争会不会爆发。方鸿渐好容易打发他们走了，还为蓝眼镜的报纸写“为民喉舌”、照相机的报纸写“直笔谠论”两名赠言。正想出门拜客，父亲老朋友本县省立中学吕校长来了，约方氏父子三人明晨茶馆吃早点，吃毕请鸿渐向暑期学校学生演讲“西洋文化在中国历史上之影响及其检讨”。鸿渐最怕演讲，要托词谢绝，谁知道父亲代他一口答应下来。他只好私下咽冷气，想这样热天，穿了袍儿套儿，讲废话，出臭汗，不是活受罪是什么？教育家的心理真与人不同！方老先生希望人家赞儿子“家学渊源”，向箱里翻了几部线装书出来，什么《问字堂集》、《癸巳类稿》、《七经楼集》、《谈瀛录》之类，吩咐鸿渐细看，搜集演讲材料。鸿渐一下午看得津津有味，识见大长，明白中国人品性方正所以说地是方的，洋人品性圆滑，所以主张地是圆的；中国人的心位置正中，西洋人的心位置偏左；西洋进口的鸦片有毒，非禁不可，中国地土性和平，出产的鸦片，吸食也不会上瘾；梅毒即是天花，来自西洋等等。只可惜这些事实虽然有趣，演讲时用不着它们，该另抱佛脚。所以当天从大伯父家吃晚饭回来，他醉眼迷离，翻了三五本历史教科书，凑满一千多字的讲稿，插穿了两个笑话。这种预备并不费心血，身血倒赔了些，因为蚊子多。
　　明早在茶馆吃过第四道照例点心的汤面，吕校长付帐，催鸿渐起身，匆匆各从跑堂手里接过长衫穿上走了，凤仪陪着方老先生喝茶。学校礼堂里早坐满学生，男男女女有二百多人，方鸿渐由吕校长陪了上讲台，只觉得许多眼睛注视得浑身又麻又痒，脚走路都不方便。到上台坐定，眼前的湿雾消散，才见第一排坐的都像本校教师，紧靠讲台的记录席上是一个女学生，新烫头发的浪纹板得像漆出来的。全礼堂的人都在交头接耳，好奇地赏着自己。他默默分付两颊道：“不要烧盘！脸红不得！”懊悔进门时不该脱太阳眼镜，眼前两片黑玻璃，心理上也好隐蔽在浓荫里面，不怕羞些。吕校长已在致辞介绍，鸿渐忙伸手到大褂口袋里去摸演讲稿子，只摸个空，慌得一身冷汗。想糟了！糟了！怎会把要紧东西遗失？家里出来时，明明搁在大褂袋里的。除掉开头几句话，其余全吓忘了。拚命追忆，只像把筛子去盛水。一着急，注意力集中不起来，思想的线索要打成结又松散了。隐约还有些事实的影子，但好比在热闹地方等人，瞥眼人堆里像是他，走上去找，又不见了。心里正在捉着迷藏，吕校长鞠躬请他演讲，下面一阵鼓掌。他刚站起来，瞧凤仪气急败坏赶进礼堂，看见演讲己开始，便绝望地找个空位坐下。鸿渐恍然大悟，出茶馆时，不小心穿错了凤仪的衣服，这两件大褂原全是凤仪的，颜色材料都一样。事到如此，只有大胆老脸胡扯一阵。
　　掌声住了，方鸿渐强作笑容　说：“吕校长，诸位先生，诸位同学：诸位的鼓掌虽然出于好意，其实是最不合理的。因为鼓掌表示演讲听得满意，现在鄙人还没开口，诸位已经满意得鼓掌，鄙人何必再讲什么呢？诸位应该先听演讲，然后随意鼓几下掌，让鄙人有面子下台。现在鼓掌在先，鄙人的演讲当不起那样热烈的掌声，反觉到一种收到款子交不出货色的惶恐。”听众大笑，那记录的女孩也含着笑，走笔如飞。方鸿渐踌躇，下面讲些什么呢？线装书上的议论和事实还记得一二，晚饭后翻看的历史教科书，影踪都没有了。该死的教科书，当学生的时候，真亏自己会读熟了应的！有了，有了！总比无话可说好些：“西洋文化在中国历史上的影响，各位在任何历史教科书里都找得到，不用我来重述。各位都知道欧洲思想正式跟中国接触，是在明朝中叶。所以天主教徒常说那时候是中国的文艺复兴。不过明朝天主教士带来的科学现在早过时了，他带来的宗教从来没有合时过。海通几百年来，只有两件西洋东西在整个中国社会里长存不灭。一件是鸦片，一件是梅毒，都是明朝所收的西洋文明。”听众大多数笑，少数笑，少数都张了嘴惊骇；有几个教师皱着眉头，那记录的女生涨红脸停笔不写，仿佛听了鸿渐最后的一句，处女的耳朵已经当众丧失贞操；吕校长在鸿渐背后含有警告意义的咳嗽。方鸿渐那时候宛如隆冬早晨起床的人，好容易用最大努力跳出被窝，只有熬着冷穿衣下床，断无缩回去道理。“鸦片本来又叫洋烟——”鸿渐看见教师里一个像教国文的老头子一面扇扇子，一面摇头，忙说：“这个”洋“当然指”三保太监下西洋“的”西洋“而说，因为据《大明会典》，鸦片是暹罗和爪哇的进贡品。可是在欧洲最早的文学作品荷马史诗《十年归》Odyssey里——”那老头子的秃顶给这个外国字镇住不敢摇动——“据说就有这东西。至于梅毒——”吕校长连咳嗽——“更无疑是舶来口洋货。叔本华早说近代欧洲文明的特点，第一是杨梅疮。诸位假如没机会见到外国原本书，那很容易，只要看徐志摩先生译的法国小说《戆第德》，就可略知梅毒的渊源。明朝正德以后，这病由洋人带来。这两件东西当然流毒无穷，可是也不能一概抹煞。鸦片引发了许多文学作品，古代诗人向酒里找灵感，近代欧美诗人都从鸦片里得灵感。梅毒在遗传上产生白痴、疯狂和残疾，但据说也能剌激天才。例如——”吕校长这时候嗓子都咳破了，到鸿渐讲完，台下拍手倒还有劲，吕校长板脸哑声致谢词道：“今天承方博士讲给我们听许多新奇的议论，我们感觉浓厚的兴趣。方博士是我世侄，我自小看他长大，知道他爱说笑话，今天天气很热，所以他有意讲些幽默的话。我希望将来有机会听到他的正经严肃的弘论。但我愿意告诉方博士：我们学校图书馆充满新生活的精神，绝对没有法国小说——”说时手打着空气，鸿渐羞得不敢看台下。
　　不到明天，好多人知道方家留洋回来的儿子公开提倡抽烟狎妓。这话传进方老先生耳朵，他不知道这说是自己教儿子翻线装书的果，大不以为然，只不好发作。紧跟着八月十三日淞沪战事的消息，方鸿渐闹的笑话没人再提起。但那些有女儿要嫁他的人，忘不了他的演讲；猜想他在外国花天酒地，若为女儿嫁他的事，到西湖月下老人祠去求签，难保不是第四签：“斯人也而有斯疾也！”这种青年做不得女婿。便陆续借口时局不靖，婚事缓议，向方家把女儿的照相、庚帖要了回去。方老太太非常懊丧，念念不忘许家二小姐，鸿渐倒若无其事。战事已起，方老先生是大乡绅，忙着办地方公安事务。县里的居民记得“一。二八”那一次没受敌机轰炸，这次想也无事，还不甚惊恐。方鸿渐住家一个星期，感觉出国这四年光阴，对家乡好像荷叶上泻过的水，留不下一点痕迹。回来所碰见的还是四年前那些人，那些人还是做四年前所做的事，说四年前所说的话。甚至认识的人里一个也没死掉；只有自己的乳母，从前常说等自己婚　养了儿子来抱小孩子的，现在病得不能起床。这四年在家乡要算白过了，博不到归来游子的一滴眼泪、一声叹息。开战后第六天日本飞机第一次来投弹，炸坍了火车站，大家才认识战争真打上门来了，就有搬家到乡下避难的人。以后飞机接连光顾，大有绝世侍人一顾倾城、再顾倾国的风度。周经理拍电报，叫鸿渐快到上海，否则交通断绝，要困守在家里。方老先生也觉得在这种时局里，儿子该快出去找机会，所以让鸿渐走了。以后这四个月里的事，从上海撤退到南京陷落，历史该如洛高（Fr.vonLogau）所说，把刺刀磨尖当笔，蘸鲜血当墨水，写在敌人的皮肤上当纸。方鸿渐失神落魄，一天看十几种报纸，听十几次无线电报告，疲乏垂绝的希望披沙拣金似的要在消息罅缝里找个苏息处。他和鹏图猜想家已毁了，家里人不知下落。阴历年底才打听出他们踪迹，方老先生的上海亲友便设法花钱接他们出来，为他们租定租界里的房子。一家人风了面唏嘘对泣。方老先生和凤仪嚷着买鞋袜；他们坐小船来时，路上碰见两个溃兵，抢去方老先生的钱袋，临走还逼方氏父子反脚上羊毛袜和绒棉鞋脱下来，跟他们的臭布袜子、破帆布鞋交换。方氏全家走个空身，只有方老太太棉袄里缝着两三千块钱的钞票，没给那两个兵摸到。旅沪同乡的商人素仰方老先生之名，送钱的不少，所以门户又可重新撑持。方鸿渐看家里人多房子小，仍住在周家，隔一两天到父母外请安。每回家，总听他们讲逃难时可怕可笑的经历；他们叙述描写的艺术似乎一次进步一次，鸿渐的注意和同情却听一次减退一些。方老先生因为拒绝了本县汉奸的引诱，有家难归，而政府并没给他什么名义，觉得他爱国而国不爱他，大有青年守节的孀妇不见宠于翁姑的怨抑。鸿渐在点金银行里气闷得很上海又没有多大机会，想有便到内地去。
　　阴历新年来了。上海的寓公们为国家担惊受恐够了，现在国家并没有亡，不必做未亡人，所以又照常热闹起来。一天，周太太跟鸿渐说，有人替他做媒，就是有一次鸿渐跟周经理出去应酬，同席一位姓张的女儿。据周太太说，张家把他八字要去了，请算命人排过，跟他们小姐的命“天作之合，大吉大利”。鸿渐笑说：“在上海这种开通地方，还请算命人来支配婚姻么？”周太太说，命是不可不信的，张先生请他去吃便晚饭，无妨认识那位小姐。鸿渐有点儿战前读书人的标劲，记得那张的在美国人洋会里做买办，不愿跟这种俗物往来，但转念一想，自己从出洋到现在，还不是用的市侩的钱？反正去一次无妨，结婚与否，全看自己中意不中意那女孩子，旁人勉强不来，答应去吃晚饭。这位张先生是浙江沿海人，名叫吉民，但他喜欢人唤他Jimmy.他在美国人花旗洋行里做了二十多年的事，从“写字”（小书记）升到买办，手里着实有钱。只生一个女儿，不惜工本地栽培，教会学校里所能传授熏陶的洋本领、洋习气，美容院理发铺所能帛造的洋时髦、洋姿态，无不应有尽有。这女儿刚十八岁，中学尚未毕业，可是张先生夫妇保有他们家乡的传统思想，以为女孩子到二十岁就老了，过二十没嫁掉，只能进古物陈列所供人凭吊了。张太太择婿很严，说亲的虽多，都没成功。有一个富商的儿子，也是留学生，张太太颇为赏识，婚姻大有希望，但一顿饭后这事再不提起。吃饭时大家谈到那几天因战事关系，租界封锁，蔬菜来源困难张太太便对那富商儿子说：“府上人多，每天伙食账不会小罢？”那人说自己不清楚，想来是多少钱一天。张太太说：“那么府上的厨子一定又老实，又能干！像我们人数不到府上一半，每天厨房开销也要那个数目呢！”那人听着得意，张太太等他饭毕走了，便说：“这种人家排场太小了！只吃那么多钱一天的菜！我女儿舒服惯的，过去吃不来苦！”婚事从此作罢。夫妇俩磋商几次，觉得宝贝女儿嫁到人家去，总不放心，不如招一个女婿到自己家里来。那天张先生跟鸿渐同席，回家说起，认为颇合资格：“家世头衔都不错，并且现在没真做到女婿已住在挂名丈人家里，将来招赘入门，易如反掌。更妙是方家经这番战事，摆不起乡绅人家臭架子，这女婿可以服服贴贴地养在张府上。结果张太太要鸿渐来家相他一下。
　　方鸿渐因为张先生请他早到谈谈，下午银行办公室完毕就去。马路上经过一家外国皮货铺子看见獭绒西装外套，新年廉价，只卖四百元。鸿渐常想有这样一件外套，留学时不敢买。譬如在伦敦，男人穿皮外套而没有私人汽车，假使不像放印子钱的犹太人或打拳的黑人，人家就疑心是马戏班的演员，再不然就是开窑子的乌龟；只有在维也纳，穿皮外套是常事，并且有现成的皮里子卖给旅客衬在外套里。他回国后，看穿的人很多，现在更给那店里的陈列撩得心动。可是盘算一下，只好叹口气。银行里薪水一百块钱已算不薄，零用尽够，丈人家供吃供住，一个钱不必贴，怎好向周经理要钱买奢侈品？回国所余六十多镑，这次孝敬父亲四十镑添买些家具，剩下不过所合四百余元。东凑西挪，一股脑儿花在这件外套上面，不大合算。国难时期，万事节约，何况天气不久回暖，就省了罢。到了张家，张先生热闹地欢迎道：“Hello！Doctor方，好久不见！”张先生跟外国人来往惯了，说话有个特征——也许在洋行、青年会、扶轮社等圈子里，这并没有什么奇特——喜欢中国话里夹无谓的英文字。他并无中文难达的新意，需要借英文来讲；所以他说话里嵌的英文字，还比不得嘴里嵌的金牙，因为金牙不仅妆点，尚可使用，只好比牙缝里嵌的肉屑，表示饭菜吃得好，此外全无用处。他仿美国人读音，维妙维肖，也许鼻音学得太过火了，不像美国人，而像伤风塞鼻子的中国人。他说“verywell”二字，声音活像小洋狗在咕噜——“vurrywul”。可惜罗马人无此耳福，否则决不单说R是鼻音的狗字母。当时张先生跟鸿渐拉手，问他是不是天天“godowntown”。鸿渐寒喧已毕，瞧玻璃橱里都是碗、瓶、碟子，便说：“张先生喜欢收藏磁器？”“Sure！havealooksee！”张先生打开橱门，请鸿渐赏鉴。鸿渐拿了几件，看都是“成化”、“宣德”、“康熙”，也不识真假，只好说：“这东西很值钱罢？”“Sure！值不少钱呢，Plentyofdough.并且这东西不比书画。买书画买了假的，一文不值，只等于wastepaper.磁器假的，至少还可以盛饭。我有时请外国friends吃饭，就用那个康熙窑”油底蓝五彩“大盘做saladdish，他们都觉得古色古香，菜的味道也有点old-time.”方鸿渐道：“张先生眼光一定好，不会买假东西。”张先生大笑道：“我不懂什么年代花纹，事情忙，也没工夫翻书研究。可是我有hunch；看见一件东西，忽然whatd”youcall灵机一动，买来准O.K.。他们古董掮客都佩服我，我常对他们说：“不用拿假货来fool我。Oyeah，我姓张的不是sucker，休想骗我！”“关上橱门，又说：”咦，headache——“便捺电铃叫用人。
　　鸿渐不懂，忙问道：“张先生不舒服，是不是？”张先生惊奇地望着鸿渐道：“谁不舒服？你？我？我很好呀！”鸿渐道：“张先生不是说”头痛“么？”张先生呵呵大笑，一面分付进来的女佣说：“快去跟太太小姐说，客人来了，请她们出来。makeitsnappy！”说时右手大拇指从中指弹在食指上“啪”的一响。他回过来对鸿渐笑道：“headache是美国话指”太太“而说，不是”头痛“！你没到States去过罢！”方鸿渐正自惭寡陋，张太太张小姐出来了，张先生为鸿渐介绍。张太太是位四十多岁的胖女人，外国名字是小巧玲珑的Tessie张小姐是十八岁的高大女孩子，着色鲜明，穿衣紧俏，身材将来准会跟她老太爷那洋行的资本一样雄厚。鸿渐没听清她名字，声音好像“我你他”，想来不是Anita，就是Juanita，她父母只缩短叫她Nita.张太太上海话比丈夫讲得好，可是时时流露本乡土音，仿佛罩褂太小，遮不了里面的袍子。张太太信佛，自说天天念十遍“白衣观世音咒”，求菩萨保佑中国军队打胜；又说这观音咒灵验得很，上海打仗最紧急时，张先生到外滩行里去办公，自己在家里念，果然张先生从没遭到流弹。鸿渐暗想享受了最新的西洋徉学设备，而竟抱这种信爷，坐在热水管烘暖的客堂里念佛，可见“西学为用，中学为体”并非难事。他和张小姐没有多少可谈，只好问她爱看什么电影。跟着两个客人来了，都是张先生的结义弟兄。一个叫陈士屏，是欧美烟草公司的高等职员，大家唤他Z.B.，仿佛德文里“有例为证”的缩写。一个叫丁讷生，外国名字倒不是诗人Tennyson而是海军大将Nelson，也在什么英国轮船公司做事。张太太说，人数凑得起一桌麻将，何妨打八圈牌再吃晚饭。方鸿渐赌术极幼稚，身边带钱又不多，不愿参加，宁可陪张小姐闲谈。经不起张太太再三怂恿，只好入局。没料到四圈之后，自己独赢一百余元，心中一动，想假如这手运继续不变，那獭绒大衣偈有指望了。这时候，他全忘了在船上跟孙先生讲的法国迷信，只要赢钱。八圈打毕，方鸿渐赢了近三百块钱。同局的三位，张太太、“有例为证”和“海军大将”一个子儿不付，一字不提，都站起来准备吃饭。鸿渐唤醒一句道：“我今天运气太好了！从来没赢过这许多钱。”张太太如梦初醒道：“咱们真糊涂了！还没跟方先生清账呢。陈先生，丁先生，让我一个人来付他，咱们回头再算得了。”便打开钱袋把钞票一五一十点交给鸿渐。吃的是西菜。“海军大将”信基督教，坐下以前，还向天花板眨白眼，感谢上帝赏饭。方鸿渐因为赢了钱，有说有笑。饭后散坐抽烟喝咖啡，他瞧风沙发旁一个小书架，猜来都是张小姐的读物。一大堆《西风》、原文《读者文摘》之外，有原文小字白文《莎士比亚全集》、《新旧约全书》、《家庭布置学》、翻版的《居里夫人传》、《照相自修法》、《我国与我民》等不朽大著以及电影小说十几种，里面不用说有《乱世佳人》。一本小蓝书，背上金字标题道：《怎样去获得丈夫而且守住他》（HowtogainaHusbandandkeephim）。鸿渐忍不住抽出一翻，只见一节道：“对男人该温柔甜蜜，才能在他心的深处留下好印象。女孩子们，别忘了脸上常带光明的笑容。”看到这里，这笑容从书上移到鸿渐脸上了。再看书面作者是个女人，不知出嫁没有，该写明“某某夫人”，这书便见得切身阅历之谈，想着笑容更廓大了。抬头忽见张小姐注意自己，忙把书放好，收敛笑容。“有例为证”要张小姐弹钢琴，大家同声附和。张小姐弹完，鸿渐要补救这令她误解的笑容，抢先第一个称“好”，求她再弹一曲。他又坐一会，才告辞出门。洋车到半路，他想起那书名，不禁失笑。丈夫是女人的职业，没有丈夫就等于失业，所以该牢牢捧住这饭碗。哼！我偏不愿意女人读了那本书当我是饭碗，我宁可他们瞧不起我，骂我饭桶。“我你他”小姐，咱们没有“举碗齐眉”的缘份，希望另有好运气的人来爱上您。想到这里，鸿渐顿足大笑，把天空月当作张小姐，向她挥手作别。洋车夫疑心他醉了，回头叫他别动，车不好拉。
　　客人全散了，张太太道：“这姓方的不合式，气量太小，把钱看得太重，给我一试就露出本相。他那时候好像怕我们赖账不还的，可笑不可笑？”张先生道：“德国货总比不上美国货呀。什么博士！还算在英国留过学，我说的英文，他好多听不懂。欧战以后，德国落伍了。汽车、飞机、打字机、照相机，哪一件不是美国花样顶新！我不爱欧洲留学生。”张太太道：“Nita，看这姓方的怎么样？”张小姐不能饶恕方鸿渐看书时的微笑，干脆说：“这人讨厌！你看他吃相多坏！全不像在外国住过的。他喝汤的时候，把面包去蘸！他吃铁排鸡，不用刀叉，把手拈了鸡腿起来咬！我全看在眼睛里。吓！这算什么礼貌？我们学校里教社交礼节的MissPrym瞧见了准会骂他猪猡相piggywiggy！”当时张家这婚事一场没结果，周太太颇为扫兴。可是方鸿渐小时是看《三国演义》、《水浒》、《西游记》那些不合教育原理的儿童读物的；他生得太早，还没福气捧读《白雪公主》、《木偶奇遇记》这一类好书。他记得《三国演义》里的名言：“妻子如衣服，”当然衣服也就等于妻子；他现在新添了皮外套，损失个把老婆才不放心上呢。
　　第三章也许因为战事中死人太多了，枉死者没消磨掉的生命力都迸作春天的生意。那年春天，所候特别好。这春所鼓动得人心像婴孩出齿时的牙龈肉，受到一种生机透芽的痛痒。上海是个暴发都市，没有山水花柳作为春的安顿处。公园和住宅花园里的草木，好比动物园里铁笼子关住的野兽，拘束、孤独，不够春光尽情的发泄。春来了只有向人身心里寄寓，添了疾病和传染，添了奸情和酗酒打架的案件，添了孕妇。最后一桩倒不失为好现象，战时人口正该补充。但据周太太说，本年生的孩子，大半是枉死鬼阳寿未尽，抢着投胎，找足前生年龄数目，只怕将来活长。
　　这几天来，方鸿渐白天昏昏想睡，晚上倒又清醒。早晨方醒，听见窗外树上鸟叫，无理由地高兴，无目的地期待，心似乎减轻重量，直长升上去。可是这欢喜是空的，像小孩子放的气球，上去不到几尺，便爆烈归于乌有，只留下忽忽若失的无名怅惘。他坐立不安地要活动，却颓唐使不出劲来，好比杨花在春风里飘荡，而身轻无力，终飞不远。他自觉这种惺忪迷怠的心绪，完全像填词里所写幽闺伤春的情境。现在女人都不屑伤春了，自己枉为男人，还脱不了此等刻板情感，岂不可笑！譬如鲍小姐那类女人，决没工夫伤春，但是苏小姐呢？她就难说了；她像是多愁善感的古美人模型。船上一别，不知她近来怎样。自己答应过去看她，何妨去一次呢？明知也许从此多事，可是实在生活太无聊，现成的女朋友太缺乏了！好比睡不着的人，顾不得安眠药片的害处，先要图眼前的舒服。
　　方鸿渐到了苏家，理想苏小姐会急忙跑进客堂，带笑带嚷，骂自己怎不早去看她。门房送上茶说：“小姐就出来。”苏家园里的桃花、梨花、丁香花都开得正好，鸿渐想现在才阴历二月底，花已经赶早开了，不知还剩些什么，留作清明春色。客堂一扇窗开着，太阳烘焙的花香，浓得塞鼻子，暖得使人头脑迷倦。这些花的香味，跟葱蒜的臭味一样，都是植物气息而有荤腥的肉感，像从夏天跳舞会上头发里发泄出来的。壁上挂的字画里有沈子培所写屏条，录的黄山谷诗，第一句道：“花气薰人欲破禅。”鸿渐看了，会心不远，觉得和尚们闻到窗外这种花香，确已犯戒，与吃荤相去无几了。他把客堂里的书画古玩反复看了三遍，正想沈子培写“人”字的捺脚活像北平老妈子缠的小脚，上面那样粗挺的腿，下面忽然微乎其微的一顿，就完事了，也算是脚的！苏小姐才出来。她冷淡的笑容　，像阴寒欲雪天的淡日，拉拉手，就：“方先生好久不见，今天怎么会来？”鸿渐想去年分别时拉手，何等亲热；今天握她的手像捏着冷血的鱼翅。分别时还是好好的，为什么重见面变得这样生分？这时候他的心理，仿佛临考抱佛脚的学生睡了一晚，发现自以为温熟的功课，还是生的，只好撒谎说，到上海不多几天，特来拜访。苏小姐礼貌周到地谢他“光临”，问他“在什么地方得意”。他嗫嚅说，还没找事，想到内地去，暂时在亲戚组织的银行里帮忙。苏小姐看他一眼道：“是不是方先生岳家开的银行？方先生，你真神秘！你什么时候吃喜酒的？咱们多年老同学了，你还瞒得一字不提。是不是得了博士回来结婚的？真是金榜挂名，洞房花烛，要算得双嘉临门了。我们就没福气瞻仰瞻仰方太太呀！”方鸿渐羞愧得无地自容，记起《沪报》那节新闻，忙说，这一定是从《沪报》看来的。便痛骂《沪报》一顿，把干丈人和假博士的来由用春秋笔法叙述一下，买假文凭是自己的滑稽玩世，认干亲戚是自己的和同随俗。还说：“我看见那消息，第一个就想到你，想到你要笑我，瞧不起我。我为这事还跟我那挂名岳父闹得很不欢呢。”苏小姐脸色渐转道：“那又何必呢！他们那些俗不可耐的商人，当然只知道付了钱要交货色，不会懂得学问是不靠招牌的。你跟他们计较些什么！那位周先生总算是你的尊长，待你也够好，他有权利在报上登那段新闻。反正谁会注意那段新闻，看到的人转背说忘了。你在大地方已经玩世不恭，倒向小节上认真，矛盾得太可笑了。”方鸿渐诚心佩服苏小姐说话漂亮，回答道：“给你这么一说，我就没有亏心内愧的感觉了。我该早来告诉你的，你说话真通达！你说我在小节上看不开，这话尤其深刻。世界上大事情像可以随便应付，偏是小事倒丝毫假借不了。譬如贪官污吏，纳贿几千万，而决不肯偷人家的钱袋。我这幽默的态度，确不彻底。”苏小姐想说：“这话不对。不偷钱袋是因为钱袋不值得偷；假如钱袋里容得几千万，偷了跟纳贿一样的安全，他也会偷。”可是她这些话不说出来，只看了鸿渐一眼，又注视地毯上的花纹道：“亏得你那玩世的态度不彻底，否则跟你做朋友的人都得寒心，怕你也不过面子上敷衍，心里在暗笑他们了。”鸿渐忙言过其实地担保，他怎样把友谊看得重。这样谈着，苏小姐告诉他，她父亲已随政府入蜀，她哥哥也到香港做事，上海家里只剩她母亲、嫂子和她，她自己也想到内地去。方鸿渐说，也许他们俩又可以同路苏小姐说起有位表妹，在北平他们的母校里读了一年，大学因战事内迁，她停学在家半年，现在也计划复学。这表妹今天恰到苏家来玩，苏小姐进去叫她出来，跟鸿渐认识，将来也是旅行伴侣。
　　苏小姐领了个二十左右的娇小女孩子出来，介绍道：“这是我表妹唐晓芙。”唐小姐妩媚端正的圆脸，有两个浅酒涡。天生着一般女人要花钱费时、调脂和粉来仿造的好脸色，新鲜得使人见了忘掉口渴而又觉嘴馋，仿佛是好水果。她眼睛并不顶大，可是灵活温柔，反衬得许多女人的大眼睛只像政治家讲的大话，大而无当。古典学者看她说笑时露出的好牙齿，会诧异为什么古今中外诗人，都甘心变成女人头插的钗，腰束的带，身体睡的席，甚至脚下践踏的鞋，可是从没想到化作她的牙刷。她头发没烫，眉毛不镊，口红也没有擦，似乎安心遵守天生的限止，不要弥补造化的缺陷。总而言之，唐小姐是摩登文明社会里那桩罕物——一个真正的女孩子。有许多都市女孩子已经是装模做样的早熟女人，算不得孩子；有许多女孩子只是浑沌痴顽的无性别孩子，还说不上女人。方鸿渐立刻想在她心上造个好印象。唐小姐尊称他为“同学老前辈”，他抗议道：“这可不成！你叫我”前辈“，我已经觉得像史前原人的遗骸了。你何必又加上”老“字？我们不幸生得太早，没福气跟你同时同学，这是恨事。你再叫我”前辈“，就是有意提醒我是老大过时的人，太残忍了！”唐小姐道：“方先生真会挑眼！算我错了，”老“字先取消。”苏小姐同时活泼地说：“不羞！还要咱们像船上那些人叫你”小方“么？晓芙，不用理他。他不受抬举，干脆什么都不叫他。”方鸿渐看唐小姐不笑的时候，脸上还依恋着笑意，像音乐停止后袅袅空中的余音。许多女人会笑得这样甜，但她们的笑容只是面部肌肉柔软操，仿佛有教练在喊口令：“一！”忽然满脸堆笑，“二！”忽然笑不知去向，只余个空脸，像电影开映前的布幕。他找话出跟她讲，问她进的什么系。苏小姐不许她说，说：“让他猜。”方鸿渐猜文学不对，教育也不对，猜化学物理全不对，应用张吉民先生的话道：“Searchme！难道读的是数学？那太利害了！”唐小姐说出来，原来极平常的是政治系。苏小姐注一句道：“这才利害呢。将来是我们的统治者，女官。”方鸿渐说：“女人原是天生的政治动物。虚虚实实，以退为进，这些政治手腕，女人生下来全有。女人学政治，那真是以后天发展先天，锦上添花了。我在欧洲，听过ErnstBergmann先生的课。他说男人有思想创造力，女人有社会活动力，所以男人在社会上做的事该让给女人去做，男人好躲在家里从容思想，发明新科学，产生新艺术。我看此话甚有道理。女人不必学政治，而现在的政治家要成功，都得学女人。政治舞台上的戏剧全是反串。”苏小姐道：“这是你那位先生故作奇论，你就喜欢那一套。”方鸿渐道：“唐小姐，你表姐真不识抬举，好好请她女子参政，她倒笑我故作奇论！你评评理看。老话说，要齐家而后能治国平天下。请问有多少男人会管理家务的？管家要仰仗女人，而自己吹牛说大丈夫要治国平天下，区区家务不屑理会，只好比造房子要先向半空里盖个屋顶。把国家社会全部交给女人有许多好处，至少可以减少战争。外交也许更复杂，秘密条款更多，可是女人因为身体关系，并不擅长打仗。女人对于机械的头脑比不上男人，战争起来或者使用简单的武器，甚至不过揪头发、抓头皮、拧肉这些本位武化，损害不大。无论如何，如今新式女人早不肯多生孩子了，到那时候她们忙着干国事，更没工夫生产，人口稀少，战事也许根本不会产生。”唐小姐感觉方鸿渐说这些话，都为着引起自己对他的注意，心中暗笑，说：“我不知道方先生是侮辱政治还是侮辱女人，至少都不是好话。”苏小姐道：“好哇！拐了弯拍了人家半天的马屁，人家非但不领情，根本就没有懂！我劝你少开口罢。”唐小姐道：“我并没有不领情。我感激得很方先生肯为我表演口才。假使我是学算学的，我想方先生一定另有议论，说女人是天生的计算动物。”苏小姐道：“也许说你这样一个人肯念算学，他从此不厌恨算学。反正翻来覆去，强词夺理，全是他的话。我从前并不知道他这样油嘴。这次同回国算领教了。大学同学的时候，他老远看见我们脸就涨红，愈走近脸愈红，红得我们瞧着都身上发难过。我们背后叫他”寒暑表“，因为他脸色忽升忽降，表示出他跟女学生距离的远近，真好玩儿！想不到外国去了一趟，学得这样厚皮老脸，也许混在鲍小姐那一类女朋友里训练出来的。”方鸿渐慌忙说：“别胡说！那些事提它干吗？你们女学生真要不得！当了面假正经，转背就挖苦得人家体无完肤，真缺德！”苏小姐看他发急，刚才因为他对唐小姐卖开的不快全消散了，笑道：“瞧你着急得那样子！你自己怕不是当面花言巧语，背后刻薄人家。”这时候进来一个近三十岁，身材高大、神气轩昂的人。唐小姐叫他“赵先生”，苏小姐说：“好，你来了，我跟你们介绍：方鸿渐，赵辛楣。”赵辛楣和鸿渐拉拉手，傲兀地把他从头到脚看一下，好像鸿渐是页一览而尽的大字幼稚园读本，问苏小姐道：“是不是跟你同船回国的那位？”鸿渐诧异，这姓赵的怎　知道自己，忽然想也许这人看过《沪报》那条新闻，立刻局促难受。那赵辛楣本来就神气活现，听苏小姐说鸿渐确是跟她同船回国的，他的表情说仿佛鸿渐化为稀淡的空气，眼睛里没有这人。假如苏小姐也不跟他讲话，鸿渐真要觉得自己子虚乌有，像五更鸡啼时的鬼影，或道家“视之不见，抟之不得”的真理。苏小姐告诉鸿渐，赵辛楣和她家是世交，美国留学生，本在外交公署当处长，因病未随机关内迁，如今在华美新闻社做政治编辑。可是她并没向赵辛楣叙述鸿渐的履历，好像他早已知道，无需说得。
　　赵辛楣躺在沙发里，含着烟斗，仰面问天花板上挂的电灯道：“方先生在什么地方做事呀？”方鸿渐有点生气，想不理他不可能，“点金银行”又叫不响，便含糊地说：“暂时在一家小银行里做事。”赵辛楣鉴赏着口里吐出来的烟圈道：“大材小用，可惜可惜！方先生在外国学的是什么呀？”鸿渐没好气道：“没学什么。”苏小姐道：“鸿渐，你学过哲学，是不是？”赵辛楣喉咙里干笑道：“从我们干实际工作的人的眼光看来，学哲学跟什么都不学全没两样。”“那么提赶快找个眼科医生，把眼光验一下；会这样东西的眼睛，一定有毛病。”方鸿渐为掩饰斗口的痕迹，有意哈哈大笑。赵辛楣以为他讲了俏皮话而自鸣得意，一时想不出回答，只好狠命抽烟。苏小姐忍住笑，有点不安。只唐小姐云端里看厮杀似的，悠远淡漠地笑着。鸿渐忽然明白，这姓赵的对自己无礼，是在吃醋，当自己是他的情敌。苏小姐忽然改口，不叫“方先生”而叫“鸿渐”，也像有意要姓赵的知道她跟自己的亲密。想来这是一切女人最可夸傲的时候，看两个男人为她争斗。自己何苦空做冤家，让赵辛楣去爱苏小姐得了！苏小姐不知道方鸿渐这种打算；她喜欢赵方二人斗法比武抢自己，但是她担心交战得太猛烈，顷刻就分胜负，二人只剩一人，自己身边就不热闹了。她更担心败走的偏是方鸿渐；她要借赵辛楣来激发方鸿渐的勇气，可是方鸿渐也许像这几天报上战事消息所说的，“保持实力，作战略上的撤退。”赵辛楣的父亲跟苏文纨的父亲从前是同僚，民国初元在北京合租房子住。辛楣和苏小姐自小一起玩。赵老太太肚子里怀着他，人家以为她准生双胞。他到四五岁时身体长大得像七八岁，用人每次带他坐电车，总得为“五岁以下孩童免票”的事跟卖票人吵嘴。他身大而心不大，像个空心大萝卜。在小学里，他是同学们玩笑的目标，因为这样庞大的箭垛子，放冷箭没有不中的道理。他和苏小姐兄妹们游戏“官打捉贼”，苏小姐和她现在已出嫁的姐姐，女孩子们跑不快，拈着“贼”也硬要做“官”或“打”，苏小姐哥哥做了“贼”要抗不受捕，只有他是乖乖挨“打”的好“贼”。玩红帽儿那故事，他老做狼；他吃掉苏小姐姊妹的时候，不过抱了她们睁眼张口做个怪样，到猎人杀狼破腹，苏小姐哥哥按他在泥里，要抠他肚子，有一次真用剪刀把他衣服都剪破了。他脾气虽好，头脑并不因此而坏。他父亲信算命相面，他十三四岁时带他去见一个有名的女相士，那女相士赞他：“火星方，土形厚，木声高，牛眼，狮鼻，棋子耳，四字口，正合《麻衣相法》所说南方贵宦之相，将来名位非凡，远在老子之上。”从此他自以为政治家。他小时候就偷偷喜欢苏小姐，有一年苏小姐生病很危脸，他听父亲说：“文纨的病一定会好，她是官太太的命，该有二十五年”帮夫运“呢。”他武断苏小姐命里该帮助的丈夫，就是自己，因为女相士说自己要做官的。这次苏小姐初到家，开口闭口都是方鸿渐，第五天后忽然绝口不提，缘故是她发见了那张旧《沪报》，眼明心细，注意到旁人忽略的事实。她跟辛楣的长期认识并不会日积月累地成为恋爱，好比冬季每天的气候罢，你没法把今天的温度加在昨天的上面，好等明天积成个和暖的日。他最擅长用外国话演说，响亮流利的美国话像天心里转滚的雷，擦了油，打上蜡，一滑就是半个上空。不过，演讲是站在台上，居高临下的；求婚是矮着半身子，仰面恳请的。苏小姐不是听众，赵辛楣有本领使不出来。
　　赵辛楣对方鸿渐虽有醋意，并无什么你死我活的仇恨。他的傲慢无礼，是学墨索里尼和希特勒接见小国外交代表开谈判时的态度。他想把这种独裁者的威风，压倒和吓退鸿渐。给鸿渐顶了一句，他倒不好像意国统领的拍桌大吼，或德国元首的扬拳示威。辛而他知道外交家的秘诀，一时上对答不来，把嘴里抽的烟卷作为遮掩的烟幕。苏小姐忙问他战事怎样，他便背诵刚做好的一篇社论，眼里仍没有方鸿渐，但又提防着他，恰像慰问害传染病者的人对细菌的态度。鸿渐没兴趣听，想跟唐小姐攀谈，可是唐小姐偏听得津津有味。鸿渐准备等唐小姐告辞，自己也起身，同出门时问她住址。辛楣讲完时局看手表说：“现在快五点了，我到报馆溜一下，回头来接你到峨嵋春吃晚饭。你想吃川菜，这是最好的四川馆子，跑堂都认识我——唐小姐，请你务必也赏面子——方先生有兴也不妨来凑热闹，欢迎得很。”苏小姐还没回答，唐小姐和方鸿渐都说时候不早，该回家了，谢辛楣的盛意，晚饭心领。苏小姐说：“鸿渐，你坐一会，我还有几句话跟你讲——辛楣，我今儿晚上要陪妈妈出去应酬，咱们改天吃馆子，好不好？明天下午四点半，请你们都来喝茶，陪陪新回国的沈先生沈太太，大家可以谈谈。”赵辛楣看苏小姐留住方鸿渐，奋然而出。方鸿渐站起来，原想跟他拉手，只好又坐下去。“这位赵先生真怪！好像我什么地方开罪了他似的，把我恨得形诸词色。”“你不是也恨着他么？”唐小姐狡猾地笑说。苏小姐脸红，骂她：“你这人最坏！”方鸿渐听了这句话，要否认他恨赵辛楣也不敢了，只好说：“苏小姐，明天茶会谢谢罢。我不想来。”唐小姐没等苏小姐开口，便说：“那不成！我们看戏的人可以不来；你是做戏的人，怎么好不来？”苏小姐道：“晓芙！你再胡说，我从此不理你。你们两个明天都得来！”唐小姐坐苏家汽车走了。鸿渐跟苏小姐两人相对，竭力想把话来冲淡，疏通这亲密得使人窒息的空气：“你表妹说话很利害，人也好像非常聪明。”“这孩子人虽小，本领大得很，她抓一把男朋友在手里玩弄着呢！”——鸿渐脸上遮不住的失望看得苏小姐心里酸溜溜的——“你别以为她天真，她才是满肚子鬼主意呢！我总以为刚进大学就谈恋爱的女孩子，不会有什么前途。你想，跟男孩子们混在一起，搅得昏天黑地，哪有工夫念书。咱们同亘的黄璧、蒋孟是，你不记得么？现在都不知道哪里去了！”方鸿渐忙说记得：“你那时候也红得很可是你自有那一种高贵的气派，我们只敢远远的仰慕着你。我真梦想不到今天会和你这样熟。”苏小姐心里又舒服了。谈了些学校旧事，鸿渐看她并没有重要的话跟自己讲，便说：“我该走了，你今天晚上还得跟伯母出去应酬呢。”苏小姐道：“我并没有应酬，那是托词，因为辛楣对你太无礼了，我不愿意长他的骄气。”鸿渐惶恐道：“你对我太好了！”苏小姐瞥他一眼低下头道：“有时候我真不应该对你那样好。”这时空气里蠕动着他该说的情话，都扑凑向他嘴边要他说。他不愿意说，而又不容静默。看见苏小姐搁在沙发边上的手，便伸手拍她的手背。苏小姐送到客堂门口，鸿渐下阶，她唤“鸿渐”，鸿渐回来问她有什么事，她笑道：“没有什么。我在这儿望你，你为什么直望前跑，头都不回？哈哈，我真是没道理女人，要你背后生眼睛了——明天早些来。”方鸿渐出了苏家，自觉已成春天的一部分，沆瀣一气，不是两小时前的春天门外汉了。走路时身体轻得好像地面在浮起来。只有两件小事梗在心里消化不了。第一，那时候不该碰苏小姐的手，应该假装不懂她言外之意的；自己总太心软，常迎合女人，不愿触犯她们，以后言动要斩截些，别弄假成真。第二，唐小姐的男朋友很多，也许已有爱人。鸿渐气得把手杖残暴地打道旁的树。不如趁早死了心罢，给一个未成年的女孩子甩了，那多丢脸！这样惘惘不甘地跳上电车，看见邻座一对青年男女喁喁情话。男孩子身上放着一堆中学教科书，女孩子的书都用电影明星照相的包书纸包着。那女子不过十六七岁，脸化妆得就像搓油摘粉调胭脂捏出来的假面具。鸿渐想上海不愧是文明先进之区，中学女孩子已经把门面油漆粉刷，招徕男人了，这是外国也少有的。可是这女孩子的脸假得老实，因为决没人相信贴在她脸上的那张脂粉薄饼会是她的本来面目。他忽然想唐小姐并不十妆饰。刻意打扮的女孩子，或者是已有男朋友，对自己的身体发生了新兴趣，发现了新价值，或者是需要男朋友，挂个鲜明的幌子，好刺眼射目，不致遭男人忽略。唐小姐无意修饰，可见心里并没有男人，鸿渐自以为这结论有深刻的心理根据，合严密的逻辑推理，可以背后批Q.E.D.的。他快活得坐不安位。电车到站时，他没等车停就抢先跳下来，险的摔一交，亏得撑着手杖，左手推在电杆木上阻住那扑向地的势头。吓出一身冷汗，左手掌擦去一层油皮，还给电车司机训了几句。回家手心涂了红药水，他想这是唐晓芙害自己的，将来跟她细细算账，微笑从心里泡沫似地浮上脸来，痛也忘了。他倒不想擦去皮是这只手刚才按在苏小姐手上的报应。
　　明天他到苏家，唐小姐已先到了。他还没坐定，赵辛楣也来了，招呼后说：“方先生，昨天去得迟，今天来得早。想是上银行办公养成的好习惯，勤勉可嘉，佩服佩服！”“过奖，过奖！”方鸿渐本想说辛楣昨天早退，今天迟到，是学衙门里上司的官派，一转念，忍住不说，还对辛楣善意地微笑。辛楣想不到他会这样无的抵抗，反有一拳打个空的惊慌。唐小姐藏不了脸上的诧异。苏小姐也觉得奇怪，但忽然明白这是胜利者的大度，鸿渐知道自己爱的是他，所以不与辛楣计较了。沈氏夫妇也来了。乘大家介绍寒喧的时候，赵辛楣拣最近苏小姐沙发坐下，沈氏夫妇合坐一张长沙发，唐小姐坐在苏小姐和沈先生坐位中间的一个绣垫上，鸿渐孤零零地近太太坐了。一坐下去，他后悔无及，因为沈太太身上有一股味道，文言里的雅称跟古罗马成语都借羊来比喻：“愠羝。”这暖烘烘的味道，搀了脂粉香和花香，熏得方鸿渐泛胃，又不好意思抽烟解秽。心里想这真是从法国新回来的女人，把巴黎大菜场的“臭味交响曲”都带到中国来了，可见巴黎大而天下小。沈太太生得怪样，打扮得妖气。她眼睛下两个黑袋，像圆壳行军热水瓶，想是储蓄着多情的热泪，嘴唇涂的浓胭脂给唾沫进了嘴，把黯黄崎岖的牙齿染道红痕，血淋淋的像侦探小说里谋杀案的线索，说话常有“Tiens！”“O　la，la！”那些法文慨叹，把自己身躯扭摆出媚态柔姿。她身体动一下，那气味又添了新的一阵。鸿渐恨不能告诉她，话用嘴说就够了，小心别把身体一扭两段。沈先生下唇肥厚倒垂，一望而知是个说话多而快像嘴里在泻肚子下痢的人。他在讲他怎样向法国人作战事宣传，怎样博得不少人对中国的同情：“南京撤退以后，他们都说中国完了。我对他们说：”欧洲大战的时候，你们政府不是也迁都离开巴黎么？可是你们是最后的胜利者。“他没有话讲，唉，他们没有话讲。”鸿渐想政府可以迁都，自己倒不能换座位。
　　赵辛楣专家审定似的说：“回答得好！你为什么不做篇文章？”“薇蕾在《沪报》上发表的外国通讯里，就把我这一段话记载进去，赵先生没看见么？”沈先生稍微失望地问。
　　沈太太扭身子向丈夫做个挥手姿势，娇笑道：“提我那东西干吗？有谁会注意到！”辛楣忙说：“看见，看见！佩服得很。想起来了，通讯里是有迁都那一段话——”鸿渐道：“我倒没有看见，叫什么题目？”辛楣说：“你们这些哲学家研究超时间的问题，当然不看报的。题目是——咦，就在口边，怎么一时想不起？”他根本没看那篇通讯，不过他不愿放弃这个扫鸿渐面子的机会。
　　苏小姐道：“你不能怪他，他那时候也许还逃躲在乡下，报都看不见呢。鸿渐，是不是？题目很容易记的：《给祖国姊妹们的几封信》，前面还有大字标题，好像是：《亚洲碧血中之欧洲青岛》，沈太太，我没记错罢？”辛楣拍大腿道：“对，对，对！《给祖国姊妹们的几封信》，《亚洲碧血中之欧洲青岛》，题目美丽极了！文纨，你记性真好！”沈太太道：“这种见不得人的东西都亏你记得。无怪认识的人都推你是天才。”苏小姐道：“好东西不用你去记，它自会留下很深的印象。”唐小姐对鸿渐道：“那是沈太太写给我们女人看的，你是”祖国的兄弟们“，没注意到，可以原谅。”沈太太年龄不小，她这信又不是写给“祖国的外甥女、侄女、侄孙女”的，唐小姐去看它，反给它攀上姊妹。
　　辛楣为补救那时候的健忘，恭维沈太太，还说华美新闻社要发行一种妇女刊物，请她帮忙。沈氏夫妇跟辛楣愈亲热了。用人把分隔餐室和客堂的幔拉开，苏小姐请大家进去用点心，鸿渐如罪人蒙赦。他吃完回到客堂里，快傍着唐小姐坐了，沈太太跟赵辛楣谈得拆不开；辛楣在伤风，鼻子塞着，所以敢接近沈太太。沈先生向苏小姐问长问短，意思要“苏老伯”为他在香港找个位置。方鸿渐自觉本日运气转好，苦尽甘来，低低问唐小姐道：“你方才什么都不吃，好像身子不舒服，现在好了没有？”唐小姐道：“我得很多，并没有不舒服呀！”“我又不是主人，你不用向我客套。我明看见你喝了一口汤，就皱眉头就匙儿弄着，没再吃东西。”“吃东西有什么好看？老瞧着，好意思么？我不愿意吃给你看，所以不吃，这是你害我的——哈哈，方先生，别当真，我并没知道你在看旁人吃。我问你，你那时候坐在沈太太身边，为什么别着脸，紧闭了嘴，像在受罪？”“原来你也是这个道理！”方鸿渐和唐小姐亲密地笑着，两人已成了患难之交。
　　唐小姐道：“方先生，我今天来了有点失望——”“失望！你希望些什么？那味道还不够利害么？”“不是那个。我以为你跟赵先生一定很热闹，谁知道什么都没有。”“抱歉得很没有好戏做给你看。赵先生误解了我跟你表姐的关系——也许你也有同样的误解——所以我今天让他挑战，躲着不还手，让他知道我跟他毫无利害冲突。”“这话真么？只要表姐有个表示，这误解不是就弄明白了？”“也许你表姐有她的心思，遣将不如激将，非有大敌当前，赵先生的本领不肯显出来。可惜我们这种老弱残兵，不经打，并且不愿打——”“何妨做志愿军呢？”“不，简直是拉来的夫子。”说着，方鸿渐同时懊恼这话太轻佻了。唐小姐难保不讲给苏小姐听。
　　“可是，战败者常常得到旁人更大的同情——”唐小姐觉得这话会引起误会，红着脸——“我意思说，表姐也许是助弱小民族的。”鸿渐快乐得心少跳了一跳：“那就顾不得了。唐小姐，我想请你跟你表姐明天吃晚饭，就在峨嵋春，你肯不肯赏脸？”唐小姐踌躇还没答应，鸿渐继续说：“我知道我很大胆冒味。你表姐说你朋友很多，我不配高攀，可是很想在你的朋友里凑个数目。”“我没有什么朋友，表姐在胡说——她跟你怎么说呀？”“她并没讲什么，她只讲你善于交际，认识不少人。”“这太怪了！我才是不见世面的乡下女孩子呢。”“别客气，我求你明天来。我想去吃，对自己没有好借口，借你们二位的名义，自己享受一下，你就体贴下情，答应了罢！”唐小姐笑道：“方先生，你说话里都是文章。这样，我准来。明天晚上几点钟？”鸿渐告诉了她钟点，身心舒泰，只听沈太太朗朗说道：“我这次出席世界妇女大会，观察出来一种普遍动态：全世界的女性现在都趋向男性方面——”鸿渐又惊又笑，想这是从古已然的道理，沈太太不该到现在出席了妇女大会才学会——“从前男性所做的职业，国会议员、律师、报馆记者、飞机师等等，女性都会做，而且做得跟男性一样好。有一位南斯拉夫的女性社会学家在大会里演讲，说除掉一部分甘心做贤妻良母的女性以外，此外的职业女性可以叫”第三性“。女性解放还是新近的事实，可是已有这样显著的成绩。我敢说，在不久的将来，男女两性的分别要成为历史上的名词。”赵辛楣：“沈太太，你这话对。现在的女真能干！文纨，就像徐宝琼徐小姐，沈太太认识她罢？她帮她父亲经营那牛奶声，大大小小的事，全是她一手办理，外表斯文柔弱，全看不出来！”鸿渐跟唐且说句话，唐小姐忍不住笑出声来。苏且本在说：“宝琼比她父亲还精明，简直就是牛奶场不出面的经理——”看不入眼鸿渐和唐小姐的密切，因就：“晓芙，有什么事那样高兴？”唐小姐摇头只是笑。苏小姐道：“鸿渐，有笑话讲出来大家听听。”鸿渐也摇不说，这更显得他跟唐小姐两口儿平分着一个秘密，苏小姐十分不快。赵辛楣做出他最成功的轻鄙表情道：“也许方大哲学家在讲解人生哲学里的乐观主义，所以唐小姐听得那么乐。对不对，唐小姐？”方鸿渐不理他，直接对苏小姐说：“我听赵先生讲，他从外表上看不出那位徐小姐是管理牛奶场的，我说，也许赵先生认为她应该头上长两只牛角，那就一望而知是什么人了。否则，外表上无论如何看不出的。”赵辛楣道：“这笑话讲得不通，头上长角，本身就变成牛了，怎会表示出是牛奶场的管理人！”说完，四顾大笑。他以为方鸿渐又给自己说倒，想今天得再接再厉，决不先退，盘恒那姓方的走了才起身，所以他身子向沙发上坐得更深陷些。方鸿渐目的已达，不愿逗留，要乘人多，跟苏小姐告别容易些。苏小姐因为鸿渐今天没跟自己亲近，特送他到走廊里，心理好比冷天出门，临走还要向火炉前烤烤手。
　　鸿渐道：“苏小姐，今天没机会多跟你讲话。明天晚上你有空么？我想请你吃晚饭，就在峨嵋春，我不希罕赵辛楣请！只恨我比不上他是老主顾，菜也许不如他会点。”苏小姐听他还跟赵辛楣在怄气，心里宽舒，笑说：“好！就咱们两个人么？”问了有些害羞，觉得这无需问得。
　　方鸿渐讷讷道：“不，还有你表妹。”“哦，有她。你请她了没有？”“请过她了，她答应来——来陪你。”“好罢，再见。”苏小姐临别时的态度，冷缩了方鸿渐的高兴。他想这事势难两全，只求做得光滑干净，让苏小姐的爱情好好的无疾善终。他叹口气，怜悯苏小姐。自己不爱她，而偏为她弄得心软，这太不公道！她太取巧了！她不应当这样容易受伤，她该熬住不叫痛。为什么爱情会减少一个人心灵的抵抗力，使人变得软弱，被摆布呢？假如上帝真是爱人类的，他决无力量做得起主宰。方鸿渐这思想若给赵辛楣知道，又该挨骂“哲学家闹玄虚”了。他那天晚上的睡眠，宛如粳米粉的线条，没有粘性，拉不长。他的快乐从睡梦里冒出来，使他醒了四五次，每醒来就像唐晓芙的脸在自己眼前，声音在自己耳朵里。他把今天和她谈话时一字一名，一举一动都将心熨贴着，迷迷糊糊地睡去，一会儿又惊醒，觉得这快乐给睡埋没了，忍住不睡，重新温一遍白天的景象。最后醒来，起身一看，是个嫩阴天。他想这请客日子拣得不安全，恨不能用吸墨水纸压干了天空淡淡的水云。今天星期一是银行里例的忙日子，他要到下午六点多钟，才下办公室，没工夫回家换了衣服再上馆子，所以早上出门前就打扮好了。设想自己是唐小姐，用她的眼睛来审定着衣镜里自己的仪表。回国不到一年，额上添了许多皱纹，昨天没睡好，脸色眼神都萎靡黯淡。他这两天有了意中人以衙，对自己外表上的缺点，知道得不宽假地详尽，仿佛只有一套出客衣服的穷人知道上面每一个斑渍和补钉。其实旁人看来，他脸色照常，但他自以为今天特别难看，花领带补得脸黄里泛绿，换了三次领带才下去吃早饭。周先生每天这时候还不起床，只有他跟周太太、效成三人吃着。将要吃完，楼上电话铃响，这电话就装在他卧室外面，他在家时休想耳根清净。他常听到心烦，以为他那未婚妻就给这电话的“盗魂铃”送了性命。这时候，女用人下来说：“方少爷电话，姓苏，是个女人。”女用说着，她和周太太、效成三人眼睛里来往的消息，忙碌得能在空气里起春水的觳纹。鸿渐想不到苏小姐会来电话，周太太定要问长问短了，三脚两步上去接，只听效成大声道：“我猜就是那苏文纨。”这孩子前天在本国史班上，把清朝国姓“爱新觉罗”错记作“亲爱保罗”，给教师痛骂一顿，气得今天赖学在家，偏是苏小姐的名字他倒过目不忘。
　　鸿渐拿起听筒，觉得整个周家都在屏息旁听，轻声道：“苏小姐哪？我是鸿渐。”“鸿渐，我想这时候你还不会出门，打个电话给你。我今天身体不舒服，晚上峨嵋春不能去了，抱歉得很！你不要骂我。”“唐小姐去不去呢？”鸿渐话出口就后悔。
　　斩截地：“那可不知道。”又幽远地：“她自然去呀！”“你害的什么病，严重不严重？”鸿渐知道已经问得迟了。
　　“没有什么，就觉得累，懒出门。”这含意是显然了。
　　“我放了心了。你好好休养罢，我明天一定来看你。你爱吃什么东西？”“谢谢你，我不要什么——”顿一顿——“那么明天见。”苏小姐那面电话挂上，鸿渐才想起他在礼貌上该取消今天的晚饭，改期请客的。要不要跟苏小姐再通个电话，托她告诉唐小姐晚饭改期？可是心里实在不愿意。正考虑着，效成带跳带跑，尖了嗓子一路叫上来道：“亲爱的蜜斯苏小姐，生的是不是相思病呀？”你爱吃什么东西？“”我爱吃大饼、油条、五香豆、鼻涕干、臭咸鲞“——”鸿渐大喝一声拖住，截断了他代开的食单，吓得他讨饶。鸿渐轻打一拳，放他走了，下去继续吃早饭。周太太果然等着他，盘问个仔细，还说：“别忘了要拜我做干娘。”鸿渐忙道：“我在等你收干女儿呢。多收几个，有挑选些。这苏小姐不过是我的老同学，并无什么关系，你放着心。”天气渐转晴朗，而方鸿渐因为早晨那电话，兴致大减，觉得这样好日子撑负不起，仿佛篷帐要坍下来。苏小姐无疑地在捣乱，她不来更好，只剩自己跟唐小姐两人。可是没有第三者，唐小姐肯来么？昨天没向她要住址和电话号数，无法问她知道不知道苏小姐今晚不来。苏小姐准会通知她，假使她就托苏小姐转告也不来呢？那就糟透了！他在银行里帮王主任管文书，今天满腹心事，拟的信稿子里出了几外毛病，王主任动笔替他改了，呵呵笑说：“鸿渐兄，咱们老公事的眼光不错呀！”到六点多钟，唐小姐毫无音信，他慌起来了，又不敢打电话问苏小姐。七点左右，一个人怏怏地踱到峨嵋春，要了间房间，预备等　它一个半钟头，到时唐小姐还不来，只好独吃。他虽然耐心等着，早已不敢希望。点了一支烟，又捺来了；晚上凉不好大开窗子，怕满屋烟味，唐小姐不爱闻。他把带到银行里空看的书翻开，每个字都认识，没一句有意义。听见外面跑堂招呼客人的声音，心就直提上来。约她们是七点半，看表才七点四十分，决不会这时候到——忽然门帘揭开，跑堂站在一旁，进来了唐小姐。鸿渐心里，不是快乐，而是感激，招呼后道：“扫兴得很苏小姐今天不能来。”“我知道。我也险的不来，跟你打电话没打通。”“我感谢电话公司，希望它营业发达，电线忙得这种临时变卦的电话都打不通。你是不是打到银行里去的？”“不，打到你府上去的。是这么一回事。一清早表姐就来电话说她今天不来吃晚饭，已经通知你了。我说那么我也不来，她要我自己跟你讲，把你的电话号数告诉了我。我摇通电话，问：”是不是方公馆？“那面一个女人声音，打着你们家乡话说——唉，我学都学不来——说：”我们这儿是周公馆，只有一个姓方的住在这儿。你是不是苏小姐，要找方鸿渐？鸿渐出门啦，等他回来，我叫他打电话给你。苏小姐，有空到舍间来玩儿啊，鸿渐常讲起你是才貌双全——“一口气讲下去，我要分辩也插不进嘴。我想这迷汤灌错了耳朵，便不客气把听筒挂上了。这一位是谁？”“这就是我亲戚周太太，敝银行的总经理夫人。你表姐在我出门前刚来过电话，所以周太太以为又是她打的。”“啊哟，不得了！她一定要错怪我表姐无礼了。我听筒挂上不到五分钟，表姐又来电话，问我跟你讲了没有，我说你不在家，她就把你银行里的电话号数告诉我。我想你那时候也许还在路上，索性等一会再打。谁知道十五钟以后，表姐第三次来电话，我有点生气了。她知道我还没有跟你通话，催我快打电话，说趁早你还没有定座，我说定了座就去吃，有什么大关系。她说不好，叫我上她家去吃晚饭。我回她说，我也不舒服，什地方都不去。衙来想想，表姐太可笑了！我偏来吃你的饭，所以电话没有打。”鸿渐道：“唐小姐，你今天简直是救苦救难，不但赏面子。我做主人的感恩不尽，以后要好好的多请几次。请的客一个都不来，就无异主人在社交生活上被判死刑。今天险透了！”方鸿渐点了五六个人吃的菜。唐小姐问有旁的客人没没两个人怎吃得下这许多东西。方鸿渐说菜并不多。唐小姐道：“你昨天看我没吃点心，是不是今天要试验我吃不吃东西？”鸿渐知道她不是妆样的女人，在宴会上把嘴收束得像眼药水瓶口那样的小，回答说：“我吃这馆子是第一次，拿不稳什么菜最配胃口。多点两样，尝试的范围广些，这样不好吃，还有那一样，不致饿了你。”“这不是吃菜，这像神农尝百草了。不太浪费么？也许一切男人都喜欢在陌生的女人前面浪费。”“也许，可是并不在一切陌生的女人前面。”“只在傻女人前面，是不是？”“这话我不懂。”“女人不傻决不因为男人浪费摆阔而对他有好印象——可是，你放心，女人全是傻的，恰好是男人所希望的那样傻，不多不少。”鸿渐不知道这些话是出于她的天真直率，还是她表姐所谓手段老辣。到菜上了，两人吃着，鸿渐向她要信址，请她写在自己带着看的那本书后空叶上，因为他从来不爱带记事小册子。他看她写了电话号数，便说：“我决不跟你通电话。我最恨朋友间通电话，宁可写信。”唐小姐：“对了，我也有这一样感觉。做了朋友应当彼此爱见面；通个电话算接过了，可是面没有见，所说的话又不能像信那样留着反复看几遍。电话是偷懒人的拜访吝啬人的通信。最不够朋友！并且，你注意到么？一个人的声音往往在电话里变得认不出，变得难听。”“唐小姐，你说得痛快。我住在周家，房门口就是一架电话，每天吵得头痛。常常最不合理的时候，像半夜清早，还有电话来，真讨厌！亏得”电视“没普遍利用，否则更不得了，你在澡盆里、被窝里都有人来窥看了。教育愈普遍，而写信的人愈少；并非商业上的要务，大家还是怕写信，宁可打电话。我想这因为写信容易出丑，地位很高，讲话很体面的人往往笔动不来。可是，电话可以省掉面目可憎者的拜访，文理不通者的写信，也算是个功德无量的发明。”方鸿渐谈得高兴，又要劝唐小姐吃，自己反吃得很少。到吃完水果，才九点钟，唐小姐要走，鸿渐不敢留她，算过账，分付跑堂打电话到汽车行放辆车来，让唐小姐坐了回家。他告诉她自己答应苏小姐明天去望病，问她去不去。她说她也许去，可是她不信苏小姐真害病。鸿渐道：“咱们的吃饭要不要告诉她？”“为什么不告诉她？——不，不，我刚才发脾气，对她讲过今天什么地方都不去的。好，随你斟酌罢。反正你要下银行办公室才去，我去得更迟一点。”“我后天想到府上来拜访，不挡驾吗？”“非常欢迎，就只舍间局促得秀，不比表姐家的大花园洋房。你不嫌简陋，尽管来。”鸿渐说：“老伯可以见见么？”唐小姐笑道：“你除非有法律问题要请教他，并且他常在他那法律事务所里，到老晚才回来。爸爸妈妈对我姐妹们绝对信任，从不干涉，不检定我拉的朋友。”说着，汽车来了，鸿渐送她上车。在回家的洋车里，想今天真是意外的圆满，可是唐且临了“我们的朋友”那一句，又使他作酸泼醋的理想里，隐隐有一大群大男孩子围绕着唐小姐。
　　唐小姐回到家里，她父母都打趣她说：“交际明星回来了！”她回房间正换衣服，女用人来说苏小姐来电话。唐小姐下去接，到半楼梯，念头一转，不下去了，分付用人去回话道：“小姐不舒服，早睡了。”唐小姐气愤地想，这准是表姐来查探自己是否在家。她太欺负人了！方鸿渐又不是她的，要她这样看管着？表姐愈这样干预，自己偏让他亲近。自己决不会爱方鸿渐，爱是又曲折又伟大的情感，决非那么轻易简单。假使这样就会爱上一个人，那么，爱情容易得使自己不相信，容易得使自己不心服了。
　　明天下午，鸿渐买了些花和水果到苏家来。一见苏小姐，他先声夺人地嚷道：“昨天是怎么一回事？你也病，她也病，这病是传染的？还是怕我请客菜里下毒药？真气得我半死！我一个人去了，你们不来，我满不在乎。好了，好了，总算认识了你们这两位大架子小姐，以后不敢碰钉了。”苏小姐抱歉道：“我真病了，到下半天才好，不敢打电话给你，怕你怪我跟你开玩笑，一会儿这样，一会儿那样。我昨天通知晓芙的时候，并没有叫她不去。让我现在打电话请她过来。这次都是我不好，下次我做主人。”便打电话问唐小姐病好了没有，请她就来，说鸿渐也在这里。苏小姐打完电话，捧了鸿渐送的花嗅着，叫用人去插在卧室中瓶里，回头问鸿渐道：“你在英国，认识有一位曹元朗么？”鸿渐摇头。“——他在剑桥念文学，是位新诗人，新近回国。他家跟我们世交，他昨天来看我，今天还要来。”鸿渐道：“好哇！怪不得昨天不赏面子了，原来跟人谈诗去了，我们是俗物呀！根本就不配认识你。那位曹一堂堂剑出身，我们在后起大学里挂个名，怎会有资格结交他？我问你，你的《十八家白话诗人》里好像没讲起他，是不是准备再版时补他进去？”苏小姐似嗔似笑，左手食指在空中向他一点道：“你这人就爱吃醋，吃不相干的醋。”她的表情和含意吓得方鸿渐不敢开口，只懊悔自己气愤装得太像了。一会儿，唐小姐来了。苏小姐道：“好架子！昨天晚上我打电话问候你，你今天也没回电话，这时候又要我请了才来。方先生在问起你呢。”唐小姐道：“我们配有架子么？我们是听人家叫来唤去的。就算是请了才来，那有什么希奇？要请了还不肯去，才够得上伟大呢！”苏小姐怕她讲出昨天打三次电话的事来，忙勾了她腰，抚慰她道：“瞧你这孩子，讲句笑话，就要认真。”便剥个鸿渐送的桔子，跟她同吃。门房领了个滚圆脸的人进来，说“曹先生”。鸿渐吓了一跳，想去年同船回国那位孙太太的孩子怎长得这样大了，险的叫他“孙世兄”。天下竟有如此相像的脸！做诗的人似乎不宜肥头胖耳，诗怕不会好。忽然记起唐朝有名的寒瘦诗贾岛也是圆脸肥短身材，曹元朗未可貌相。介绍寒喧已毕，曹元朗从公事皮包里拿出一本红木夹的法帖，是荣宝斋精制蓑衣裱的宣纸手册。苏小姐接过来，翻了翻，说：“曹先生，让我留着细看，下星期奉还，好不好？——鸿渐，你没读过曹先生的大作罢？”鸿渐正想，什么好诗，要录在这样讲究的本子上。便恭敬地捧过来，打开看见毛笔写的端端正正宋体字，第一首十四行诗的题目是《拼盘姘伴》，下面小注个“一”字。仔细研究，他才发现第二页有作者自述，这“一”“二”“三”“四”等等是自注的次序。自注“一”是：“Melangeadultere”。这诗一起道：昨夜星辰今夜摇漾于飘至明夜之风中（二）
　　圆满肥白的孕妇肚子颤巍巍贴在天上（三）
　　这守活寡的逃妇几时有了个新老公（四）？
　　Jug！Jug！（五）污泥里——Efangoeilmondo！（六）——夜莺歌唱（七）……
　　鸿渐忙跳看最后一联：雨后的夏夜，灌饱洗净，大地肥而新的，最小的一棵草参加无声的呐喊：“Wirsind！”（三十）
　　诗后细注着字名的出处，什么李义山、爱利恶德（T.S.Eliot）、拷背延耳（TristanCorbiere）、来屋拜地（Leopardi）、肥儿飞儿（FranzWerfel）的诗篇都有。鸿渐只注意到“孕妇的肚子”指满月，“逃妇”指嫦娥，“泥里的夜莺”指蛙。他没脾胃更看下去，便把诗稿搁在茶几上，说：“真是无字无来历，跟做旧诗的人所谓”学人之诗“差不多了。这作风是不是新古典主义？”曹元朗点头，说“新古典的”那个英文字。苏小姐问是什么一首，便看《拼盘姘伴》一遍，看完说：“这题目就够巧妙了。一结尤其好；”无声的呐喊“五个字真把夏天蠢动怒发的生机全传达出来了。Toutyfourmilledevie，亏曹先生体会得出。”诗人听了，欢喜得圆如太极的肥脸上泛出黄油。鸿渐忽然有个可怕的怀疑，苏小姐是大笨蛋，还是撒谎精。唐小姐也那诗看了，说：“曹先生，你对我们这种没有学问的读者太残忍了。诗里的外国字，我一个都不认识。”曹元朗道：“我这首诗的风格，不认识外国字的人愈能欣赏。题目是杂拌儿、十八扯的意思，你只要看忽而用这个人的诗句，忽而用那个人的诗句，中文里夹了西文，自然有一种杂凑乌合的印象。唐小姐，你领略到这个拉杂错综的印象，是不是？”唐小姐只好点头。曹元朗脸上一圈圈的笑痕，像投了石子的水面，说：“那就是捉摸到这诗的精华了，不必去求诗的意义。诗有意义是诗的不幸！”苏小姐道：“对不住，你们坐一会，我去拿件东西来给产看。”苏小姐转了背，鸿渐道：“曹先生，苏小姐那本《十八家白话诗人》再版的时候，准会添进了你算十九家了。”曹元朗道：“那决不会，我跟他们那些人太不同了，合不起来。昨天苏小姐就对我说，她为了得学位写那本书，其实她并不瞧得起那些人的诗。”“真的么？”“方先生，你看那本书没有？”“看过忘了。”鸿渐承苏小姐送了一本，只略翻一下，看十八家是些什么人。
　　“她序上明明引着JulesTellier的比喻，说有个生脱发病的人去理发，那剃头的对他说不用剪发，等不了几天，头毛压儿全掉光了；大部分现代文学也同样的不值批评。这比喻还算俏皮。”鸿渐只好说：“我倒没有留心到。”想亏得自己不要娶苏小姐，否则该也把苏小姐的书这样熟读。可惜赵辛楣法文程度不够看书，他要像曹元朗那样，准会得苏小姐欢心。
　　唐小姐道：“表姐书里讲的诗人是十八根脱下的头发，将来曹先生就像一毛不拔的守财奴的那根毛。”大家笑着，苏小姐拿了一只紫檀扇匣进来，对唐小姐做个眼色，唐小姐徽笑点头。苏小姐抽开匣盖，取出一把雕花沉香骨的女用折扇，递给曹元朗道：“这上面有首诗，请你看看。”元朗摊开扇子，高声念了一遍，音调又像和尚施食，又像戏子说白。鸿渐一字没听出来，因为人哼诗跟临死呓语二者都用乡音。元朗朗诵以后，又猫儿念经的，嘴唇翻拍着默诵一，说：“好，好！素朴真挚，有古代民歌的风味。”苏小姐有忸怩之色，道：“曹先生眼光真利害，老实说，那诗还过得去么？”方鸿渐同时向曹元朗手里接过扇子，一看就心中作恶。好好的飞金扇　面上，歪歪斜斜地用紫墨水钢笔写着——
　　难道我监禁你？
　　还是你霸占我？
　　你闯进我的心，
　　关上门又扭上锁。
　　丢了锁上的钥匙，
　　是我，也许你自己。
　　从此无法开门，
　　永远，你关在我心里。
　　诗后小姐是：“民国二十六年秋，为文纨小姐录旧作。王尔恺。”这王尔恺是个有名的青年政客，在重庆做着不大不上的官。两位小姐都期望地注视方鸿渐，他放下扇子，撇嘴道：“写这种字就该打手心！我从没看见用钢笔写的折扇，他倒不写一段洋文！”苏小姐忙道：“你不要管字的好坏，你看诗怎样？”鸿渐道：“王乐恺那样热口做官的人还会做好诗么？我又不向他谋差使，没有恭维歪诗的义务。”他没注意唐小姐向自己皱眉摇头。
　　苏小姐怒道：“你这人最讨厌，全是偏见，根本不配讲诗。”便把扇子收起来。
　　鸿渐道：“好，好，让我平心静气再看一遍。”苏小姐虽然撅嘴说：“不要你看了，”仍旧让鸿渐把扇子拿去。鸿渐忽然指着扇子上的诗大叫道：“不得了！这首诗是偷来的。”苏小姐铁青着脸道：“别胡说！怎么是偷的？”唐小姐也睁大了眼。
　　“至少是借的，借的外债。曹先生说它有古代民歌的风味，一点儿不错。苏小姐，你记得么？咱们在欧洲文学史班上就听见先生讲起这首诗。这是德国十五六世纪的民歌，我到德国去以前，跟人补习德文，在初级读本里又念过它，开头说：”我是你的，你是我的，“后面大意说：”你已关闭，在我心里；钥匙遗失，永不能出。“原文字句记不得了，可是意思决不会开错。天下断没有那样暗合的事。”苏小姐道：“我就不记得欧洲文字史班上讲过这首诗。”鸿渐道：“怎么没有呢？也许你上课的时候没留神，没有我那样有闻必录。这也不能怪你，你们上的是本系功课，不做笔记只表示你们学问好；先生讲的你们全知道了。我们是中国文学系来旁听的，要是课堂上不动笔呢，就给你们笑程度不好，听不懂，做不来笔记。”苏小姐说不出话，唐小姐低下头。曹元朗料想方鸿渐认识的德文跟自己差不多，并且是中国文学系学生，更不会高明——因为在大学里，理科学生瞧不起文科学生，外国语文系学生瞧不起中国文学系学生，中国文学系学生瞧不起哲学系学生，哲学系学生瞧不起社会学系学生，社会学系学生瞧不起教育系学生，教育系学生没有谁可以给他们瞧不起了，只能瞧不起本系的先生。曹元朗顿时胆大说：“我也知道这诗有来历，我不是早说士代民歌的作风么？可是方先生那种态度，完全违反文艺欣赏的精神。你们弄中国文学的，全有这个”考据癖“的坏习气。诗有出典，给识货人看，愈觉得滋味浓厚，读着一首诗就联想到无数诗来烘云托月。方先生，你该念念爱利恶德的诗，你就知道现代西洋诗人的东西，也是句句有来历的，可是我们并不说他们抄袭。苏小姐，是不是？”方鸿渐恨不能说：“怪不得阁下的大作也是那样斑驳陆离。你们内行人并不以为厅怪，可是我们外行人要报告捕房捉贼起赃了。”只对苏小姐笑道：“不用扫兴。送给女人的东西，很少是真正自己的，拆穿了都是借花献佛。假如送礼的人是个做官的，那礼物更不用说是旁人身上剥削下来的了。”说着，奇怪唐小姐可以不甚理会。
　　苏小姐道：“我顶不爱听你那种刻薄话。世界上就只你方鸿渐一个人聪明！”鸿渐略坐一下，瞧大家讲话不起劲，便告辞先走，苏小姐也没留他。他出门后浮泛地不安，知道今天说话触了苏小姐，那王尔恺一定又是个她的爱慕者。但他想到明天是访唐小姐的日子，兴奋得什么都忘了。
　　明天方鸿渐到唐家，唐小姐教女用人请他在父亲书房里坐。见面以后就说：“方先生，你昨天闯了大祸，知道么？”方鸿渐想一想，笑道：“是不是为了我批评那首诗，你表姐跟我生气？”“你知道那首诗是谁做的？”她瞧方鸿渐瞪着眼，还不明白——“那首诗就是表姐做的，不是王乐恺的。”鸿渐跳起来道：“呀？你别哄我，扇子上不是明写着”为文纨小姐录旧作“么？”“录的说是文纨小姐的旧作。王尔恺跟表伯有往来，还是赵辛楣的上司，家里有太太。可是去年表姐回国，他就讨好个不休不歇，气得赵辛楣人都瘦了。论理，肚子里有大气，应该人膨胀得胖些，你说对不对？后来行政机关搬进内地，他做官心，才撇下表姐也到里头去了。赵辛楣不肯到内地，也是这个缘故。这扇子就是他送给表姐的，他特请了一个什么人雕刻扇骨子上的花纹，那首诗还是表姐得意之作呢。”“这文理不通的无聊政客，扇子上落的款不明不白，害我出了岔子，该死该死！怎么办呢？”“怎么办呢？好在方先生口才好，只要几句话就解释开了。”鸿渐被赞，又得意，又谦逊道：“这事开得太糟了，怕不容易转圜。我回去赶快写封信给你表姐，向她请罪。”“我很愿意知道这封信怎样写法，让我学个乖，将来也许应用得着。”“假使这封信去了效果很好，我一定把稿子抄给你看。昨天我走了以后，他们骂我没有？”“那诗人说了一大堆话，表姐倒没有讲什么，还说你国文很好。那诗人就引他一个朋友的话，说现代人要国文好，非研究外国文学不可；从前弄西洋科学的人该通外国语文，现在中国文学的人也该先精通洋文。那个朋友听说不久要回国，曹元朗要领他来见表姐呢。”“又是一位宝贝！跟那诗人做朋友的，没有好货。你看他那首什么《拼盘姘伴》，简直不知所云。而且他并不是老实安分的不通，他是仗势欺人，有恃无恐的不通，不通得来头大。”“我们程度幼稚，不配开口。不过，我想留学外国有名大学的人不至于像你所说那样糟罢。也许他那首诗是有意开玩笑。”“唐小姐，现在的留学跟前清的科举功名一样，我父亲常说，从前人不中进士，随你官做得多么大，总抱着终身遗憾。留了学也可以解脱这种自卑心理，并非为高深学问。出洋好比出痘子，出痧子，非出不可。小孩子出过痧痘，就可以安全长大，以后碰见这两种毛病，不怕传染。我们出过洋，也算了了一桩心愿，灵魂健全，见了博士硕士们这些微生虫，有抵抗力来自卫。痘出过了，我们就把出痘这一回事忘了；留过学的人也应说把留学这事了。像曹元朗那种念念不忘是留学生，到处挂着牛津剑桥的幌子，就像甘心出天花变成麻子，还得意自己的脸像好文章加了密圈呢。”唐小姐笑道：“人家听了你的话，只说你嫉妒他们进的大学比你进的有名。”鸿渐想不出话来回答，对她傻笑。她倒愿意他有时对答不来，问他道：“我昨天有点奇怪，你怎会不知道那首诗是表姐做的。你应该看过她的诗。”“我和你表姐是这一次回国船上熟起来的，时间很短。以前话都没有谈过。你记得那一天她讲我在学校里的外号是”寒暑表“么？我对新诗不感兴趣，为你表姐的缘故而对新诗发生兴趣，我觉得犯不着。”“哼，这话要给她知道了——”“唐小姐，你听我说。你表姐是个又有头脑又有才学的女人，可是——我怎么说呢？有头脑有才学的女人是天生了教笨的男人向她颠倒的，因为他自己没有才学，他把才学看得神秘，了不得，五体投地的爱慕，好比没有钱的穷小姐对富翁的崇拜——”“换句话说，像方先生这样聪明，是喜欢目不识丁的笨女人。”“女人有女人的特别的聪明，轻盈活泼得跟她的举动一样。比了这种聪明，才学不过是沉淀渣滓。说女人有才学，就仿佛赞美一朵花，说它在天平上称起来有白菜番薯的斤两。真聪明的女人决不用功要做成才女，她只巧妙的偷懒——”唐小姐笑道：“假如她要得博士学位呢？”“她根本不会想得博士，只有你表姐那样的才女总要得博士。”“可是现在普通大学毕业亦得做论文。”“那么，她毕业的那一年，准有时局变动，学校提早结束，不用交论文，就送她毕业。”唐小姐摇头不信，也不接口，应酬时小意几献殷勤的话，一讲就完，经不起再讲；恋爱时几百遍讲不厌、听不厌的话，还不到讲的程度；现在所能讲的话，都讲得极边尽限，礼貌不容他昧越分。唐小姐看他不作声，笑道：“为什么不说话了？”他也笑道：“咦，你为什么不说话了？”唐小姐告诉他，本乡老家天井里有两株上百年的老桂树，她小时候常发现树上成群聒噪的麻雀忽然会一声不响，稍停又忽然一齐叫起来，人谈话时也有这景象。
　　方鸿渐回家路上，早有了给苏小姐那封信的腹稿，他觉得用文言比较妥当，词意简约含混，是文过饰非轻描淡写的好工具。吃过晚饭，他起了草，同时惊骇自己撒谎的本领会变得这样伟大，怕这玩笑开得太大了，写了半封信又搁下笔。但想到唐小姐会欣赏，会了解，这谎话要博她一笑，他又欣然续写下去里面说什么：“昨天承示扇头一诗，适意有所激，见名章隽句，竟出诸伧夫俗吏之手，惊极而恨，遂厚诬以必有蓝本，一时取快，心实未安。叨大知爱，或勿深责。”信后面写了昨天的日期，又补两行道：“此书成后，经一日始肯奉阅，当曹君之面而失据败绩，实所不甘。恨恨！又及。”写了当天的日期。他看了两遍，十分得意；理想中倒不是苏小姐读这封信，而是唐小姐读它。明天到银行，交给收发处专差送去。傍晚回家，刚走到卧室门口，电话铃响。顺手拿起听筒说：“这儿是周家，你是什么地方呀？”只听见女人声答道：“你猜猜看，我是谁？”鸿渐道：“苏小姐，对不对？”“对了。”清脆的笑声。
　　“苏小姐，你收到我的信没有？”“你肯原谅我，我不能饶恕我自己。”“吓，为了那种小事得着这样严重么？我问你，你真觉得那首诗好么？”方鸿渐竭力不让脸上的笑漏进说话的声音里道：“我只恨这样好诗偏是王尔恺做的，太不公平了！”“我告诉你，这首诗并不是王尔恺做的。”“那么，谁做的？”“是我做着玩儿的。”“呀！是你做的？我真该死！”方鸿渐这时亏得通的是电话而不是电视，否则他脸上的快乐跟他声音的惶怕相映成趣，准会使苏小姐猜疑。
　　“你说这首诗有蓝本也不冤枉。我在一本谛尔索（Tirsot）收集的法国古跳舞歌里，看见这个意思，觉得新鲜有趣，也仿做一首。据你讲，德文里也有这个意思。可见这是很平常的话。”“你做得比文那首诗灵活。”“你别当面奉承我，我不相信你的话！”“这不是奉承的话。”“你明天下午来不来呀？”方鸿渐忙说“来”，听那面电话还没挂断，自己也不敢就挂断。
　　“你昨天说，男人不把自己东西给女人，是什么意思呀？”方鸿渐陪笑说：“因为自己东西太糟了，拿不出手，不得已只能借旁的好东西来贡献。譬如请客，家里太局促，厨子手段太糟，就不得不上馆子，借它的地方跟烹调。”苏小姐格格笑道：“算你有理，明天见。”方鸿渐满头微汗，不知道急出来的，还是刚到家里，赶路的汗没有干。
　　那天晚上方鸿渐就把信稿子录出来，附在一封短信里，寄给唐小姐。他恨不能用英文写信，因为文言信的语气太生分，白话信的语气容易变成讨人厌的亲热；只有英文信容许他坦白地写“我的亲爱的唐小姐”、“你的极虔诚的方鸿渐”。这些西文书函的平常称呼在中文里就剌眼肉麻。他深知自己写的其文富有黄国人言论自由和美国人宣言独立的精神，不受文法拘束的，不然真想仗外国文来跟唐小姐亲爱，正像政治犯躲在外国租界里活动。以后这一个多月里，他见了唐小姐七八次，写给她十几封信，唐小姐也回了五六封信。他第一次到唐小姐的信，临睡时把信看一遍，搁在枕边，中夜一醒，就开电灯看信，看完关灯躺好，想想信里的话，忍不住又开灯再看一遍。以后他写的信渐渐变成一天天的随感杂记，随身带到银行里，碰见一桩趣事，想起一句话，他就拿笔在纸上跟唐小姐切切私语，有时无话可说，他还要写，例如：“今天到行起了许多信稿子，到这时候才透口气，伸个懒腰，a-a-a-ah！听得见我打呵欠的声音么？茶房来请午饭了，再谈。你也许在吃饭，祝你”午饭多吃口，活到九千九百九十九“；”又如：“这封信要寄给你了，还想写几句话。可是你看纸上全写满了，只留这一小方，刚挤得进我心里那一句话，它还怕羞不敢见你的面呢。哎哟，纸——”写信的时候总觉得这是慰情聊胜于无，比不上见面，到见了面，许多话倒竿不出来，想还不如写信。见面有瘾的；最初，约着见一面就能使见面的前后几天都沾着光，变成好日子。渐渐地恨不能天天见面了；到后来，恨不能刻刻见面了。写好信发出，他总担心这信像支火箭，到落地时，火已熄了，对方收到的只是一段枯炭。
　　唐小姐跟苏小姐的来往也比从前减少了，可是方鸿渐迫于苏小姐的恩威并施，还不得不常向苏家走动。苏小姐只等他正式求爱，心里怪他太浮太慢。他只等机会向她声明并不爱她，恨自己心肠太软，没有快刀斩乱丝的勇气。他每到苏家一次，出来就懊悔这次多去了，话又多说了。他渐渐明白自己是个西洋人所谓“道义上的懦夫”，只怕唐小姐会看破了自己品格上的大弱点。一个星期六下午他请唐小姐喝了茶回家，看见桌子上赵辛楣明天请吃晚饭的帖子，大起惊慌，想这也许是他的订婚喜酒，那就糟了，苏小姐更要爱情专注在自己身上了。苏小姐打电话来问他收到请帖没有，说辛楣托她转邀，还叫他明天上午去谈谈。明天苏小姐见了面，说辛楣请他务必光临，大家叙叙，别无用意。他本想说辛楣怎会请到自己，这话在嘴边又缩回去了；他现在不愿再提起辛楣对自己的仇视，又加深苏小姐的误解。他改口问有没有旁的客人。苏小姐说，听说还有两个辛楣的朋友。鸿渐道：“小胖子大诗人曹元朗是不是也请在里面？有他，菜也可以省一点；看见他那个四喜丸子的脸，人就饱了。”“不会有他罢。辛楣不认识他，我知道辛楣跟你一对小心眼儿，见了他又要打架，我这儿可不是战场，所以我不让他们两人碰头。元朗这人顶有意思的，你全是偏见，你的心我想也偏在夹肢窝里。自从那一次后，我也不让你和元朗见面，免得冲突。”鸿渐本想说：“其实全没有关系，”可是在苏小姐抚爱的眼光下，这话不能出口。同时知道到苏家来朝参的又添了个曹元朗，心放了许多。苏小姐忽然问道：“你看赵辛楣这人怎么样？”“他本领比我大，仪表也很神气，将来一定得意。我看他倒是个理想的——呃——人。”假如上帝赞美魔鬼，社会主义者歌颂小布尔乔亚，苏小姐听了也不会这样惊奇。他准备鸿渐嘲笑辛楣，自己主持公道，为辛楣辩护。他便冷笑道：“请客的饭还没到口呢，已经恭维主人了！他三天两天写信给我，信上的话我也不必说，可是每封信都说他失眠，看了讨厌！谁叫他失眠的，跟我有什么关系？我又不是医生！”苏小姐深知道他失眠跟自己大有关系，不必请教医生。
　　方鸿渐笑道：“《毛诗》说：”窈窕淑女，寤寐求之；求之不得，寤寐思服。“他写这种信，是地道中国文化的表现。”苏小姐瞪眼道：“人家可怜，没有你这样运气呀！你得福不知，只管口轻薄取笑人家，我不喜欢你这样。鸿渐，我希望你做人厚道些，以后我真要好好的劝劝你。”鸿渐吓得哑口无言。苏小姐家里有事，跟他约晚上馆子里见面。他回到家整天闷闷不乐，觉得不能更延宕了，得赶快表明态度。方鸿渐到馆子，　那两个客人已经先在。　一个躬背高额，大眼睛，仓白脸，戴夹鼻金丝眼镜，穿的西装袖口遮没手指，光光的脸，没胡子也没皱纹，而看来像个幼稚的老太婆或者上了年纪的小孩子。　一个气概飞扬，鼻子直而高，侧望像脸上斜搁了一张梯，颈下打的领结饱满齐整得使方鸿渐绝望地企羡。　辛楣了见鸿渐热烈欢迎。彼此介绍之后，鸿渐才知道那位躬背的是哲学家褚慎明，另一位叫董斜川，原任捷克中国公使馆军事参赞，内调回国，尚未到部，　善做旧诗，是个大才子。　这位褚慎明原名褚家宝，成名以后嫌“家宝”这名字不合哲学家身分，据斯宾诺沙改名的先例，换成“褚明”，取“慎思明辩”的意思。　他自小负神童之誉，但有人说他是神经病。　他小学，中学，大学都不肯毕业，因为他觉得没有先生配教他考他。　他最恨女人，眼睛近视得利害而从来不肯配眼镜，因为怕看清楚了女人的脸，又常说人性里有天性跟兽性两部分，他自己全是天性。　他常翻外国哲学杂志，查出世界大哲学家的通信处，写信给他们，说自己如何爱读他们的书，把哲学杂志书评栏里赞美他们著作的话，改头换面算自己的意见。　外国哲学家是知识分子里最牢骚不平的人，专门的权威没有科学家那样高，通俗的名气没有文学家那样大，忽然几万里外有人写信恭维，不用说高兴得险的忘掉了哲学。他们理想中国是个不知怎样鄙塞落伍的原始国家，而这个中国人信里说几句话，倒有分寸，便回信赞褚慎明是中国新哲学的创始人，还有送书给他的。不过褚慎明再写信去，就收不到多少复信，缘故是那些虚荣的老头子拿了他的第一封信向同行卖弄，不料彼此都收到他的这样一封信，彼此都是他认为“现代最伟大的哲学家”，不免扫兴生气了。　褚慎明靠着三四十封这类回信，吓倒了无数人，有位爱才的阔官僚花一万金送他出洋。西洋大哲学家不回他信的只有柏格森；柏格森最怕陌生人去缠他，住址严守秘密，电话簿上都没有他的名字。褚慎明到了欧洲，用尽心思，写信到柏格森寓处约期拜访，谁知道原信退回，他从此对直觉主义痛心疾首。　柏格森的敌人罗素肯敷衍中国人，请他喝过一次茶，他从此研究数理逻辑。　他出洋时，为方便起见，不的不戴眼镜，对女人的态度逐渐改变。杜慎卿厌恶女人，跟她们隔三间屋还闻着她们的臭气，褚慎明要女人，所以鼻子同样的敏锐。他心里装满女人，研究数理逻辑的时候，看见aposteriori那个名词会联想到post－erior，看见×记号会联想到kiss，亏得他没细读柏拉图的太米谒斯对话（Timaeus），否则他更要对住×记号出神。　他正把那位送他出洋的大官僚讲中国人生观的著作翻成英文，每月到国立银行领一笔生活费过极闲适的日子。董斜川的父亲董沂孙是个老名士，虽在民国作官而不忘前清。　斜川才气甚好，跟着老子作旧诗。　中国是出儒将的国家，不比法国有一两个提得起笔的将军，就要请进国家学院去高供着。　斜川的将略跟一般儒将相去无几而他的诗即使不是儒将作的，也算得好了。　文能穷人，所以他官运不好，这对于士兵，倒未始非福。他作军事参赞，不去讲武，倒批评上司和同事们文理不通，因此内调。他回国不多几天，想另谋个事。方鸿渐见董斜川像尊人物，又听赵辛楣说是名父之子，不胜倾倒，说：“老太爷沂孙先生的诗，海内闻名。董先生不愧家学渊源，更难得是文武全才。”他自以为这算得恭维周到了。董斜川道：“我作的诗，路数跟家严不同。家严年轻时候的诗取径没有我现在这样高。　他到如今还不脱黄仲则，龚定庵那些乾嘉习气，　我一开笔就做的同光体。”方鸿渐不敢开口。赵辛楣向跑堂要了昨天开的菜单，予以最後审查。　董斜川也向跑堂的要了一支秃笔，一方砚台，把茶几上的票子飞快的书写着。　方鸿渐心里诧异。　褚慎明危坐不说话，像内视着潜意识深处的趣事而微笑，比了他那神秘的笑容，蒙娜丽莎（Mona Lisa）的笑算不得什么一回事。　鸿渐攀谈道：“褚先生最近研究些什么哲学问题？”褚慎明神色慌张，　撇了鸿渐一眼，别转头叫赵辛楣道：“老赵，苏小姐该来了。　我这样等女人，生平是破例。”辛楣把菜单给跑堂，回头正要答应，看见董斜川在写，忙说：“斜川，你在干什么？”董斜川头都不抬道：“我在写诗。”辛楣释然道：“快多写几首，我虽不懂诗，最爱看你的诗。　我那位朋友苏小姐，新诗做得非常好，对旧诗也很能欣赏。　回头把你的诗给她看。”斜川停笔，手指拍着前额，像追思什么句子，又继续写，一面说：“新诗跟旧诗不能比！　我那年在庐山跟我们那位老世伯陈散原先生聊天，偶尔谈起白话诗。老头子居然看过一两首新诗。他说还算徐志摩的诗有点意思，可是只相当于明初杨基那些人的境界，太可怜了。女人做诗，至多是第二流，鸟里面能唱的都是雄的，譬如鸡。”辛楣大不服道：“为什么外国人提起夜莺，总说它是雌的？”褚慎明对雌雄性别，最有研究，　冷冷道：“夜莺雌的不会唱，会唱的是雄夜莺。”说着，苏小姐来了。辛楣利用主人职权，当鸿渐的面向她专利地献殷勤。斜川一拉手后，正眼不瞧她，因为他承受老派名士对女人的态度，或者谑浪玩弄，这是对妓女的风流，或者眼观鼻，鼻观心，这是对朋友内眷的礼貌。褚哲学家害馋痨地看着苏小姐，大眼珠仿佛哲学家谢林的“绝对观念”，像“里弹出的子药”，险的突破眼眶，迸碎眼镜。　辛楣道：“今天本来也请了董太太，董先生说她有事不能来。　董太太是美人，一笔好中国画，跟我们这位斜川兄真是珠联璧合。”斜川客观地批判说：“内人长得相当漂亮，画也颇有家法。　她画的《斜阳萧寺图》，在很多老辈的诗集里见得到题咏。　她跟我龙树寺，回家就画这个手卷，我老太爷题两首七绝，　有两句最好：”贞元朝士今谁在，无限僧寮旧夕阳！“的确，　老辈一天少似一天，人才好像每况愈下，”不须上溯康乾世，回首同光已惘然！“。”　说时摇头慨叹。
　　方鸿渐闻所未闻，甚感兴味。　只奇怪这样一个英年洋派的人，何以口气活像遗少，也许是学同光体诗的缘故。　辛楣请大家入席，为苏小姐杯子里斟满了法国葡萄汁，　笑说：“这是专给你喝的，我们另有我们的酒。　今天席上慎明兄是哲学家，你跟斜川兄都是诗人，　方先生又是哲学家又是诗人，一身兼两长，更了不得。　我一无所能，只会喝两口酒，　方先生，我今天陪你喝它两斤酒，斜川兄也是洪量。”方鸿渐吓得跳起来道：“谁讲我是哲学家和诗人？　我更不会喝酒，简直滴酒不饮。”辛楣按住酒壶，眼光向席上转道：“今天谁要客气推托，我们就罚他两杯，好不好？”斜川道：“赞成！　这样好酒，罚还是便宜。”鸿渐拦不住道：“赵先先生，我真不会喝酒，也给我葡萄汁，行不行？”辛楣道：“哪有不会喝酒的留法学生？葡萄汁是小姐们喝的。　慎明兄因为神经衰弱戒酒，是个例外。　你别客气。”斜川呵呵笑道：“你即不是文纨小姐的”倾国倾城貌“，又不是慎明先生的”多愁多病身“，我劝你还是”有酒直须醉“罢。　好，先干一杯，一杯不成，就半杯。”苏小姐道：“鸿渐好像是不会喝酒——辛楣这样劝你，　你就领情稍微喝一点罢。”　辛楣听苏小姐护惜鸿渐，恨不得鸿渐杯里的酒滴滴都化成火油。他这愿望没实现，可是鸿渐喝一口，已觉一缕火线从舌尖伸延到胸膈间。　慎明喝茶，酒杯还空着。　跑堂拿上一大瓶叵耐牌A字牛奶，　说已隔水温过。　辛楣把瓶给慎明道：“你自斟自酌罢，我不跟你客气了。”　慎明倒了一杯，　尖着嘴唇尝了尝，说：“不凉不暖，正好。”然后从口袋里掏出个什么外国补药瓶子，数四粒丸药，搁在嘴里，喝一口牛奶咽下去。　苏小姐道：“褚先生真知道养生！”　慎明透口气道：“人没有这个身体，全是心灵，岂不更好；我并非保重身体，我只是哄乖了了它，好不跟我捣乱——辛楣，这牛奶还新鲜。”辛楣道：“我没哄你罢？　我知道你的脾气，这瓶奶送到我家以后，我就搁在电气冰箱里冻着。　你对新鲜牛奶这样认真，我有机会带你去见我们相熟的一位徐小姐，　她开奶牛场，请她允许你每天凑着母牛的奶直接呼一个饱——今天的葡萄汁，　牛奶都是我带来的，没叫馆子里预备。　文纨，吃完饭，我还有一匣东西给你。　你爱吃的。”苏小姐道：“什么东西？——哦，你又要害我头痛了。”方鸿渐道：“我就不知道你爱吃什么东西，下次也可以买来孝敬你。”辛楣又骄又妒道：“文纨，不要告诉他。”苏小姐又为自己的嗜好抱歉道：“我在外国想吃广东鸭肫肝，不容易买到。去年回来，大哥买了给我吃，咬得我两太阳酸痛好几天。　你又要来引诱我了。”鸿渐道：“外国菜里从来没有鸡鸭肫肝，我在伦敦看见成箱的鸡鸭肫肝贱得一文不值，人家买了给猫吃。”辛楣道：“英国人吃东西远比不上美国人花色多。　不过，外国人的吃胆总是太小，　不敢冒险，　不像我们中国人什么肉都敢吃。　并且他们的烧菜原则是”调“，我们是”烹“，所以他们的汤菜尤其不够味道。　他们白煮鸡，烧了一滚，把汤丢了，只吃鸡肉，真是笑话。”鸿渐道：“这还不算冤呢！　茶叶初到外国，那些外国人常把整磅的茶叶放在一锅子水里，到水烧开，泼了水，加上胡椒和盐，专吃那叶子。”大家都笑。斜川道：“这跟樊樊山把鸡汤来沏龙井茶的笑话相同。　我们这老世伯光绪初年做京官的时候，有人外国回来送给他一罐咖啡，他以为是鼻烟，把鼻孔里的皮都擦破了。　他集子里有首诗讲这件事。”鸿渐道：“董先生不愧系出名门！　今天听到不少掌故。”慎明把夹鼻眼镜按一下，咳声嗽，说：“方先生，　你那时候问我什么一句话？”鸿渐胡涂道：“什么时候？”“苏小姐还没来的时候，”——鸿渐记不起——“你好像问我研究什么哲学问题，对不对？”　对这个照例的问题，　褚慎明有个刻板的回答，　那时候因为苏小姐还没来，所以他留到现在表演。
　　“对，对。”“这句话严格分析起来，　有点毛病。哲学家碰见问题，第一步研究问题：这成不成问题，　不成问题的是假问题pesudoquestion，不用解决，也不可解决。假使成问题呢，第二步研究解决，相传的解决正确不正确，要不要修正。　你的意思恐怕不是问我研究什么问题，而是问我研究什么问题的解决。”方鸿渐惊奇，　董斜川厌倦，苏小姐迷或，赵辛楣大声道：“妙，，分析得真精细，了不得！　了不得！　鸿渐兄，你虽然研究哲学，今天也甘拜下风了，听了这样好的议论，大家得干一杯。”鸿渐经不起辛楣苦劝，　勉强喝了两口，说：“辛楣兄，我只在哲学系混了一年，看了几本指定参考书。　在褚先生前面只能虚心领教做学生。”褚慎明道：“岂敢，　岂敢！　听方先生的话好像把一个个哲学家为单位，来看他们的著作。　这只算研究哲学家，至多是研究哲学史，算不得研究哲学。充乎其量，　不过做个哲学教授，不能成为哲学家。　我喜欢用自己的头脑，不喜欢用人家的头脑来思想。　科学文学的书我都看，　可是非万不得已决不看哲学书。　现在许多号称哲学家的人，并非真研究哲学，　只研究些哲学上的人物文献。　严格讲起来，他们不该叫哲学家philosophers，该叫”哲学家学家“philophilosophers.”鸿渐说：“philophilosophers这个字很妙，是不是先生用自己头脑想出来的？”“这个字是有人在什么书上看见了告诉Bertie，　Bertie告诉我的。”“谁是Bertie？”“就是罗素了。”世界有名的哲学家，新袭勋爵，而褚慎明跟他亲狎得叫他乳名，　连董斜川都羡服了，便说：“你跟罗素很熟？”“还够得上朋友，承他瞧得起，请我帮他解答许多问题。”　天知道褚慎明并没吹牛，罗素确问过他什么时候到英国，有什么计划，　茶里要搁几块糖这一类非他自己不能解决的问题——“方先生，你对数理逻辑用过功没有？”“我知道这东西太难了，从没学过。”“这话有语病，你没学过，怎会”知道“它难呢？　你的意思是：”听说这东西太难了。“”辛楣正要说“鸿渐兄输了，罚一杯”，　苏小姐为鸿渐不服气道：“褚先生可真精明厉害哪！　吓得我口都不敢开了。”慎明说：“不开口没有用，心里的思想照样的混乱不合逻辑，　这病根还没有去掉。”苏小姐撅嘴道：“你太可怕了！　我们心里的自由你都要剥夺了。　我瞧你就没本领钻到人心里去。”褚慎明有生以来，美貌少女跟他讲“心”，今天是第一次。　他非常激动，夹鼻眼镜泼刺一声直掉在牛奶杯子里，溅得衣服上桌布上都是奶，　苏小姐胳膊上也沾润了几滴。　大家忍不注笑。　赵辛楣捺电铃叫跑堂来收拾。　苏小姐不敢皱眉，轻快地拿手帕抹去手臂上的飞抹。　褚慎明红着脸，把眼镜擦干，幸而没破，可是他不肯戴上，怕看清了大家脸上逗留的余笑。
　　董斜川道：“好，好，虽然”马前泼水“，居然”破镜重园“，　慎明兄将来的婚姻一定离合悲欢，大有可观。”辛楣道：“大家干一杯，预敬我们大哲学家未来的好太太。　方先生，半杯也喝半杯。”——辛楣不知道大哲学家从来没有娶过好太太，苏格拉底的太太就是泼妇，褚慎明的好朋友罗素也离了好几次婚。
　　鸿渐果然说道：“希望褚先生别像罗素那样的三四次离婚。”慎明板着脸道：“这就是你所学的哲学！”　苏小姐道：“鸿渐，我看你醉了，眼睛都红了。”斜川笑得前仰后合。　辛楣嚷道：“岂有此理！　说这种话非罚一杯不可！”本来敬一杯，鸿渐只需喝一两口，　现在罚一杯，鸿渐自知理屈，挨了下去，渐渐觉得另有一个自己离开了身子在说话。
　　慎明道：“关于Bertie结婚离婚的事，我也和他谈过。　他引一句英国古话，说结婚仿佛金漆的鸟笼，笼子外面的鸟想住进去，笼内的鸟想飞出来；所以结而离，离而结，没有了局。”苏小姐道：“法国也有这么一句话。　不过，不说是鸟笼，说是被围困的城堡fortresse　assiegee，城外的人想冲进去，城里的人想逃出来。　鸿渐，是不是？”鸿渐摇头表示不知道。
　　辛楣道：“这不用问，你还会错吗！”慎明道：“不管它鸟笼罢，　围城罢，像我这种一切超脱的人是不怕被围困的。”鸿渐给酒摆布得失掉自制力道：“反正你会摆空城计。”结果他又给辛楣罚了半杯酒，　苏小姐警告他不要多说话。　斜川像在寻思什么，忽然说道：“是了，是了。　中国哲学家里，王阳明是怕老婆的。”——这是他今天第一次没有叫“老世伯”的人。
　　辛楣抢说：“还有什么人没有？　方先生，你说，你念过中国文学的。”鸿渐忙说：“那是从前的事，根本没有念通。”辛楣欣然对苏小姐做个眼色，苏小姐忽然变得很笨，视若无睹。
　　“大学里教你国文的是些什么人？”斜川不无兴趣地问。
　　鸿渐追想他的国文先生都叫不响，不比罗素，陈散原这些名字，像一支上等哈瓦那雪茄烟，可以挂在口边卖弄，便说：“全是些无名小子，可是教我们这种不通的学生，已经太好了。　斜川兄，我对诗词真的一窍不通，叫我做呢，一个字都做不出。”苏小姐嫌鸿渐太没面子，心痒痒地要为他挽回体面。
　　斜川冷笑道：“看的是不是燕子庵，人境庐两家的诗？”“为什么？”“这是普通留学生所能欣赏的二毛子旧诗。　东洋留雪生捧苏曼殊，西洋留学生捧黄公度。　留学生不知道苏东坡，黄山谷，心目间只有这一对苏黄。　我没说错罢？　还是黄公度好些，苏曼殊诗里的日本味儿，浓得就像日本女人头发上的油气。”苏小姐道：“我也是个普通留学生，就不知道近代的旧诗谁算顶好。董先生讲点给我们听听。”“当然是陈散原第一。　这五六百念年，算他最高。　我常说唐以后的大诗人可以把地理名字来概括，叫”陵谷山原“。　三陵：杜少陵，王广陵——知道这个人么？——梅宛陵；二谷：李昌谷，黄山谷；四山：王半山，陈后山，元遗山；可是只有一原，陈散原。”说时，翘着左手大拇指。　鸿渐懦怯地问道：“不能添个”坡“字么？”“苏东坡，他差一点。”鸿渐咋舌不下，想苏东坡的诗还不入他法眼，这人做的诗不知怎样好法，便问他要刚才写的诗来看。　苏小姐知道斜川写了诗，也向他讨，因为只有做旧诗的人敢说不看新诗，做新诗的人从不肯说不懂旧诗的。　斜川把四五张纸，分发同席，傲然靠在椅背上，但觉得这些人都不懂诗，决不能领略他句法的妙处，就是赞美也不会亲切中肯。这时候，他等待他们的恭维，同时知道这恭维不会满足自己，仿佛鸦片瘾发的时候只找到一包香烟的心理。　纸上写着七八首近体诗，格调很老成。辞军事参赞回国那首诗有：“好赋归来看妇靥，大惭名字止儿啼”；愤慨中日战事的诗有：“直疑天似醉，欲与日偕亡”；此外还有：“清风不必一钱买，快雨瑞宜万户封”；“石齿漱寒濑，松涛泻夕风”；“未许避人思避世，独扶浅醉赏残花”。可是有几句像：“泼眼空明供睡鸭，蟠胸秘怪媚潜虬”；“数子提携寻旧迹，哀芦苦竹照凄悲”；“秋气身轻一身过，鬓丝摇影万鸦窥”；意思非常晦涩。　鸿渐没读过《散原精舍诗》，还竭力思索这些字句的来源。　他想芦竹并没起火，照东西不甚可能，何况“凄悲”是探海灯都照不见的。“数子”明明指朋友并非小孩子，朋友怎可以“提携”？　一万只乌鸦看中诗人几根白头发，难道“乱发如鸦窠”，要宿在他头上？　心里疑惑，不敢发问，怕斜川笑自己外行人不懂。
　　大家照例称好，斜川客气地淡漠，仿佛领袖受民众欢迎时的表情。　辛楣对鸿渐道：“你也写几首出来，　让我们开开眼界。”　鸿渐极口说不会做诗。　斜川说鸿渐真的不会做诗，倒不必勉强。　辛楣道：“大家喝一大杯，把斜川兄的好诗下酒。”鸿渐要喉舌两关不留难这口酒，溜税似地直咽下去，只觉胃里的东西给这口酒激的要冒上来，好比已塞的抽水马桶又经人抽一下水的景象。　忙搁下杯子。咬紧牙齿，用坚强的意志压住这阵泛溢。
　　苏小姐道：“我没见过董太太，可是我想像得出董太太的美。　董先生的诗：”好赋归来看妇靥“，活画出董太太的可爱的笑容，两个深酒涡。”赵辛楣道：“斜川有了好太太不够，还在诗里招摇，我们这些光杆看了真眼红，”说时，仗着酒勇，涎着脸看苏小姐。
　　褚慎明道：“酒涡生在他太太脸上，只有他一个人看，现在写进诗里，我们都可以仔细看个饱了。”斜川生气不好发作，板着脸说：“跟你们这种不通的人，根本不必谈诗。我这一联是用的两个典，上句梅圣俞，下句杨大眼，你们不知道出处，就不要穿凿附会。”辛楣一壁斟酒道：“抱歉抱歉！　我们罚自己一杯。　方先生，你应该知道出典，你不比我们呀！　为什么也一窍不通？　你罚两杯，来！”鸿渐生气道：“你这人不讲理，为什么我比你们应当知道？”苏小姐因为斜川骂“不通”，有自己在内，甚为不快，说：“我也是一窍不通的，可是我不喝这杯罚酒。”辛楣已有醉意，不受苏小姐约束道：“你可以不罚，他至少也得还喝一杯，我陪他。”说时，把鸿渐杯子里的酒斟满了，拿起自己的杯子来一饮而尽，向鸿渐照着。
　　鸿渐毅然道：“我喝完这杯，此外你杀我头也不喝了。”举酒杯直着喉咙灌下去，灌完了，把杯子向辛楣一扬道：“照——”他“杯”字没出口，紧闭嘴，连跌带撞赶到痰盂边，“哇”的一声，菜跟酒冲口而出，想不到肚子里有那些呕不完的东西，只吐得上气不接下气，鼻涕眼泪胃汁都赔了。　心里只想：“大丢脸！　亏得唐小姐不在这儿。”　胃里呕清了，恶心不止，旁茶几坐下，　抬不起头，衣服上都溅满脏沫。　苏小姐要走近身，他疲竭地做手势阻止她。　辛楣在他吐得厉害时，为他敲背，斜川叫跑堂收拾地下，拿手巾，自己先倒杯茶给他漱口。褚慎明掩鼻把窗子全打开，满脸鄙厌，可是心里高兴，觉得自己泼的牛奶，给鸿渐的呕吐在同席的记忆里冲掉了。
　　斜川看鸿渐好了些，笑说：“”凭阑一吐，不觉箜篌“，怎么饭没吃完，已经忙着还席了！　没有关系，以后拼着吐几次，就学会喝酒了。”辛楣道：“酒，证明真的不会喝了。　希望诗不是真的不会做，哲学不是真的不懂。”苏小姐发恨道：“还说风凉话呢！　全是你不好，把他灌到这样，明天他真生了病，瞧你做主人的有什么脸见人？——鸿渐，你现在觉得怎么样？”把手指按鸿渐的前额，看得辛楣悔不曾学过内功拳术，为鸿渐敲背的时候，使他受至命伤。
　　鸿渐头闪开说：“没有什么，就是头有点痛。辛楣兄，今天真对不住你，各位也给我搅得扫兴，请继续吃罢。　我想先回家去了，过天到辛楣兄府上来谢罪。”苏小姐道：“你多坐一会，等头不痛了再走。”辛楣恨不得立刻撵鸿渐滚蛋，便说：“谁有万金油？　慎明，你随身带药的，有没有万金油？”慎明从外套和裤子袋里掏出一大堆盒儿，保喉，补脑，强肺，健胃，通便，发汗，止痛的药片，药丸，药膏全有。　苏小姐捡出万金油，伸指蘸了些，为鸿渐擦在两太阳。　辛楣一肚皮的酒，几乎全成酸醋，忍了一会，说：“好一点没有？今天我不敢留你，改天补请。　我吩咐人叫车送你回去。”苏小姐道：“不用叫车，他坐我的车，我送他回家。”辛楣惊骇得睁大了眼，口吃说：“你，你不吃了？还有菜呢。”鸿渐有气无力地恳请苏小姐别送自己。
　　苏小姐道：“我早饱了，今天菜太丰盛了。　褚先生，董先生，请慢用，我先走一步。　辛楣，谢谢你。”辛楣哭丧着脸，看他们俩上车走了。　他今天要鸿渐当苏小姐面出丑的计划，差不多完全成功，可是这成功只证实了他的失败。　鸿渐斜靠着车垫，苏小姐叫他闭上眼歇一会。　在这个自造的黑天昏地里，　他觉得苏小姐凉快的手指摸他的前额，又听她用法文低声自语：“Pauvre　petiti（可怜的小东西）”他力不从心，不能跳起来抗议。　汽车到周家，苏小姐命令周家的门房带自己汽车夫扶鸿渐进去。　到周先生周太太大惊小怪赶出来认苏小姐，要招待她进去小坐，她汽车早开走了。老夫妇的好奇心无法满足，又不便细问蒙头躺着的鸿渐，只把门房考审个不了，还嫌他没有观察力，骂他有了眼睛不会用，为什么不把苏小姐看个仔细。
　　明天一早方鸿渐醒来，头里还有一条齿线的痛，头像进门擦鞋底的棕毯。躺到下半天才得爽朗，可以起床。写了一封信给唐小姐，只说病了，不肯提昨天的事。追想起来，对苏小姐真过意不去，她上午下午都来过电话，问他好了没有，有没有兴臻去夜谈。　那天是旧历四月十五，暮春早夏的月亮原是情人的月亮，不比秋冬是诗人的月色，何况月亮团圆，鸿渐恨不能去看唐小姐。苏小姐的母亲和嫂子上电影院去了，用人们都出去逛了，只剩她跟看门的在家。她见了鸿渐，说本来自己也打算看电影去的，叫鸿渐坐一会，她上去加件衣服，两人同到园里去看月。她一下来，鸿渐先闻着刚才没闻到的香味，发现她不但换了衣服，并且脸上唇上都加了修饰。苏小姐领他到六角小亭子里，两人靠栏杆坐了。他忽然省悟这情势太危险，今天不该自投罗网，后悔无及。他又谢了苏小姐一遍，苏小姐又问了他一遍昨晚的睡眠，今天的胃口，当头皎洁的月亮也经不起三遍四遍的赞美，只好都望月不作声。鸿渐偷看苏小姐的脸，光洁得像月光泼上去就会滑下来，眼睛里也闪活症月亮，嘴唇上月华洗不淡的红色变为滋润的深暗。苏小姐知道他在看自己，回脸对他微笑，鸿渐要抵抗这媚力的决心，像出水的鱼，头尾在地上拍动，可是挣扎不起。他站起来道：“文纨，我要走了。”苏小姐道：“时间早呢，忙什么？还坐一会。”指着自己身旁，鸿渐刚才坐的地方。
　　“我要坐远一点——你太美了！这月亮会作弄我干傻事。”苏小姐的笑声轻腻得使鸿渐心里抽痛：“你就这样怕做傻子么？会下来，我不要你这样正襟危坐，又浊拜堂听说教。我问你这聪明人，要什么代价你才肯做子？”转脸向他顽皮地问。
　　鸿渐低头不敢看苏小姐，可是耳朵里、鼻子里，都是抵制不了的她，脑子里也浮着她这时候含笑的印象，像漩涡里的叶子在打转：“我没有做傻子的勇气。”苏小姐胜利地微笑，低声说：“Embrasse-moi！”说着一壁害羞，奇怪自己竟有做傻子的勇气，可是她只敢躲在外国话里命令鸿渐吻自己。鸿渐没法推避，回脸吻她。这吻的分量很轻，范围很小，只仿佛清朝官场端茶送客时的把嘴唇抹一抹茶碗边，或者从前西洋法庭见证人宣誓时的把嘴唇碰一碰《圣经》，至多像那些信女们吻西藏活佛或罗马教皇的大脚指，一种敬而远之的亲近。吻完了，她头枕在鸿渐肩膀上，像小孩子甜睡中微微叹口气。鸿渐不敢动，好一会，苏小姐梦醒似的坐直了，笑说：“月亮这怪东西，真教我们都变了傻子了。”“并且引诱我犯了不可饶赦的罪！我不能再待了。”鸿渐这时候只怕苏小姐会提起订婚结婚，爱情好有保障。
　　“我偏不放你走——好，让你走，明天见。”苏小姐看鸿渐脸上的表情，以为他情感冲动得利害，要失掉自主力，所以不敢留他了。鸿渐一溜烟跑出门，还以为刚才唇上的吻，轻松得很，不当作自己爱她的证据。好像接吻也等于体格检验，要有一定斤两，才算合格似的。
　　苏小姐目送他走了，还坐在亭子里。心里只是快活，没有一个成轮廓的念头。想着两句话：“天上月圆，人间月半，”不知是旧句，还是自己这时候的灵感。今天是四月半，到八月半不知怎样。“孕妇的肚子贴在天上，”又记起曹元朗的诗，不禁一阵厌恶。听见女用人回来了，便站起来，本能地掏手帕在嘴上抹了抹，仿佛接吻会留下痕迹的。觉得剩余的今夜只像海水浴的跳板，自己站在板的极端，会一跳冲进明天的快乐里，又兴奋，又战栗。
　　方鸿渐回家，锁上房门，撕了五六张稿子，才写成下面的一封信：文纨女士：
　　我没有脸再来见你，所以写这封信。从过去直到今夜的事，全是我不好。我没有借口，我无法解释。我不敢求你谅宥，我只希望你快忘记我这个软弱、没有勇气的人。因为我真心敬爱你，我愈不忍糟蹋你的友谊。这几个月来你对我的恩意，我不配受，可是我将来永远作为宝贵的回忆。祝你快乐。
　　惭悔得一晚没睡好，明天到银行叫专差送去。提心吊胆，只怕还有下文。十一点钟左右，一个练习生来请他听电话，说姓苏的打来的，他腿都软了，拿起听筒，预料苏小姐骂自己的话，全行的人都听见。
　　苏小姐的声音很柔软：“鸿渐么？我刚收到你的信，还没拆呢。信里讲些什么？是好话我就看，不是好话我就不看；留着当了你面　拆开来羞你。”鸿渐吓得头颅几乎下缩齐肩，眉毛上升入发，知道苏小姐误会这是求婚的信，还要撒娇加些波折，忙说：“请你快看这信，我求你。”“这样着急！好，我就看。你等着，不要挂电话——我看了，不懂你的意思。回头你来解释罢。”“不，苏小姐，不，我不敢见你——”不能再遮饰了，低声道：“我另有——”怎么说呢？糟透了！也许同事们全在偷听——“我另外有——有个人。”说完了如释重负。
　　“什么？我没听清楚。”鸿渐摇头叹气，急得说抽去了脊骨的法文道：“苏小姐，咱们讲法文。我——我爱一个人，——爱一个女人另外，懂？原谅，我求你一千个原谅。”“你——你这个浑蛋！”苏小姐用中文骂他，声音似乎微颤。鸿渐好像自己耳颊上给她这骂沉重地打一下耳光，自卫地挂上听筒，苏小姐的声音在意识里搅动不住。午时一个人到邻近小西菜馆里去饭，怕跟人谈话。忽然转念，苏小姐也许会失恋自杀，慌得什么都吃不进。忙赶回银行，写信求她原谅，请她珍重，把自己作践得一文不值，哀恳她不要留恋。发信以后，心上稍微宽些，觉得饿了，又出去吃东西。四点多钟，同事都要散，他想今天没兴致去看唐小姐了。收发处给他地封电报，他惊惶失，险以为苏小姐的死信，有谁会打电报来呢？拆开一看，“平成”发出的，好像是湖南一个皮名，减少了恐慌，增加了诧异。忙讨本电报明码翻出来是：“敬聘为教捋月薪三百四十元酌送路费盼电霸国立三闾大学校长高松年。”“教捋”即“教授”的错误，“电霸”准是“电复”。从没听过三闾大学，想是个战后新开的大学，高松年也不知道是谁，更不知道他聘自己当什么系的教授。不过有国立大学不远千里来聘请，终是增添身价的事，因为战事起了只一年，国立大学教授还是薪水阶级里可企羡的地位。问问王主任，平成确在湖南，王主任要电报看了，赞他实至名归，说点金银行是小地方，蛟龙非池中之物，还说什么三年国立大学教授就等于简任官的资格。鸿渐听得开心，想这真是转运的消息，向唐小姐求婚一定也顺利。今天太值得记念了，绝了旧葛藤，添了新机会。他晚上告诉周经理夫妇，周经理也高兴，只说平成这地方太僻远了。鸿渐说还没决定答应。周太太说，她知道他先要请苏文纨小姐那样，早结婚了，新式男女没结婚说“心呀，肉呀”的亲密，只怕甜头吃完了，结婚后反而不好。鸿渐笑她只知道个苏小姐。她道：“难道还有旁人么？”鸿渐得意头上，口快说三天告诉她确实消息。她为她死掉的女儿吃醋道：“瞧不出你这样一个人倒是你抢我夺的一块好肥肉！”鸿渐不屑计较这些粗鄙的话，回房间写如下的一封信：晓芙：
　　前天所发信，想已目。我病全好了；你若补写信来慰问，好比病后一帖补药，还是欢迎的。我今天收到国立三闾大学电报，聘我当教授。校址好像太偏僻些，可是不失为一个机会。我请你帮我决定去不去。你下半年计划怎样？你要到昆明去复学，我也可以在昆明谋个事，假如你进上海的学校，上海就变成我唯一依恋的地方。总而言之，我魔住你，缠着你，冤鬼作祟似的附上你，不放你清静。我久想跟我——啊呀！“你”错写了“我”，可是这笔误很有道理，你想想为什么——讲句简单的话，这话在我心里已经复习了几千遍。我深恨发明不来一个新鲜飘忽的说法，只有我可以说，只有你可以听，我说过，我听过，这说法就飞了，过去现在和未来没有第二个男人好对第二个女人这样说。抱歉得很，对绝世无双的你，我　　只能用几千年经人滥用的话来表示我的情感。你允许我说那句话么？我真不敢冒味，你不知道我怎样怕你生气。
　　明天一早鸿渐吩咐周经理汽车夫送去，下午出银行就上唐家。洋车到门口，看见苏小姐的汽车也在，既窘且怕。苏小姐汽车夫向他脱帽，说：“方先生来得巧，小姐来了不多一会。”鸿渐胡扯道：“我路过，不过去了，”便转个弯回家。想这是撒一个玻璃质的谎，又脆薄，又明亮，汽车夫定在暗笑。苏小姐会不会大讲坏话，破人好事？但她未必知道自己爱唐小姐，并且，这半年来的事讲出来只丢她的脸。这样自譬自慰，他又不担忧了。他明天白等了一天，唐小姐没信来。后天去看唐小姐，女用人说她不在家。到第五天还没信，他两次拜访都扑个空。鸿渐急得眠食都废，把自己的信背了十几遍，字字推敲，自觉并无开罪之处。也许她要读书，自己年龄比她大八九岁，谈恋爱就得结婚，等不了她大学毕业，她可能为这事迟疑不决。只要她答应自己，随她要什么时候结婚都可以，自己一定守节。好，再写封信去，说明天礼拜日求允面谈一次，万事都由她命令。
　　当夜刮大风，明天小雨接大雨，一脉相延，到下午没停过。鸿渐冒雨到唐家，小姐居然在家；她微觉女用人的态度有些异常，没去理会。一见唐小姐，便知道她今天非常矜持，毫无平时的笑容，出来时手里拿个大纸包。他勇气全漏泄了，说：“我来过两次，你都不在家，礼拜一的信收到没有？”“收到了。方先生，”——鸿渐听她恢复最初的称呼，气都不敢透——“方先生听说礼拜二也来过，为什么不进来，我那天倒在家。”“唐小姐，”——也还她原来的称呼——“怎么知道我礼拜二来过？”“表姐的车夫看见方先生，奇怪你过门不入，他告诉了表姐，表姐又诉我。你那天应该进来，我们在谈起你。”“我这种人值得什么讨论！”“我们不但讨论，并且研究你，觉得你行为很神秘。”“我有什么神秘？”“还不够神秘么？当然我们不知世事的女孩子，莫测高深。方先生的口才我早知道，对自己所作所为一定有很满意中听的解释。大不了，方先生只要说：”我没有借口，我无法解释，“人家准会原谅。对不对？”“怎么？”鸿渐直跳起来，“你看见我给你表姐的信？”“表姐给我看的，她并且把从船上到那天晚上的事全告诉我。”唐小姐脸上添了愤恨，鸿渐不敢正眼瞧她。
　　“她怎样讲？”鸿渐嗫嚅说；他相信苏文纨一定加油加酱，说自己引诱她、吻她，准备据实反驳。
　　“你自己做的事还不知道么？”“唐小姐，让我解释——”“你”有法解释“，先对我表姐去讲。”方鸿渐平日爱唐小姐聪明，这时候只希望她拙口钝腮，不要这样咄咄逼人。“表姐还告诉我几件关于方先生的事，不知道正确不正确。方先生现在住的周家，听说并不是普通的亲戚，是贵岳家，方先生以前结过婚——”鸿渐要插嘴，唐小姐不愧是律师的女儿，知道法庭上盘问见证的秘诀，不让他分辩——“我不需要解释，是不是岳家？是就好了。你在外国这几年有没有恋爱，我不知道。可是你在回国的船上，就看中一位鲍小姐，要好得寸步不离，对不对？”鸿渐低头说不出话——“鲍小姐走了，你立刻追求表姐，直到——我不用再说了。并且，据说方先生在欧洲念书，得到过美国学位——”鸿渐顿足发恨道：“我跟你吹过我有学位没有？这是闹着玩儿的。”“方先生人聪明，一切逢场作戏，可是我们这种笨蛋，把你开的玩笑都得认真——”唐小姐听方鸿渐嗓子哽了，心软下来，可是她这时候愈心疼，愈心恨，愈要责罚他个痛快——“方先生的过去太丰富了！我爱的人，我要能够占领他整个生命，他在碰见我以前，没有过去，留着空白等待我——”鸿渐还低头不——“我只希望方先生前途无量。”鸿渐身心仿佛通电似的发麻，只知道唐小姐在说自己，没心思来领会她话里的意义，好比头脑里蒙上一层油纸，她的话雨点似的渗不进，可是油纸震颤着雨打的重量。他听到最后一句话，绝望地明白，抬起头来，两眼是泪，像大孩子挨了打骂，咽泪入心的脸。唐小姐鼻子忽然酸了。“你说得对。我是个骗子，我不敢再辩，以后决不来讨厌。”站起来就走。
　　唐小姐恨不能说：“你为什么不辩护呢？我会相信你，”可是只说：“那么再会。”她送着鸿渐，希他还有话说。外面雨下得正大，她送到门口，真想留他等雨势稍杀再走。鸿渐披上雨衣，看看唐小姐，瑟缩不敢拉手。唐小姐见他眼睛里的光亮，给那一阵泪滤干了，低眼不忍再看，机械地伸手道：“再会——”有时候，“不再坐一会么？”可以撵走人，有时候“再会”可以挽留人；唐小姐挽不住方鸿渐，所以加一句“希望你远行一路平安”。他回卧室去，适才的盛气全消灭了，疲乏懊恼。女用人来告诉道：“方先生怪得很站在马路那一面，雨里淋着。”他忙到窗口一望，果然鸿渐背马路在斜对面人家的篱笆外站着，风里的雨线像水鞭子正侧横斜地抽他漠无反应的身体。她看得心溶化成苦水，想一分钏后他再不走，一定不顾笑话，叫用人请他回来。这一分她好长，她等不及了，正要分付女用人，鸿渐忽然回过脸来，狗抖毛似的抖擞身子，像把周围的雨抖出去，开步走了。唐小姐抱歉过信表姐，气愤时说话太决绝，又担忧鸿渐失神落魄，别给汽车电车撞死了。看了几次表，过一个钟头，打电话到周家问，鸿渐还没回去，她惊惶得愈想愈怕。吃过晚饭，雨早止了，她不愿意家里人听见，溜出门到邻近糖果店借打电话，心乱性急，第一次打错了，第二次打过了只听对面铃响，好久没人来接。周经理一家三口都出门应酬去了，鸿渐在小咖啡馆里呆坐到这时候才回家，一进门用人便说苏小姐来过电话，他火气直冒，倒从麻木里苏醒过来，他正换干衣服，电话铃响，置之不理，用人跑上来接，一听便说：“方少爷，苏小姐电话。”鸿渐袜子没穿好，赤了左脚，跳出房门，拿起话筒，不管用听见不听见，厉声——只可惜他淋雨受了凉，已开始塞鼻伤风，嗓子没有劲——说：“咱们已经断了，断了！听见没有？一次两次来电话干吗？好不要脸！你捣得好鬼！我瞧你一辈子嫁不了人——”忽然发现对方早挂断了，险的要再打电话给苏小姐，逼她听完自己的臭骂。那女用人在楼梯转角听得有趣，赶到厨房里去报告。唐小姐听到“好不要脸”，忙挂上听筒，人都发晕，好容易制住眼泪，回家。
　　这一晚，方鸿渐想着白天的事，一阵阵的发烧，几乎不相信是真的，给唐小姐一条条说破了，觉得自己可鄙可贱得不成为人。明天，他刚起床，唐家包车夫送来一个纸包，昨天见过的，上面没写字，猜准是自己写给她的信。他明知唐小姐不会，然而希她会写几句话，借决绝的一刹那让交情多延一口气，忙拆开纸包，只有自己的旧信。他垂头丧气，原纸包了唐小姐的来信，交给车夫走了。唐小姐收到那纸包的匣子，好奇拆开，就是自己送给鸿渐吃的夹心朱古力糖金纸匣子。她知道匣子里是自己的信，不愿意打开，似乎匣子不打开，自己跟他还没有完全破裂，一打开便证据确凿地跟　他断了。这样痴坐了不多久——也许只是几秒种——开了匣盖，看见自己给他的七封信，信封都破了，用玻璃纸衬补的，想得出他急于看信，撕破了信封又手指笨拙地补好。唐小姐心里一阵难受。更发现盒子底衬一张纸，上面是家里的住址跟电话号数，记起这是跟他第一次吃饭时自己写在他书后空页上的，他剪下来当宝贝似的收藏着。她对了发怔，忽然想昨天他电话里的话，也许并非对自己说的；一月前第一次打电话，周家的人误会为苏小姐，昨天两次电话，那面的人一听，就知道是找鸿渐的，毫不问姓名。彼此决裂到这个田地，这猜想还值得证实么？把方鸿渐忘了就算了。可是心里忘不了他，好比牙齿钳去了，齿腔空着作痛，更好比花盆里种的小树，要连根拔它，这花盆就得碎。唐小姐脾气高傲，宁可忍痛至于生病。病中几天，苏小姐天天来望她陪她，还告诉她已跟曹元朗订婚，兴头上偷偷地把曹元朗求婚的事告诉她。据说曹元朗在十五岁时早下决心不结婚，一见了苏小姐，十五年来的人生观像大地震时的日本房屋。因此，“他自己说，他最初恨我怕我，想躲着我，可是——”苏小姐笑着扭身不说完那句话。求婚是这样的，曹元朗见了面，一股怪可怜的样子，忽然把一个丝绒盒子塞在苏小姐手里，神色仓皇地跑了。苏小姐打开，盒子里盘一条金挂链，头上一块大翡翠，链下压一张信纸。唐小姐问她信上说些什么，苏小姐道：“他说他最初恨我，怕我，可是现在——唉，你这孩子最顽皮，我不告诉你。”唐小姐病愈姊妹姊夫邀她到北平过夏。阳历八月底她回上海，苏小姐恳请她做结婚时的傧相。男傧相就是曹元朗那位留学朋友。他见唐小姐，大献殷勤，她厌烦不甚理他。他撇着英国腔向曹元朗说道：“Dashit！Thatgirlisforget-me-notandtouch-me-notinone，aredrosewhichhassomehowturnedintotheblueflower.”曹元朗赞他语妙天下，他自以为这句话会传到唐小姐耳朵里。可是唐小姐在吃喜酒后第四天，跟她父亲到香港转重庆去了。
　　第四章方鸿渐把信还给唐小姐时，痴钝并无感觉。过些时，他才像从昏厥里醒过来，开始不住的心痛，就像因蜷曲而麻木的四肢，到伸直了血脉流通，就觉得剌痛。昨天囫囵吞地忍受的整块痛苦，当时没工夫辨别滋味，现在，牛反刍似的，零星断续，细嚼出深深没底的回味。卧室里的沙发书桌，卧室窗外的树木和草地，天天碰见的人，都跟往常一样，丝毫没变，对自己伤心丢脸这种大事全不理会似的。奇怪的是，他同时又觉得天地惨淡，至少自己的天地变了相。他个人的天地忽然从世人公共生活的天地里分出来，宛如与活人幽明隔绝的孤鬼，瞧着阳世的乐事，自己插不进，瞧着阳世的太阳，自己晒不到。人家的天地里，他进不去，而他的天地里，谁都可以进来，第一个拦不住的就是周太太。一切做长辈的都不愿意小辈瞒着自己有秘密；把这秘密哄出来，逼出来，是长辈应尽的责任。唐家车夫走后，方鸿渐上楼洗脸，周太太半楼梯劈面碰见，便想把昨夜女用人告诉的话问他，好容易忍住了，这证明刀不但负责任，并且有涵养。她先进餐室，等他下来。效成平日吃东西极快，今天也慢条斯理地延宕着，要听母亲问鸿渐话。直到效成等不及，上学校去了，她还没风鸿渐来吃早点，叫用人去催，才知道他早偷偷出门了。周太太因为枉费了克己工夫，脾气发得加倍的大，骂鸿渐混账，说：“就是住旅馆，出门也得分付茶房一声。现在他吃我周家的饭，住周家的房子，赚我周家的钱，瞒了我外面去胡闹，一早出门，也不来请安，目无尊长，成什么规矩！他还算是念书人家的儿子！书上说的：”清早起，对父母，行个礼，“他没念过？他给女人迷错了头，全没良心，他不想想不靠我们周家的栽培，什么酥小姐、糖小姐会看中他！”周太太并不知道鸿渐认识唐小姐，她因为“芝麻酥糖”那现成名词，说“酥”顺口带说了“糖”；信口胡扯，而偏能一语道破，天下未卜先知的预言家都是这样的。
　　方鸿渐不吃早点就出门，确为了躲避周太太。他这时候怕人盘问，更怕人怜悯或教训。他心上的新创口，揭着便痛。有人失恋了，会把他们的伤心立刻像叫化子的烂腿，血淋淋地公开展览，博人怜悯，或者事过境迁，像战士的金疮旧斑，脱衣指示，使人惊佩。鸿渐只希望能在心理的黑暗里隐蔽着，仿佛病的眼睛避光，破碎的皮肉怕风。所以他本想做得若无其事，不让人看破自己的秘密，瞒得过周太太，便不会有旁人来管闲事了。可是，心里的痛苦不露在脸上，是桩难事。女人有化妆品的援助，胭脂涂得浓些，粉擦得厚些，红白分明会掩饰了内心的凄黯。自己是个男人，平日又不蓬首垢面，除了照例的梳头刮脸以外，没法用非常的妆饰来表示自己照常。仓卒间应付不来周太太，还是溜走为妙。鸿渐到了银行，机械地办事，心疲弱得没劲起念头。三闾大学的电报自动冒到他记忆面上来，他叹口气，毫无愿力地复电应允了。他才分付信差去拍电报，经理室派人来请。周经理见了他，皱眉道：“你怎么一回事？我内人在发肝胃气，我出门的时候，王妈正打电话请医生呢。”鸿渐忙申辩，自己一清早到现在没碰见过她。
　　周经理器丧着脸道：“我也开不清你们的事。可是你丈母自从淑英过世以后，身体老不好。医生量她血压高，叮嘱她动不得气，一动气就有危险，所以我总让她三他，你——你不要拗她顶她。”说完如释重负的吐口气。周经理见了这挂名姑爷，乡绅的儿子，留洋学生，有点畏闪，今天的谈话，是义不容辞，而心非所乐。他跟周太太花烛以来，一向就让她。当年死了女儿，他想娶个姨太太来安慰自己中年丧女的悲，给周太太知道了，生病求死，嚷什么“死了干净，好让人家来填缺，”吓得他安慰也不需要了，对她更短了气焰。他所说的“让她三分”，不是“三分流水七分尘”的“三分”，而是“天下只有三分月色”的“三分”。
　　鸿渐勉强道：“我记着就是了。不知道她这时候好了没有？要不要我打个电话问问？”“你不要打！她跟你生的气，你别去自讨没趣。我临走分付家里人等医生来过，打电话报告我的。你丈母是上了年纪了！二十多年前，我们还没有来上海，那时候她就有肝胃气病。发的时候，不请医生打针，不吃止痛药片，要吃也没有！有人劝她抽两口鸦片，你丈母又不肯，怕上瘾。只有用我们乡下土法，躺在床上，叫人拿了门闩，周身捶着。捶她的人总是我，因为这事要亲人干，旁人不知痛痒，下手太重，变成把棒打了。可是现在她吃不消了。这方法的确很灵验，也许你们城里人不想信的。”鸿渐正在想未成婚的女婿算不算“亲人”，忙说：“相信！相信！这也是一种哄骗神经的方法，分散她对痛处的集中注意力，很有道理。”周经理承认他解释得对。鸿渐回到办公桌上，满肚子不痛快，想周太太的态度一天坏似一天，周家不能长住下去了，自己得赶早离开上海。周经理回家午饭后到行，又找鸿渐谈话，第一句便问他复了三闾大学的电报没有。鸿渐忽然省悟，一股怒气使心从痴钝里醒过来，回答时把身子挺足了以至于无可更添的高度。周经理眼睛躲避着鸿渐的脸，只瞧见写字桌前鸿渐胸脯上那一片白衬衫慢慢地饱满扩张，领带和腰带都在离桌上升，便说：“你回电应聘了最好，在我们这银行里混，也不是长久的办法，”还请他“不要误会”。鸿渐剌耳地冷笑，问是否从今天起自己算停职了。周经理软弱地摆出尊严道：“鸿渐，我告诉你别误会！你不久就远行，当然要忙着自己的事，没工夫兼顾行里——好在行里也没有什么事，我让你自由，你可以不必每天到行。至于薪水呢，你还是照支——”“谢谢你，这钱我可不能领。”“你听我说，我教会计科一起送你四个月的薪水，你旅行的费用，不必向你老太爷去筹——”“我不要钱，我有钱，”鸿渐说话时的神气，就仿佛国立四大银行全他随身口袋里，没等周经理说完，高视阔步出经理室去了。只可惜经理室太小，走不上两步，他那高傲的背影已不复能供周经理瞻仰。而且气愤之中，精神照顾不周，皮鞋直踏在门外听差的脚上，鸿渐只好道歉，那听差提起了腿满脸苦笑，强说：“没有关系。”周经理摇摇头，想女人家不懂世事，只知道家里大发脾气，叫丈夫在外面做人为难自己惨淡经营了一篇谈话腹稿，本想从鸿渐的旅行费说到鸿渐的父亲，承着鸿渐的父亲，语气捷转说：“你回国以后，没有多跟你老太爷老太太亲热，现在你又要出远门了，似乎你应该回府住一两个月，伺候伺候二老。我跟我内人很喜欢你在舍间长住，效成也舍不得你去可是我扣留住你，不让你回家做孝顺儿子，亲家、亲家母要上门来”探亲相骂“了——”说到此地，该哈哈大笑，拍着鸿渐的手或臂或肩或背，看他身体上什么可拍的部分那时候最凑手方便——“反正你常到我家里来玩儿，可不是一样？要是你老不来，我也不答应的。”自信这一席话委婉得体，最后那一段尤其接得天衣无缝，曲尽文书科王主任所谓“顺水推舟”之妙，王主任起的信稿子怕也不过如此。只可恨这篇好谈话一讲出口全别扭了，自己先发了慌，态度局促，鸿渐那混小子一张没好气挨打嘴巴的脸，好好给他面子下台，他偏愿意抓踊了面子顶撞自己，真不识抬举，莫怪太太要厌恶他。那最难措辞的一段话还闷在心里，像喉咙里咳不出来的粘痰，搅得奇痒难搔。周经理象征地咳一声无谓的嗽，清清嗓子。鸿渐这孩子，自己白白花钱栽培了他，看来没有多大出息。方才听太太说，新近请人为他评命，命硬得很，婚姻不会到头，淑英没过门就给他死了！现在正交着桃花运，难保不出乱子，让他回家给方乡绅严加管束也好，自己卸了做长辈的干系。可是今天突然撵他走，终不大好意思——唉，太太仗着发病的脾气，真受不了！周经理叹口气，把这事搁在一边，拿起桌子上的商业信件，一面捺电铃。
　　方鸿渐不愿意脸上的羞愤给同僚们看见，一口气跑出了银行。心里咒骂着周太太，今天的事准是她挑拨出来的，周经理那种全听女人作主的丈夫，也够可鄙了！可笑的是，到现在还不明白为什么周太太忽然在小茶杯里兴风作浪，自忖并没有开罪她什么呀！不过，那理由不用去追究，他们要他走，他就走，决不留连，也不屑跟他计较是非。本来还想买点她爱吃的东西晚上回去孝敬她，讨她喜欢呢！她知道了苏小姐和自己往来，就改变态度，常说讨厌话。效成对自己本无好感，好像为他补习就该做他的枪手的，学校里的功课全要带回家来代做，自己不答应，他就恨。并且那小鬼爱管闲事，亏得防范周密，来往信札没落在他手里。是了！是了！一定是今天早晨唐家车夫来取信，她起了什么疑心，可是她犯不着发那么大的脾气呀？真叫人莫名其妙！好！好！运气坏就坏个彻底，坏个痛快。昨天给情人甩了，今天给丈人撵了，失恋继以失业，失恋以臻失业，真是摔了仰天交还会跌破鼻子！“没兴一齐来”，来就是了索性让运气坏得它一个无微不至。周家一天也不能住了，只有回到父亲母亲那儿挤几天再说，像在外面挨了打的狗夹着尾巴窜回家。不过向家里承认给人撵回来，脸上怎下得去？这两天来，人都气笨了，后脑里像棉花裹的鼓槌在打布蒙的鼓，模糊地沉重，一下一下的跳痛，想不出圆满的遮羞方式，好教家里人不猜疑自己为什么突然要回家过不舒服的日子。三闾大学的电报，家里还没知道，报告了父亲母亲，准使他们高兴，他们高兴头上也许心气宽和，不会细密地追究盘问。自己也懒得再想了，依仗这一个好消息，硬着头皮回家去相机说话。跟家里讲明白了，盘桓到老晚才回周家去睡，免得见周经理夫妇的面，把三件行李收拾好，明天一早就溜走，留封信告别，反正自己无面目见周经理周太太，周经理周太太也无面目见自己，这倒省了不少麻烦。搬回家也不会多住，只等三闾大学旅费汇来，便找几个伴侣上路。上路之前不必到银行去，乐得逍遥几天，享点清闲之福。不知怎样，清闲之福会牵起唐小姐，忙把念头溜冰似的滑过，心也虚闪了闪幸未发作的痛。
　　鸿渐四点多钟到家，老妈子一开门就嚷：“大少爷来了，太太，大少爷来了，不要去请了。”鸿渐进门，只见母亲坐在吃饭的旧圆桌侧面，抱着阿凶，喂他奶粉，阿丑在旁吵闹。老妈子关上门赶回来逗阿丑，教他“不要吵，乖乖的叫声”大伯伯“，大伯伯给糖你吃”。阿丑停嘴，光着眼望了望鸿渐，看不像有糖会给他，又向方老太太跳嚷去了。
　　这阿丑是老二鹏图的儿子，年纪有四岁了，下地的时候，相貌照例丑的可笑。鹏图没有做惯父亲，对那一团略具五官七窍的红肉，并不觉得创造者的骄傲和主有者的偏袒，三脚两步到老子书房里去报告：“生下来一个妖怪。”方豚翁老先生抱孙心切，刚占了个周易神卦，求得≡，是“小畜”卦，什么“密云不雨”，“舆脱辐，夫妻反目”，“血去惕出无咎”。他看了《易经》的卦词纳闷，想莫非媳妇要难产或流产，正待虔诚再卜一卦，忽听儿子没头没脑的来一句，吓得直跳起来：“别胡说！小孩子下地没有？”鹏图瞧老子气色严重，忙规规矩矩道：“是个男孩子母子都好。”方豚翁强忍着喜欢，教训儿子道：“已经是做父亲的人了，讲话还那样不正经，瞧你将来怎么教你儿子！”鹏图解释道：“那孩子的相貌实在丑——请爸爸起个名字。”“好，你说他长得丑，就叫他”丑儿“得了。”方豚翁想起《荀子·非相篇》说古时大圣大贤的相貌都是奇丑，便索性跟孙子起个学名叫“非相”。方老太太也不懂什么非相是相，只嫌“丑儿”这名字不好，说：“小孩子相貌很好——初生的小孩子全是那样的，谁说他丑呢？你还是改个名字罢。”这把方豚翁书袋底的积年陈货全掏出来了：“你们都不懂这道理，要鸿渐在家，他就会明白。”一壁说，到书房里架子上拣出两三部书，翻给儿子看，因为方老太太识字不多。方鹏图瞧见书上说：“人家小儿要易长育，每以贱名为小名，如犬羊狗马之类，”又知道司马相如小字犬子，桓熙小字石头，范晔小字砖儿，慕容农小字恶奴，元叉小字夜叉，更有什么斑兽、秃头、龟儿、獾郎等等，才知道儿子叫“丑儿”还算有体面的。方豚翁当天上茶馆跟大家谈起这事，那些奉承他的茶友满口道贺之外，还恭维他取的名字又别致，又浑成，不但典雅，而且洪亮。只有方老太太弄孙的时候，常常脸摩着脸，代他抗议道：“咱们相貌多漂亮！咱们是标臻小宝贝心肝，为什么冤枉咱丑？爷爷顶不讲道理，去拉掉他胡子。”方鸿渐在外国也写信回来，对侄儿的学名发表意见，说《封神榜》里的两个开路鬼，哥哥叫方弼，兄弟叫方相，“方非相”的名字好像在跟鬼兄弟抬杠，还是趁早换了。方豚翁置之不理。去年战事起了不多几天，老三凤仪的老婆也养个头胎儿子，方豚翁深有感于“兵凶战危”，触景生情，叫他“阿凶”，据《墨子·非攻篇》为他取学名“非攻”。豚翁题名字上了瘾，早想就十几个排行的名字，只等媳妇们连一不二养下孩子来顶领，譬如男叫“非熊”，用姜太公的故事，女叫“非烟”，用唐人传奇。
　　这次逃难时，阿丑阿凶两只小东西真累人不浅。鸿渐这个不近人情的鳏夫听父母讲逃难的苦趣，便心中深怪两位弟妇不会领孩子，害二老受罪。这时候阿丑阿凶缠着祖母，他们的娘连影子都不见，他就看不入眼。方老太太做孝顺媳妇的年分太长了，忽然轮到自己做婆婆，简直做不会，做不像。在西洋家庭里，丈母娘跟女婿间的争斗，是至今保存的古风，我们中国家庭里婆婆和媳妇的敌视，也不输他们那样悠久的历史。只有媳妇怀孕，婆婆要依仗了她才能荣升祖母，于是对她开始迁就。到媳妇养了个真实不假的男孩子，婆婆更加让步。方老太太生性懦弱，两位少奶倒着实利害，生阿丑的时候，方家已经二十多年没听见小孩子哭声了，老夫妇不免溺爱怂恿，结果媳妇的气焰暗里增高，孙子的品性显然恶化。凤仪老婆肚子挣气，头胎也是男孩子，从此妯娌间暗争愈烈。老夫妇满脸的公平待遇，两儿子媳妇背后各怨他们的偏袒。鸿渐初回国，家里房子大，阿丑有奶妈领着，所以还不甚碍眼讨厌。逃难以后，阿丑的奶妈当然可以省掉了；三奶奶因为阿凶是开战时生的，一向没用奶妈，到了上海，要补用一个，好跟二奶奶家的阿丑扯直。依照旧家庭的不成文法，孙子的乳母应当由祖父母出钱雇的。方豚翁逃难到上海，景况不比从，多少爱惜小费，不肯为二孙子用乳母。可是他对三奶奶谈话，一个字也没提起经济，他只说上海不比家乡，是个藏垢纳污之区，下等女人少有干净的；女用人跟汽车夫包车夫了孩子，出来做奶妈，这种女人全有毒，喂不得小孩子，而且上海风气太下流了，奶妈动不动要请假出去过夜，奶汗起了变化，小孩子吃着准不相宜，说不定有终身之恨。三奶奶瞧公婆要她自己领这孩子。一口闷气胀得肚子都渐渐大了，吃东西没胃口，四肢乏力，请医服药，同时阿凶只能由婆婆帮着带领。医生一星期前才证明她不是病，是怀近四个月的孕。二奶奶腆着颤巍巍有六个月孕的肚子，私下跟丈夫冷笑道：“我早猜到那么一着，她自己肚子里全明白什么把戏。只好哄你那位糊涂，什么臌胀，气痞，哼，想瞒得了我！”大家庭里做媳妇的女人平时吃饭的肚子要小，受气的肚子要大；一有了胎，肚子真大了，那时吃饭的肚子可以放大，受气的肚子可以缩小。这这两位奶奶现在的身体像两个吃饱苍蝇的大蜘蛛，都到了减少屋子容量的状态，忙得方老太太应接不暇，那两个女用人也乘机吵着，长过一次工钱。
　　方豚翁为了三媳妇的病，对家庭医药大起研究的兴趣。他在上海，门上冷落，不比从前居乡的时候。同乡一位庸医是他邻居，仰慕他的名望，钉人有暇，来陪他闲谈。这位庸医在本真的是“三世行医，一方尽知”，总算那一方人抵抗力强，没给他祖父父亲医绝了种，把四方剩了三方。方豚翁正如一切老辈读书人，自信“不为良相，便为良医”，懂得医药。那庸医以为他广通声气，希望他介绍生意，免不了灌他几回迷汤。这迷汤好比酒，被灌者的量各各不同；豚翁的迷汤量素来不大，给他灌得酒醉的忘其所以。恰好三媳妇可以供给他做试验品，他便开了不少方子。三奶奶觉得公公和邻居医生的药吃了无效，和丈夫吵，要去请教西医。豚翁知道了这事，心里先不高兴，听说西医断定媳妇不是病，这不高兴险的要发作起来。可是西医说她有孕，是个喜讯，自己不好生气，只得隐忍，另想方法来挽回自己医道的体面，洗涤中国医学的耻辱。方老太太带鸿渐进他卧室，他书桌上正摊着《镜花缘》里的奇方摘录在《验方新编》的空白上。豚翁看见儿子，便道：“你来了，我正要叫你来，跟你说话。你有个把月没来了，家里也该常来走走。我做父亲的太放纵你们了，你们全不知道规矩礼节——”翻着《验方新编》对方老太太道：“娘，三媳妇既然有喜，我想这张方子她用得着。每天两次，每次豆腐皮一张，不要切碎，酱油麻油冲汤吞服。这东西味道不苦。可以下饭，最好没有，二媳妇也不妨照办。这方子很有道理：豆腐皮是滑的，麻油也是滑的，在胎里的孩子胞衣滑了，容易下地，将来不致难产，你把这方子给她们看看。不要去，听我跟鸿渐讲话——鸿渐，你近三十岁的人了，自己该有分寸，照理用不到我们背时的老士董来多嘴。可是——娘，咱们再不管教儿子，人家要代咱们管教他了，咱们不能丢这个脸，对不对——你丈母早晨来个电话，说你在外面荒唐，跟女人胡闹，你不要辩，我不是糊涂人，并不全相信她——”豚翁对儿子伸着左手，掌心向下，　个压止他申辩的信号——“可是你一定有行迹不检的地方，落在她眼里。你这年龄自然规规矩矩地结了婚完事；是我不好，一时姑息着你，以后一切还是我来替你作主。我想你搬回家住罢，免得讨人家厌，同时好有我来管教你。家里粗茶淡饭的苦生活，你也应该过过；年轻人就贪舒服，骨头松了，一世没有出息。”方鸿渐羞愤头上，几十句话同时涌到嘴边，只挣扎出来：“我是想明天搬回来，我丈母在发神经病，她最爱无事生风，真混账——”豚翁怫然道：“你这态度就不对，我看你愈变愈野蛮无礼了。就算她言之过甚，也是她做长辈的一片好意，你们这些年轻人——”方豚翁话里留下空白，表示世间无字能形容那些可恶无礼的年轻人。
　　方老太太瞧鸿渐脸难看，怕父子俩斗口，忙怯懦地、狡猾地问儿子道：“那位苏小姐怎么样了？只要你真喜欢她，爸爸和我总照着你意思办，只要你称心。”方鸿渐禁不住脸红道：“我和她早不往来了。”这脸红逃不过老夫妇的观察，彼此做个眼色，豚翁彻底了解地微笑道：“是不是吵嘴闹翻了？这也是少年男女间常有的事，吵一次，感情好一次。双方心里都已经懊悔了，面子上还负气谁也不理谁。我讲得对不对？这时候要有个第三者，出来转圜。你不肯受委屈认错，只有我老头子出面做和事老，给她封宛转的信，她准买我面子。”豚翁笑容和语气里的顽皮，笨重得可以压坍楼板。
　　鸿渐宁可父亲生气，最怕他的幽默，慌得信口胡说道：“她早和人订婚了。”老夫妇眼色里的含意愈深了。豚翁肃然改容道：“那么，你是——是所谓”失恋“了。唔，那也犯不着糟踏自己呀！日子长着呢。”豚翁不但饶赦，而且怜惜遭受女人欺侮的这个儿子了。
　　鸿渐更局促了。不错，自己是“失恋”——这两个字在父嘴里，生涩拗口得——可是，并非为了苏文纨。父母的同情施错了地方，仿佛身上受伤有创口，而同情者偏向皮肉完好处去敷药包布。要不要诉他们唐小姐的事？他们决不会了解，说不定父亲就会大笔一挥，直接向唐小姐替自己求婚，他会闹这种笑话的。鸿渐支吾掩饰了两句，把电报给豚翁看了。不出所料，同太太的事果然撇在一边。豚翁说，这才是留学生干的事，比做小银行职员混饭强多了；平成那地方确偏僻些，可是“咱们方家在自由区该有个人，我和后方可以通通声气，我自从地方沦陷后一切行动，你可以进去向有关方面讲讲。”过一会，豚翁又说：“你将来应该按月寄三分之一的薪水给我，并不是我要你的钱，是训练你对父母的责任心，你两个兄弟都分担家里开销的。”吃晚饭桌上，豚翁夫妇显然偏袒儿子了，怪周家小气，容不下人，要借口撵走鸿渐：“商人终是商人，他们看咱们方家现在失势了。这种鄙吝势利的暴发户，咱们不希罕和他们做亲家。”二老议决鸿渐今夜回周家去收拾行李，明天方老太太去访问周太太的病，替鸿渐谢打扰，好把行李带走。
　　鸿渐吃完晚饭，不愿意就到周家，便一个人去看电影。电影散场，又延宕了一会，料想周经理夫妇都睡了，才慢慢回去。一进卧室，就见桌上有效成的英文文法教科书，书里夹着字条：“鸿渐哥：我等不及你了，要去睡觉了。文法练习第三十四到三十八，请你快快一做。还有国文自由命题一篇，随便做二百字，肯做三百字更好，马马虎虎，文章不要太好。明天要交卷也。ThankYouVeryMuch.”书旁一大碟枇杷和皮核，想是效成等自己时消闲吃的。鸿渐哼了一声，把箱子整理好，朦胧略睡，一清早离开周家。周太太其实当天下午就后悔，感觉到胜利的空虚了，只等鸿渐低心下气来赔罪，就肯收回一切成命。明早发现鸿渐不告而别，儿子又在大跳大骂要逃一天学，她气得唠叨不了，方老太太来时，险的客串“探亲相骂”。午饭时，点金银行差人把鸿渐四个月薪水送到方家；方豚翁代儿子收下了。
　　方鸿渐住在家里，无聊得很。他天天代父亲写信、抄药方，一有空，便上街溜达。每出门，心里总偷偷希望，在路上，在车子里，在电影院门口，会意外碰见唐小姐。碰见了怎样呢？有时理想自己的冷淡、骄傲，对她视若无睹，使她受不了。有时理想中的自己是微笑地镇静，挑衅地多礼，对她客气招呼，她倒窘得不知所措。有时他的想像力愈雄厚了，跟一个比唐小姐更美的女人勾手同行，忽与尚无男友的唐小姐劈面相逢；可是，只要唐小姐有伤心绝望的表示，自己立刻甩了那女人来和她言归于好。理想里的唐小姐时而骂自己“残忍”，时而强抑情感，别转了脸，不让睫毛上眼泪给自己看见。
　　家里住近十天，已过端午，三闾大学毫无音信，鸿渐开始焦急。一天清早，专差送封信来，是赵辛楣写的，说昨天到点金银行相访未晤，今天下午四时后有暇请来舍一谈，要事面告。又说：“以往之事，皆出误会，望勿介意。”顶奇怪的是称自己为：“鸿渐同情兄。”鸿渐看后，疑团百出。想现在赵辛楣娶定苏小姐了，还来找自己干吗，终不会请去当他们结婚的傧相。等一会，报纸来了，三奶奶抢着看，忽然问：“大哥的女朋友是不是叫苏文纨？”鸿渐恨自己脸红，知道三奶奶兴趣浓厚地注视自己的脸，含糊反问她什么。三奶奶指报纸上一条启事给他看，是苏鸿业、曹元真两人具名登的，要读报者知道姓苏的女儿和姓曹的兄弟今天订婚。鸿渐惊异得忍不住叫“咦”！想来这就是赵辛楣信上所说的“要事”了。苏小姐会嫁给曹元朗，女人傻起来真没有底的！可怜的是赵辛楣。他没知道，苏小姐应允曹元朗以后，也说：“赵辛楣真可怜，他要怨我忍心了。”曹诗人高兴头上，平时对女人心理的细腻了解忘掉个干净，冒失地说：“那不用愁，他会另找到对象。我希望人人像我一样快乐，愿意他也快快恋爱成功。”苏小姐沉着脸不响，曹元朗才省悟话说错了。一向致力新诗，没留心到元微之的两句：“曾经沧海难为水，除却巫山不是云，”后悔不及。苏小姐当然以为看中自己的人，哪能轻易赏识旁的女人？她不嫁赵辛楣，可是她潜意识底，也许要赵辛楣从此不娶，耐心等曹元朗死了候补。曹元朗忙回家做了一首情诗送来，一以志嘉二以补过。这诗的大意表示了破除财产私有的理想，说他身心一切都与苏小姐共有。他情感热烈，在初夏的骄阳下又多跑了几次，头上正生着两个小疖，脸上起了一层红疙瘩，这些当然也跟苏小姐共有的。
　　方鸿渐准五点钟找到赵辛楣住的洋式公寓，没进门就听见公寓里好几家正开无线电，播送风行一时的《春之恋歌》，空气给那位万众倾倒的国产女明星的尖声撕割得七零八落——
　　春天，春天怎么还不来？
　　我心里的花儿早已开！
　　唉！！！我的爱——逻辑的推论法然是：夏天没到，她身体里就结果子了。那女明星的娇声尖锐里含着浑浊，一大半像鼻子里哼出来的，又腻又粘，又软懒无力，跟鼻子的主产品鼻涕具有同样品性。可是，至少该有像鼻子那么长短，才包涵得下这弯绕连绵的声音。走到支楼赵家门外，里面也播着这歌呢。他一而按铃，想该死！该死！听这种歌好比看淫书淫画，是智力落后、神经失常的表示，不料赵辛楣失恋了会堕落至此！用人开门接名片进去无线电就止声了。用人出来请进小客室，布置还精臻壁上挂好几个大镜框。有赵辛楣去世的父亲的大照相、赵辛楣硕士制服手执文赁的大照相、赵辛楣美国老师的签字照相。留美学生夏令会的团体照相里赵辛楣美第一排席地坐着，为教观者容易起见，他在自己头顶用红墨水做个“＋”号，正画在身后站的人的胸腹上，大有替他用日本方法“切腹”之观。紧剌眼的是一张彩色的狭长照相，内容是苏小姐拿棍子赶一群白羊，头上包块布，身上穿的想是牧装，洋溢着古典的、浪漫的、田园诗的、牧歌的种种情调。可惜这牧羊女不像一心在管羊，脸朝镜框外面，向观者巧笑。据照相边上两行字，这是苏小姐在法国乡下避暑时所摄，回国后放大送给辛楣的。鸿渐竟会轻快地一阵嫉妒，想苏小姐从未给自己看过这张好照相。在这些亲、师、友、妇等三纲五常摄影之外，有一副对、一幅画，落的都是辛楣的款。对是董斜川写的《九成宫》体：“阙尚鸳鸯社；闹无鹅鸭邻。辛楣二兄，三十不娶，类李东川诗所谓”有道者“，迁居索句，戏撰疥壁。”那幅画是董斜川夫人手笔，标题《结庐人境图》。鸿渐正待细看，辛楣出来了，急忙中穿的衣服，钮子还没有扣好，天气热，内心也许有点羞愧，脸涨红得有似番茄。鸿渐忙说：“我要脱衣服，请你做主人的赞同。”辛楣道：“好，好。”女用人把两人衣服拿去挂了，送上茶烟，辛楣分付她去取冷饮。鸿渐称赞他房子精致。问他家里有多少人。辛楣说只有他跟他老太太，此外三个用人，他哥哥嫂嫂都住在天津。他看鸿渐一眼，关切地说：“鸿渐兄，你瘦得多了。”鸿渐苦笑说：“都是你那一天灌醉了我，害我生的病。”辛楣怕恐道：“那许多请你别再提了！咱们不打不成相识，以后相处的日子正长，要好好的交个朋友。我问你，你什么时候知道苏小姐爱上曹元朗的？”“今天早晨看见报上订婚启事，我才知道。”“嗳！”——声音里流露出得意——“我大前天清早就知道了。她自己告诉我的，还劝我许多好意的话。可是我到现在不知道那姓曹的是什么样儿的人。”“我倒看见过这人，可是我想不到苏小姐会看中他。我以为她一定嫁给你。”“可不是么！我以为她一定嫁给你。谁知道还有个姓曹的！这妞儿的本领真大，咱们俩都给她玩弄得七颠八倒。客观地讲起来，可不得不佩服她。好了，好了，咱们俩现在是同病相怜，将来是同事——”“什么？你也到三闾大学去？”于是，辛楣坦白地把这事的前因后果讲出来。三闾大学是今年刚着手组织的大学，高松年是他的先生。本来高松年请他去当政治系主任，他不愿意撇下苏小姐，忽然记起她说过鸿渐急欲在国立大学里谋个事，便偷偷拍电报介绍鸿渐给高松年，好教苏小姐跟鸿渐疏远。可是高松年不放松他，函电络绎的请他去，他大前天从苏小姐处奉到遣散命令，一出来就回电答应了。高松年上次来信，托他请鸿渐开履历寄去，又说上海有批应聘的同人，将来由他约齐同行，旅费和路程单都先寄给他。
　　鸿渐恍然大悟道：“我该好好的谢你，为我找到饭碗。”辛楣道：“哪里的话！应当同舟共济。”鸿渐道：“我忘掉问你，你信上叫我”同情兄“，那是什么意思？”辛楣笑道：“这是董斜川想出来的，他说，同跟一个先生念书的叫”同师兄弟“，同在一个学校的叫”同学“，同有一个情人的该叫”同情“。”鸿渐忍不住笑道：“这名字好妙。可惜你的”同情者“是曹元朗，不是我。”辛楣道：“你这人太不坦白！咱们现在是同病相怜，我失恋，你也失恋，当着我，你不用装假挣面子。难道你就不爱苏小姐？”“我不爱她。我跟你同病，不是”同情“。”“那么，谁甩了你？你可以告诉我么？”掩抑着秘密再也压不住了：“唐小姐。”鸿渐垂首低声说。
　　“唐晓芙！好眼力，好眼力！我真是糊涂到了。”本来辛楣仿佛跟鸿渐同遭丧事，竭力和他竞赛着阴郁沉肃的表情，不敢让他独得伤心之名。这时候他知道鸿渐跟自己河水不犯井水，态度轻松了许多，嗓子已恢复平日的响朗。他留住鸿渐，打电话叫董斜川来，三人同上馆子吃晚饭。辛楣的失恋，斜川全知道的。饭后谈起苏小姐和曹元朗订婚的事，辛楣宽宏大度地说：“这样最好。他们志同道合，都是研究诗的。”鸿渐、斜川一致反对，说同行最不宜结婚，因为彼此是行家，谁也哄不倒谁，丈夫不会莫测高深地崇拜太太，太太也不会盲目地崇拜丈夫，婚姻的基础就不牢固。辛楣笑道：“这些话跟我说没有用。我只希望他们俩快乐。”大家都说辛楣心平气和得要成“圣人”了。圣人笑而不答，好一会，取出烟斗眼睛顽皮地闪光道：“曹元朗的东西，至少有苏小姐读：苏小姐的东西，至少有曹元朗读。彼此都不会没有读者，还不好么？”大家笑说辛楣还不是圣人，还可以做朋友。
　　以后鸿渐就不寂寞了，三人常常来往。三星期后，辛楣请新同事上茶室早餐，大家好认识。鸿渐之外，还有三位。中国文学系主任李梅亭是高松年的老同事，四十来岁年纪，戴副墨晶眼镜，神情傲兀，不大理会人，并且对天气也鄙夷不理，因为这是夏历六月中旬，他穿的还是黑呢西装外套。辛楣请他脱衣服，他死不肯；辛楣倒替他出汗，自己的白衬衫像在害黄热病。一位顾尔廉是高松年的远亲，好像没梦想到会被聘为历史系副教授的，快乐像沸水似的洋溢满桌，对赵李两位尤为殷勤。他虽是近五十岁的干瘪男人，绰有天真妩媚小姑娘的风致，他的笑容比他的脸要年轻足足三十年，口内两只金门牙使他的笑容尤其辉煌耀目。一位孙柔嘉女士，是辛楣报馆同事前辈的女儿，刚大学毕业，青年有志，不愿留在上海，她父亲恳求辛楣为她谋得外国语文系助教之职。孙小姐长圆脸，旧象牙色的颧颊上微有雀斑，两眼分得太开，使她常常着惊异的表情；打扮甚为素净，怕生得一句话也不敢讲，脸上滚滚不断的红晕。她初来时叫辛楣“赵叔叔”，辛楣忙教她别这样称呼，鸿渐暗笑。
　　辛楣送老太太到天津去后回来，已是阳历九月初，该动身了，三闾大学定十月初开学的。辛楣又想招大家吃饭商定行期。辛楣爱上馆子吃饭，动不动借小事请客，朋友有事要求他，也得在饭桌上跟他商量，仿佛他在外国学政治和外交，只记着两句，拿破仑对外交官的训令：“请客菜要好，”和斯多威尔候爵（LordStowell）的办事原则：“请吃饭能使事务滑溜顺利。”可是这一次鸿渐抗议说，这是大家的事，不该老让辛楣一个人破钞，结果改为聚餐。吃饭时议定九月二十日坐意大利公司的船到宁波，辛楣说船标五张由他去买，都买大菜间，将来再算账。李顾两位没说什么。吃完饭，侍者送上账单，顾先生抢着归他一个人付账，还说他久蓄此心，要请诸同人一聚，今天最巧没有了。大家都说岂有此理，顾先生眼瞥账单，也就不再坚持，只说：“这小数目，何必分摊？其实让我作东得了。”辛楣一总付了钱，等柜台上找。顾先生到厕所去，李先生也跟去了。出馆子门分手的时候，李先生问辛楣是否轮船公司有熟人，买票方便。辛楣道，托中国旅行社去办就行。李先生道：“我有个朋友在轮船公司做事，要不要我直接托他买？我们已经种种费先生的心，这事兄弟可以效劳。”辛楣道：“那最好没有。五张大菜间，拜托拜托！”当天下午，鸿渐拉了辛楣、斜川坐咖啡馆，谈起这次同行的三个人，便说：“我看李梅亭这讨厌家伙，肚子里没有什么货，怎么可以当中国文学系主任，你应当介绍斜去。”辛楣吐舌道：“斜川？他肯去么？你不信问他自己。只有我们一对失恋的废物肯到那地方去斜川家里有年轻美貌的太太。”斜川笑道：“别胡闹，我对教书没有兴趣。”若有水田三百亩，来年不作猢狲王；“你们为什么不陪我到香港去找机会？”鸿渐道：“对呀，我呢，回国以后等于失业，教书也无所谓。辛楣出路很多，进可以做官，退可以办报，也去坐冷板凳，我替他惋惜。”辛楣道：“办报是开发民智，教书也是开发民智，两者都是”精神动员“，无分彼此。论影响的范围，是办报来得广；不过，论影响的程度，是教育来得深。我这次去也是添一个人生经验。”斜川笑道：“这些大帽子活该留在你的社论里去哄你的读者的。”辛楣发急道：“我并非大话欺人，我真的相信。”鸿渐道：“说大话哄人惯了，连自己也哄相信——这是极普通的心理现象。”辛楣道：“你不懂这道理。教书也可以干政治，你看现在许多中国大政客，都是教授出身，在欧洲大陆上也一样，譬如捷的第一任总统跟法国现在的总理。五政治的人先去教书，一可以把握表年心理；二可以训练自己的干部人才，这跟报纸的制造舆论是一贯的。”鸿渐道：“这不是大教授干政治，这是小政客办教育。从前愚民政策是不许人民受教育，现代愚民政策是只许人民受某一种教育。不受教育的人，因为不识字，上人的当，受教育的人，因为识了字，上印刷品的当，像你们的报纸宣传品、训练干部讲义之类。”辛楣冷笑道：“大家听听，方鸿渐方先生的议论多透辟呀！他年龄刚二十八岁，新有过一次不幸的恋爱经验，可是他看破了教育，看破了政治，看破了一切，哼！我也看破了你！为了一个黄毛丫头，就那么愤世嫉俗，真是小题大做！”鸿渐把杯子一顿道：“你说谁？”辛楣道，“我说唐晓芙，你的意中人，她不是黄毛丫头么？”鸿渐气得脸都发白，说苏文纨是半老徐娘。
　　辛楣道：“她半老不半老，和我不相干，我总不像你那样袒护着唐晓芙，她知道你这样作情未断，还会覆水重收——斜川，对不对？——真没有志气！要不要我替你通个消息？”鸿渐说不出话，站起来了，斜川拉他坐下去，说：“别吵！别吵！人家都在看咱们了。我替你们难为情，反正你们是彼此彼此。鸿渐近来呢，是好像有点反常，男子汉，大丈夫，为一个女子——”鸿渐愤然走出咖啡馆，不去听他。回到家里，刚气鼓鼓地坐着，电话来了，是斜川的声音：“何必生那么大的气？”鸿渐正待回答，那一头换辛楣在说话：“哙，老方呀，我道歉可以，可是你不要假生气呀！今天你作主人，没付账就跑，我们做客人的身上没带钱，扣在咖啡馆里等你来救命呢！S.O.S.快来！晚上水酒一怀谢罪。”鸿渐忍不住笑道：“我就来了。”十九日下午辛楣把李梅亭代习的船票交给鸿渐，说船公司改期到二十二日下午六点半开船，大家六点正上船。在西洋古代，每逢有人失踪，大家说：“这人不是死了，就是教书去了。”方鸿渐虽然不至于怕教书像怕死，可是觉得这次教书是坏运气的一部分，连日无精打采，对于远行有说不出的畏缩，能延宕一天是一天。但船公司真的宽限两天，他又恨这事拖着不痛快，倒不如早走干脆。他带三件行李：一个大子，一个铺盖袋，一个手提箱。方老太太替他置备衣服被褥，说：“到你娶了媳妇，这些事就不用我来管了。”方豚翁道：“恐怕还得要你操心，现在那些女学生只会享现成，什么都不懂的。”方老太太以为初秋天气，变化不测，防儿子路上受寒，要他多带一个小铺盖卷，把晚上用得着的薄棉被和衣服捆在里面，免得天天打开大铺盖。鸿渐怕行李多了累赘，说高松年信上讲快则一星期，迟则十天，准能到达，天气还不会冷，手提里搁条薄羊毛毯就够了。方豚翁有许多临别赠言分付儿子记着，成双作对地很好听，什么“咬紧牙关，站定脚跟”，“可长日思家，而不可一刻恋家”，等等。鸿渐知道这些虽然对自己说，而主要是记载在日记和回忆录里给天下后世看方豚翁怎样教子以义方的。因为豚翁近来闲着无事，忽然发现了自己，像小孩子对镜里的容貌，摇头侧目地看得津津有味。这种精神上的顾影自怜使他写自传、写日记，好比女人穿中西各色春夏秋冬的服装，做出支颐扭颈、行立坐卧种种姿态，照成一张张送人留念的照相。这些记载从各个方面，各种事实来证明方豚翁的高人一等。他现在一言一动，同时就想日记里、言行录里如何记法。记载并不完全凿空，譬如水泡碰破了总剩下一小滴水。研究语言心理学的人一望而知是“语文狂”；有领袖欲的人，不论是文武官商，全流露这种病态。朋友来了，豚翁常把日记给他们看；邻居那位庸医便知道端午节前方家大儿子滥交女友，给豚翁训斥了一顿，结果儿子“为之悚然感司，愧悔无巳”。又如前天的日记写他叫鸿渐到周家去辞行，鸿渐不肯，骂周太太鄙吝势利，他怎样教训儿子“君子躬自厚而薄责于人，亲无失亲，故无失故”，结果儿子怎样帖然“无词”。其实鸿渐并没骂周太太。是豚翁自己对她不满意，所以用这种皮里阳秋的笔法来褒贬。鸿渐起初确不肯去辞行，最后还是去了，一个人没见到。如蒙大赦。过一天，周家送四色路菜来。鸿渐这不讲理的人，知道了非常生气，不许母亲受。方老太太叫儿子自己下去对送礼的人说，他又不肯见周家的车夫。结果周家的车夫推来推去，扔下东西溜了。鸿渐牛性，不吃周家送来的东西。方豚翁日记上添了一条，笑儿子要做“不食周粟”的伯夷叔齐。
　　第五章鸿渐想叫辆汽车上轮船码头。精明干练的鹏图说，汽车价钱新近长了好几倍，鸿渐行李简单，又不勿忙，不如叫两辆洋车，反正有凤仪相送。二十二日下午近五点，兄弟俩出门，车拉到法租界边上，有一个法国巡捕领了两个安南巡捕在搜检行人，只有汽车容易通过。鸿渐一瞧那法国巡捕，就是去年跟自己同船来上海的，在船上讲过几次话，他也似乎还认识鸿渐，一挥手，放鸿渐车子过去。鸿渐想同船那批法国警察，都是乡下人初出门，没一个不寒窘可怜。曾几何时，适才看见的一个已经着色放大了。本来苍白的脸色现在红得像生牛肉，两眼里新织满红丝，肚子肥凸得像青蛙在鼓气，法国人在国际上的绰号是“虾蟆”，真正名副其实，可惊的是添了一团凶横的兽相。上海这地方比得上希腊神话里的魔女岛，好好一个人来了就会变成畜生。至于那安南巡捕更可笑了。东方民族没有像安南人地样形状委琐不配穿制服的。日本人只是腿太短，不宜挂指挥刀。安南人鸠形鹄面，皮焦齿黑，天生的鸦片鬼相，手里的警棍，更像一支鸦片枪。鸿渐这些思想，安南巡仿佛全猜到，他拦住落后的凤仪那辆车子，报复地搜检个不了。他把饼干匣子，肉松罐头全划破了，还偷偷伸手要了三块钱，终算铺盖袋保持完整。鸿渐管着大小两个箱子，路上不便回头，到码头下车，找不见凤仪，倒发了好一会的急。
　　鸿渐辛楣是同舱，孙小姐也碰见了，只找不着李顾两人。船开了还不见他们踪迹，辛楣急得满头大汗，鸿渐孙小姐也帮着他慌。正在烦恼茶房跑来说，三等舱有位客人要跟辛楣谈话，不能上头等舱来，只可以请辛楣下去。鸿渐跟辛楣去一看，就是顾先生，手舞足蹈地叫他们下来。两人忙问：“李先生呢？”顾先生道：“他和我同舱，在洗脸。李先生的朋友只买到三张大菜间，所以李先生和我全让给你们，改坐房舱。”两人听了，很过意不去。顾先生道：“房舱也够舒服了，我领两位去参观参观。”两人跟他进舱，满舱是行李，李先生在洗脚。辛楣和鸿渐为舱位的事，向郑重道谢。顾先生插口道：“本来只有两张大菜间，李先生再三恳求他那位朋友，总算弄到第三张。”辛楣道：“其实那两张，你们两位老先生一人一张，我们年轻人应当苦一点。”李先生道：“大不了十二个钟点的事，算不得什么。大菜间我也坐过，并不比房舱舒服多少。”晚饭后，船有点晃。鸿渐和辛楣并坐在钉牢甲板上的长椅子上。鸿渐听风声水声，望着海天一片昏黑，想起去年回国船上好多跟今夜仿佛一胎孪生的景色，感慨无穷。辛楣抽着鸿渐送他的大烟，忽然说：“鸿渐，我有一个猜疑。可是这猜疑太卑鄙了；假如猜疑得不对，反而证明我是小人，以小人之心度人。”“你说——只要猜疑的不是我。”“我觉得要和顾都在撒谎。五张大菜间一定全买得到，他们要省钱，所以凭空造出这许多话来。你看，李梅亭那一天拦着要去办理票子，上船以前，他一字没提起票子难买的事。假如他提起，我就会派人去办。这中间准有鬼。我气的是，他们捣了鬼，还要赚我们的感激。”“我想你猜得很对。要省钱为什么不老实说？我们也可以坐房舱。并且，学校不是汇来每人旅费一百元么？高松年来信说旅费绰乎有余，省什么小钱？”辛楣道：“那倒不然。咱们俩没有家累；他们都是上了年纪，有小孩子的人，也许家用需要安排。高松年的话也做不得准。现在走路不比太平时候，费用是估计不定的，宁可多带些钱好。你带多少？”鸿渐道：“我把口袋里用剩的钱全带在身边，加上汇来的旅费，有一百六七十元。”辛楣道：“够了。我带了二百元。我只怕李和顾把学校旅费大部分留在家里，带的行李又那么大一堆，万一路上钱不够起来，岂不耽误大家的事。”鸿渐笑道：“我看他们把全家都装在行李里了，老婆、儿子、甚至住的房子。你看李梅亭的铁箱不是有一个人那么高么？他们不必留钱在家里。”辛楣也笑了一笑，说：“鸿渐，我在路上要改变作风了。我比你会花钱，贪嘴，贪舒服。在李和顾的眼睛里，咱们俩也许是一对无知小子，不识物力艰难不体谅旁人。从今以后，我不作主了，膳宿一切，都听他们支配。免得我们挑了贵的旅馆饭馆，勉强他们陪着花钱。这次买船票，是个好教训。”“老赵，你了不起！真有民主精神，将来准做大总统。这次买船票咱们已经带累了孙小姐，她是脸皮嫩得很的女孩子，话说不出口，你做”叔叔“的更该替她设想。”“是呀。并且孙小姐是学校没有给旅费的，我忘掉告诉你。”“为什么？”“我不知道为什么。高松年信上明说要她去，可是汇款只给我们四个人分。也许助教的职位太小了，学校觉得不配津贴旅费，反正这种人才有的是。”“这太岂有此理了。我们已经在赚钱，倒可以不贴旅费，孙小姐第一次出来做事，哪里可以叫她赔本？你到了学校，一定要为她向当局去争。”“我也这样想，补领总不成问题。”“辛楣，我有句笑话，你别生气。这条路我们第一次走，交通并不方便。我们这种毫无旅行经验的人，照管自己都照管不来，你为什么带一个娇弱的上海小姐同走？假如她吃苦不来，半路病倒，不是添个累赘么？除非你别有用意，那就——”“胡闹，胡闹！我何尝不知道路上麻烦，只是情面难却呀！她是外国语文系，我是政治系，将来到了学校，她是旁人的officewife，跟我道不同不相为谋。并且我事先告诉这女孩子，路上很辛苦，不比上海，她讲她吃得起苦。”“她吃得起苦，你路上就甜了。”辛楣作势把烟烫鸿渐的脸道：“你要我替你介绍，是不是？那容易得很！”鸿渐手护着脸笑道：“老实对你说，我没有正眼瞧过她，她脸圆脸扁都没看清楚呢。真是，我们太无礼了！吃饭　的时候，我们讲我们的话，没去理她，吃了饭就向甲板上跑，撇下她一个人。她第一次离开家庭，冷清清的更觉得难受了。”“我们新吃过女人的亏，都是惊弓之鸟，看见女人影子就怕了。可是你这一念温柔，已经心里下了情种。让我去报告孙小姐，说：”方先生在疼你呢！“”“你放习，我决不做你的”同情者“；你有酒，留到我吃你跟孙小姐喜酒的时候再灌。”“别胡说！人家听见了好意思么？我近来觉悟了，决不再爱大学出身的都市女人。我侍候苏文纨够苦了，以后要女人来侍候我。我宁可娶一个老实、简单的乡下姑娘，不必受高深的教育，只要身体健康、脾气服从，让我舒舒服服做她的LordandMaster.我觉得不必让恋爱在人生里占据那么重要的地位。许多人没有恋爱，也一样的生活。”“你这话给我父亲听见，该说”孺子可教“了。可是你将来要做官，这种乡下姑娘做官太太是不够料的，她不会帮你应酬，替你拉拢。”“宁可我做了官，她不配做官太太；不要她想做官太太，逼得我非做官、非做贪官不可。譬如娶了苏文纨，我这次就不能跟你同到三闾大学去了，她要强着我到她爱去的地方去。”“你真爱到三闾大学去么？”鸿渐不由惊奇地问，“我佩服你的精神，我不如你。你对结婚和做事，一切比我有信念。我还记得那一次褚慎明还是苏小姐讲的什么”围城“。我近来对人生万事，有这个感想。譬如我当初很希望到三闾大学去，所以接了聘书，近来愈想愈乏味，这时候自恨没有勇气原船退回上海。我经过这一次，不知道何年何月会结婚，不过我想你真娶了苏小姐，滋味也不过尔尔。狗为着追求水里肉骨头的影子，丧失了到嘴的肉骨头！跟爱人如愿以偿结了婚，恐怕那时候肉骨头下肚，倒要对水怅惜这不可再见的影子了。我问你，曹元朗结婚以后，他太太勉强他做什么事，你知道不知道？”“他在”战时物资委员会“当处长，是新丈人替他谋的差使，这算得女儿嫁妆的一部分。”“好哇！国家，国家，国即是家！你娶了苏小姐，这体面差使不就是你的？”“呸！要靠了裙带得意，那人算没有骨气了。”“也许人家讲你像狐狸，吃不到葡萄就说葡萄酸。”“我一点儿不嫉妒。我告诉你罢，苏小姐结婚那一天，我去观礼的——”鸿渐只会说：“啊？”——“苏家有请帖来，我送了礼——”“送的什么礼？”“送的大花篮。”“什么花？”“反正分付花店送就是了，管它什么花。”“应当是杏花，表示你爱她，她不爱你；还有水仙，表示她心肠太硬；外加艾草，表示你为了她终身痛苦。另外要配上石竹花来加重这涵意的力量。”“胡说！夏天哪里有杏花水仙花，你是纸上谈兵。好，你既然内行，你自己——将来这样送人结婚罢。我那天去的用意，就是试验我有没有勇气，去看十几年心爱的女人跟旁人结婚。咦！去了之后，我并不触目伤心。我没见过曹元朗，最初以为苏且赏识他，一定他比我强；我给人家比下去了，心上很难过。那天看见这样一个怪东西，苏小姐竟会看中他！老实说，眼光如此的女人就不配嫁我赵辛楣，我也不希罕她。”鸿渐拍辛楣的大腿道：“痛快！痛快！”“他们俩订婚了不多几天，苏老太太来看家母，说了许多好话，说文纨这孩子脾气执拗，她自己劝过女儿没用，还说不要因为这事坏了苏家跟赵家两代交情。更妙的是——我说出来你要笑的——她以后每天早晨在菩萨前面点香的时候，替我默祷幸福——”鸿渐忍不住笑了——“我对我母亲说，她为什么不念几卷经超度我呢？我母亲以为我很关心，还打听了好些无聊的事告诉我。这次苏鸿业在重庆有事，不能赶回来，写信说一切由女儿作主，只要她称习。这一对新人都洋气得很，反对旧式结婚的挑黄道吉日，主张挑洋日子。说阳历五月最不利结婚，阳历六月最宜结婚，可是他们订婚已经在六月里，所以延期到九月初结婚。据说日子也大有讲究，星期一二三是结婚的好日子，尤其是星期三；四五六一天坏似一天，结果他们挑的是星期三——”鸿渐笑道：“这准是曹元朗那家伙想出来的花样。”辛楣笑道：“总而言之，你们这些欧洲留学生最讨厌，花样名目最多。偏偏结婚的那个星期三，天气是秋老虎，热得利害。我在路上就想，侥天之幸，今天不是我做新郎。礼堂里虽然有冷气，曹元朗穿了黑呢礼服，忙得满头是汗，我看他带的白硬领圈，给汗浸得又黄又软。我只怕他整个胖身体全化在汗里，像洋蜡烛化成一摊油。苏小姐也紧张难看。行婚礼的时候，新郎新娘脸哭不出笑不出的表情，全不像在干喜事，倒像——不，不像上断头台，是了，是了，像公共场所”谨防扒手“牌子下面那些积犯的相惩里的表情。我忽然想，就是我自己结婚行礼，在万目睽睽之下，也免不了像个被破获的扒手。因此我恍然大悟，那种眉花眼笑的美满结婚照相，全不是当时照的。”“大发现！大发现！我有兴趣的是，苏小姐当天看你怎么样。”“我躲着没给她看见，只跟唐小姐讲几句话——”鸿渐的心那一跳的沉重，就好像货车卸货时把包裹向地下一掼，只奇怪辛楣会没听见——“她那天是女傧相，看见了我，问我是不是来打架的，还说行完仪式，大家缶新人身上撒五色纸条的时候，只有我不准动手，怕我借机会掷手榴弹、洒硝镪水。她问我将来的计划，我告诉她到三闾大学去。我想她也许不愿意听见你的名字，所以我一句话没提到你。”“那最好！不要提起我，不要提起我。”鸿渐嘴里机械地说着，心里仿佛黑牢里的禁锢者摸索着一根火柴，刚划亮，火柴就熄了，眼羊没看清的一片又滑回黑暗里。譬如黑夜里两条船相迎擦过，一个在这条船上，瞥见对面船舱的灯光里正是自己梦寐不忘的脸，没来得及叫唤，彼此早距离远了。这一刹那的撙近，反见得暌隔的渺茫。鸿渐这时只暗恨辛楣糊涂。
　　“我也没跟她多说话。那个做男傧相的人，曹元朗的朋友，缠住她一刻不放松，我看他对唐晓芙很有意思。”鸿渐忽然恨唐小姐，恨得心像按在棘剌上的痛，抑止着声音里的战栗说：“关于这种人的事，我不爱听，别去讲他们。”够了。这时候海风大得很回舱睡罢，明天一清早要上岸的。“说时，打个呵欠。鸿渐跟着他，刚转弯，孙小姐从凳上站起招呼。辛楣吓了一大跳，忙问她一个人在甲板上多少时候了，风大得很不怕冷么。录小姐说，同舱女人带的孩子器吵得心烦，所以她出来换换空气。辛楣说：”这时候有点风浪，你晕船不晕船？“孙小姐道：”还好。赵先生和方先生出洋碰见的风浪一定比这个利害得多。“辛楣道：”利害得很呢。可是我和方先生走的不是一条路，“说时把手鸿渐一下，暗示他开口，不要这样无礼貌地哑默。鸿渐这时候，心像和心里的痛在赛跑，要跑得快，不让这痛赶上，胡扯些不相干的话，仿佛抛掷些障碍物，能暂时拦阴这痛的追赶，所以讲了一大堆出洋船上的光景。他讲到飞鱼，孙小姐闻所未闻，见过大鲸鱼没有。辛楣觉得这问题无可猜的幼稚。鸿渐道：”看见，多的是。有一次，我们坐的船险的嵌在鲸鱼的牙齿缝里。“灯光照着孙小姐惊奇的眼睛张得像吉沃吐（Giotto）画的”○“一样圆，辛楣的猜疑深了一层，说：”你听他胡说！“鸿渐道：”我讲的话千真万确。这条鱼吃了中饭在睡午觉。孙小姐，你知道有人听说话跟看东西全用嘴的，他们张开了嘴听，张开了嘴看，并且张开了嘴睡觉。这条鱼伤风塞鼻子，所以睡觉的时候，嘴是张开的。亏得它牙缝里塞得结结实实的都是肉屑，否则我们这条船真危险了。“孙小姐道：”方先生在哄我，赵叔叔，是不是？“辛楣鼻子里做出鄙夷的声音。鸿渐道：”鱼的牙齿缝里溜得进一条大海船，真有这事。你不信，我可以翻——“辛楣道：”别胡闹了，咱们该下去睡了。孙小姐，你爸爸把你交给我的，我要强追你回舱了，别着了凉——“鸿渐笑道：”真是好“叔叔”！“辛楣乘孙小姐没留意，狠狠地在鸿渐背上打一下道：”这位方先生最爱撒谎，把童话里的故事来哄你。“睡在床上，鸿渐觉得心里的痛直逼上来，急救地找话来说：”辛楣，你打得我到这时候还痛！“辛楣道：”你这人没良心！方才我旁观者看得清清楚楚，孙小姐——唉！这女孩子刁滑得很我带她来，上了大当——孙小姐就像那条鲸鱼，张开了口，你这糊涂虫就像送上门去的那条船。“鸿渐笑得打滚道：”神经过敏！神经过敏！“真笑完了，继以假笑，好心里的痛吓退。
　　“我相信我们讲的话，全给这女孩子听去了。都是你不好，嗓子提得那么高——”“你自己，我可没有。”“你想，一个大学毕业生会那样天真幼稚么？”方先生在哄我，是不是？“”——辛楣逼尖喉咙，自信模仿得维妙维肖——“我才不上她当呢！只有你这傻瓜！我告诉你，人不可以貌相。你注意到我跟她说你讲的全是童话么？假使我不说这句话，她一定要问你借书看——”“要借我也没有。”“不是这么说。女人不肯花钱买书，大家都知道的。男人肯买糖、衣料、化妆品，送给女人，而对于书只肯借给她，不买了送她，女人也不要他送。这是什么道理？借了要还的，一借一还，一本书可以做两次接触的借口，而且不着痕迹。这是男女恋爱必然的初步，一借书，问题就大了。”鸿渐笑道：“你真可怕！可是你讲孙小姐的话完全是痴人说梦。”辛楣对舱顶得意地笑道：“那也未见得。好了，不要再讲话了，我要睡了。”鸿渐知道今天的睡眠像唐晓芙那样的不可追求，想着这难度的长夜，感到一种深宵旷野独行者的恐怯。他竭力寻出话来跟辛楣说，辛楣不理他，鸿渐无抵抗、无救援地让痛苦蚕食虫蚀着他的心。
　　明天一清早，船没进港就老远停了。磨到近中午，船公司派两条汽船来，摆渡客人上岸。头二等跟一部分三等乘客先上第一条船。这船的甲板比大轮船三等舱的甲板低五六尺，乘客得跳下去，水一荡漾，两船间就距离着尺把的海，像张了口等人掉进去。乘客同声骂船公司混帐，可是人人都奋不顾身地跳了，居然没出岔子。跳痛了肚子的人想来不少，都手按肚子，眉头皱着，一声不响。鸿渐只担心自己要生盲肠炎。船小人挤，一路上只听见嚷：“船侧了，左面的人到右面去几个。”“不好了！右面人太多了！大家要不要性命？”每句话全船传喊着，雪球似的在各人嘴边滚过，轮廓愈滚愈臃肿。鸫渐和人攀谈，知道上了岸旅馆难找，十家九家客满。辛楣说，同船来的有好几百个客人，李和顾在第二条船上，要等齐了他们再去找旅馆，怕今天只能露宿了。船靠岸，辛楣和孙小姐带着行李去找旅馆，鸿渐留在码头上等李顾两位，辛楣住定了旅馆会来接他们。辛楣等刚走，忽然发出空袭警报，鸿渐着急起来，想坏运气是结了伴来的，自己正在倒，难保不炸死，更替船上的李顾担忧。转念一想，这船是日本盟邦意大利人的财产，不会被炸，倒是自己逃命要紧。后来瞧码头上的人并不跪，鸿渐就留下来，侥幸没放紧急警报。一个多钟头后，警报解除了，辛楣也赶来。不多一会，第二条船黑压压、闹哄哄地近岸。鸿渐一眼瞧见李先生的飙失箱，衬了狭小的船首，仿佛大鼻子阔嘴生在小脸上，使人起局部大于全体的惊奇，似乎推了几何学上的原则。那大箱子能从大船上运下，更是物理学的奇迹。李先生脸上少了那副黑眼镜，两只大白眼睛像剥掉壳的煮熟鸡蛋。辛楣忙问眼镜哪里去了，李先生从口袋里掏出戴上，说防跳船的时候，万一眼镜从鼻子上滑下来摔破了。
　　李先生们因为行李累赘，没赶上第一条船。可是李梅亭语气里，俨然方才船上遭遇空袭的恐怖是代替辛楣等受的；假如他没把大菜间让给辛楣们，他也有上摆渡船的优先权，不会夹在水火中间，“神经受打击”了。辛楣俩假装和应酬的本领到此简直破产，竟没法表示感谢。顾尔谦的兴致倒没减低，嚷成一片道：“今天好运气，真是死里逃生哪！那时候就想不到还会跟你们两位相见。我想今天全船的人都靠李先生的福——李先生，有你在船上，所以飞机没光顾。这话并不荒谬，我相信命运的。曾文正公说：”不信天，信运气。“”李先生本来像冬蛰的冷血动物，给顾先生当众恭维得春气入身，蠕蠕欲活，居然赏脸一笑道：“做大事业的人都相信命运的。我这次出门前，有朋友跟我排过八字，说现在正转运，一路逢凶化吉。”顾先生拍手道：“可不是么？我一点儿没有错。”鸿渐忍不住道：“我也算过命，今年运气坏得很，各位不怕连累么？”顾先生头摆得像小孩子手里的摇鼓道：“哪里的话！哪里的话！唉！今天太运气！他们住在上海的人真是醉生梦死，怎知道出门有这样的危险。内地是不可不来的。咱们今儿晚上得找个馆子庆祝一下，兄弟作小东。”大家在旅馆休息一会，便出去聚餐。李梅亭多喝了几杯酒，人全活过来，适才不过是立春时的爬虫，现在竟是端午左右的爬虫了。他向孙小姐问长问短，讲了许多风话。
　　辛楣跟鸿渐同房间，回旅馆后，两人躺在床上闲话。鸿渐问辛楣注意到李梅亭对孙小姐的丑态没有。辛楣道：“我早看破他是个色鬼。他上岸时没戴墨晶眼镜，我留心看他眼睛，白多黑少，是个淫邪之相，我小时候听我老太爷讲过好多。”鸿渐道：“我宁可他好色，总算还有点人气，否则他简直没有人味儿。”正说着，忽听见隔壁李顾房里有女人沙嗓子的声音；原来一般中国旅馆的壁，又薄又漏，身体虽住在这间房里，耳朵像住在隔壁房里的。旅馆里照例有瞎眼抽大烟的女人，排房间兜揽生意，请客人点唱绍兴戏。李先生在跟她们讲价钱，顾先生敲板壁，请辛楣鸿渐过去听戏。辛楣说隔了板壁一样听得见，不过来了。顾先生笑道：“这太便宜了你们，也得出钱哪。啊啊！两位先生，这是句笑话。”辛楣跟　鸿渐同时努嘴做个鬼脸，没说什么。鸿渐晚没睡好，今天又累了，邻室虽然弦歌交作，睡眠漆黑一团，当头罩下来，他一忽睡到天明，觉得身体里纤屑蜷伏的疲倦，都给睡眠熨平了，像衣服上的皱纹折痕经过烙铁一样。他忽然想，要做个地道的失恋者，失眠绝食，真是不容易的。前天的痛苦似乎利害得把遭损伤的情感痛绝了根，所有的痛苦全提出来了，现在他顽钝软弱，没余力再为唐晓芙心痛。辛楣在床上欠伸道：“活受罪！隔壁绍兴戏唱完了，你就打鼾，好利害！屋顶没给你鼻子吹掉就算运气了。我到天快亮才睡熟的。”鸿渐一向自以为睡得很文静，害羞道：“真的么？我不信，我从来不打鼾的。也许是隔壁人打，你误会我了。你知道，这壁脆薄得很。”辛楣生气道：“你这人真无赖！你倒不说是我自己打鼾，赖在你身上？我只恨当时没法请唱片公司的人把你的声音灌成片子。”假使真灌成片子，那声气哗啦哗啦，又像风涛澎，又像狼吞虎咽，中间还夹着一丝又尖又细的声音，忽高忽低，袅袅不绝。有时这一条丝高上去、高上去，细得、细得像放足的风筝线要断了，不知怎么像过一峰尖，又降落安稳下来。赵辛楣剌激得神给它吊上去，掉下来，这时候追想起还恨得要扭断鸿渐的鼻子，警告他下次小心。鸿渐道：“好了，别再算账了。我昨天累了，可是你这样不侥人，天罚你将来娶一个鼻息如雷的老婆，每天晚上在你枕头边吹喇叭。”辛楣笑道：“老实告诉你，我昨天听你打鼾，想到跟你在船上讲的择配标准里，该添一条：睡时不得打鼾。”鸿渐笑道：“这在结婚以前倒没法试验出来，——”辛楣道：“请你别说了。我想一个人打鼾不打鼾，相貌上看得出来。”鸿渐道：“那当然。娶一个烂掉鼻子的女人，就不成问题了。”辛楣从床上跳起来，要拧鸿渐的鼻子。
　　那天的路程是从宁波到溪口，先坐船，然后换坐洋车。他们上了船，天就微雨。时而一点两点，像不是头顶这方天下的，到定晴细看，又没有了。一会儿，雨点密起来，可是还不像下雨，只仿佛许多小水珠在半空里顽皮，滚着跳着，顽皮得够了，然后趁势落地。鸿渐等都挤在船头上看守行李，纷纷拿出雨衣来穿，除掉李先生，他说这雨下不大，不值得打开箱子取雨衣。这寸愈下愈老成，水点贯串作丝，河面上像出了痘，无数麻瘢似的水涡，随生随灭，息息不停，到雨线更密，又仿佛光滑的水面上在长毛。李先生爱惜新买的雨衣，舍不得在旅行中穿，便自怨糊涂，说不该把雨衣搁在箱底，这时候开箱，衣服全会淋湿的。孙小姐知趣得很，说自己有雨帽，把手里的绿绸小伞借给他。这原是把有天没日头的伞，孙小姐用来遮太阳的，怕打在行李里压断了骨子，所以手里常提着。上了岸，李先生进茶馆，把伞收起，大家吓了一跳，又忍不住笑。这绿绸给雨淋得脱色，李先生的脸也回黄转绿，胸口白衬衫上一摊绿渍，仿佛水彩画的残稿。孙小姐红了脸，慌忙道歉。李先生勉强说没有关系，顾先生一连声叫跑堂打洗脸水。辛楣跟洋车夫讲价钱，鸿渐替孙小姐爱惜这顶伞，分会茶房拿去挤了水，放在茶炉前面烘。李先生望着灰色的天，说雨停了，路上不用撑伞了。
　　吃完点心，大家上车。茶房把伞交还孙小姐，湿漉漉加了热气腾腾。这时候已经下午两点钟，一行人催洋车夫赶路。走不上半点钟，有一个很陡的石子坡，拉李先生那只大铁箱的车夫，载重路滑，下坡收脚不住，摔了一交，车子翻了。李先生急得跳下自己坐的车，嚷；“箱子给你摔坏了，”又骂那车夫是饭桶。车夫指着血淋淋的膝盖请他看，他才不说话。好容易打发了这车夫，叫到另一辆车。走到那顶藤条扎的长桥，大家都下车步行。那桥没有栏杆，两边向下塌，是瘦长的马鞍形。辛楣抢先上桥，走了两步，便缩回来，说腿都软了。车夫们笑他，鼓励他。顾先生道：“让我走个样子给你们看，”从容不迫过了桥，站在桥堍，叫他们过来。李先生就抖擞精神，脱了眼镜，步步小心，到了那一头，叫：“赵先生，快过来，不要怕。孙小姐，要不要我回来搀你过桥？”辛楣自从船上那一夜以后，对孙小姐疏远得很。这时候，他深恐济危扶困，做“叔叔”的责无旁贷，这侠骨柔肠的好差使让给鸿渐罢，便提心吊胆地先过去了。鸿渐知道辛楣的用意，急得暗骂自己胆小，搀她怕反而误事，只好对孙小姐苦笑道：“只剩下咱们两个胆子小的人了。”孙小姐道：“方先生怕么？我倒不在乎。要不要我走在前面？你跟着我走，免得你望出去，空荡荡地，愈觉得这桥走不完，胆子愈小。”鸿渐只有感佩，想女人这怪东西，要体贴起人来，真是无微不至。汗毛孔的折叠里都给她温存到。跟了上桥，这滑滑的桥面随足微沉复起，数不清的藤缝里露出深深在下墨绿色的水，他命令眼睛只注视着孙小姐旗袍的后襟，不敢瞧旁处。幸而这桥也有走完的时候，孙小姐回脸，胜利地微笑，鸿渐跳下桥堍，嚷道：“没进地狱，已经罚走奈何桥了！前面还有这种桥没有？”顾尔谦正待说：“你们出洋的人走不惯中国路的，”李亭用剧台上的低声问他看过《文章游戏》么，里面有篇“扶小娘儿过桥”的八股文，妙得很。辛楣笑说：“孙小姐，是你在前面领着他？还是他在后面照顾你？”鸿渐恍然明白，人家未必看出自己的懦无用，跟在孙小姐后面可以有两种解释，忙抢说：“是孙小姐领我过桥的。”这对孙小姐是老实话，不好辩驳，而旁人听来，只觉得鸿渐在客气。鸿渐的虚荣心支使他把真话来掩饰事实；孙小姐似乎看穿他的用心，只笑笑，不说什么。
　　天色渐昏，大雨欲来，车夫加劲赶路，说天要变了。天仿佛听见了这句话，半空里轰隆隆一声回答，像天宫的地板上滚着几十面铜鼓。从早晨起，空气闷塞得像障碍着呼吸，忽然这时候天不知哪里漏了个洞，天外的爽气一阵阵冲进来，半黄落的草木也自昏沉里一时清醒，普遍地微微叹息，瑟瑟颤动，大地像蒸笼揭去了盖。雨跟着来了，清凉畅快，不比上午的雨只仿佛天空郁热出来的汗。雨愈下愈大，宛如水点要抢着下地，等不及排行分列，我挤了你，你拚一我，合成整块的冷水，没头没脑浇下来。车夫们跑几步把淋湿的衣襟拖脸上的水，跑路所生的热度抵不过雨力，彼此打寒噤说，等会儿要好好喝点烧酒，又请乘客抬身子好从车卒下拿衣服出来穿。坐车的缩作一团，只恨手边没衣服可添，李先生又向孙小姐借伞。这雨浓染着夜，水里带了昏黑下来，天色也陪着一刻暗似一刻。一行人众像在一个机械画所用的墨水瓶里赶路。夜黑得太周密了，真是伸手不见五指！在这种夜里，鬼都得要碰鼻子拐弯，猫会自恨它的一嘴好胡子当不了昆虫的触须。车夫全有火柴，可是只有两辆车有灯。密雨里点灯大非易事，火柴都湿了，连划几根只引得心里的火直冒。此时此刻的荒野宛如燧人氏未生以前的世界。鸿渐忙叫：“我有个小手电。”打开身上的提掏它出来，向地面一射，手掌那么大的一圈黄光，无数的雨线飞蛾见火似的匆忙扑向这光圈里来。孙小姐的大手电雪亮地光射丈余，从黑暗的心脏里挖出一条隧道。于是辛楣下车向孙小姐要了手电，叫鸿渐也下车，两人一左一右参差照着，那八辆车送出殡似的跟了田岸上的电光走。走了半天，李顾两人下车替。鸿渐回到车上，倦得瞌睡，忽然吵醒，睁眼望出去，白光一道躺在地上，只听得李先生直声嚷。车子都停下来。原来李先生左手撑伞，右手拿手电，走了些路，胳膊酸了，换手时，失足掉在田里，挣扎不起。大家从泥水里拉他上来，叫他坐车，仍由鸿渐照路。不知走了多少时候，只觉雨下不住，路走不完，鞋子愈走愈重，困倦得只继续机械地走，不敢停下来，因为一停下来，这两条腿就再走不动。辛楣也替了顾先生。久而久之，到了镇上，投了村店，开发了车夫，四个人脱下鞋子来，上面的泥就抵得贪官刮的地皮。李梅亭像洗了个泥澡，其余三人裤子前后和背心上，纵横斑点，全是泥泪。大家疲乏的眼睛给雨淋得粉红，孙小姐冷得嘴唇淡紫。外面雨停了，头脑里还在刮风下雨，一片声音。鸿渐吃些热东西，给辛楣强着喝点烧酒，要热水洗完脚，头就睡熟了。辛楣也累得很只怕鸿渐鼾声打搅，正在担心，没提防睡眠闷棍似的忽然一下子打他入黑暗底，滤清了梦，纯粹、完整的睡眠。
　　一觉醒来，天气若无其事的晴朗，只是黄泥地表示夜来有雨，面粘心硬，像夏天热得半溶的太妃糖，走路容易滑倒。大家说，昨天走得累了，湿衣服还没干，休息一天，明早上路。顾尔谦的兴致像水里浮的软木塞，倾盆大雨都打它不下，就提议午后游雪窦山。游山回来，辛楣打听公共汽车票的习法。旅店主人说，这车票难买得很，天没亮就得上车站去挤，还抢买不到，除非有证件的机关人员，可以通融早买票子。五个人都没有证件，因为他们根本没想到旅行时需要这东西。那时候从上海深入内地的人，很少走这条路，大多数从香港转昆明；所以他们动身以前，也没有听见人提起，只按照高松年开的路程走。孙小姐带着她的毕业文赁那全无用处。李先生回房开箱子拿出一匣名片道：“这不知道算得证件么？”大家争看，上面并列着三行衔头：“国立三闾大学主任”、“新闻学研究所所长”，还有一条是一个什么县党部的前任秘书。这片子纸质坚致，字体古雅，一点不含糊是中华书局聚珍版精印的。背面是花体英文字：“ProfessorMaydinLea”。李先生向四人解释，“新闻学研究所”是他跟几位朋友在上海办的补习学校；第一行头衔省掉“中国语文系”五个字可以跟第二三行字数相等。鸿渐问他，为什么不用外国现成姓Lee.李梅亭道：“我请教过精通英文的朋友，托他挑英文里声音相同而有意义的字。中国人姓名每字有本身的意义，把字母拼音出来，毫无道理，外国人看了，不容易记得。好比外国名字译成中文，”乔治“没有”佐治“好记，”芝加哥“没有”诗家谷“好记；就因为一个专切音，一个切音而有意义。”顾先生点头称叹。辛楣狠命把牙齿咬跟唇，因为他想着“Mating”跟“梅亭”也是同音而更有意义。鸿渐说：“这片子准有效，会吓倒这公路站长。我陪李先生去。”辛楣看鸿渐一眼，笑道：“你这样子去不得，还是我陪李先生去。我上去换身衣服。”鸿渐两天没剃胡子梳头，昨天给雨淋透的头发，东结一团，西剌一尖，一个个崇山峻岭，装湿了，身上穿件他父亲的旧夹袍，短仅过膝，露出半尺有零的裤筒。大家看了鸿渐笑。李梅亭道：“辛楣就那么要面子！我这身衣服更糟，我尽它去。”他的旧法兰绒外套经过浸湿烤干这两重水深火热的痛苦，疲软肥肿，又添上风瘫病；下身的裤管，肥粗圆满，毫无折痕，可以无需人腿而卓立地上，像一对空心的国家柱石；那根充羊毛的“不皱领带”，给水洗得缩了，瘦小蜷曲，像前清老人的辫子。辛楣换了衣履下来，李先生叹惜他衣锦夜行，顾先生啧啧称羡，还说：“有劳你们两位，咱们这些随员只能叨光了。真是能者多劳！希望两位马到成功。”辛楣顽皮地对鸿渐说：“好好陪着孙小姐，”鸿渐一时无词可对。孙小姐的脸红忽然使他想起在法国时饭上冲酒的凉水；自己不会喝酒，只在水里冲一点点红酒，常看这红液体在白液体里泛布爱逮（这两个字应该是“云爱”、“云逮”——输入者注），做出云雾状态，顿刻间整杯的水变成淡红色。他想也许女孩子第一次有男朋友的心境也像白水冲了红酒，说不上爱情，只是一种温淡的兴奋。
　　辛楣俩去了一个多钟点才回来。李梅亭绷着脸，辛楣笑容可掬，说明天站长特留两张票，后天留三张票，五人里谁先走。结果议决李顾两位明天先到金华。吃晚饭时，梅亭喝了几杯酒，脸色才平和下来。原来他们到车站去见站长，伟递片子的人好一会才把站长找来。他跑得满头大汗，一来就赶着辛楣叫“李先生”、“李所长”，撇下李梅亭不理，还问辛楣是否也当“那馆”主笔。辛楣据实告拆他，在《华美新闻》社当编辑。那站长说：“那也是张好报纸，我常看。我们这车站管理有未善之处，希望李先生指教。”说着，把自己姓名写给辛楣，言外有要求他在报上揄扬之意。辛楣讲起这事，妨不住笑，说他为车票关系，不得不冒充李先生一下。顾尔谦愤然道：“这种势利小鬼，只重衣衫不重——当然赵先生也是位社会上有名人物，可是李先生没有他那样挺的西装，所以吃了亏了。”李梅亭道：“我并不是没有新衣服，可是路上风尘仆仆，我觉得犯不着糟蹋。”辛楣忙说：“没有李先生这张片子，衣服再新也没有用。咱们敬李先生一杯。”明天早晨，大家送李顾上车，梅亭只关心他的大铁箱，车临开，还从车窗里伸头叫辛楣鸿渐仔细看这箱子在车顶上没有。脚夫只摇头说，今天行李多，这狼□（字“犭亢”——输入者）家伙搁不下了，明天准到，反正结行李票的，不会误事。孙小姐忙向李先生报告，李无生皱了眉头正有嘱咐，这汽车头轰隆隆掀动了好一会，突然鼓足了气开发，李先生头一晃，所说的话仿佛有手一把从他嘴边夺去向半空中扔了，孙小姐侧着耳朵全没听到。鸿渐们看了乘客的扰乱拥挤，担忧着明天，只说：“李顾今天也挤得上车，咱们不成问题。”明天三人领到车票，重赏管行李的脚夫，叮嘱他务必把他们的大行李搁在这班车上，每人手提只小箱子，在人堆里等车，时时刻刻鼓励自己，不要畏缩。第一辆新车来了，大家一拥而上，那股蛮劲儿证明中国大有冲锋敢死之士，只没上前全去。鸿渐瞧人多挤不进，便想冲上这时候开来的第二辆车，谁知道总有人抢在前头。总算三人都到得车上，有个立足之地，透了口气，彼此会心苦笑，才有工夫出汗。人还不断的来。气急败坏的。带笑软商量的：“对不住，请挤一挤！”以大义晓谕的：“出门出路，大家方便，来，挤一挤！好了！好了！”眼前指点的：“朋友，让一让，里面有的是地方，拦在门口好傻！”其势汹汹的：“我有票子，为什么不能上车？这车是你包的？哼！”结果，买到票子的那一堆人全上了车，真料不到小车厢会像有弹性，容得下这许多人。这车厢仿佛沙丁鱼罐，里面的人紧紧的挤得身体都扁了。可是沙丁鱼的骨头，深藏在自己身里，这些乘客的肘骨膝骨都向旁人的身体里硬嵌。罐装的沙丁鱼条条挺直，这些乘客都蜷曲波折，腰跟腿弯成几何学上有名目的角度。辛楣的箱子太长，横放不下，只能在左右两行坐位中间的过道上竖直，自己高高坐在上面。身后是个小提篮，上面跨坐着抽香烟的女主人，辛楣回头请她抽烟小心，别烧到人衣服，倒惹那女人说：“你背后不生眼睛，我眼睛可是好好的，决不会抽烟抽到你裤子上，只要你小心别把屁股揞我的烟头。”那女人的同乡都和着她欢笑。鸿渐挤得前，靠近汽车夫，坐在小提箱上。孙小姐算在木板搭的长凳上有个坐位，不过也够不舒服了，左右两个男人各移大腿证出来一角空隙，只容许猴子没进化成人以前生尾巴那小块地方贴凳。在旅行的时候，人生的地平线移近；坐汔车只几个钟点，而乘客仿佛下半世全在车里消磨的，只要坐定了，身心像得到归宿，一劳永逸地看书、看报、抽烟、吃东西、瞌睡，路程以外的事暂时等于身后身外的事。
　　汽车夫把私带的东西安轩了，入坐开车。这辆车久历风尘，该庆古稀高寿，可是搞战时期，未便退休。机器是没有脾气癖性的，而这辆车倚老卖老，修炼成桀骜不训、怪僻难测的性格，有时标劲像大官僚，有时别扭像小女郎，汽车夫那些粗人休想驾叹了解。它开动之际，前头咳嗽，后汇气，于是掀身一跳，跳得乘客东倒西撞，齐声叫唤，孙小姐从卒位上滑下来，鸿渐碰痛了头，辛楣差一点向后跌在那女人身上。这车声威大震，一口气走了一二十里，忽然要休息了，汽车夫强它继续前进。如是者四五次，这车觉悟今天不是逍遥散步，可以随意流连，原来真得走路，前面路还走不完呢！它生气不肯走了，汽车夫只好下车，向车头疏通了好一会，在路旁拾了一团烂泥，请它享用，它喝了酒似的，欹斜摇摆地缓行着。每逢它不肯走，汽车夫就破口臭骂，此刻骂得更利害了。骂来骂去，只有一个意思：汽车夫愿意跟汽车的母亲和祖母发生肉体恋爱。骂的话虽然欠缺变化，骂的力气愈来愈足。汽车夫身后坐的是个穿制服的公务人员和一个十五六岁的女孩子，像是父女。那女孩子年纪虽小，打扮得脸上颜色塞过雨后虹霓、三棱镜下日光或者姹紫嫣红开遍的花园。她擦的粉不是来路贷，似乎泥水匠粉饰墙壁用的，汽车颠动利害，震得脸上粉粒一颗颗参加太阳光里飞舞的灰尘。她听汽车夫愈骂愈坦白了，天然战胜人工，涂抹的红色里泛出羞恶的红色来，低低跟老子说句话。公务员便叫汽车夫道：“朋友，说话请斯文点，这儿是女客，啊！”汽车夫变了脸，正待回嘴，和父女俩同凳坐的军官夫妇也说：“你骂有什么用？汽车还是要抛锚。你这粗话人家听了剌耳朵。”汽车夫本想一撒手，说“老子不开了”！一转念这公务员和军官都是站长领到车房里先上车占好座位的，都有簇新的公事皮包，听说上省政府公干，自己斗不过他们，只好妨着气，自言自语说：“咱老子偏爱骂，不干你事！怕剌耳朵，塞了它做聋子！”车夫没好气，车开得更暴厉了，有一次一颠，连打恶心，嘴里一口口浓厚的气息里有作酸的绍兴酒味、在腐化中的大葱和萝卜味。鸿渐也在头晕胃泛，闻到这味道，再忍不住了，冲口而出的吐，忙掏手帕按住。早晨没吃东西，吐的只是酸水，手帕吸不尽，手指缝里汪出来，淋在衣服上，亏得自己抑住没多吐。又感觉坐得不舒服，箱子太硬太低，身体嵌在人堆里，脚不能伸，背不能弯，不容易改变坐态，只有轮流地侧重左右屁股坐着，以资调节，左倾坐了不到一分钟，臀骨酸痛，忙换为右倾，百无是处。一刻难受似一刻，几乎不相信会有到站的时候。然而抛锚三次以后，居然到了一个小站，汽车夫要吃午饭了，客人也下去在路旁的小饭店里吃饭。鸿渐等三人如蒙大赦，下车伸伸腰，活动活动腿，饭是没胃口吃了，泡壶茶，吃几片箱子里的饼干。休息一会，又有精力回车受罪，汽车夫说，这车机器坏了，得换辆车。大家忙上原车拿了随身行李，抢上第二辆车。鸿渐等意外地在车梢占有好卒位。原车有卒位而现在没卒位的那些人，都振振有词说：该照原车的位子坐，中华民国不是强盗世界，大家别讲。有位子坐的人，不但身体安稳，心理也占优势；他们可以冷眼端详那些没座位的人，而那些站的人只望着窗外，没勇气回看他们。这是辆病车，正害疟疾，走的时候，门窗无不发抖，坐在车梢的人更给它震动得骨节松脱、腑脏颠倒，方才吃的粳米饭仿佛在胃里□（字“王争”——输入者）琮有如赌场中碗里的骰子。天黑才到金华，结票的行李没从原车上搬过来，要等　明天的车运送。鸿渐等疲乏地出车站，就近一家小旅馆里过夜。今天的苦算吃完了，明天的苦还远得很这一夜的身心安适是向不属今明两天的中立时间里的躲避。
　　旅馆名叫“欧亚大旅社”。虽然直到现在欧洲人没来住过，但这名称不失为一种预言，还不能断定它是夸大之词。后面两进中国式平屋，木板隔成五六间卧室，前面黄泥地上搭了一个席棚，算是饭堂，要凭那股酒肉香、炒菜的刀锅响、跑堂们的叫嚷，来引诱过客进去投宿。席棚里电灯辉粕，扎竹涂泥的壁上贴满了红绿纸条，写的是本店拿手菜名，什么“清蒸甲鱼”、“本地名腿”、“三鲜米线”、“牛奶咖啡”等等。十几张饭桌子一大半有人占了。掌柜写账的桌子边坐个胖女人坦白地摊开白而不坦的胸膛，喂孩子吃奶；奶是孩子吃的饭，所以也该在饭堂吃，证明这旅馆是科学管理的。她满腔都是肥腻腻的营养，小孩子吸的想是加糖的溶化猪油。她那样肥硕，表示这店里的饭菜也营养丰富；她靠掌柜坐着，算得不落言诠的好广告。鸿渐等看定房间，洗了脸，出来吃饭，找个桌子坐下。桌面就像《儒林外史》里范进给胡屠户打了耳光的脸，刮得下斤把猪油。大家点了菜，鸿渐和孙小姐都说胃口不好，要吃清淡些，便一人叫了个米线。辛楣不爱米线，要一客三鲜糊涂面。鸿渐忽然瞧见牛奶咖啡的粉红纸条，诧异道：“想不到这里会有这东西，真不愧”欧亚大旅社“了！咱们先来一杯醒醒胃口，饭后再来一杯，做它一次欧洲人，好不好？”孙小姐无可无不可，辛楣道：“我想不会好吃，叫跑堂来问问。”跑堂一口担保是上海来的好东西，原封没打开过。鸿渐问什么牌子，跑堂不知道什么牌子，反正又甜又香的顶刮刮货色，一纸包冲一杯。辛楣恍然大悟道：“这是哄小孩子的咖啡方糖——”鸿渐高兴头上，说：“别廛究了，来三杯试试再说，多少总有点咖啡香味儿。：跑堂应声去了。孙小姐说：”这咖啡糖里没有牛奶成分，怎么叫牛奶咖啡，一定是另外把奶粉调进去的。“鸿渐向那位胖女人歪歪嘴道：”只要不是她的奶，什么都行。“孙小姐皱眉努嘴做个颇可爱的厌恶表情。辛楣红了脸忍笑道：”该死！该死！你不说好话。“咖啡来了，居然又黑又香，面上浮一层白沫，鸿渐问跑堂是什么，跑堂说是牛奶，问什么牛奶，说是牛奶的脂膏。辛楣道：”我看像人的唾沫。“鸿渐正要喝，恨得推开杯子说：”我不要喝了！“孙小姐也不肯喝，辛楣一壁笑，一壁道歉，可是自己也不喝，顽皮地向杯子里吐一口，果然很像那浮着的白沫。鸿渐骂他糟蹋东西，孙小姐只是笑，像母亲旁观孩子捣乱，宽容地笑。跑堂上了菜跟辛楣的面。面烧得太烂了，又腻又粘，像一碗浆糊，面上堆些鸡颈骨、火腿皮。辛楣见了，大不高兴，鸿渐笑道：”你讲咖啡里有唾沫，我看你这面里有人的鼻涕。“辛楣把面碗推向他道：”请你吃。“叫跑堂来拿去换，跑堂不肯，只得另要碗米线来吃了。吃完算账时，辛楣说：”咱们今天亏得没有李梅亭跟顾尔谦，要了东西不吃，给他们骂死了。可是这面我实在吃不下，这米线我也不敢仔细研究。“卧房里点的是油灯，没有外面亮，三人就坐着不进去，闲谈一回。都有些疲乏过度的兴奋，孙小姐也有说有笑，但比了辛楣鸿渐的胡闹，倒是这女孩子老成。
　　这时候，有个三四岁的女孩子两手向头发里乱爬，嚷到那胖女店主身边。胖女人一手拍怀里睡熟的孩子，一手替那女孩子搔痒。她手上生的五根香肠，灵敏得很，在头发里抓一下就捉到个虱子，掐死了，叫孩子摊开手掌受着，陈尸累累。女孩子把另一手指着死虱，口里乱数：“一，二，五，八，十……”孙小姐看见了告诉辛楣鸿渐，大家都觉得上痒起来，便回卧室睡觉。可是方才的景象使他们对床铺起了戒心，孙小姐借手电给他们在床上照一次，偏偏电用完了，只好罢休。辛楣道：“不要害怕，疲倦会战胜一切小痛痒，睡一晚再说。”鸿渐上床，好一会没有什么，正放心要睡去，忽然发痒，不能忽略的痒，一处痒，两处痒，满身痒，心窝里奇痒。蒙马脱尔（Monmartre）的“跳蚤市场”和耶路撒冷圣庙的“世界蚤虱大会”全像在这欧亚大旅社里举行。咬得体无完肤，抓得指无余力。每一处新鲜明确的痒，手指迅雷闪电似的捺住，然后谨慎小心地拈起，才知道并没捉到那咬人的小东西，白费了许多力，手指间只是一小粒皮肤悄。好容易捺死一臭虫，宛如报了分那样的舒畅，心安虑得，可以入睡，谁知道杀一并未儆百，周身还是痒。到后来，疲乏不堪，自我意识愈缩愈小，身体只好推出自己之外，学我佛如来舍身喂虎的榜样，尽那些蚤虱去受用，外国人说听觉敏锐的人能听见跳蚤的咳嗽；那一晚上，这副尖耳朵该听得出跳蚤们吃饱了噫气。早晨清醒，居然自己没给蚤虱吃个精光，收拾残骸剩肉还够成个人，可是并没有成佛。只听辛楣在闲上狠声道：“好呀！又是一个！你吃得我舒服呀？”鸿渐道：“你在跟跳蚤谈话，还是在捉虱？”辛楣道：“我在自杀。我捉到两个臭虫、一个跳蚤，捺死了，一点一点红，全是我自己的血，这不等于自杀——咦，又是一个！啊哟，给它溜了——鸿渐，我奇怪这家旅馆里有这许多吃血动物，而女掌柜还会那样肥胖。”鸿渐道：“也许这些蚤虱就是女掌柜养着，叫它们客人的血来供给她的。我劝你不要捉了，回头她叫你一一偿命，怎么得了！赶快起床，换家旅馆罢。”两人起床，把内衣脱个精光，赤身裸体，又冷又笑，手指沿衣服缝掏着捺着，把衣服拌了又拌然后穿上。出房碰见孙小姐，脸上有些红点，扑鼻的花露水香味，也说痒了一夜。三人到汽车站“留言板”上看见李顾留的纸条，说住在火车站旁一家旅馆内，便搬去了。跟女掌柜算账的时候，鸿渐说这店里跳蚤太多，女掌柜大不答应，说她店里的床铺最干净，这臭虫跳蚤准是鸿渐们随身带来的。
　　行李陆续运来，今天来个箱子，明天来个铺盖，他们每天下午，得上汽车站去领。到第五天，李梅亭的铁箱还没影踪，急得他直嚷直跳，打了两次长途电话，总算来了。李梅亭忙打开看里面东西有没有损失，大家替他高兴，也凑着看。箱子内部像口橱，一只只都是小抽屉，拉开抽屉，里面是排得整齐的白卡片，像图书馆的目录。他们失声奇怪，梅亭面有得色道：“这是我的随身法宝。只要有它，中国书全烧完了，我还能照样在中国文学系开课程。”这些卡片照四角号码排列，分姓名题目两种。鸿渐好奇，拉开一只抽屉，把卡片一拨，只见那张片子天头上红墨水横写着“杜甫”两字，下面紫墨水写的标题，标题以后，蓝墨水细字的正文。鸿渐觉得梅亭的白眼睛在黑眼镜里注视着自己的表情，便说：“精细了！了不得——”自知语气欠强，哄不过李梅亭，忙加一句：“顾先生，辛楣，你们要不要来瞧瞧？真正是科学方法！”顾尔谦说：“我是要广广眼界，学是学不来的了！”不怕嘴酸舌干地连声赞叹：“李先生，你的钢笔书法也雄健得很并且一手能写好几休字，变化百出，佩服佩服！”李先生笑道：“我字写得很糟，这些片子都是我指导的学生写的，有十几个人的手笔在里面。”顾先生摇头道：“唉！名师必出高徒！名师必出高徒！”这样上下左右打开了几只抽屉，李梅亭道：“下面全是一样的，没有什么可看了。”顾尔谦道：“包罗万象！我真恨不能偷了去——”李梅亭来不及阻止，他早拉开近箱底两只抽屉——“咦！这不是卡片——”孙小姐凑上去瞧，不肯定地说：“这像是西药。”李梅亭冰冷地说：“这是西药，我备着路上用的。”顾尔谦这时候给好奇心支使得没注意主人表情，又打开两只抽屉，一瓶瓶紧暖稳密地躺在棉花里，露出软木塞的，可不是西药？李梅亭忍不住挤开顾尔谦道：“东西没有损失，让我合上箱子罢。”鸿渐恶意道：“东西是不会有人偷的，只怕脚夫手脚粗，扔箱子的时候，把玻璃瓶震碎了，你应该仔细检点一下。”李梅亭嘴里说：“我想不会，我棉花塞得好好的，”手本能地拉抽屉了。这箱里一半是西药，原瓶封口的消治龙、药特灵、金鸡纳霜、福美明达片，应有尽有。辛楣道：“李先生，你一个人用不了这许多呀！是不是高松年托你替学校带的？”梅亭像淹在水里的人，忽然有人拉他一把，感激地不放松道：“对了！对了！内地买不到西药，各位万一生起病来，那时候才知道我李梅亭的功劳呢！”辛楣笑道：“预谢，预谢！有了上半箱的卡片，中国书烧完了，李先生一个人可以教中国文学；有了下半箱的药，中国人全病死了，李先生还可以活着。”顾尔谦道：“哪里的话！李先生不但是学校的功臣，并且是我们的救命恩人——”亚当和夏娃为好奇心失去了天堂，顾尔廉也为好奇心失去了李梅亭安放他的天堂，恭维都挽回不来了，跟着的几句话险的使他进地狱——“我这两天冷热不调，嗓子有点儿痛——可是没有关系，到利害的时候，我问你要三五片福美明达来含。”辛楣说在金华耽误这好几天，钱花了不少，大家把身上的余钱摊出来，看共有多少。不出他在船上所料，李顾都没有把学校给的旅费全数带上。这时候两人也许又留下几元镇守口袋的钱，作香烟费，只合交出来五十余元；辛楣等三人每人剩八十余元。所住的旅馆账还没有付，无论如何，到不了学校。大家议决拍电报给高松年，请他汇笔款子到吉安的中央银行里。辛楣道，大家身上的钱在到吉安以前，全部充作公用，一个子儿不得浪费。李先生问，香烟如何。辛楣道，以后香烟也不许买，大家得戒烟。鸿渐道：“我早戒了，孙小姐根本不抽烟。”辛楣道：“我抽烟斗，带着烟草，路上不用买，可是我以后也不抽，免得你们瞧着眼红。”李先生不响，忽然说：“我昨天刚买了两罐烟，路上当然可以抽，只要不再买就是了。”当天晚上，一行五人买了三等卧车票在金华上火车，明天一早可到鹰潭，有几个多情而肯远游的蚤虱一路陪着他们。
　　火车一清早到鹰潭，等行李领出，公路汽车早开走了。这镇上唯一像样的旅馆挂牌“客满”，只好住在一家小店里。这店楼上住人，楼下卖茶带饭。窄街两面是房屋，太阳轻易不会照进楼下的茶座。门口桌子上，一叠饭碗，大碟子里几块半生不熟的肥肉，原是红烧，现在像红人倒运，又冷又黑。旁边一碟馒头，远看也像玷污了清白的大闺女，全是黑斑点，走近了，这些黑点飞升而消散于周遭的阴暗之中，原来是苍蝇。这东西跟蚊子臭虫算得小饭店里的岁寒三友，现在刚是深秋天气，还显不出它们的后凋劲节。楼只搁着一张竹梯子，李先生的铁箱无论如何运不上去，店主拍胸担保说放在楼下就行，李先生只好自慰道：“譬如这箱子给火车耽误了没运到，还不是一样的人家替我看管，我想东西不会走漏的。在金华不是过了好几天才到么？”大家赞他想得通。辛楣由伙计陪着先上楼去看卧室，楼板给他们践踏得作不平之鸣，灰尘扑簌簌地掉下来，顾先生笑道：“赵先生的身体真重！”店主瞧孙小姐掏手帕出来拂灰，就说：“放心，这楼板牢得很。楼板要响的好，晚上贼来，客人会惊醒。我们这店里贼从没来过，他不敢来，就因为我们这楼板会响。吓！耗子走动，我棕楼板也报信的。”伙计下梯来招呼客人上去，李梅亭依依不舍地把铁箱托付给店主。楼上只有三间房还空着，都是单铺，伙计在赵方两人的房间里添张竹榻，要算双铺的价钱。辛楣道：“咱们这间房最好，沿街，光线最足，床上还有帐子。可是，我不愿睡店里的被褥，回头得另想办法。”鸿渐道：“好房间为什么不让给孙小姐？”辛楣指壁上道：“你瞧罢。”只见剥落的白粉壁上歪歪斜斜地写着淡墨字：“路过鹰潭与王美玉女士恩爱双双题此永久纪念济南许大隆题。”记着中华民国年月日，一算就是昨天晚上写的。后面也像许大隆的墨迹，是首诗：“酒不醉人人自醉色不迷人人自迷今朝有缘来相会明日你东我向西。”又写着：“大爷去也！”那感叹记号使人想出这位许先生撇着京剧说白的调儿，挥着马鞭子，慷慨激昂的神气。此外有些铅笔小字，都是讲王美玉的，想来是许先生酒醉色迷那一夜以前旁人的手笔，因为许先生的诗就写在“孤王酒醉鹰潭宫王美玉生来好美容”那几个铅笔字身上。又有新式标点的铅笔字三行：“注意！王美玉有毒！抗战时期，凡我同胞，均须卫生为健国之本，万万不可传染！而且她只认洋钱没有情！过来人题！”旁边许大隆的淡墨批语道：“毁坏名誉该当何罪？”鸿渐笑道：“这位姓许的倒有情有义得很！”辛楣也笑道：“孙小姐这房间住得么？李梅亭更住不得——”正说着，听得李顾那面嚷起来，顾先生在和伙计吵，两人跑去瞧。那伙计因为店里的竹榻全为添铺用完了，替顾先生把一扇板门搁在两张白木凳上，算是他的床。顾尔谦看见辛楣和鸿渐，声势大振，张牙舞爪道：“二位瞧他可恶不可恶？这是搁死人尸首用的，他不是欺负我么？”伙计道：“店里只有这块板了，你们穿西装的文明人，要讲理。”顾尔谦拍自己青布大褂胸脯上一片油腻道：“我不穿西装的就不讲理？为什么旁人有竹榻睡，我没有？我不是照样付钱的？我并不是迷信可是出门出路，也讨个利市，你这家伙全不懂规矩。”李梅亭自从昨天西药发现以后，对顾尔谦不甚庇护，冷眼瞧他们吵架，这时候插嘴道：“你把这板搬走就是了。吵些什么！你想法把我的箱子搬上来，那箱子可以当床，我请你抽支香烟，”伸出左手的食指摇动着仿佛是香烟的样品。伙计看只是给烟熏黄的指头，并非香烟，光着眼道：“香烟在哪里？”李梅亭摇头道：“哼，你这人笨死了！香烟我自然有，我还会骗你？你把我这铁箱搬上来，我请你抽。”伙计道：“你有香烟就给我一根，你真要我搬箱子，那不成。”李先生气得只好笑，顾先生胜利地教大家注意这伙计蛮不讲理。结果鸿渐睡的竹榻跟这扇门对换了。
　　孙小姐来了，辛楣问到何处吃早点。李梅亭道：“就在本店罢。省得上街去找，也许价钱便宜些。”辛楣不便出主意，伙计恰上来沏茶，便问他店里有什么东西吃。伙计说有大白馒头、四喜肉、鸡蛋、风肉。鸿渐主张切一碟风肉夹了馒头吃，李顾赵三人赞成，说是“本位文化三明治”，要分付伙计下去准备。孙小姐说：“我进来的时候，看见这店里都是苍蝇，馒头和肉尽苍蝇呆着，恐怕不大卫生。”李梅亭笑道：“孙小姐毕竟是深闺娇养的，不知道行路艰难，你要找一家没有苍蝇的旅馆，只能到外国去了！我担保你吃了不会生病，就是生病，我箱子里有的是药，”说时做个鬼脸，倒比他本来的脸合式些。辛楣正在喝李梅亭房里新沏的开水，喝了一口，皱眉头道：“这水愈喝愈渴，全是烟火气，可以代替火油点灯的——我看这店里的东西靠不住，冬天才有风肉，现在只是秋天，知道这风肉是什么年深月久的古董。咱们别先叫菜，下去考察一下再决定。”伙计取下壁上挂的一块乌黑油腻的东西，请他们赏鉴，嘴里连说：“好味道！”引得自己口水要流，生怕经这几位客人的馋眼睛一看，肥肉会减瘦了。肉上一条蛆虫从腻睡里惊醒，载蠕载袅，李梅亭眼快，见了恶心，向这条蛆远远地尖了嘴做个指示记号道：“这要不得！”伙计忙伸指头按着这嫩肥软白的东西，轻轻一捺，在肉面的尘垢上划了一条乌光油润的痕迹，像新浇的柏油路，一壁说：“没有什么呀！”顾尔谦冒火，连声质问他：“难道我们眼睛是瞎的？”大家也说：“岂有此理！”顾尔谦还唠唠叨叨地牵涉适才床板的事。这一吵吵得店主来了，肉里另有两条蛆也闻声探头出现。伙计再没法毁尸灭迹，只反复说：“你们不吃，有人要吃——我吃给你们看——”店主拔出嘴里的旱烟筒，劝告道：“这不是虫呀，没有关系的，这叫”肉芽“——”肉“——”芽“。”方鸿渐引申说：“你们这店里吃的东西都会发芽，不但是肉。”店主不懂，可是他看见大家都笑，也生气了，跟伙计用土话咕着。结果，五人出门上那家像样旅馆去吃饭。
　　李梅亭的片子没有多大效力，汽车站长说只有照规矩登记，按次序三天以后准有票子。五人大起恐慌：三天房饭好一笔开销，照这样耽误，怕身上的钱到不了吉安。大家没精打采地走回客栈，只见对面一个女人倚门抽烟。这女人尖颧削脸，不知用什么东西烫出来的一头鬈发，像中国写意画里的满树梅花，颈里一条白丝围巾，身上绿绸旗袍，光华夺目，可是那面子亮得像小家女人衬旗袍里子用的作料。辛楣拍鸿渐的膊子道：“这恐怕就是”有美玉于斯“了。”鸿渐笑道：“我也这样想。”顾尔谦听他们背诵《论语》，不懂用意，问：“什么？”李梅亭聪明，说：“尔谦，你想这种地方怎会有那样打扮的女子——你们何以背《论语》？”鸿渐道：“你到我们房里来看罢。”顾乐谦听说是妓女，呆呆地观之不足，那女人本在把孙小姐从头到脚的打量，忽然发现顾先生的注意，便对他一笑，满嘴鲜红的牙根肉，块垒不平像侠客的胸襟，上面疏疏地缀几粒娇羞不肯露出头的黄牙齿。顾先生倒臊得脸红，自幸没人瞧见，忙跟孙小姐进店。辛楣和鸿渐一夜在火车里没睡好，回房躺着休息，李梅亭打门进来了，问有什么好东西给他看。两人懒起床，叫他自己看墙壁上的文献。李梅亭又向窗外一望，回头直嚷道：“你们两个年轻人不怀好意呀！怪不得你们要占据这间房，对面一定就是那王美玉的卧房，相去只四五尺的距离，跳都跳得过去。你们起来瞧，床上是红被，桌子上有大镜子，还有香水瓶儿——唉！你们没结婚的人太不老实。这事开不得玩笑的——咦，她上来了！”两人从床上伸头一瞧，果然适才倚门抽烟的女人对窗立着，慌忙缩头睡下。李先生若无其事地靠窗昂首抽烟，黑眼镜里欣赏对面的屋顶，两人在床上等得不耐烦，正想叫李梅亭出去忽听那女人说话了：“你们哪块来的啥。”李先生如梦初醒地一跳道：“你问谁呀？我呀？我们是上海来的。”这话并不可笑，而两人笑得把被蒙住头，又赶快揭开被，要听下文。那女人道：“我也是上海来的，逃难来这块的——你们干什么的？”李先生下意识地伸手到口袋里去掏片子，省悟过来，尊严地道：“我们都是大学教授。”那女人道：“教书的？教书的没有钱，为什么不走私做买卖？”两人又蒙上被。李先生只鼻子里应一声。那女人道：“我爹也教书的——”两人笑得蒙着头叫痛——“那个跟你们一起的女人是谁？她也是教书的？”李先生道：“是的。”那女人道：“我也过进学堂——她赚多少钱啥？”辛楣怕这女人笑孙小姐赚的钱没有她多大声咳嗽，李先生只说：“很多，很多——抽支烟罢？哪，接好——”两人紧张得不敢吐气，李先生下面的话更使他们不能相信自己的耳朵——“我问你，公共汽车的票子难买得很，你——你熟人多，有没有法想一个？我们好好的谢你。”那女人讲了一大串话，又快又脆，像钢刀削萝卜片，大意是：公路车票买不到，可以搭军用运货汽车，她认识一位侯营长，一会儿来看她，到时李先生过去当面接洽。李先生千谢万谢。那女人走了，李先生回身向赵方二人得意地把头转个圈儿，一言不发，望着他们。二人钦佩他异想他开，真有本领。李先生恨不能身外化身，拍着自己肩膀，说：“老李，真有你！”所以也不谦虚说：“我知道这种女人路数多，有时用得着她们，这就是孟尝君结交鸡鸣狗盗的用意。”李先生去后，辛楣和鸿渐睡熟了。鸿渐睡梦里，觉得有东西在掸这肌理稠密的睡，只破了一个小孔，而整个睡都退散了，像一道滚水的注射冰面，醒过来只听见：“哙！哙！”昏头昏脑下床一看，王美玉在向这面叫，正要关窗不理她，忽想起李梅亭跟她的接洽。辛楣也惊醒了，王美玉道：“那戴黑眼镜的呢？侯营长来了。”李梅亭得到通知，忙把压在褥子下的西装裤子和领带取出，早刮过脸，皮破了好几处，倒也红光满面。临走时，李梅亭说妓女家里不能白去的，去了要开销，这笔交际费如何算法，自己方才已经赔了一支香烟。大家担保他，只要交涉顺利，不但费用公担，还有酬劳。李梅亭问他们要不要到辛楣房间里去隔窗旁听，“反正没有什么秘密的事。”余人无此雅兴，说现在四点钟，上街溜达，六点钟在吃早点地馆子里聚会。到时候，李梅亭兴冲冲来了。大家忙问事情怎样，李梅亭道：“明天正午开车。”大家还问长问短，李梅亭说这位侯营长晚上九点钟要来看行李，有问题可以面询。这些军用货车每辆搭客一人和行李一件或两件，开向韶关去的，到了韶关再坐火车进湖南。一算费用比坐公共汽车贵一，“可是，”李梅亭说，“到处等汽车票，一等就是几天，这房饭钱全省下来了。”辛楣踌躇说：“好是很好，可是学校汇到吉安的钱怎么办？”李梅亭道：“那很容易，去个电报请高校长汇到韶关得了。”鸿渐道：“到韶关折回湖南，那不是兜远路么？”李梅亭怫然道：“我能力有限，只能办到这样。方先生有面子，也许侯营长为你派专车直放学校。”顾尔谦说：“李先生办事不会错。明天一早拍个电报，中午上车走它妈的，要教我在这个鬼地方等五天，头发都白了。”李梅亭还悻悻道：“今天王美玉家打茶围的钱将来归我一个人出得了。”鸿渐忍着气道：“就是不坐军车，交际费也该大家出的，这是绝对两回事。”辛楣桌下踢鸿渐一脚，嘴里胡扯一阵，总算双方没有吵起来，孙小姐睁大的眼睛也恢复了常态。
　　回旅馆不多一会，伙计在梯子下口里含着饭嚷：“侯营长来了！”大家赶下来。侯营长有个桔皮大鼻子，鼻子上附带一张脸，脸上应有尽有，并未给鼻子挤去眉眼，鼻尖生几个酒刺，像未熟的草莓，高声说笑，一望而知是位豪杰。侯营长瞧见李梅亭，笑说：“怎么我回到小王那里，你已经溜了？什么时候走的？”李梅亭支吾着忙把同行三人介绍，孙小姐还没下来。侯营长演说道：“我们这货车不能私带客人的，带客人违儿犯军法，懂不懂？可是我看你们在国立学校教书，总算也是公务机关人员，所以冒险行个方便，懂不懂？我一个钱不要你们的，你们也清苦得很我不在乎这几个钱，懂不懂？可是我手下开车的、押车的弟史要几个香烟钱，钱少了你们拿不出去，懂不懂？我并不要钱，你们行李不多罢？里面没有上海带来的私货罢？哈哈，你们念书人有时候很贪小便宜的！”笑得两颊肌肉把鼻孔牵得更大了。大家同声说不带私货，李梅亭指着自己的铁箱道：“这是一件行李，楼上还有——”侯营长的眼睛忽然变成近视，努目注视了好一会才似乎看清了，放机关枪似的说：“好家伙！这是谁的？里面什么东西？这不能带——”忽然又近视了，睁眼望着刚下梯来的孙小姐——“这也是你们同走的？这——这我也不能带。方才跟你讲不到几句话，我就给人叫走了，没交代清楚，女人不带。要是女人可以带，我早带小王一二一，开步走了，哈哈。”孙小姐气得嘤然作声，鸿渐等　侯营长进了对门，向他已消灭的阔背出声骂：“浑蛋！”辛楣和顾先生孙小姐不要介意，“这种人嘴里没有好话。”孙小姐道：“都是我一个人妨碍了你们搭车——”鸿渐道：“还有李先生这只八宝箱呢！李先生你——”李梅亭向孙小姐道歉道：“我事情没办好，带累你受侮辱。”这样一说，鸿渐倒没法损他了。
　　这事不成，李梅亭第一个说“侥幸”，还说：“失马安知非福。带枪杆的人不讲理的，我们同走有孙小姐，一切该慎重。而且到韶关转湖南，冤枉路走得太多，花的钱也不合算，方先生说话对了。”在鹰潭这几天里，李梅亭对鸿渐刮目相看，特别殷勤，可是鸿渐愈嫌恶他，背后跟辛楣笑说：“为了打茶围那几块钱，怕我挑眼，就帝样没志气。我做了他，宁可掏腰包的。”鸿渐晚上睡不着的时候，自惜自怜，愈想愈懊悔这次的来。与李梅亭顾尔谦等为伍，就是可耻的堕落。这十来天的旅行磨得一个人志气消沉。一天他辛楣散步，听见一个卖花生的小贩讲家乡话，问起来果然是同乡，逃难流落在此的。这小贩只淡淡说声住在本县城里那条街，并不向他诉苦经，借同乡盘缠，鸿渐又放心、又感慨道：“这人准碰过不知多少同乡的钉子，所以不再开口了。我真不敢想要历过多少挫折，才磨练到这种死心塌地的境界。”辛楣笑他颓丧，说：“你这样经不起打击，一辈子恋爱不会成功。”鸿渐道：“谁像你肯在苏小姐身上花二十年的工夫。”辛楣道：“我这几天来心里也闷，昨天半夜醒来，忽然想苏文纨会不会有时候想到我。”鸿渐想起唐晓芙和自己，心像火焰的舌头突跳起，说：“想到你还是想你？我们一天要想到不知多少人，亲戚、朋友、仇人，以及不相干的见过面的人。真正想一个人，记挂着他，希望跟他接近，这少得很。人事太忙了，不许我们全神贯注，无间断地怀念一个人。我们一生对于最亲爱的人的想念，加起来恐怕不会一点钟，此外不过是念头在他身上瞥过，想到而已。”辛楣笑道：“我总希望，你将来会他几秒钟给我。告诉你罢，我第一次碰到你以后，倒常常想你，念念不释地恨你，可惜我没有看表，计算时间。”鸿渐道：“你看，情敌的彼此想念，比情人的彼此想念还要多——那时候也许苏小姐真在梦见你，所以你会忽然想到她。”辛楣道：“人家哪里有工夫梦见我们这种孤魂野鬼。并且她已经是曹元朗的人了，要梦见我就是对她丈夫不忠实。”鸿渐瞧他的正经样儿，笑得打跌道：“你这位政治家真是独裁的作风！谁做你的太太，做梦也不能自由，你要派特务式作人员去侦察她的潜意识。”三天后到南城去的公路汽车照例是挤得仅可容足，五个人都站在人堆里，交相安慰道：“半天就到南城了，站一会儿没有关系。”一个穿短衣服、满脸出油的汉子摆开两膝，像打拳里的四平势，牢实地坐在位子上，仿佛他就是汽车配备的一部分，前面放个滚圆的麻袋，里面想是米。这麻袋有坐位那么高，刚在孙小姐身畔。辛楣对孙小姐道：“为什么不坐呀？比坐位舒服多了。”孙小姐也觉得站着摇摇撞撞地不安，向那油脸汉道声歉，要坐下去。那油脸汉子直跳起来，双手拦着，翻眼嚷：“这是米，你知道不知道？吃的米！”孙小姐窘得说不出话，辛楣怒容相向道：“是米又怎么样？她这样一个女人坐一下也不会压碎你的米。”那汉子道：“你做了男人也不懂道理，米是要吃到嘴里去的呀——”孙小姐羞愤顿足道：“我不要坐了！赵先生，别理他。”辛楣不答应，方李顾三人也参加吵嘴，骂这汉子蛮横，自己占了坐位，还把米袋妨碍人家，既然不许人家坐米袋，自己快把位子让出来。那汉子看他们人多气壮，态度软下来了，说：“你们男人坐，可以，你们这位太太坐，那不行！这是米，吃到嘴里去的。”孙小姐第二次申明愿意一路站到南城，辛楣等说：“我们偏不要坐，是这位小姐要坐，你又怎样？”那汉子没法，怒目打量孙小姐一下，把垫坐的小衣包拿出来，捡一条半旧的棉裤，盖在米袋上，算替米戴上防毒具，厉声道：“你坐罢！”孙小姐不要坐，但经不起汽车的颠簸和大家的劝告，便坐了。斜对着孙小姐有位子坐的是个年轻白净的女人，带着孝，可是嘴唇和眼皮擦得红红的，纤眉细眼小鼻子，五官平淡得像一把热手巾擦脸就可以抹而去之的，说起话来，扭头撅嘴。她本在看热闹，此时跟孙小姐攀谈，一中苏州话，问孙小姐是不是上海来的，骂内地人凶横，和他们没有理讲。她说她丈夫在浙江省政府当科员，害病新死，她到桂林投奔夫兄去的。她知道孙小姐有四个人同走，十分忻羡，自怨自怜说：“我是孤苦零丁，路上只有一个用人陪了我，没有你福气！”她还表示愿意同走到衡阳，有个照应。正讲得热闹，汽车停了打早尖，客人大半下车吃早点。那女人不下车，打开提篮，强孙小姐吃她带的米粉糕，赵方二人怕寡妇分糕为难也下车散步去了。顾尔谦瞧他们下去，掏出半支香烟大吸。李梅亭四顾少人，对那寡妇道：“你那时候不应该讲你是寡妇单身旅行的，路上坏人多，车子里耳目众多，听了你的话要起邪念的。”那寡妇向李梅亭眼珠一溜，嘴一扯道：“先生真是好人！”那女人叫坐在她左边的二十多岁的男人道：“阿福，让这位先生坐。”这男人油头滑面，像浸油的楷耙核，穿件青布大褂，跟女人并肩而坐，看不出是用人。现在他给女人揭破身份，又要让位子，骨朵着嘴只好站起来。李先生假客套一下，便挨挨擦擦地坐下。孙小姐看不入眼，也下车去。到大家回车，汽车上路，李先生在咀嚼米糕，寡妇和阿福在吸香烟。鸿渐用英文对辛楣道：“你猜一猜，这香烟是谁的？”辛楣笑道：“我什么不知道！这人是个撒谎精，他那两罐烟到现在还没抽完，我真不相信。”鸿渐道：“他的烟味难闻，现在三张跟同时抽，真受不了，得戴防毒口罩。请你抽一会烟斗罢，解解他的烟毒。”到了南城，那寡妇主仆两人和他们五人住在一个旅馆里。依李梅亭的意思，孙小姐与寡妇同室，阿福独睡一间。孙小姐口气里决不肯和那寡妇作伴，李梅亭却再三示意，余钱无多，旅馆费可省则省。寡妇也没请李梅亭批准，就主仆俩开了一个房间。大家看了奇怪，李梅亭尤其义愤填胸，背后咕了好一阵：“男女有别，尊卑有分。”顾尔谦借到一张当天的报，看不上几行，直嚷：“不好了！赵先生，李先生，不好了！孙小姐。”原来日本人进攻长沙，形势危急得很。五人商议一下，觉得身上盘费决不够想回去，只有赶到吉安，领了汇款，看情形再作后图。李梅亭忙把长沙紧急的消息告诉寡妇，加油加酱，如火如荼，就仿佛日本军部给　他一个人的机密情报，吓得那女人不绝地娇声说：“啊呀！李先生，个末那亨呢！”李梅亭说自己这种上等人到处有办法，会相机行事，绝处逢生，“用人们就靠不住了，没有知识——他有知识也不做用人了！跟着他走，准闯祸。”李梅亭别了寡妇不多时，只听她房里阿福厉声说话：“潘科长派我送你的，你路上见一个好一个，知道他是什么人？潘科长那儿我将来怎样交代？”那妇人道：“吃醋也轮得到你？我要你来管？给你点面子，你就封了王了！不识抬举、忘恩负义的王八蛋！”阿福冷笑道：“王八是谁挑我做的？害了你那死鬼男人做王八不够还要害我——啊呀呀——”一溜烟跑出房来。那女人在房里狠声道：“打了你耳光，还要教你向我烧路头！你放肆，请你尝尝滋味，下次你别再想——”李先生听他们话中有因，作酸得心似绞汁的青梅，恨不能向那寡妇问个明白，再痛打阿福一顿。他坐立不定地向外探望，阿福正躲在寡妇房外，左手抚摩着红肿的脸颊，一眼瞥见李梅亭，自言自语：“不向尿缸里照照自己的脸！想吊膀子揩油——”李先生再有涵养工夫也忍不住了，冲出房道：“猪猡！你骂谁？”阿福道：“骂你这猪猡。”李先生道：“猪猡骂我。”阿福道：“我骂猪猡。”两人“鸡生蛋”“蛋生鸡”的句法练习没有了期，反正谁嗓子高，谁的话就是真理。顾先生怕事，拉李先生，说：“这种小人跟他计较什么呢？”阿福威风百倍道：“你有种出来！别像乌龟躲在洞里，我怕了你——”李先生果然又要夺门而出，辛楣鸿渐听不过了，也出来喝阿福道：“人家不理你了，你还嘴里不清不楚干什么？”阿福有点气馁，还嘴硬道：“笑话！我骂我的，不干你们的事。”辛楣嘴里的烟半高翘着像老式军舰上一尊炮的形势，对擦大手掌，响脆地拍一下，握着拳头道：“我旁观抱不平，又怎么样？”阿福眼睛里全是恐惧，可是辛楣话没说完，那寡妇从房里跳　出道：“谁敢欺负我的用人？两欺一，不要脸！枉做了男人，欺负我寡妇，没有出息！”辛楣鸿渐慌忙逃走。那寡妇得意地冷笑，海骂几句，拉阿福回房去了。辛楣教训了李梅亭一顿，鸿渐背后对辛楣道：“那雌老虎跳出来的时候，我们这方面该孙小姐出场，就抵得住了。”下半天寡妇碰见他们五人，佯佯不睬，阿福不顾坟起的脸，对李梅亭挤眼撇嘴。那寡妇有事叫“阿福”，声音里滴得下蜜糖。李梅亭叹了半夜的气。
　　旅馆又住了一天。在这一天里，孙小姐碰到那寡妇还点头徽笑，假如辛楣等不在旁，也许彼此应酬几句，说车票难买，旅馆里等得气闷。可是辛楣等四人就像新学会了隐身法似的，那寡妇路上到，眼睛里没有他们。明天上车，辛楣等把行李全结了票，手提的东西少，挤上去都抢到坐位。寡妇带的是些不结票的小行李；阿福上车的时候，正像欢迎会上跟来宾拉手的要人，恨不能向千手观音菩萨分几双手来才够用。辛楣瞧他们俩没位子坐，笑说：“亏得昨天闹翻了，否则这时候还要让位子呢，我可不肯。”“我”字说得有意义地重，李梅亭脸红了，大家忍信笑。那寡妇远远地望着孙小姐，使她想起牛或马的瞪眼向人请求，因为眼睛就是不会说话的动物的舌头。孙小姐心软了，低头不看，可是觉得坐着不安，直到车开，偷眼望见那寡妇也有了位子，才算心定。
　　车下午到宁都。辛楣们忙着领行李，大家一点，还有丙件没运来，同声说：“晦气！这一等　不知道又是几天。”心里都担忧着钱。上车站对面的旅馆一问，只剩两间双铺房了。辛楣道：“这哪里行？孙小姐一个人一间房，单铺的就够了，我们四个人，要有两间房。”孙小姐不踌躇说：“我没有关系，在　先生方先生房里添张竹铺得了，不省事省钱么？”看了房间，搁了东西，算了今天一路上的账，大家说晚饭只能将就吃些东西了，正要叫伙计忽然一间房里连嚷：“伙计！伙计！”带咳带呛，正是那寡妇的声音，跟　着大吵起来。仔细一听，那寡妇叫了旅馆里的饭，吃不到几筷菜就心，这时候才街道菜是用桐油炒的；阿福这粗货，没理会味道，一口气吞了两碗饭，连饭连菜吐个干净，“隔夜吃的饭都吐出来了！”寡妇如是说，仿佛那顿在南城吃的饭该带到桂林去的。李梅亭拍手说：“真是天罚他，瞧这浑蛋还要撒野不撒野。这旅馆里的饭不必请教了，他们俩已经替咱们做了试验品。”五人出旅馆的时候，寡妇房门大开，阿福在床上哼哼唧唧，她手扶桌子向痰盂心，伙计一手拿杯开水，一手拍她背。李先生道：“咦，她也吐了！”辛楣道：“呕吐跟打呵欠一样，有传染性的。尤其晕船的时候，看不得人家呕。”孙小姐弯着含笑的眼睛说：“李先生，你有安定胃神经的药，送一片给她，她准——”李梅亭在街上装腔跳嚷道：“孙小姐，你真坏！你也来开我的玩笑。我告诉你的赵叔叔。”晚上为谁睡竹榻的问题，辛楣等三人又谦证了一阵。孙小姐给　辛楣和鸿渐强逼着睡床，好像这不是女人应享的权利，而是她应尽的义务。辛楣人太高大，竹榻容不下。结果鸿渐睡了竹榻，刚夹在两床之间，躺了下去，局促得只想翻来覆去，又拘谨得动都不敢动。不多时，他听辛楣呼吸和匀，料已睡熟，想便宜了这家伙，自己倒在这两张不挂帐子的床中间，做了个屏风，替他隔离孙小姐。他又嫌桌上的灯太亮，妨了好一会，熬不住了，轻轻地下床，想喝口冷茶，吹来灯再睡。沿床里到桌子前，不由自主望望孙小姐，只见睡眠把她的脸洗濯得明净滋润，一堆散发不知怎样会覆在她脸上，使她脸添了放任的媚姿，鼻尖上的发梢跟着鼻息起伏，看得代她脸痒，恨不能伸手替她掠好。灯光里她睫毛仿佛微动，鸿渐一跳，想也许自己错，又似乎她忽然呼吸短促，再一看，她睡着不动的脸像在泛红。慌忙吹来了灯，溜回竹榻，倒惶恐了半天。
　　明天一早起，李先生在账房的柜台上看见昨天的报，第一道消息就是长沙烧成白地，吓得声音都遗失了，一分钟后才找回来，说得出话。大家焦急得没工夫觉得饿，倒省了一顿早点。鸿渐毫没主意，但仿佛这不是自己一个人的事，跟着人走，总有办法。李梅亭唉声叹气道：“倒霉！这一次出门，真是倒足了霉！上海好几处留我的留我，请我的请我，我鬼迷昏了头，却不过高松年的情面，吃了许多苦，还要半途而废，走回头路！这笔账向谁去算？”辛楣道：“要走回头路也没有钱。我的意思是，到了吉安领了学校汇款再看情形，现大不用计划得太早。”大家吐口气，放了心。顾尔谦忽然明地说：“假如学校款子没有汇，那就糟透了。”四人不耐烦地同声说他过虑，可是意识里都给他这话唤起了响应，彼此举的理由，倒不是驳斥顾尔谦，而是安慰自己。顾尔谦忙想收回那句话，仿佛给人拉住的蛇尾巴要缩进洞，道：“我也知道这事不可能，我说一声罢了。”鸿渐道：“我想这问题容易解决。我们先去一个人。吉安有钱，就打电报叫大家去；吉安没有钱，也省得五个人全去扑个空，白费了许多车钱。”辛楣道：“着呀！咱们分工，等行李的等行李，领钱的领钱，行动灵活点，别大家拚在一起老等。这钱是汇给我的，我带了行李先上吉安，鸿渐陪我走，多个帮手。”孙小姐温柔而坚决道：“我也跟赵先生走，我行李也来了。”李梅亭尖利地给辛楣一个X光的透视道：“好，只剩我跟顾先生。可是我们的钱都充了公了，你们分多少钱给我们？”顾尔谦向李梅亭抱歉地笑道：“我行李全到了，我想跟他们去，在这儿住下去没有意义。”李梅亭脸上升火道：“你们全去了，撇下我一个人，好！我无所谓。什么”同舟共济“！事到临头，还不是各人替自己打算？说老实话，你们到吉安领了钱，干脆一个子儿不给我得了，难不倒我李梅亭。我箱子里的药要在内地卖千反块钱，很容易的事。你们瞧我讨饭也讨到了上海。”辛楣诧异说：“咦！李先生，你怎么误会到这个地步！”顾尔谦抚慰地说：“梅亭先生，我决不先走，陪你等行李。”辛楣道：“究竟怎么办？我一个人先去，好不好？李先生，你总不疑心我会吞灭公款——要不要我留下行李作押！”说完加以一笑，减低语意的严重，可是这笑生硬倔强宛如干浆糊粘上去的。
　　李梅亭摇手连连道：“笑话！笑话！我也决不是以”不人之心“推测人的——”鸿渐自言自语道：“还说不是”——“我觉得方先生的提议不切实际——方先生，抱歉抱歉，我说话一向直率的。譬如赵先生，你一个人到吉安领了钱，还是向前进呢？向后转呢？你一个人作不了主，还要大家就地打听消息共同决定的——”鸿渐接嘴道：“所以我们四个人先去呀。服从大多数的决定，我们不是大多数么？”李梅亭说不出话，赵顾两人忙劝开了，说：“大家患难之交，一致行动。”午饭后，鸿渐回到房里，埋怨辛楣太软，处处让着李梅亭：“你这委曲求全的气量真不痛快！做领袖有时也得下辣手。”孙小姐笑道：“我那时候瞧方先生跟李先生两人睁了眼，我看着你，你看着我，气呼呼的，真好玩儿！像互相要吞掉彼此的。”鸿渐笑道：“糟糕！丑态全落在你眼里了。我并不想吞他，李梅亭这种东西，吞下去要害肚子的——并且我气呼呼了没有？好像我没有呀。”孙小姐道：“李先生是嘴里的热气，你是鼻子里的冷气。”辛楣在孙小姐背后鸿渐翻白眼儿伸舌头。
　　向吉安去的路上，他们都恨汽车又笨又慢，把他们跃跃欲前的心也拖累了不能自由，同时又怕到了吉安一场空，愿意这车走下去，走下去，永远在开动，永远不到达，替希望留着一线生机。住定旅馆以后，一算只剩十来块钱，笑说：“不要紧，一会儿就富了。”向旅馆账房打听，知道银行怕空袭，下午四点钟后才开门，这时候正办公。五个人上银行，一路留心有没有好馆子，因为好久没痛快吃了。银行里办事人说，钱来了好几天了，给他们一张表格去填。辛楣向办事讨过一支毛笔来填写，李顾两位左右夹着他，怕他不会写字似的。这支笔写秃了头，需要蘸的是生发油，不是墨水，辛楣一写一堆墨，李顾看得满心不以为然。那办事人说：“这笔不好写，你带回去填得了。反正你得找铺保盖图章——可是，我告诉你，旅馆不能当铺保的。”这把五人吓坏了，跟办事员讲了许多好话，说人地生疏，铺保无从找起，可否通融一下。办事员表示同情和惋惜，可是公事公办，得照章程做，劝他们先去找。大家出了银行，大骂这章程不通，骂完了，又互相安慰说：“无论如何，钱是来了。”明天早上，辛楣和李梅亭吃几颗疲乏的花生米，灌半壶冷淡的茶，同出门找本地教育机关去了。下午两点多钟，两人回来，头垂头气丧，精疲力尽，说中小学校全疏散下乡，什么人都没找到，“吃了饭再说罢，你们也饿晕了。”几口饭吃下肚，五人精神顿振，忽想起那银行办事员倒很客气，听他口气，好像真找不到铺保，钱也许就给了，晚上去跟他软商量罢。到五点钟，孙小姐留在旅馆，四人又到银行。昨天那办事员早忘记他们是谁了，问明白之后，依然要铺保，教他们到教局去想办法，他听说教育局没有搬走。大家回旅馆后，省钱，不吃东西就睡了。
　　鸿渐饿得睡不熟，身子像没放文件的公事皮包，几乎腹背相贴，才领略出法国人所谓“长得像没有面包吃的日子”还不够亲切；长得像没有面包吃的日子，长得像失眠的夜，都比不上因没有面包吃而失的夜那样漫漫难度。东方未明，辛楣也醒，咂嘴舐舌道：“气死我了，梦里都没有东西吃，别说桓的时候了。”他做梦在“都会饭店”吃中饭，点了汉堡牛排和柠檬甜点，老等不来，就饿醒了。鸿渐道：“请你不要说了，说得我更饿了。你这小气家伙，梦里吃东西有我没有？”辛楣笑道：“我来不及通知你，反正我没有吃到！现在把李梅亭烤熟了给你吃，你也不会嫌了罢。”鸿渐道：“李梅亭没有肉呀，我看你又白又胖，烤得火工到了，蘸甜面酱、椒盐——”辛楣笑里带呻吟：“饿的时不能笑，一笑肚子愈掣痛。好家伙！这饿像有牙齿似的从里面咬出来，啊呀呀——”鸿渐道：“愈躺愈受罪，我起来了。上街达一下，活动活动，可以忘掉饿。早晨街上清静，出去呼吸点新鲜空气。”辛楣道：“要不得！新鲜空气是开胃健脾的，你真是自讨苦吃。我省了气力还要上教育局呢。我劝你——”说着又笑得嚷痛——“你别上毛，熬住了，留点东西维持肚子。”鸿渐出门前，辛楣问他要一大杯水了充实肚子，仰天躺在床上，动也不动，一转侧身体里就有波涛汹涌的声音。鸿渐拿了些公账里的作钱，准备买带壳花生回来代替早餐，辛楣警告他不许打偏手偷吃。街上的市面，仿佛缩在被里的人面，还没露出来，卖花生的杂货铺也关着门。鸿渐走前几步，闻到一阵烤山薯的香味，鼻子渴极喝水似的吸着，饥饿立刻把肠胃加紧地抽。烤山薯这东西，本来像中国谚语里的私情男女，“偷着不如偷不着，”香味比滋味好；你闻的时候，觉得非吃不可，真到嘴，也不过尔尔。鸿渐看见一个烤山薯的摊子，想这比花生米好多了，早餐就买它罢。忽然注意有人正作成这个摊子的生意，衣服体态活像李梅亭；他细一瞧，不是他是谁，买了山薯脸对着墙壁在吃呢。鸿渐不好意思撞破他，忙向小弄里躲了。等他去后，鸿渐才买了些回去，进旅馆时，遮遮掩掩的深怕落在掌柜或伙计的势利眼里，给他们看破了寒窘，催算账，赶搬场。辛楣见是烤山薯，大赞鸿渐的采办本领，鸿渐把适才的事告诉辛楣，辛楣道：“我知他没把钱全交出来。他慌慌张张地偷吃，别梗死了。烤山薯吃得快，就梗喉咙，而且滚热的，真亏他！”孙小姐李先生顾先生来了，都说：“咦！怎么找到这东西？妙得很！”顾先生跟着上教育局，说添个人，声势壮些。鸿渐也去，辛楣嫌他十几天不梳头剃胡子，脸像剌猥头发像准备母鸡在里面孵蛋，不许他去。近中午，孙小姐道：“他们还不回来，不知道有希望没有？”鸿渐道：“这时候不回来，我想也许事情妥了。假如干脆拒绝了，他们早会回来，教育局路又不远。”辛楣到旅馆，喝了半壶水，喘口气，大骂那教育局长是糊涂鸡子儿，李顾也说“岂有此理”。原来那局长到局很迟，好容易来了，还不就见，接见时口风比装食品的洋铁罐还紧，不但不肯作保，并且怀疑他们是骗子，两个指头拈着李梅亭的片子仿佛是捡的垃圾，眼睛瞟着片子上的字说：“我是老上海，上海滩上什么玩意儿全懂，这种新闻学校都是挂空头招牌的——诸位不要误会，我是论个大概。”国立三闾大学“？这名字生得很我从来没听见过。新立的？那我也该知道呀！”可怜他们这天饭都不敢多吃，吃的饭并不能使他们不饿，只滋养栽培了饿，使饿在他们身体里长存，而他们不至于饿死了不再饿。辛楣道：“这样下去，钱到手的时候，我们全死了，只能买棺材下殓了。”顾先生忽然眼睛一亮道：“你们两位路看见那”妇女协会“没有？我看见的。我想女人心肠软，请孙小姐去走一趟，也许有点门路——这当然是不得已的下策。”孙小姐一诺无辞道：“我这时候就去。”辛楣满脸不好意思，望着孙小姐道：“这怎么行？你父亲把你交托给我的，我事做不好，怎么拖累你？”孙小姐道：“我一路上已经承赵先生照应——”辛楣不愿意听她感谢自己，忙说：“好，你试一试罢，希诅你运气比我们好。”孙小姐到妇女协会没碰见人，说明早再去。鸿渐应用心理学的知识，道：“再去碰见人也没有用。女人的性情最猜疑，最小气。叫女人去求女人，准碰钉子。”辛楣因为旅馆章程是三天一清账，发悉明天付不出钱，李先生豪爽地说：“假使明天还没有办法，而旅馆逼钱，我卖掉药得了。”明天孙小姐去了不到一个钟点，就带一个灰布装的女同志回来。在她房里叽叽咕咕了一会儿，孙小姐出来请辛楣等进去。那女同志正细看孙小姐的毕业文——上面有孙小姐戴方帽子的漂亮照相。孙小姐一一介绍了，李先生又送上片子。她肃然起敬，说她有个朋友在公路局做事，可能帮些忙，她下半天来给回音。大家千恩万谢，又不敢留她吃饭，恭送出门时，孙小姐跟她手勾手，尤其亲热。吃那顿中饭的时候，孙小姐给她的旅伴们恭维得脸像东方初出的太阳。
　　直到下行五点钟，那女同志影踪全无，大家又饿又急，问了孙小姐好几次，也问不出个道理。鸿渐觉得冥冥中有个预兆，这钱是拿不到的了，不干不脆地拖下去，有劲使不出来，仿佛要反转动弹簧门碰上似的无处用力。晚上八点钟，大家等得心都发霉，安定地绝望，索性不再悉了，准备睡觉。那女同志跟她的男朋友宛如诗人“尽日觅不得，有时还自来”的妙句，忽然光顾，五个人欢喜得像遇见久别的情人，亲热得像狗迎接回家的主人。那男人大剌剌地坐了，第问句话，大家殷勤抢答，引得他把手一拦道：“一个人讲话够了。”他向孙小姐要了文凭，细细把照相跟孙小姐本人认着，孙小姐徽徽疑心他不是对照相，是在鉴赏自己，倒难为情起来。他又盘问赵辛楣一下，怪他们不带随身证明文件。他女朋友在旁说了些好话，他才态度和缓，说他并非猜疑很愿意交朋友，但不知用公路局名义铺保，是否有效，教他们先向银行问明白了，通知他再盖章。所以他们又多住了一天，多上了一次银行。那天晚上，大家睡熟了还觉得饿，仿佛饿宣告独立，具体化了，跟身子分开似的。
　　两天后，他们到钱；旅馆与银行间这条路径，他们的鞋子也走熟得不必有脚而能自身来回了。银行里还交给他们一个高松年新拍来的电报，请他们放心到学校，长沙战事并无影响。汝天晚上，他们借酬谢和庆祝为名，请女同志和她朋友上馆子放量大吃一顿。顾先生三杯酒下肚，嘻开嘴，千金一笑地金牙灿烂，酒烘得发亮的脸探海灯似的向全桌照一周，道：“我们这位李先生离开上海的时候，曾经算过命，说有贵人扶持，一路逢凶化吉，果然碰见了你们两位，萍水相，做我们的保人，两位将来大富大贵，未可限量——赵先生，李先生，咱们五个人公敬他们两位一杯，孙小姐，你，你，你也喝一口。”孙小姐满以为“贵人”指的自己，早低着头，一阵红的消息在脸上透漏，后来听见这话全不相干，这红像暖天向玻璃上呵的气，没成晕就散了。那位女同志跟她的朋友虽然是民主国家的公民，知道民为贵的道理，可是受了这封建思想的恭维，也快乐得两张酒脸像怒放的红花。辛楣顽皮道：“要讲贵人，咱们孙小姐也是贵人，没有她——”李梅亭不等他说完，就敬孙小姐酒。鸿渐道：“我最惭愧了，这次我什么事都没有做，真是饭桶。”李梅亭道：“是呀！小方是真正的贵人，坐在诱馆里动也不动，我们替他跑腿。辛楣，咱们虽然一无结果，跑是跑得够苦的，啊？”当晚临睡，辛楣道：“今天可以舒舒服服地睡了。鸿渐，你看那位女同志长得真丑，喝了酒更吓得死人，居然也有男人爱她。”鸿渐道：“我知道她难看，可是因为她是我们的恩人，我不忍细看她。对于丑人，细看是一种残忍——除非他是坏人，你要惩罚他。”明天上午，他们到了界化陇，是江西和湖南的交界。江西公路车不开过去了，他们该换坐中午开的湖南公路车。他们一路来坐车，到站从没有这样快的，不计较路走得少，反觉得净了半天，说休息一夜罢，今天不赶车了。这是片荒山冷僻之地，车站左右面公路背山，有七八家小店。他们投宿的里，厨房设在门口，前间白天的过客的餐堂，晚上是店主夫妇的洞房，后间隔为两间暗不见日、漏雨透风、夏暖冬凉、顺天应时的客房。店周围浓烈的尿屎气，仿佛这店是棵菜，客人有出肥料灌溉的义务。店主当街炒菜，只害得辛楣等　在房里大打喷嚏；鸿渐以为自己着了凉，李先生说：“谁在家里惦记我呢！”到后来才明白是给菜里的辣椒薰出来的。饭后，四个男人全睡午觉，孙小姐跟辛楣鸿渐同房，只说不困，坐在外间的竹躺椅里看书，也睡着了。他醒来头痛，身上冷，晚饭时吃不下东西。这是暮秋天气，山深日短，云雾里露出一线月亮，宛如一只挤着的近视眼睛。少顷，这月亮圆得什么都粘不上，轻盈得什么都压不住，从蓬松如絮的云堆下无牵挂地浮出来，原来还有一边没满，像被打耳光的脸肿着一边。孙小姐觉得胃里不舒服，提议踏月散步。大家沿公路走，满地枯草，不见树木，成片像样的黑影子也没有，夜的文饰遮掩全给月亮剥光了，不留体面。
　　那一晚，山里的寒气把旅客们的睡眠冻得收缩，不够包裹整个身心，五人只支离零碎地睡到天明。照例辛楣和鸿渐一早溜出来，让孙小姐房里从容穿衣服。两回房拿手巾牙刷，看孙小姐还没起床，被蒙着头呻吟。他们忙问她身休有什么不服，她说头晕得身不敢转侧，眼不敢睁开。辛楣伸手按她前额道：“热度像没有。怕是累了，受了些凉。你放心好好休息一天，咱们三人明天走。”孙小姐嘴里说不必，作势抬头，又是倒下去，良久吐口气，请他们在她床前放个痰盂。鸿渐问店主要痰盂，店主说，这样大的地方还不够吐痰？要痰盂有什么用？半天找出来一个洗脚的破木盆。孙小姐向盆里直吐。吐完躺着。鸿渐出去要开水，辛楣说外间有太阳，并且竹躺椅的枕头高，睡着舒服些，教她试穿衣服，自己抱条被先替她在躺椅上铺好。孙小姐不肯让他们扶，垂头闭眼，摸着壁走到躺椅边颓然倒下。鸿渐把辛楣的橡皮热水袋冲满了，给她暖胃，问她要不要喝水。她喝了一口又吐出来，两人急了，想李梅亭带的药里也许有仁丹，隔门问他讨一包。李梅亭因为车到中午才开，正在床上懒着呢。他的药是带到学校去卖好价钱的，留着原封不动，准备十倍原价去卖给穷乡僻壤的学校医院。一包仁丹打开了不过吃几粒，可是封皮一拆，余下的便卖不了钱，又不好意思向孙小姐算账。虽然仁丹值钱无几，他以为孙小姐一路上对自己的态度也不够一包仁丹的交情；而不给她药呢，又显出自己小气。他在吉安的时候，三餐不全，担心自己害营养不足的病，偷打开了一瓶日本牌子的鱼肝油丸，第天一餐以后，吃三粒聊作滋补。鱼肝油丸当然比仁丹贵，但已打开的药瓶，好比嫁过的女人，减了市价。李先生披衣出房一问，知道是胃里受了冷，躺一下自然会好的，想鱼肝油丸吃下去没有关系，便说：“你们先用早点罢，我来服侍孙小姐吃药。”辛楣鸿渐都避嫌疑，不愿意李梅亭说他们冒他的功，真吃早点去了。李梅亭回房取一粒丸药，讨杯开水；孙小姐懒张眼，随他摆布咽了下去鸿渐吃完早点，去看孙小姐，只闻着一阵鱼腥，想她又吐了，怎会有这样怪味儿，正想问她，忽见她两颊全是湿的，一部分泪水从紧闭的眼梢里流过耳边，滴湿枕头。鸿渐慌得手足无措，仿佛无意中撞破了自己不该看的秘密，忙偷偷告诉辛楣。辛楣也想这种哭是不许给陌生人知道的，不敢向她问长问短。两人参考生平关于女人的全部学问，来解释她为什么哭。结果英雄所见略同，说她的哭大半由于心理的痛苦；女孩子千里辞家，半途生病，举目无亲，自然要哭。两人因为她哭得不敢出声，尤其可怜她，都说要待她好一点，轻轻走去看她。她像睡着了，脸上泪渍和灰尘，结成几道黑痕；幸亏年轻女人的眼泪还不是秋冬的雨点，不致把自己的脸摧毁得衰败，只像清明时节的梦雨，浸肿了地面，添了些泥。
　　从界化陇到邵阳这四五天里，他们的旅行顺溜像子，他们把新发现的真理挂在嘴上说：“钱是非有不可的。”邵阳到学校全是山路，得换坐轿子。他们公共汽车坐腻了，换新鲜坐轿子，喜欢得很。坐了一会，才知道比汽车更难受，脚趾先冻得痛，宁可下轿走一段再坐。一路上崎岖缭绕，走不尽的山和田，好像时间已经遗忘了这条路途。走了七十多里，时间仿佛把他们收回去了，山雾渐起，阴转为昏，昏凝为黑，黑得浓厚的一块，就是他们今晚投宿的小村子。进了火铺，轿夫和挑夫们生起火来，大家转着取暖，一面烧菜做饭。火铺里晚上不点灯，把一长片木柴烧着了一头，插在泥堆上，苗条的火焰摇摆伸缩，屋子里东西的影子跟着活了。辛楣等睡在一个统间里，没有床铺，只是五叠干草。他们倒宁可睡稻草，胜于旅馆里那些床，或像凹凸地图，或像肺病人的前胸。鸿渐倦极，迷迷糊糊要睡，心终放不平稳，睡四面聚近来，可是合不拢，仿佛两半窗帘要按缝了，忽然拉链梗住，还漏进一线外面的世界。好容易睡熟了，梦深处一个小声间带哭嚷道：“别压住我的红棉袄！别压住我的红棉袄！”鸿渐本能地身子滚开，意识跳跃似的清醒过来，头边一声叹息，轻微得只像被遏抑的情感偷偷在呼吸。他吓得汗毛直竖，黑暗里什么都瞧不见，想划根火柴，又怕真照见了什么东西，辛楣正打鼾，远处一条狗在叫。他定一定神，笑自己活见鬼，又神经松懈要睡，似乎有什么力量拒绝他睡，把他的身心撑起，撑起，不让他安顿下去，半睡半醒间（云爱）（云逮）地感醒的时候，一个人是轻松悬空的，一睡熟就沉重了。正挣扎着，他听邻近孙小姐呼吸颤促像欲哭不能，注意力警醒一集中，睡又消散了，这清清楚楚地一声吧息，仿佛工作完毕的叶口气，鸿渐头一侧，躲避那张叹气的嘴，喉舌都给恐怖干结住了，叫不出“谁呀”两字，只怕那张嘴会凑耳朵告诉自己他是谁，忙把被蒙着头，心跳得像胸膛里容不下。隔被听见辛楣睡觉中咬牙，这声音解除了他的恐怖，使他觉得回到人的世界，探出头来，一件东西从他头边跑过，一阵老鼠叫。他划根火柴，那神经的火焰一跳就熄了，但他已瞥见表上正是十二点钟。孙小姐给火光耀醒翻身，鸿渐问她是不是梦魇，孙小姐告诉他，她构里像有一双小孩子的手推开她的身体，不许她睡。鸿渐也说了自己的印象，劝她不要害怕。
　　早晨不到五点钟，轿夫们淘米煮饭。鸿渐和孙小姐两人下半夜都没有睡，也跟着起来，到屋外呼吸新鲜空气。才发现这屋背后全是坟，看来这屋就是铲平坟墓造的。火铺屋后不远矗立一个破门框子，屋身烧掉了，只剩这个进出口，两扇门也给人搬走了。鸿渐指着那些土馒头问：“孙小姐，你相信不相信有鬼？”孙小姐自从梦魇以后，跟鸿渐熟多了，笑说：“这话很难回答。有时候，我相信有鬼；有时候，我决不相信有鬼。譬如昨天晚上，我觉得鬼真可怕。可是这时候虽然四周围全是坟墓，我又觉得鬼绝对没有这东西了。”鸿渐道：“这意思很新鲜。鬼的存在的确有时间性的，好像春天有的花，到夏天就没有。”孙小姐道：“你说你听见的声音像小孩子的，我梦里的手也像是小孩子的，这太怪了。”鸿渐道：“也许我们睡的地方本来是小孩子的坟，你看这些坟都很小，不像是大人的。”孙小姐天真地问：“为什么鬼不长大的？小孩子死了几十年还是小孩子？”鸿渐道：“这就是生离死别比百年团聚好的地方，它能使人不老。不但鬼不会长大，不见了好久的朋友，在我们的心目里，还是当年的丰采，尽管我们自己已经老了——喂，辛楣。”辛楣呵呵大笑道：“你们两人一清早到这鬼窝里来谈些什么？”两人把昨天晚的事告诉他，他冷笑道：“你们两人真是魂梦相通，了不得！我一点没感觉什么；当然我是粗人，鬼不屑拜访的——轿夫说今天下午可以到学校了。”方鸿渐在轿子里想，今天到学校了，不知是什么样子。反正自己不存奢望。适才火铺屋后那个破门倒是好象征。好像个进口，背后藏着深宫大厦，引得人进去了，原来什么没有，一无可进的进口、一无可去的去处。“撇下一切希望罢，你们这些进来的人！”虽然这么说，按捺不下的好厅心和希冀像火炉上烧滚的水，勃勃地掀动壶盖。只嫌轿子走得不爽气，宁可下了轿自己走。辛楣也给这理鼓动得在轿子里坐不定，下轿走着，说：“鸿渐，这次走路真添了不少经验。总算功德圆满，取经到了西天，至少以后跟李梅亭、顾尔谦胁肩谄笑的丑态，也真叫人吃不消。”鸿渐道：“我发现拍马屁跟恋爱一样，不容许有第三都冷眼旁观。咱们以后恭维人起来，得小心旁边没有其他的人。”辛楣道：“像咱们这种旅行，最试验得出一个人的品性。旅行是最劳顿，最麻烦，叫人本相毕现的时候。经过长期苦旅行而彼此不讨厌的人，才可以结交作朋友——且慢，你听我说——结婚以后的蜜月旅行是次序颠倒的，庆该先同旅行一个月，一个月舟车仆仆以后，双方还没有彼此看破，彼此厌恶，还没有吵嘴翻脸，还要维持原来的婚约，这种夫妇保证不会离婚。”“你这话为什么不跟曹元朗夫妇去讲？”“我这句话是专为你讲的，sonny.孙小姐经过这次旅行并不使你讨厌罢？”辛楣说着，回头望望孙小姐的轿子，转过脸来，呵呵大笑。
　　“别胡闹。我问你，你经过这次旅行，对我的感想怎么样？觉得我讨厌不讨厌？”“你不讨厌，可是全无用处。”鸿渐想不到辛楣会这样干脆的回答，气得只好苦笑。兴致扫尽，静默地走了几步，向辛楣一挥手说：“我坐轿子去了。”上了轿子，闷闷不乐，不懂为什么说话坦白算是美德。
　　第六章三闾大学校长高松年是位老科学家。这“老”字的位置非常为难，可以形容科学，也可以形容科学家。不幸的是，科学家跟科学不大相同；科学家像酒，愈老愈可贵，而科学像女人，老了便不值钱。将来国语文法发展完备，终有一天可以明白地分开“老的科学家”和“老科学的家”，或者说“科学老家”和“老科学家”。现在还早得很呢，不妨笼统称呼。高校长肥而结实的脸像没发酵的黄面粉馒头，“馋嘴的时间”（EdaxVetustas）咬也咬不动他，一条牙齿印或皱纹都没有。假使一个犯校规的女学生长得很漂亮，高校长只要她向自己求情认错，也许会不尽本于教育精神地从宽处分。这证明这位科学家还不老。他是二十年前在外国研究昆虫学的；想来三十年前的昆虫都进化成为大学师生了，所以请他来表率多士。他在大学校长里，还是前途无量的人。大学校长分文科出身和理科出身两类。文科出身的人轻易做不到这位子的。做到了也不以为荣，准是干政治碰壁下野，仕而不优则学，借诗书之泽，弦诵之声来休养身心。理科出身的人呢，就完全不同了。中国是世界上最提倡科学的国家，没有旁的国度肯这样给科学家大官做的。外国科学进步，中国科学家进爵。在国外，研究人情的学问始终跟研究物理的学问分歧；而在中国，只要你知道水电，土木，机械，动植物等等，你就可以行政治人——这是“自然齐一律”最大的胜利。理科出身的人当个把校长，不过是政治生涯的开始；从前大学之道在治国平天下，现在治国平天下在大学之道，并且是条坦道大道。对于第一类，大学是张休息的靠椅；对于第二类，它是个培养的摇篮——只要他小心别摇摆得睡熟了。高松年发奋办公，夙夜匪懈，精明得真是睡觉还睁着眼睛，戴着眼镜，做梦都不含糊的。摇篮也挑选得很好，在平成县乡下一个本地财主家的花园里，面溪背山。这乡镇绝非战略上必争之地，日本人唯一豪不吝惜的东西——炸弹——也不会浪费在这地方。所以，离开学校不到半里的镇上，一天繁荣似一天，照相铺，饭店，浴室，戏院，警察局，中小学校，一应俱全。今年春天，高松年奉命筹备学校，重庆几个老朋友为他饯行，席上说起国内大学多而教授少，新办尚未成名的学校，地方偏僻，怕请不到名教授。高松年笑道：“我的看法跟诸位不同。名教授当然好，可是因为他的名望，学校沾着他的光，他并不倚仗学校里地位。他有架子，有脾气，他不会全副精神为学校服务，更不会绝对服从当局指挥。万一他闹别扭，你不容易找替人，学生又要借题目麻烦。我以为学校不但造就学生，并且应该造就教授。找到一批没有名望的人来，他们要借学校的光，他们要靠学校才有地位，而学校并非非有他们不可，这种人才真能跟学校合为一体，真肯为公家做事。学校也是个机关，机关当然需要科学管理，在健全的机关里，决没有特殊人物，只有安分受支配的一个个单位。所以，找教授并非难事。”大家听了，倾倒不已。高松年事先并没有这番意见，临时信口胡扯一阵。经朋友们这样一恭维，他渐渐相信这真是至理名言，也对自己倾倒不已。他从此动不动就发表这段议论，还加上个帽子道：“我是研究生物学的，学校也是个有机体，教职员之于学校，应当像细胞之于有机体——”这段至理名言更变而为科学定律了。亏得这一条科学定律，李梅亭，顾尔谦，还有方鸿渐会荣任教授。他们那天下午三点多到学校。高松年闻讯匆匆到教员宿舍里应酬一下，回到办公室，一月来的心事不能再搁在一边不想了。自从长沙危急，聘好的教授里十个倒有九个打电报来托故解约，七零八落，开不出班，幸而学生也受战事影响，只有一百五十八人。今天一来就是四个教授，军容大震，向部里报上也体面些。只是怎样对李梅亭和方鸿渐解释呢？部里汪次长介绍汪处厚来当中国文学系主任，自己早写信聘定李梅亭了，可是汪处厚是汪次长的伯父，论资格也比李梅亭好，那时侯给教授陆续辞聘的电报吓昏了头，怕上海这批人会打回票，只好先敷衍次长。汪处厚这人不好打发，李梅亭是老朋友，老朋友总讲得开，就怕他的脾气难对付，难对付！这姓方的青年人倒容易对付的。他是赵辛楣的来头，辛楣最初不恳来，介绍了他，说他是留学德国的博士，真糊涂透顶！他自己开来的学历，并没有学位，只是个各国浪荡的流学生，并且并非学政治的，聘他当教授太冤枉了！至多做副教授，循序渐升，年轻人初做事不应该爬得太高，这话可以叫辛楣对他说。为难的还是李梅亭。无论如何，他千辛万苦来了，决不会一翻脸就走的；来得困难，去也没那么容易，空口允许他些好处就是了。他从私立学校一跳而进公立学校，还不是自己提拔他的；做人总要有良心。这些反正是明天的事，别去想它，今天——今天晚上还有警察局长的晚饭呢。这晚饭是照例应酬，小乡小镇上的盛馔，反来覆去，只有那几样，高松年也吃腻了。可是这时候四点钟已过，肚子有点饿，所以想到晚饭，嘴里一阵潮湿。同路的人，一到目的地，就分散了，好像是一个波浪里的水打到岸边，就四面溅开。可是，鸿渐们四个男人当天还一起到镇上去理发洗澡。回校只见告白板上贴着粉红纸的布告，说中国文学系同学今晚七时半在联谊室举行茶会，欢迎李梅亭先生。梅亭欢喜得直说：“讨厌，讨厌！我累得很，今天还想早点睡呢！这些孩子热心得不懂道理，赵先生，他们消息真灵呀！”辛楣道：“岂有此理！政治系学生为什么不开会欢迎我呀？”梅亭道：“忙什么？今天的欢迎会，你代我去，好不好？我宁可睡觉的。”顾尔谦点头叹道：“念中国书的人，毕竟知体，我想旁系的学生决不会这样尊师重道的。”说完笑迷迷地望着李梅亭，这时候，上帝会懊悔没在人身上添一条能摇的狗尾巴，因此减低了不知多少表情的效果。鸿渐道：“你们都什么系，什么系，我还不知道是哪一系的教授呢。高校长给我的电报没说明白。”辛楣忙说：“那没有关系。你可以教哲学，教国文——”梅亭狞笑道：“教国文是要得我许可的，方先生；你好好的巴结我一下，什么都可以商量。”说着，孙小姐来了，说住在女生宿舍里，跟女生指导范小姐同室，也把欢迎会这事来恭维李梅亭，梅亭轻佻笑道：“孙小姐，你改了行罢。不要到外国语文系办公室了，当我的助教，今天晚上，咱们俩同去开会。”五人同在校门口小馆子吃晚饭的时候，李梅亭听而不闻，食而不知其味，大家笑他准备欢迎会上演讲稿，梅亭极口分辨道：“胡说！这要什么准备！”晚上近九点钟，方鸿渐在赵辛楣房里讲话，连打呵欠，正要回房里去睡，李梅亭打门进来了。两人想打趣他，但瞧他脸色不正，便问：“怎么欢迎会完得这样早？”梅亭一言不发，向椅子里坐下鼻子里出气像待开发的火车头。两人忙问他怎么来了。他拍桌大骂高松年混账，说官司打到教育部去，自己也不会输的，做了校长跟人吃晚饭这时候还不回来，影子也找不见，这种玩忽职守，就该死。今天欢迎会原是汪处厚安排好的，兵法上有名的“敌人喘息未定，即予以迎头痛击”。先来校的四个中国文学系的讲师和助教早和他打成一片，学生也唯命是听。他知道高松年跟李梅亭有约在先，自己迹近乘虚篡窃，可是当系主任和结婚一样，“先进门三日就是大”。这开会不是欢迎，倒像新姨太太的见礼。李梅亭跟了学生代表一进会场，便觉空气两样，听得同事和学生一两声叫“汪主任”，己经又疑又慌。汪处厚见了他，热情地双手握着他的手，好半天搓摩不放，仿佛捉搦了情妇的手，一壁似怨似慕的说：“李先生，你真害我们等死了，我们天天在望你——张先生，薜先生，咱们不是今天早晨还讲起他的——咱们今天早晨还讲起你。路上辛苦啦？好好休息两天，再上课，不忙。我把你的功课全排好了。李先生，咱们俩真是神交久矣。高校长拍电报到成都要我组织中国文学系，我想年纪老了，路又不好走，换生不如守熟，所以我最初实在不想来。高校长，他可真会咕哪！他请舍侄”——张先生，薜先生，黄先生同声说：“汪先生就是汪次长的令伯”——“请舍侄再三劝驾，我却不过情，我内人身体不好，也想换换空气。到这儿来了，知道有你先生，我真高兴，我想这系办得好了——”李梅亭一篇主任口气的训话闷在心里讲不出口，忍住气，搭讪了几句，喝了杯茶，只推头痛，早退席了。辛楣和鸿渐安慰李梅亭一会，劝他回房睡，有话明天跟高松年去说。梅亭临走说：“我跟老高这样的交情，他还会耍我，他对你们两位一定也有把戏。瞧着罢，咱们取一致行动，怕他什么！”梅亭去后，鸿渐望着辛楣道：“这不成话说！”辛楣皱眉道：“我想这里面有误会，这事的内幕我全不知道。也许李梅亭压根儿在单相思，否则太不像话了！不过，像李梅亭那种人，真要当主任，也是个笑话，他那些印头衔的名片，现在可糟了，哈哈。”鸿渐道：“我今年反正是倒霉年，准备到处碰钉子的。也许明天高松年不认我这个蹩脚教授。”辛楣不耐烦道：“又来了！你好像存着心非倒霉不痛快似的。我告诉你，李梅亭的话未可全信——而且，你是我面上来的人，万事有我。”鸿渐虽然抱最大决意来悲观，听了又觉得这悲观不妨延期一天。明天上午，辛楣先上校长室去，说把鸿渐的事讲讲明白，叫鸿渐等着，听了回话再去见高松年。鸿渐等了一个多钟点，不耐烦了，想自己真是神经过敏，高松年直接打电报来的，一个这样机关的首领好意思说话不作准么？辛楣早尽了介绍人的责任。现在自己就去正式拜会高松年，这最干脆。高松年看方鸿渐和颜色，不相信世界上会有这样脾气好或城府深的人，忙问：“碰见赵先生没有？”“还没有。我该来参见校长，这是应当的规矩。”方鸿渐自信说话得体。高松年想糟了！糟了！辛楣一定给李梅亭缠住不能脱身，自己跟这姓方的免不了一番唇舌：“方先生，我是要跟你谈谈——有许多话我已经对赵先生说了——”鸿渐听口风不对，可脸上的笑容一时不及收敛，怪不自在地停留着，高松年看得恨不得把手指撮而去之——“方先生，你收到我的信没有？”一般人撒谎，嘴跟眼睛不能合作，嘴尽管雄纠纠地胡说，眼睛懦怯不敢平视对方。高松年老于世故，并且研究生物学的时候，学到西洋人相传的智慧，那就是：假使你的眼光能与狮子或老虎的眼光相接，彼此怒目对视，那野兽给你催眠了不敢扑你。当然野兽未必肯在享用你以前，跟你飞眼送秋波，可是方鸿渐也不是野兽，至多只能算是家畜。他给高松年三百瓦脱的眼光射得不安，觉得这封信不收到是自己的过失，这次来得太冒昧了，果然高松年写信收回成命，同时有一种不出所料的满意，惶遽地说：“没有呀！我真没有收到呀！重要不重要？高先生什么时候发的？”倒像自己撒谎，收到了信在抵赖。“咦！怎么没收到？”高松年直跳起来，假惊异的表情做得维妙维肖，比方鸿渐的真惊惶自然得多。他没演话剧，是话剧的不幸而是演员们的大幸——“这信很重要。唉！现在抗战时间的邮政简直该死。可是你先生已经来了，好得很，这些话可以面谈了。”鸿渐稍微放心，迎合道：“内地跟上海的信，常出乱子。这次长沙的战事恐怕也有影响，一大批信会遗失，高先生给我的信若是寄出得早——”高松年做了个一切撇开的手势，宽弘地饶赦那封自己没写，方鸿渐没收到的信：“信就不提了，我深怕方先生看了那封信，会不肯屈就，现在你来了，你就别想跑，呵呵！是这么一回事，你听我说，我跟你先生素昧平生，可是我听辛楣讲起你的学问人品种种，我真高兴，立刻就拍电报请先生来帮忙，电报上说——”高松年顿一顿，试探鸿渐是不是善办交涉的人，因为善办交涉的人决不会这时候替他说他自己许下的条件的。可是方鸿渐像鱼吞了饵，一钓就上，急口接说：“高先生电报上招我来当教授，可是没说明白什么系的教授，所以我想问一问？”“我原意请先生来当政治系的教授，因为先生是辛楣介绍来的，说先生是留德的博士。可是先生自己开来的履历上并没有学位——”鸿渐的脸红得像有一百零二度寒热的病人——“并且不是学政治的，辛楣全搅错了。先生跟辛楣的交情本来不很深罢？”鸿渐脸上表示的寒热又升高了华氏表上一度，不知怎么对答，高松年看在眼里，胆量更大——“当然，我决不计较学位，我只讲真才实学。不过部里定的规矩呆板得很，照先生的学历，只能当专任讲师，教授待遇呈报上去一定要驳下来的。我想辛楣的保荐不会错，所以破格聘先生为副教授，月薪二百八十元，下学年再升。快信给先生就是解释这一回事。我以为先生收到信的。”鸿渐只好第二次声明没收到信，同时觉得降级为副教授已经天恩高厚了。“先生的聘书，我方才已经托辛楣带去了。先生教授什么课程，现在很成问题。我们暂时还没有哲学系，国文系教授已经够了，只有一班文法学院一年级学生共修的论理学，三个钟点，似乎太少一点，将来我再想办法罢。”鸿渐出校长室，灵魂像给蒸气碌碡（Steam－roller）滚过，一些气概也无。只觉得自己是高松年大发慈悲收留的一个弃物。满肚子又羞又恨，却没有个发泄的对象。回到房里，辛楣赶来，说李梅亭的事终算帮高松年解决了，要谈鸿渐的事，知道鸿渐已经跟高松年谈过话，忙道：“你没有跟他翻脸罢？这都是我不好。我有个印象以为你是博士，当初介绍你到这来，只希望这事快成功——”“好让你专有苏小姐。”——“不用提了，我把我的薪水，——，好，好，我不，我不，”辛楣打拱赔笑地道歉，还称赞鸿渐有涵养，说自己在校长室讲话，李梅亭直闯进来，咆哮得不成提统。鸿渐问梅亭的事怎样了的。辛楣冷笑道：“高松年请我劝他，磨咕了半天，他说除非学校照他开的价钱买他带来的西药——唉，我还要给高松年回音呢。我心上要牵挂着你的事，所以先赶回来看你。”鸿渐本来气倒平了，知道高松年真依李梅亭的价钱替学校买他带来的私货，又气闷起来，想到李梅亭就有补偿，只自己一个人吃亏。高松年下贴子当晚上替新来的教授接风，鸿渐闹别扭要辞，经不起辛楣苦劝，并且傍晚高松年亲来回拜，终于算有了面子，还是去了。辛楣虽然不像李梅亭有提炼成丹，旅行便携的中国文学精华片，也随身带着十几本参考书。方鸿渐不知道自己会来教论理学的，携带的西洋社会史，原始文化，史学丛书等等一本也用不着。他仔细一想，慌张得没有工夫生气了，希望高松年允许自己改教比较文化史和中国文学史，可是前一门功课现在不需要，后一门功课有人担任。叫化子只讨到什么吃什么，点菜是轮不着的。辛楣安慰他说：“现在的学生程度不比从前——”学生程度跟世道人心好像是在这进步的大时代里仅有的两件退步的东西——“你不要慌，无论如何对付得过。”鸿渐上图书馆找书，馆里通共不上一千本书，老的，糟的，破旧的中文教科书居其中大半，都是因战事而停办的学校的遗产。一千年后，这些书准像敦煌石室的卷子那样名贵，现在呢，它们古而不稀，短见浅识的藏书家还不知道收买。一切图书馆本来像死用功的人大考时的头脑，是学问的坟墓；这图书馆倒像个敬惜字纸的老式慈善机关，若是天道有知，办事人今世决不遭雷击，来生一定个个聪明，人人博士。鸿渐翻找半天，居然发现一本中国人译的论理学纲要，借了回房，大有唐三藏取到佛经回长安的快乐。他看了几页论理学纲要，想学生在这地方是买不到教科书的，要不要把这本书公开或印了发给大家。一转念，这事不必。从前先生另有参考书作枕中秘宝，所以肯用教科书；现在没有参考书，只靠这本教科书来灌输智识，宣扬文化，万不可公诸大众，还是让学生们莫测高深，听讲写笔记罢。自己大不了是个副教授，犯不着太卖力气的。上第一堂先对学生们表示同情，慨叹后方书籍的难得，然后说在这种环境下，教授才不是个赘疣，因为教授讲学是印刷术没发明以前的应急办法，而今不比中世纪，大家有书可看，照道理不必在课堂上浪费彼此的时间——鸿渐自以为这话说出去准动听，又高兴得坐不定，预想着学生的反应。鸿渐等是星期三到校的，高松年许他们休息到下星期一才上课。这几天里，辛楣是校长的红人，同事拜访他的最多。鸿渐就少人光顾。这学校草草创办，规模不大；除掉女学生跟少数带家眷的教职员外，全住在一个大园子里。世态炎凉的对照，愈加分明。星期日下午，鸿渐正在预备讲义，孙小姐来了，脸色比路上红活得多。鸿渐要去叫辛楣，孙小姐说她刚从辛楣那儿来，政治系的教授们在开座谈会呢，满屋子的烟，她瞧人多有事，就没有坐下。方鸿渐笑道：“政治家聚在一起，当然是乌烟瘴气。”孙小姐笑了一笑，说：“我今天来谢谢方先生跟赵先生。昨天下午学校会计处把我旅费补送来了。”“这是赵先生替你争取来的。跟我无关。”“不，我知道，”孙小姐温柔而固执着，“这是你提醒赵先生的。你在船上——”孙小姐省悟多说了半句话，涨红脸，那句话也遭到了腰斩。鸿渐猛记得船上的谈话，果然这女孩全听在耳朵里了，看她那样子，自己也窘起来。害羞脸红跟打呵欠或口吃一样，有传染性，情况粘滞，仿佛像穿橡皮鞋走泥淖，踏不下而又拔不出。忙支吾开顽笑说：“好了，好了。你回家的旅费有了。还是趁早回家罢，这儿没有意思。”孙小姐小孩子般颦眉撅嘴道：“我真想回家！我天天想家，我给爸爸写信也说我想家。到明年暑假那时候太远了，我想着就心焦。”“第一次出门总是这样的，过几时就好了。你跟你们那位系主任谈过没有。”“怕死我了！刘先生要我教一组英文，我真不会教呀！刘先生说四组英文应当同时间上课的，系里连他只有三个先生，非我担任一组不可。我真不知道怎样教法，学生个个比我高大，看上去全凶得很。”“教教就会了。我也从来没教过书。我想程度不会好，你用心准备一下，教起来绰绰有余。”“我教的一组是入学考英文成绩最糟的一组，可是，方先生，你不知道我自己多少糟，我想到这儿来好好用一两年功。有外国人不让她教，到要我去丢脸！”“这儿有什么外国人呀？”“方先生不知道么？历史系主任韩先生的太太，我也没有见过，听范小姐说，瘦得全身是骨头，难看得很。有人说她是白俄，有人说她是这次奥国归并德国以后流亡出来的犹太人，她丈夫说她是美国人。韩先生要她在外国语文系当教授，刘先生不答应，说她没有资格，英文都不会讲，教德文教俄文现在用不着。韩先生生了气，骂刘先生自己没有资格，不会讲英文，编了几本中学教科书，在外国暑期学校里混了张证书，算什么东西——话真不好听，总算高先生劝开了，韩先生在闹辞职呢。”“怪不得前天校长请客他没有来。咦！你本领真大，你这许多消息，什么地方听来的？”孙小姐笑道：“范小姐告诉我的。这学校像个大家庭，除非你住在校外，什么秘密都保不住，并且口舌多得很。昨天刘先生的妹妹从桂林来了，听说是历史系毕业的。大家都说，刘先生跟韩先生可以讲和了，把一个历史系的助教换一个外文系的教授。”鸿渐掉文道：“妹妹之于夫人，亲疏不同；助教之于教授，尊卑不敌。我做了你们的刘先生，决不肯吃这个亏的。”说着，辛楣进来了，说：“好了，那批人送走了——孙小姐，我不知道你不会就去的。”你说这句话全无意思的，可是孙小姐脸红。鸿渐忙把韩太太这些事告诉他，还说：“怎么学校里还有这许多政治暗斗？倒不如进官场爽气。”辛楣宣扬教义似的说：“有群众生活的地方全有政治。”孙小姐坐一会去了。辛楣道：“我写信给她父亲，声明把保护人的责任移交给你，好不好？”鸿渐道：“我看这题目已经像教国文的老师所谓”做死“了，没有话可以说了，你换个题目来开顽笑，行不行？”辛楣笑他扯淡。上课一个多星期，鸿渐跟同住一廊的几个同事渐渐熟了。历史系的陆子潇曾作敦交睦邻的拜访，所以一天下午鸿渐去回看他。陆子潇这人刻意修饰，头发又油又光，深为帽子埋没，与之不共戴天，深冬也光着顶。鼻子短而阔，仿佛原有笔直下来的趋势，给人迎鼻孔打了一拳，阻止前进，这鼻子后退不迭，向两傍横溢。因为没结婚，他对自己年龄的态度，不免落后在时代的后面；最初他还肯说外国算法的十足岁数，年复一年，他偷偷买了一本翻译的LifeBeginsatForty，对人家干脆不说年龄，不讲生肖，只说：“小得很呢！还是小弟弟呢！”同时表现小弟弟该有的活泼和顽皮。他讲话时喜欢窃窃私语，仿佛句句是军事机密。当然军事机密他也知道的，他不是有亲戚在行政院，有朋友在外交部么？他亲戚曾经写给他一封信，这左角印“行政院”的大信封上大书着“陆子潇先生”，就仿佛行政院都要让他正位居中似的。他写给外交部那位朋友的信，信封虽然不大，而上面开的地址“外交部欧美司”六字，笔酣墨饱，字字端楷，文盲在黑夜里也该一目了然的。这一封来函，一封去信，轮流地在他桌上妆点着。大前天早晨，该死的听差收拾房间，不小心打翻墨水瓶，把行政院淹得昏天黑地，陆子潇挽救不及，跳脚痛骂。那位亲戚国而忘家，没来过第二次信；那位朋友外难顾内，一封信也没回过。从此，陆子潇只能写信到行政院去，书桌上两封信都是去信了。今日正是去信外交部的日子。子潇等鸿渐看见了桌上的信封，忙把这信搁在抽屉里，说：“不相干。有一位朋友招我到外交部去，回他封信。”鸿渐信以为真，不得不做出惜别的神情道：“啊哟！怎么陆先生要高就了！校长肯放你走么？”子潇连摇头道：“没有的事！做官没有意思，我回信去坚辞的。高校长待人也厚道，好几个电报把我催来，现在你们各位又来了，学校渐渐上规道，我好意思拆他台么？”鸿渐想起高松年和自己的谈话，叹气道：“校长对你先生，当然另眼相看了。像我们这种——”子潇说话低得有气无声，仿佛思想在呼吸：“是呀。校长就是有这个毛病，说了话不作准的。我知道了你的事很不平。”机密得好像四壁全挂着偷听的耳朵。鸿渐没想到自己的事人家早已知道了，脸微红道：“我到没有什么，不过高先生——我总算学个教训。”“那里的话！副教授当然有屈一点，可是你的待遇算是副教授里最高的了。”“什么？副教授里还分等么？”鸿渐大有英国约翰生博士不屑分别臭虫和跳虱的等级的意思。“分好几等呢。譬如你们同来，我们同系的顾尔谦就比你低两级。就像系主任罢，我们的系主任韩先生比赵先生高一级，赵先生又比外语系的刘东方高一级。这里面等次多得级很，你先生初回国做事，所以搅不清了。”鸿渐茅塞顿开，听说自己比顾尔谦高，气平了些，随口问道：“为什么你们的系主任薪水特别高呢？”“因为他是博士，Ph.D.。我没到过美国，所以没听见过他毕业的那个大学，据说很有名。在纽约，叫什么克莱登大学。”鸿渐吓得直跳起来，宛如自己的阴私给人揭破，几乎失声叫道：“什么大学？”“克来登大学。你知道克莱登大学？”“我知道。哼，我也是——”鸿渐恨不得把自己舌头咬住，已经漏泄三个字。子潇听话中有因，像黄泥里的竹□（竹头，旬），尖端微露，便想盘问到底。鸿渐不肯说，他愈起疑心，只恨不能采取特务机关的有效刑罚来逼口供。鸿渐回房，又气又笑。自从唐小姐把文凭的事向他质问以后，他不肯再想起自己跟爱尔兰人那一番交涉，他牢记着要忘掉这事。每逢念头有扯到它的远势，他赶快转移思路，然而身上已经一阵羞愧的微热。适才陆子潇的话倒仿佛一帖药，把心里的鬼胎打下一半。韩学愈撒他的谎，并非跟自己同谋，但有了他，似乎自己的欺骗减轻了罪名。当然新添上一种不快意，可是这种不快意是透风的，见得天日的，不比买文凭的事像谋杀迹灭的尸首，对自己都要遮掩得一丝不露。撒谎骗人该像韩学愈那样才行，要有勇气坚持到底。自己太不成了，撒了谎还要讲良心，真是大傻瓜。假如索性大胆老脸，至少高松年的欺负就可以避免。老实人吃的亏，骗子被揭破的耻辱，这两种相反的痛苦，自己居然一箭双雕地兼备了。鸿渐忽然想，近来连撒谎都不会了。因此恍然大悟，撒谎往往是高兴快乐的流露，也算是一种创造，好比小孩子游戏里的自骗自（Pseudoluege）。一个人身心畅适，精力充溢，会不把顽强的事实放在眼里，觉得有本领跟现实开顽笑。真到忧患穷困的时候，谎话都讲不好的。这一天，韩学愈特来拜访。通名之后，方鸿渐倒窘起来，同时快意地失望。理想中的韩学愈不知怎样的嚣张浮滑，不料是个沉默寡言的人。他想陆子潇也许记错，孙小姐准是过信流言。木讷朴实是韩学愈的看家本领——不，养家本钱，现代人有两个流行的信仰。第一：女子无貌便是德，所以漂亮的女人准比不上丑女人那样有思想，有品节；第二：男子无口才，就是表示有道德，所以哑巴是天下最诚朴的人。也许上够了演讲和宣传的当，现代人矫枉过正，以为只有不说话的人开口准说真话，害得新官上任，训话时个个都说：“为政不在多言，”恨不能只指嘴，指心，三个手势了事。韩学愈虽非哑巴，天生有点口吃。因为要掩饰自己的口吃，他讲话少，慢，著力，仿佛每个字都有他全部人格作担保。高松年在昆明第一次见到他，觉得这人诚恳安详，像个君子，而且未老先秃，可见脑子里的学问多得冒上来，把头发都挤掉了。再一看他开的学历，除掉博士学位以外，还有一条：“著作散见美国”史学杂志“”星期六文学评论“等大刊物中”，不由自主地另眼相看。好几个拿了介绍信来见的人，履历上写在外国“讲学”多次。高松年自己在欧洲一个小国里过读书，知道往往自以为讲学，听众以为他在学讲——讲不来外国话借此学学。可是在外国大刊物上发表作品，这非有真才实学不可。便问韩学愈道：“先生的大作可以拿来看看么？”韩学愈坦然说，杂志全搁在沦陷区老家里，不过这两种刊物中国各大学全该定阅的，就近应当一找就到，除非经过这番逃难，图书馆的旧杂志损失不全了。高松年想不到一个说谎者会这样泰然无事；各大学的书籍七零八落，未必找得着那期杂志，不过里面有韩学愈的文章看来是无可疑问的。韩学愈也确向这些刊物投过稿，但高松年没知道他的作品发表在“星期六文学评论”的人事广告栏（Personals）（“中国少年，受高等教育，愿意帮助研究中国问题的人，取费低廉”）和“史学杂志”的通信栏（“韩学愈君徵求二十年前本刊，愿出让者请某处接洽”）。最后他听说韩太太是美国人，他简直改容相敬了，能娶外国老婆的非精通西学不可，自己年轻时不是想娶个比国女人没有成功么？这人做得系主任。他当时也没想到这外国老婆是在中国娶的白俄。跟韩学愈谈话访佛看慢动电影（Slow－motionpicture），你想不到简捷的一句话需要那么多的筹备，动员那么复杂的身体机构。时间都给他的话胶着，只好拖泥带水地慢走。韩学愈容颜灰暗，在阴天可以与周围的天色和融无间，隐身不见，是头等保护色。他有一样显著的东西，喉咙里有一个大核。他讲话时，这喉核忽升忽降，鸿渐看得自己的喉咙都发痒。他不说话咽唾沫时，这核稍隐复现，令鸿渐联想起青蛙吞苍蝇的景象。鸿渐看他说话少而费力多，恨不能把那喉结瓶塞头似的拔出来，好让下面的话松动。韩学愈约鸿渐上他家去吃晚饭，鸿渐谢过他，韩学愈又危坐不说话了，鸿渐只好找话敷衍，便问：“听说嫂夫人是在美国娶的？”韩学愈点头，伸颈咽口唾沫，唾沫下去，一句话从喉核下浮上：“你先生到过美国没有？”“没有去过——”索性试探他一下——“可是，我一度想去，曾经跟一个Dr.Mahoney通信。”是不是自己神经过敏呢？韩学愈似乎脸色微红，像阴天忽透太阳。“这个人是个骗子。”韩学愈的声调并不激动，说话也不增多。“我知道。什么克莱登大学！我险的上了他的当。”鸿渐一面想，这人肯说那爱尔兰人是“骗子”，一定知道瞒不了自己了。“你没有上他的当罢！克莱登是好学校，他是这学校里开除的小职员，借着幌子向外国不知道的人骗钱，你真没有上当？唔，那最好。”“真有克莱登这学校么？我以为全是那爱尔兰人捣的鬼。”鸿渐诧异得站起来。“很认真严格的学校，虽然知道的人很少——普通学生不容易进。”“我听陆先生说，你就是这学校毕业的。”“是的。”鸿渐满腹疑团，真想问个详细。可是初次见面，不好意思追究，倒像自己不相信他，并且这人说话经济，问不出什么来。最好有机会看看他的文凭，就知道他的克莱登是一是二了。韩学愈回家路上，腿有点软，想陆子潇的报告准得很，这姓方的跟爱尔兰人有过交涉，幸亏他没去过美国，就恨不知道他是否真的没买文凭，也许他在撒谎。方鸿渐吃韩家的晚饭，甚为满意。韩学愈虽然不说话，款客的动作极周到；韩太太虽然相貌丑，红头发，满脸雀斑，像面饼上苍蝇下的粪，而举止活泼得通了电似的。鸿渐然发现西洋人丑跟中国人不同：中国人丑得像造物者偷工减料的结果，潦草塞责的丑；西洋人丑得像造物者恶意的表现，存心跟脸上五官开玩笑，所以丑得有计划，有作用。韩太太口口声声爱中国，可是又说在中国起居服食，没有在纽约方便。鸿渐终觉得她口音不够地道，自己没到过美国，要赵辛楣在此就听得出了，也许是移民到纽约去的。他到学校以后，从没有人对他这样殷勤过，几天来的气闷渐渐消散。他想韩学愈的文凭假不假，管它干么，反正这人跟自己要好就是了。可是，有一件事，韩太太讲纽约的时候，韩学愈对她做个眼色，这眼色没有逃过自己的眼，当时就有一个印象，仿佛偷听到人家背后讲自己的话。这也许是自己多心，别去想它。鸿渐兴高采烈，没回房就去看辛楣：“老赵，我回来了。今天对不住你，让你一个人吃饭。”辛楣因为韩学愈没请自己，独吃了一客又冷又硬的包饭，这吃到的饭在胃里作酸，这没吃到的饭在心里作酸，说：“国际贵宾回来了！饭吃得好呀？是中国菜还是西洋菜？洋太太招待得好不好？”“他家里老妈子做的中菜。韩太太真丑！这样的老婆在中国也娶的到，何必去外国去觅呢！辛楣，今天我恨你没有在——”“哼，谢谢——今天还有谁呀？只有你！真了不得！韩学愈上自校长，下到同事谁都不理，就敷衍你一个人。是不是洋太太跟你有什么亲戚？”辛楣欣赏自己的幽默，笑个不了。鸿渐给辛楣那么一说，心里得意，假装不服气道：“副教授就不是人？只有你们大主任大教授配彼此结交？辛楣，讲正经话，今天有你，韩太太的国籍问题可以解决了。你是老美国，听她说话盘问她几句，就水落石出。”辛楣虽然觉得这句话中听，这不愿意立刻放弃他的不快：“你这人真没良心。吃了人家的饭，还要管闲事，探听人家阴私。只要女人可以做太太，管她什么美国人俄国人。难道是了美国人，她女人的成分就加了倍？养孩子的效率会与众不同？”鸿渐笑道：“我是对韩学愈的学籍的有兴趣，我总有一个感觉，假使他太太的国籍是假的，那么他的学籍也有问题。”“我劝你省点事罢。你瞧，谎是撒不得的。自己捣了鬼从此对人家也多疑心——我知道你那一会事是开的顽笑，可是开顽笑开出来多少麻烦。像我们这样规规矩矩，就不会疑神疑鬼。”鸿渐恼道：“说得好漂亮！为什么当初我告诉了你韩学愈薪水比你高一级，你要气得掼纱帽不干呢？”辛楣道：“我并没有那样气量小——，这全是你不好，听了许多闲话来告诉我，否则我耳根清净，好好的不会跟人计较。”辛楣新学会一种姿态，听话时躺在椅子里，闭了眼睛，只有嘴边烟斗里的烟篆表示他并未睡着。鸿渐看了早不痛快，更经不起这几句话：“好，好！我以后再跟你讲话，我不是人。”辛楣瞧鸿渐真动了气，忙张眼道：“说着顽儿的。别气得生胃病，抽枝烟。以后恐怕到人家去吃晚饭也不能够了。你没有看见通知？是的，你不会有的。大后天开校务会议，讨论施行导师制问题，听说导师要跟学生同吃饭的。”鸿渐闷闷回房，难得一团高兴，找朋友扫尽了兴。天生人是教他们孤独的，一个个该各归各，老死不相往来。身体里容不下的东西，或消化，或排泄，是个人的事，为什么心里容不下的情感，要找同伴来分摊？聚在一起，动不动自己冒犯人，或者人开罪自己，好像一只只刺猬，只好保持著彼此间的距离，要亲密团结，不是你刺痛我的肉，就是我擦破你的皮。鸿渐真想把这些感慨跟一个能了解自己的人谈谈，孙小姐好像比赵辛楣能了解自己，至少她听自己的话很有兴味——不过，刚才说人跟人该免接触，怎么又找女人呢？也许男人跟男人在一起像一群刺猬，男人跟女人在一起像——鸿渐想不出像什么，翻开笔记来准备明天的功课。鸿渐教的功课到现在还有三个钟点，同事们谈起，无人不当面羡慕他的闲适，倒好像高松年有点私心，特别优待他。鸿渐对论理学素乏研究，手边又没有参考，虽然努力准备，并不感觉兴趣。这些学生来上他的课压根儿为了学分。依照学校章程，文法学院学生应该在物理，化学，生物，论理四门之中，选修一门。大半人一窝蜂似的选修了论理。这门功课最容易——“全是废话”——不但不必做实验，天冷的时候，还可以袖手不写笔记。因为这门功课容易，他们选它；也因为这门功课容易，他们瞧不起它，仿佛男人瞧不起容易到手的女人。论理学是“废话”，教论理学的人当然是“废物”，“只是个副教授”，而且不属于任何系的。他们心目中，鸿渐的地位比教党义和教军事训练的高不了多少。不过教党义的和教军事的是政府机关派的，鸿渐的来头没有这些人大，“听说是赵辛楣的表弟，跟着他来的；高松年只聘他做讲师，赵辛楣替他争来的副教授。”无怪鸿渐老觉得班上的学生不把听讲当作一会事。在这种空气之下，讲书不会有劲。更可恨论理学开头最枯燥无味，要讲到三段论法，才可以穿插点缀些笑话，暂时还无法迎合心理。此外有两件事也使鸿渐不安。一件是点名。鸿渐记得自己老师里的名教授从不点名，从不报告学生缺课。这才是堂堂大学者的风度：“你们要听就听，我可不在乎。”他企羡之余，不免模仿。上第一课，他像创世纪里原人阿大（Adam）唱新生禽兽的名字，以后他连点名簿子也不带了。到第二星期，他发现五十多学生里有七八个缺席，这些空座位像一嘴牙齿忽然吊了几枚，留下的空穴，看了心里不舒服。下一次，他注意女学生还固守着第一排原来的座位，男学生像从最后一排坐起的，空着第二排，第三排孤另另地坐一个男学生。自己正观察这阵势，男学生都顽皮地含笑低头，女学生随自己的眼光，回头望一望，转脸瞧着自己笑。他总算熬住没说：“显然我拒绝你们的力量比女同学吸引你们的力量都大。”想以后非点名不可，照这样下去，只剩有脚而跑不子的椅子和桌子听课了。不过从大学者的放任忽变而为小学教师的琐碎，多么丢脸，这些学生是狡猾不过的，准看破了自己的用意。一件是讲书。这好像衣料的尺寸不够而硬要做成称身的衣服。自以为预备的材料很充分，到上课才发现自己讲得收缩不住地快，笔记上已经差不多了，下课钤还有好一会才打。一片无话可说的空白时间，像白漫漫一片水，直向开足马达的汽车迎上来，望着发急而又无处躲避。心慌意乱中找出话来支扯，说不上几句又完了，偷眼看手表，只拖了半分钟。这时候，身上发热，脸上发红，讲话开始口吃，觉得学生都在暗笑。有一次，简直像挨饿几天的人服了泻药，什么话也挤不出，只好早退课一刻钟。跟辛楣谈起，知道他也有此感，说毕竟初教书人没经验。辛楣还说：“现在才明白为什么外国人要说”杀时间“（killtime），打下课钤以前那几分钟的难过！真恨不能把它一刀两段。”鸿渐最近发明一个方法，虽然不能一下子杀死时间，至少使它受些致命伤。他动不动就写黑板，黑板上写一个字要嘴里讲十个字那些时间。满脸满手白粉，胳膊酸半天，这都值得，至少以后不会早退。不过这些学生作笔记不大上劲，往往他讲得十分费力，有几个人坐着一字不写，他眼睛威胁地注视着，他们才懒洋洋把笔在本子上画字。鸿渐瞧了生气，想自己总不至于李梅亭糟，何以隔壁李梅亭的“秦汉社会风俗史”班上，学生笑声不绝，自己的班上这样无精打采。他想自己在学校读书的时候，也不算坏学生，何以教书这样不出色。难道教书跟作诗一样，需要“别才”不成？只懊悔留学外国，没混个专家的头衔回来，可以声威显赫，开藏有洋老师演讲的全部笔记秘本的课程，不必像现在帮闲打杂，承办人家剩下来的科目。不过李梅亭这些人都是教授有年，有现成讲义的。自己毫无经验，更无准备，教的功课又并非出自愿，要参考也没有书，当然教不好。假如混过这一年，高松年守信用，升自己为教授，暑假回上海弄几本外国书看看，下学年不相信会比不上李梅亭。这样想着，鸿渐恢复了自尊心。回国后这一年来，他跟他父亲疏远得多。在从前，他会一五一十，全禀告方□（辶＋豚）翁的。现在他想像得出□（辶＋豚）翁的回信。□（辶＋豚）翁的心境好就抚慰儿子说：“尺有所短，寸有所长，学者未必能为良师”，这够叫人内愧了；他心境不好，准责备儿子从前不用功，急时抱佛脚，也许还来一堆“亡羊补牢，教学相长”的教训，更受不了。这是纪念周上对学生说的话，自己在教职员席里傍听得腻了，用不到千里迢迢去搬来。开校务会议前的一天，鸿渐和辛楣商量好到镇上去吃晚饭，怕导师制实行以后，这自由就没有了。下午陆子潇来闲谈，问鸿渐知道孙小姐的事没有。鸿渐问他什么事，子潇道：“你不知道就算了。”鸿渐了解子潇的脾气，不问下去。过一会，子潇尖利地注视着鸿渐，像要看他个对穿，道：“你真的不知道么？怎么会呢？”叮嘱他严守秘密，然后把这事讲出来。教务处一公布孙小姐教丁组英文，丁组的学生就开紧急会议，派代表见校长和教务长抗议。理由是：大家都是学生，当局不该歧视，为什么傍组是副教授教英文，丁组只派个助教来教。他们知道自己程度不好，所以，他们振振有词地说，必需一个好教授来教他们。亏高松年有本领，弹压下去。学生不怕孙小姐，课堂秩序不大好。作了一次文，简直要不得。孙小姐征求了外国语文系刘主任的同意，不叫丁组的学生作文，只叫他们练习造句。学生知道了大闹，质问孙小姐为什么人家作文，他们造句，把他们当中学生看待。孙小姐说：“因为你们不会作文。”他们道：“不会作文所以要学作文呀。”孙小姐给他们嚷得没法，只好请刘主任来解释，才算了局。今天是作文的日子，孙小姐进课堂就瞧见黑板上写着：“BeatdownMissS.！MissS.isJapaneseenemy！”学生都含笑期待着。孙小姐叫他们造句，他们全说没带纸，只肯口头练习，叫一个学生把三个人称多少数各做一句，那学生一口气背书似的说：“Iamyourhusband.Youraremywife.Heisalsoyourhusband.Weareyourmanyhusbands.——”全课堂笑得前仰后合。孙小姐奋然出课堂，这事不知道怎样结束呢。子潇还声明道：“这学生是中国文学系的。我对我们历史系的学生私人训话一次，劝他们在孙小姐班上不要胡闹，招起人家对韩先生的误会，以为他要太太教这一组，鼓动本系学生撵走孙小姐。”鸿渐道：“我什么都不知道呀。孙小姐跟我好久没见面了。竟有这样的事。”子潇又尖刻地瞧鸿渐一眼道：“我以为你们俩是常见面的。”鸿渐正说：“谁告诉你的！”孙小姐来了，子潇忙起来让坐，出门时歪着头对鸿渐点一点，表示他揭破了鸿渐的谎话，鸿渐没工夫理会，忙问孙小姐近来好不好。孙小姐忽然别转脸，手帕按嘴，肩膀耸动，唏嘘哭起来。鸿渐急跑出来叫辛楣，两人进来，孙小姐倒不哭了。辛楣把这事问明白，好言抚慰了半天，鸿渐和着他。辛楣发狠道：“这种学生非严办不可，我今天晚上就跟校长去说——你报告刘先生没有？”鸿渐道：“这倒不是惩戒学生的问题。孙小姐这一班决不能再教了。你该请校长找人代她的课，并且声明这事是学校对不住孙小姐。”孙小姐道：“我死也不肯教他们了。我真想回家，”声音又哽咽着。辛楣忙说这是小事，又请她同去吃晚饭。她还在踌躇，校长室派人送来帖子给辛楣。高松年今天替部里派来视察的参事接风，各系主任都得奉陪，请辛楣这时候就去招待。辛楣说：“讨厌！咱们今天的晚饭吃不成了，”跟着校役去了。鸿渐请孙小姐去吃晚饭，可是并不热心。她说改天罢，要回宿舍去。鸿渐瞧她脸黄眼肿，挂着哭的幌子，问她要不要洗个脸，不等她回答，检块没用过的新毛巾出来，拔了热水瓶的塞头。她洗脸时，鸿渐望着窗外，想辛楣知道，又要误解的。他以为给她洗脸的时候很充分了，才回过头来，发现她打开手提袋，在照小镜子，擦粉涂唇膏呢。鸿渐一惊，想不到孙小姐随身配备这样完全，平常以为她不修饰的脸原来也是件艺术作品。孙小姐面部修理完毕，衬了颊上嘴上的颜色，哭得微红的上眼皮，也像涂了胭脂的，替孙小姐天真的脸上意想不到地添些妖邪之气。鸿渐送她出去，经过陆子潇的房，房门半开，子潇坐在椅子里吸烟，瞧见鸿渐俩，忙站起来点头，又半坐下去，宛如有弹簧收放着。走不到几步，听见背后有人叫，回头看是李梅亭，满脸得意之色，告诉他们俩高松年刚请他代理训导长，明天正式发表，这时候要到联谊室去招待部视学呢。梅亭仗着黑眼镜，对孙小姐像显微镜下看的微生物似的细看，笑说：“孙小姐愈来愈漂亮了。为什么不来看我，只看小方？你们俩什么时候订婚——”鸿渐“嘘”了他一声，他笑着跑了。鸿渐刚回房，陆子潇就进来，说：“咦，我以为你跟孙小姐同吃晚饭去了。怎么没有去？”鸿渐道：“我请不起，不比你们大教授。等你来请呢。”子潇道：“我请就请，有什么关系。就怕人家未必赏脸呀。”“谁？孙小姐？我看你关心她得很，是不是看中了她？哈哈，我来介绍。”“胡闹胡闹！我要结婚呢，早结婚了。唉，”曾经沧海难为水“！”鸿渐笑道：“谁教你眼光那样高的。孙小姐很好，我跟她一道来，可以担保得了她的脾气——”“我要结婚呢，早结婚了，”仿佛开留声机时，针在唱片上碰到障碍，三番四复地说一句话。“认识认识无所谓呀。”子潇猜疑地细看鸿渐道：“你不是跟她好么？夺人之爱，我可不来。人弃我取，我更不来。”“岂有此理！你这人存心太卑鄙。”子潇忙说他说着玩儿的，过两天一定请客。子潇去了，鸿渐想着好笑。孙小姐知道有人爱慕，准会高兴，这消息可以减少她的伤心。不过陆子潇像配不过她，她不会看中他的。她干脆嫁了人好，做事找气受，太犯不着。这些学生真没法对付，缠得你头痛，他们黑板上写的口号，文理倒很通顺，孙小姐该引以自慰，等她气平了跟她取笑。辛楣吃晚饭回来，酒气醺醺，问鸿渐道：“你在英国，到过牛津剑桥没有？他们的导师制（Tutorialsystem）是怎么一会事？”鸿渐说旅行到牛津去过一天，导师制详细内容不知道，问辛楣为什么要打听。辛楣道：“今天那位贵客视学先生是位导师制专家，去年奉命到英国去研究导师制的，在牛津和剑桥都住过。”鸿渐笑道：“导师制有什么专家！牛津或剑桥的任何学生，不知道得更清楚么？这些办教育的人专会挂幌子虎人。照这样下去，这要有研究留学，研究做校长的专家呢。”辛楣道：“这话我不敢同意。我想教育制度是值得研究的，好比做官的人未必都知道政府组织的利弊。”“好，我不跟你辨，谁不知道你是讲政治学的？我问你，这位专家怎么说呢？他这次来是不是跟明天的会议有关？”“导师制是教育部的新方针，通知各大学实施，好像反响不甚好，咱们这儿高校长是最热心奉行的人——我忘掉告诉你，李瞎子做了训导长了，咦，你知道了——这位部视学顺便来指导的，明天开会他要出席。可是他今天讲的话，不甚高明。据他说，牛津剑桥的导师制缺点很多，离开师生共同生活的理想很远，所以我们行的是经他改良，经部核准的计划。在牛津剑桥，每个学生有两个导师，一位学业导师，一位道德导师（Moraltutor）。他认为这不合教育原理，做先生的应当是”经师人师“，品学兼备，所以每人指定一个导师，就是本系的先生；这样，学问和道德可以融贯一气了。英国的道德导师是有名无实的；学生在街上闯祸给警察带走，他到警察局去保释，学生欠了店家的钱，还不出，他替他保证。我们这种导师责任大得多了，随时随地要调查，矫正，向当局报告学生的思想。这些都是官样文章，不用说它，他还有得意之笔。英国导师一壁抽烟斗，一壁跟学生谈话的。这最违背新生活运动，所以咱们当学生的面，绝不许抽烟，最好压根儿戒烟——可是他自己并没有戒烟。菜馆里供给的烟，他一枝一枝抽个不亦乐乎，临走还袋了一匣火柴。英国先生只跟学生同吃晚饭，并且分桌吃的，先生坐在台上吃，师生间隔膜得很。这亦得改良，咱们以后一天三餐都跟学生同桌吃——”“干脆跟学生同床睡觉得了！”辛楣笑道：“我当时险的说出口。你还没听见李瞎子的议论呢。他恭维了那位视学一顿，然后说什么中西文明国家都严于男女之防，师生恋爱是有伤师道尊严的，万万要不得，为防患未然起见，未结婚的先生不得做女学生的导师。真气得死人，他们都对我笑——这几个院长和系主任里，只有我没结婚。”“哈哈，妙不可言！不过，假使不结婚的男先生训导女学生有师生恋爱的危险，结婚的男先生训导女生更有犯重婚罪的可能，他没想到。”“我当时质问他，结了婚而太太没带来的人做得做不得女学生的导师，他支吾其词，请我不要误会。这瞎子真混蛋，有一天我把同路来什么苏州寡妇，王美玉的笑话替他宣传出去。吓，还有，他说男女同事来往也不宜太密，这对学生的印象不好——”鸿渐跳起来道：“这明明指我跟孙小姐说的，方才瞎子看见我跟她在一起。”辛楣道：“这倒不一定指你，我看当时，高松年的脸色变了一变，这里面总有文章。不过我劝你快求婚，订婚，结婚。这样，李瞎子不能说闲话，而且——”说时扬着手，嘻开嘴，“你要犯重婚罪也有机会了。”鸿渐不许他胡说：问他跟高松年讲过学生侮辱孙小姐的事没有。辛楣说，高松年早知道了，准备开除那学生。鸿渐又告诉他陆子潇对孙小姐有意思，辛楣说他做“叔叔”的只赏识鸿渐。说笑了一回，辛楣临走道：“唉，我忘掉了最精彩的东西。部里颁布的导师规程草略里有一条说，学生毕业后在社会上如有犯罪行为，导师连带负责——”鸿渐惊骇得呆了。辛楣道：“你想，导师制变成这么一个东西。从前明成祖诛方孝孺十族，听说方孝孺的先生都牵连杀掉的。将来还有人敢教书么？明天开会，我一定反对。”“好家伙！我在德国听见的纳粹党教育制度也没有这样利害。这算牛津剑桥的导师制么？”“哼，高松年还要我写篇英文投到外国杂志去发表，让西洋人知道咱们也有牛津剑桥的学风。不知怎么，外国一切好东西到中国没有不走样的，”辛楣叹口气，不知道这正是中国的利害，天下没敌手，外国东西来一件，毁一件。跟孙小姐扰乱的那个中国文学系学生是这样处置的。外文系主任刘东方主张开除，国文系主任汪处厚反对。赵辛楣因为孙小姐是自己的私人，肯出力而不肯出面，只暗底下赞助刘东方的主张。训导长李梅亭出来解围，说这学生的无礼，是因为没受到导师薰陶，愚昧未开，不知者不罪，可以原谅，记过一次了事。他叫这学生到自己卧房里密切训导了半天，告诉他怎样人人要开除他，汪处厚毫无办法，全亏自己保全，那学生红着眼圈感谢。孙小姐的课没人代，刘东方怕韩太太乘虚而入，亲自代课，所恨国立大学不比私立大学，薪水是固定的，不因钟点添多而加薪。代了一星期课，刘东方厌倦起来，想自己好傻，这气力时间费得冤枉，博不到一句好话。假使学校真找不到代课的人，这一次显得自己做系主任的为了学生学业，不辞繁剧，亲任劳怨。现在就放着一位韩太太，自己偏来代课，一屁股要两张坐位，人家全明白是门户之见，忙煞也没处表功。同事里赵辛楣的英文是有名的，并且只上六点钟的功课，跟他情商请他代孙小姐的课，不知道他答应不答应。孙小姐不是他面上的人么？她教书这样不行，保荐她的人不该负责吗？当然，赵辛楣的英文好像比自己都好——刘东方不得不承认——不过，丁组的学生程度糟得还不够辨别好坏，何况都是傍系的学生，自己在本系的威信不致动摇。刘东方主意已定，先向高松年提议，高松年就请赵辛楣来会商。辛楣因为孙小姐关系，不好斩钉截铁地拒绝，灵机一动，推荐方鸿渐。松年说：“咦，这倒不失为好办法，方先生钟点本来太少，不知道他的英文怎样？”辛楣满嘴说：“很好，”心里想鸿渐教这种学生总绰有余裕的。鸿渐自觉在学校的地位不稳固，又经辛楣细陈利害，刘东方的劝驾，居然大胆老脸低头小心教起英文来。这事一发表，韩学愈来见高松年，声明他太太绝不想在这儿教英文，表示他对刘东方毫无怨恨，他愿意请刘小姐当历史系的助教。高松年喜欢道：“同事们应当和衷共济，下学年一定聘夫人帮忙。”韩学愈高傲地说：“下学年我留不留，还成问题呢。协合大学来了五六次信要我跟我内人去。”高松年忙劝他不要走，他夫人的事下学年总有办法。鸿渐到外文系办公室接功课，碰见孙小姐，低声开顽笑说：“这全是你害我的——要不要我代你报仇？”孙小姐笑而不答。陆子潇也没再提起请饭。在导师制讨论会上，部视学先讲了十分钟冠冕堂皇的话，平均每分钟一句半“兄弟在英国的时候”。他讲完看一看手表，就退席了。听众喉咙里忍住的大小咳嗽声全放出来，此作彼继，Ehem？KeKeKe，——在中国集会上，静默三分钟后，主席报告后，照例有这么一阵咳嗽。咳几声例嗽之外，大家还换了较舒适的坐态。高松年继续演说，少不得又把细胞和有机体的关系作第N次的阐明，希望大家为团体生活牺牲一己的方便。跟着李梅亭把部颁大纲和自己拟的细则宣读付讨论。一切会议上对于提案的赞成和反对极少是就事论事的。有人反对这提议是跟提议的人闹意见。有人赞成这提议是跟反对这提议的人过不去。有人因为反对或赞成的人跟自己有关系所以随声附和。导师跟学生同餐的那条规则，大家一致抗议，带家眷的人闹得更利害。没带家眷的物理系主任说，除非学校不算导师的饭费，那还可以考虑。家里饭菜有名的汪处厚说，就是学校替导师出饭钱，导师家里照样要开饭，少一个人吃，并不省柴米。韩学愈说他有胃病的，只能吃面食，跟学生同吃米饭，学校是不是担保他生命的安全。李梅亭一口咬定这是部颁的规矩，至多星期六晚饭和星期日三餐可以除外。算学系主任问他怎样把导师向各桌分配，才算难倒了他。有导师资格的教授副教授讲师四十余人，而一百三十余男学生开不到二十桌。假使每桌一位导师，六个学生，导师不能独当一面，这一点尊严都不能维持，渐渐地会招学生轻视的。假使每桌两位导师，四个学生，那末现在八个人一桌的菜听说已经吃不够，人数减少而桌数增多，菜的量质一定更糟，是不是学校准备贴钱。大家有了数字的援助，更理直气壮了，急得李梅亭说不出话，黑眼镜取下来又戴上去，又取下来，眼睁睁望着高松年。赵辛楣这时候大发议论，认为学生吃饭也应当自由，导师制这东西应当联合傍的大学抗议。最后把原定的草案，修改了许多。议决每位导师每星期至少跟学生吃两顿饭，由训导处安排日期。因为部视学说，在牛津和剑桥，饭前饭后有教师用拉丁文祝福，高松年认为可以模仿。不过，中国不像英国，没有基督教的上帝来听下界通诉，饭前饭后没话可说。李梅亭搜索枯肠，只想出来“一粥一饭，要思来处不易”二句，大家哗然失笑。儿女成群的经济系主任自言自语道：“干脆大家像我儿子一样，念：”吃饭前，不要跑；吃饭后，不要跳——“”高松年直对他眨白眼，一壁严肃地说：“我觉得在坐下吃饭以前，由训导长领学生静默一分钟，想想国家抗战时期民生问题的艰难，我们吃饱了肚子应当怎样报效国家社会，这也是很有意义的举动。”经济系主任说：“我愿意把主席的话作为我的提议，”李梅亭附议，高松年付表决，全体通过。李梅亭心思周密，料到许多先生跟学生吃了半碗饭，就放下筷溜出饭堂，回去舒舒服服的吃，所以定下饭堂规矩：导师的饭该由同桌学生先盛学生该等候导师吃完，共同退出饭堂，不得先走。看上来全是尊师。外加吃饭时不准讲话，只许吃哑饭，真是有苦说不出。李梅亭一做训导长，立刻戒烟，见同事们抽烟如故，不足表率学生，想出来进一步的师生共同生活。他知道抽烟最利害的地方是厕所，便藉口学生人多而厕所小，住校教职员人少而厕所大，以后师生可以通用厕所。他以为这样一来彼些顾忌面子，不好随便吸烟了。结果先生不用学生厕所，而学生拥挤到先生厕所来，并且大胆吸烟解秽，因为他们知道这是比紫禁城更严密的所在，洋人所谓皇帝陛下都玉趾亲临，派不得代表的（Oulesroisnepeuventallerqu“enpersonne）。在这儿各守本位，没有人肯管闲事，能摆导师的架子。照例导师跟所导学生每星期谈一次话，有几位先生就借此请喝茶吃饭，像汪处厚韩学愈等等。起辛楣实在看不入眼，对鸿渐说这次来是上当，下学年一定不干。鸿渐添了钟点以后，倒兴致恢复了好些。他发现他所教丁组英文班上，有三个甲组学生来旁听，常常殷勤发问。鸿渐得意非凡，告诉辛楣。苦事是改造句卷子，好比洗脏衣服，一批洗干净了，下一批还是那样脏。大多数学生看一看批的分数，就把卷子扔了，自己白改得头痛。那些学生虽然外国文不好，卷子上写的外国名字很神气。有的叫亚利山大，有的叫伊利沙白，有的叫迭克，有的叫”小花朵“（Florrie），有的人叫”火腿“（Bacon），因为他中国名字叫”培根“。一个姓黄名伯仑的学生，外国名字是诗人”摆伦“（Byron），辛楣见了笑道：”假使他姓张，他准叫英国首相张伯伦（Chamberlain）；假使他姓齐，他会变成德国飞机齐伯林（Zeppelin），甚至他可以叫拿坡仑，只要中国有跟“拿”字声音相近的姓。“鸿渐说，中国人取外国名字，使他常想起英国的猪和牛，它的肉一上菜单就换了法国名称。阳历年假早过了。离大考还有一星期。一个晚上，辛楣跟鸿渐商量寒假同去桂林顽儿，谈到夜深。鸿渐看表，已经一点多钟，赶快准备睡觉。他先出宿舍到厕所去。宿舍楼上楼下都睡得静悄悄的，脚步就像践踏在这些睡人的梦上，钉铁跟的皮鞋太重，会踏碎几个脆薄的梦。门外地上全是霜。竹叶所剩无几，而冷风偶然一阵，依旧为吹几片小叶子使那么大的傻劲。虽然没有月亮，几株梧桐树的秃枝，骨鲠地清晰。只有厕所前面所挂的一盏植物油灯，光色昏浊，是清爽的冬夜上一点垢腻。厕所的气息，也像怕冷，缩在屋子里不出来，不比在夏天，老远就放著哨。鸿渐没进门，听见里面讲话。一人道：”你怎么一回事？一晚上泻了好几次！“另一人呻吟说：”今天在韩家吃坏了——“鸿渐辨声音，是一个旁听自己英文课的学生。原来问的人道：”韩学愈怎么老是请你们吃饭？是不是为了方鸿渐——“那害肚子的人报以一声”嘘“。鸿渐吓得心直跳，可是收不住脚，那两个学生也鸦雀无声。鸿渐倒做贼心虚似的，脚步都鬼鬼祟祟。回到卧室，猜疑种种，韩学愈一定在暗算自己，就不知道他怎样暗算，明天非公开拆破他的西洋镜不可。下了这个英雄的决心，鸿渐才睡著。早晨他还没醒，校役送封信来，拆看是孙小姐的，说风闻他上英文，当著学生驳刘东方讲书的错误，刘东方已有所知，请他留意。鸿渐失声叫怪，这是那里来的话，怎么不明不白又添了个冤家。忽然想起那三个旁听的学生全是历史系而上刘东方甲组英文的，无疑是他们发的问题里藏有陷阱，自己中了计。归根到底，总是韩学愈那混蛋捣的鬼，一向还以为他要结交自己，替他守秘密呢！鸿渐愈想愈恨。盘算了半天，怎么先跟刘东方解释。鸿渐到外国语言文系办公室，孙小姐在看书，见了他满眼睛的说话。鸿渐嗓子里一小处干燥，两手微颤，跟刘东方略事寒暄，就鼓足勇气说：”有一位同事在外面说——我也是人家传给我听的——刘先生很不满意我教的英文，在甲组上课的时候常对学生指摘我讲书的错误——“”什么？“刘东方跳起来，”谁说的？“孙小姐脸上的表情更是包罗万象，假装看书也忘掉了。”——我本来英文是不行的，这次教英文一半也因为刘先生的命令，讲错当然免不了，只希望刘先生当面教正。不过，这位同事听说跟刘先生有点意见，传来的话我也不甚相信。他还说，我班上那三个傍听的学生也是刘先生派来侦探的。“”啊？什么三个学生——孙小姐，你到图书室去替我借一本书，呃，呃，商务出版的“大学英文选”来，还到庶务科去领——领一百张稿纸来。“孙小姐怏怏去了，刘东方听鸿渐报了三个学生的名字，说：”鸿渐兄，你只要想这三个学生都是历史系的，我怎么差唤得动，那位散布谣言的同事是不是历史系的负责人？你把事实聚拢来就明白了。“鸿渐冒险成功，手不颤了，做出大梦初醒的样子道：”韩学愈，他——“就把韩学愈买文的事麻口袋倒米似的全说出来。刘东方又惊又喜，一连声说”哦“，听完了说：”我老实告诉你罢，舍妹在历史系办公室，常听见历史系学生对韩学愈说你上课骂我呢。“鸿渐罚誓说没有，刘东方道：”你想我会想信么？他捣这个鬼，目的不但是撵走你，还想让他太太顶你的缺。他想他已经用了我妹妹，到那时没有人代课，我好意思不请教他太太么？我用人是大公无私的，舍妹也不是他私人用的，就是她丢了饭碗，我决计尽我的力来维持老哥的地位。喂，我给你看件东西，昨天校长室发下来的。“他打开抽屉，检出一叠纸给鸿渐看。是英文丁组学生的公呈，写”呈为另换良师以重学业事“，从头到底说鸿渐没资格教英文，把他改卷子的笔误和忽略罗列在上面，证明他英文不通。鸿渐看得面红耳赤。刘东方道：”不用理它。丁组学生的程度还干不来这东西。这准是那三个旁听生的主意，保不定有韩学愈的手笔。校长批下来叫我查复，我一定替你辨白。“鸿渐感谢不已，临走，刘东方问他把韩学愈的秘密告诉傍人没有，叮嘱他别讲出去。鸿渐出门，碰见孙小姐回来，称赞他跟刘东方谈话的先声夺人，他听了欢喜，但一想她也许看见那张呈文，又羞了半天。那张呈文，牢牢地贴在他意识里，像张粘苍蝇的胶纸。刘东方果然有本领。鸿渐明天上课，那三个傍听生不来了。直到大考，太平无事。刘东方教鸿渐对坏卷子分数批得宽，对好卷子分数批得紧，因为不及格的人多了，引起学生的恶感，而好分数的人太多了，也会减低先生的威望。总而言之，批分数该雪中送炭，万万不能悭吝——用刘东方的话说：”一分钱也买不了东西，别说一分分数！“——切不可锦上添花，让学生把分数看得太贱，功课看得太容易——用刘东方的话说：”给教化子至少要一块钱，一块钱就是一百分，可是给学生一百分，那不可以。“考完那一天，汪处厚碰到鸿渐，说汪太太想见他跟辛楣，问他们俩寒假里那一天有空，要请吃饭。他听说他们俩寒假上桂林，摸著胡子笑道：”去干么呀？内人打算替你们两位做媒呢。“
　　第七章胡子常是两撇，汪处厚的胡子只是一画。他二十年前早留胡子，那时候做官的人上唇全毛茸茸的，非此不足以表身分，好比西洋古代哲学家下颔必有长髯，以示智慧。他在本省督军署当秘书，那位大帅留的菱角胡子，就像仁丹广告上移植过来的，好不威武。他不敢培植同样的胡子，怕大帅怪他僭妄；大帅的是乌菱圆角胡子，他只想有规模较小的红菱尖角胡子。谁知道没有枪杆的人，胡子也不像样，又稀又软，挂在口角两旁，像新式标点里的逗号，既不能翘然而起，也不够飘然而袅。他两道浓黑的眉毛，偏根根可以跟寿星的眉毛竟赛，仿佛他最初刮脸时不小心，把眉毛和胡子一股脑儿全剃下来了，慌忙安上去，胡子跟眉毛换了位置；嘴上的是眉毛，根本不会长，额上的是胡子，所以欣欣向荣。这种胡子，不留也罢。五年前他和这位太太结婚，刚是剃胡子的好借口。然而好像一切官僚、强盗、赌棍、投机商人，他相信命。星相家都说他是“木”命“木”形，头发和胡子有如树木的枝叶，缺乏它们就表示树木枯了。四十开外的人，头发当然半秃，全靠这几根胡子表示老树着花，生机未尽。但是为了二十五岁的新夫人，也不能一毛不拔，于是剃去两缕，剩中间一撮，又因为这一撮不够浓，修削成电影明星式的一线。这件事难保不坏了脸上的风水，不如意事连一接二地来。新太太进了门就害病，汪处厚自己给人弹劾，官做不成，亏得做官的人栽筋斗，宛如猫从高处掉下来，总能四脚着地，不致太浪狈。他本来就不靠薪水，他这样解譬着。而且他是老派名士，还有前清的习气，做官的进候非常风雅，退了位可以谈谈学问；太太病也老是这样，并不加重。这也许还是那一线胡子的功效，运气没坏到底。
　　假使留下的这几根胡子以够挽留一部分的运气，胡子没剃的时候，汪处厚的好运气更不用说。譬如他那位原配的糟糠之妻，凑趣地死了，让他娶美丽的续弦夫人。结婚二十多年，生的一个儿子都在大学毕业，这老婆早死了。死掉老婆还是最经济的事，虽然丧葬要一笔费用，可是离婚不要赡养费么？重婚不要两处开销么？好多人有该死的太太，就不像汪处厚有及时悼亡的运气。并且悼亡至少会有人送礼，离婚和重婚连这点点礼金都没有收入的，还要出诉讼费。何况汪处厚虽然做官，骨子里只是个文人，文人最喜欢有人死，可以有题目做哀悼的文章。棺材店和殡仪馆只做新死人的生意，文人会向一年、几年、几十年、甚至几百年的陈死人身上生发。“周年逝世纪念”和“三百年祭”，一样的好题目。死掉太太——或者死掉丈夫，因为有女作家——这题目尤其好；旁人尽管有文才，太太或丈夫只是你的，这是注册专利的题目。汪处厚在新丧里做“亡妻事略”和“悼亡”诗的时候，早想到古人的好句；“眼前新妇新儿女，已是人生第二回，”只恨一时用不上，希望续弦生了孩子，再来一首“先室人忌辰泫然有作”的诗，反这两句改头换面嵌过去。这首诗至现在还没有做。第二位汪太太过了门没生孩子，只生病。在家养病反把这病养家了，不肯离开她，所以她终年娇弱得很，愈使她的半老丈夫由怜而怕。她曾在大学读过一年，因贫血症退学休养，家里一住四五年，每逢头不晕不痛、身子不哼哼唧唧的日子，跟老师学学中国画，弹弹钢琴消遣。中国画和钢琴是她嫁妆里代表文化的部分，好比其它女人的大学毕业文凭（配乌油木镜框）和学士帽照相（十六寸彩色配金漆乌油木镜框）。汪处厚不会懂西洋音乐，当然以为太太的钢琴弹得好；他应该懂得一点中国画，可是太太的画，丈夫觉得总不会坏。他老对客人说：“她这样喜欢弄音乐、画画，都是费心思的东西，她身体怎么会好！”汪太太就对客人谦虚说：“我身体不好，不能常常弄这些东西，所以画也画不好，琴也弹不好。”自从搬到这小村里，汪太太寂寞得常跟丈夫吵。她身分娇贵，瞧不起丈夫同事们的老婆，嫌她们寒窘。她丈夫不放心单身男同事常上自已家来，嫌他们年轻。高松年知道她在家里无聊，愿意请她到学校做事。汪太太是聪明人，一口拒绝。一来她自知资格不好，至多做个小职员，有伤体面。二来她知道这是男人的世界，女权那样发达的国家像英美，还只请男人去当上帝，只说He，不说She.女人出来做事，无论地位怎么高，还是给男人利用，只有不出面躲在幕后，可以用太太或情妇的资格来指使和摆布男人。女生指导兼教育系讲师的范小姐是她的仰慕者，彼此颇有往来。刘东方的妹妹是汪处厚的拜门学生，也不时到师母家来谈谈。刘东方有一次托汪太太为妹妹做媒。做媒和做母亲是女人的两个基本欲望，汪太太本来闲得发闷，受了委托，仿佛失业的人找到职业。汪处厚想做媒是没有危险的，决不至于媒人本身也做给人去。汪太太早有计划，要把范小姐做给赵辛楣，刘小姐做给方鸿渐。范小姐比刘小姐老，比刘小姐难看，不过她是讲师，对象该是地位较高的系主任。刘小姐是个助教，嫁个副教授已经够好了。至于孙小姐呢，她没拜访过汪太太；汪太太去看范小姐的时候，会过一两次，印象并不太好。
　　鸿渐俩从桂林回来了两天，就收到汪处厚的帖子。两人跟汪处厚平素不往来，也没见过汪太太，看了帖子，想起做媒的话。鸿渐道：“汪老头儿是大架子，只有高松年和三位院长够资格上他家去吃饭，当然还有中国文学系的人。你也许配得上，拉我进去干吗？要说是做媒，这儿没有什么女人呀，这老头子真是！”辛楣道：“去瞻仰瞻仰汪太太也无所谓。也许老汪有侄女、外甥女或者内姨之类——汪太太听说很美——要做给你。老汪对你说，没有对我说，指的是你一个人。你不好意思，假造圣旨，拉我来陪你，还说替咱们俩做媒呢！我是不要人做媒的。”嚷了一回，议决先拜访汪氏夫妇，问个明白，免得开玩笑当真。
　　汪家租的黑砖半西式平屋是校舍以外本地最好的建筑，跟校舍隔一条溪。冬天的溪水涸尽，溪底堆满石子，仿佛这溪新生的大大小小的一窝卵。水涸的时候，大家都不走木板桥而踏着石子过溪，这表示只要没有危险，人人愿意规外行动。汪家的客堂很显敞，砖地上铺了席，红木做的老式桌椅，大方结实，是汪处厚向镇上一个军官家里买的，万一离校别有高就，可以卖给学校。汪处厚先出来，满面春风，问两人觉得客堂里冷不冷，分付丫头去搬火盆。两人同声赞美他住的房子好，布置得更精致，在他们这半年来所看见的房子里，首屈一指。汪先生得意地长叹道，“这算得什么呢！我有点东西，这一次全丢了。两位没看见我南京的房子——房子总算没给日本人烧掉，里面的收藏陈设都不知下落了。幸亏我是个达观的人，否则真要伤心死呢。”这类的话，他们近来不但听熟，并且自已也说惯了。这次兵灾当然使许多有钱、有房子的人流落做穷光蛋，同时也让不知多少穷光蛋有机会追溯自己为过去的富翁。日本人烧了许多空中楼阁的房子，占领了许多乌托邦的产业，破坏了许多单相思的姻缘。譬如陆子潇就常常流露出来，战前有两三个女人抢着嫁他，“现在当然谈不到了！”李梅亭在上海闸北，忽然补筑一所洋房，如今呢？可惜得很！该死的日本人放火烧了，损失简直没法估计。方鸿渐也把沦陷的故乡里那所老宅放大了好几倍，妙在房子扩充而并不会侵略邻舍的地。赵辛楣住在租界里，不能变房子的戏法，自信一表人才，不必惆怅从前有多少女人看中他，只说假如战争不发生，交涉使公署不撤退，他的官还可以做下去——不，做上去。汪处厚在战前的排声也许不像他所讲的阔绰，可是同事们相信他的吹牛，因为他现在的起居服食的确比旁人舒服，而且大家都知道他是革职的贪官——“政府难得这样不包庇，不过他早捞饱了！”他指着壁上持的当代名人字画道：“这许多是我逃难出来以后，朋友送的。我灰了心了，不再收买古董了，内地也收买不到什么——那两幅是内人画的。”两人忙站起来细看那两条山水小直幅。方鸿渐表示不知道汪太太会画，出于意外；赵辛楣表示久闻汪太太善画，名下无虚。这两种表示相反相成，汪先生高兴得摸着胡子说：“我内人的身体可惜不好，她对于画和音乐——”没说完，汪太太出来了。骨肉停匀，并不算瘦，就是脸上没有血色，也没擦胭脂，只傅了粉。嘴唇却涂泽鲜红，旗袍是浅紫色，显得那张脸残酷地白。长睫毛，眼梢斜撇向上。头发没烫，梳了髻，想来是嫌本地理发店电烫不到家的缘故。手里抱着皮热水袋，十指甲全是红的，当然绝非画画时染上的颜色，因为她画的青山绿水。
　　汪太太说她好久想请两位过来玩儿，自己身体不争气，耽误到现在。两人忙问她身体好了没有，又说一向没敢来拜访，赏饭免了罢。汪太太说她春夏两季比秋冬健朗些，晚饭一定要来吃的。汪先生笑道：“我这顿饭不是白请的，媒人做成了要收谢仪，吃你们两位的谢媒洒也得十八加十八——三十六桌呢！”鸿渐道：“这怎么请得起！谢大媒先没有钱，别说结婚了。”辛楣道：“这个年头儿，谁有闲钱结婚？我照顾自己都照顾不来！汪先生，汪太太，吃饭和做媒，两件事全心领谢谢，好不好？”汪先生道：“世界变了！怎么年轻人一点热情都没有？一点——呃——”浪漫“都没有？婚不肯结，还要装穷！好，我们不要谢仪，替两位白当差，娴，是不是？”汪太太道：“啊呀！你们两位一吹一唱。方先生呢，我不大知道，不过你们留学的人，随身本领就是用不完的财产。赵先生的家世、前途，我们全有数目，只怕人家小姐攀不上——瞧我这媒婆劲儿足不足？”大家和着她笑了。
　　辛楣道：“有人看得中我，我早结婚了。”汪太太道：“只怕是你的眼睛高，挑来挑去，没有一个中意的。你们新回国的单身留学生，像新出炉的烧饼，有小姐的人家抢都抢不匀呢。吓！我看见得多了，愈是有钱的年轻人愈不肯结婚。他们能够独立，不在乎太太的陪嫁、丈人的靠山，宁可交女朋友，花天酒地的胡闹，反正他们有钱。要讲没有钱结婚，娶个太太比滥交女朋友经济得多呢。你们的借口，理由不充分。”两人听得骇然，正要回答，汪处厚假装出正颜厉色道：“我有句声明。我娶你并不是为了经济省钱，我年轻的时候，是有句的规矩人，从来不胡闹，你这话人家误会了可了不得！”说时，对鸿渐和辛楣顽皮地眨眼。
　　汪太太轻藐地哼一声：“你年轻的时候？我——我就不相信你年轻过。”汪处厚脸色一红。鸿渐忙说，汪氏夫妇这样美意，不敢鼓辜负，不过愿意知道介绍的是什么人。汪太太拍手道：“好了，好了！方先生愿意了。这两位小姐是谁，天机还不可泄漏。处厚，不要说出来！”汪先生蒙太太这样密切地嘱咐，又舒适了，说：“你们明天来了，自然会知道。别看得太严重，借此大家叙叙。假如两位毫无意思，同吃顿饭有会么关系，对方总不会把这个作为把柄，上公堂起诉，哈哈！我倒有句忠言奉劝。这战争看来不是一年两年的事，要好好拖下去呢。等和平了再结婚，两位自己的青春都嗟跎了。”莫遣佳期更后期“，这话很有道理。两位结了婚，公私全有好处。我们这学校大有前途，可是一时请人不容易，像两位这样的人才——娴，我不是常和你讲他们两位的？——肯来屈就，学校决不放你们走。在这儿结婚成家，就安定下来，走不了，学校借光不少。我兄弟呢——这话别说出去——下学期也许负责文学院。教育系要从文学院分出去变成师范学院，现在教育系主任孔先生当然不能当文学院长了。兄弟为个人打算，也愿意千方百计扣信你们。并且家眷也在学校做事，夫妇两个人有两个人的收入，生活负担并不增加——”汪太太截断他话道：“寒碜死了！真是你方才所说”一点浪漫都没有“，一五一十打什么算盘！”汪先生道：“瞧你那样性急！”浪漫“马上就来。结婚是人生最美满快乐的事，我和我内人都是个中人，假使结婚不快乐，我们应该苦劝两位别结婚，还肯做媒么？我和她——”汪太太皱眉摇手道：“别说了，肉麻！”她记起去年在成都逛寺院，碰见个和尚讲轮回，丈夫偷偷对自己说：“我死了，赶快就投人身，来得及第二次娶你，”忽然心上一阵厌恨。鸿渐和辛楣尽义务地恭维说，像他们这对夫妇是千中拣一的。
　　在回校的路上，两人把汪太太讨论个仔细。都觉得她是个人物。但是为什么嫁个比她长二十岁的丈夫？两人武断她娘家穷，企羡汪处厚是个地方官。她的画也过得去不过上面题的字像老汪写的。鸿渐假充内行道：“写字不能描的，不比画画可以涂改。许多女人会描几笔写意山水，可是写字要她们的命。汪太太的字怕要出丑。”鸿渐到自己卧室门口，正掏钥匙开锁。辛楣忽然吞吞吐吐说：“你注意到么——汪太太的神情里有一点点像——像苏文纨，”未说完，三脚两步上楼去了。鸿渐惊异地目送着他。
　　客人去后，汪先生跟太太回卧室，问：“我今天总没有说错话罢？”这是照例的问句，每次应酬之后，爱挑眼的汪太太总要矫正丈夫的。汪太太道：“没有罢，我也没心思来记——可是文学院长的事，你何必千诉他们！你老喜欢吹在前面。”汪处厚这时候确有些后悔，可是嘴硬道：“那无所谓的，让他们知道他们的饭碗一半在我手里。你今天为什么扫我的面子——”汪处厚想起了，气直冒上来——“就是年轻不年轻那些话，”他加这句解释，因为太太的表情是诧异。汪太太正对着梳妆台的圆镜子，批判地审视自己的容貌，说：“哦，原来如此。你瞧瞧镜子里你的脸，人都吃得下似的，多可怕！我不要看见你！”汪太太并不推开丫在身后的丈夫，只从粉盒子里取出绒粉拍，在镜子里汪先生铁青的脸上，扑扑两下，使他面目模糊。
　　刘东方这几天上了心事。父亲母亲都死了，妹妹的终身是哥哥的责任。去年在昆明，有人好意替她介绍，不过毫无结果。当然家里有了她，刘太太多个帮手，譬如两个孩子身上的绒线衣服全是她结的，大女儿还跟着她睡。可是这样一年一年蹉跎下去，哥哥嫂嫂深怕她嫁不掉，一辈子的累赘。她前年逃难到内地，该进大学四年级，四年级生不许转学，嫂嫂又要生孩子，一时雇不到用人，家里乱得很，哥哥没心思替她想办法。一耽误下来，她大家没毕业。为了这事，刘东方心里很抱歉，只好解嘲说，大家毕业的女人不知多少，有几个真能够自立谋生的。刘太太怪丈夫当初为什么教妹妹进女子大学，假如进了男女同学的学校，婚事早解决了。刘东方逼得急了，说：“范小姐是男女同学的学校毕业的，为什么也没有嫁掉？”刘太太说：“你又来了，她比范小姐总好得多——”肯这样说姑娘的，还不失为好嫂嫂。刘东方叹气道：“这也许命里注定的。我母亲常说，妹妹生下来的时候，脸朝下，背朝上，是要死在娘家的。妹妹小的时候，我们常跟她开玩笑。现在看来，她真要做老处女了。”刘太太忙说：“做老处女怎么可以？真是年纪大了，嫁给人做填房也好，像汪太太那样不是很好么？”言下大有以人力挽回天命之意。去年刘东方替方鸿渐排难解纷，忽然想这个人做妹夫倒不坏：他是自己保全的人，应当感恩识抬举，跟自己结这一门亲事，他的地位也可以巩固了；这样好机会要错过，除非这人是个标准傻瓜。刘太太也称赞丈夫心思敏捷，只担心方鸿渐本领太糟，要大舅子替他捧牢饭碗。后来她听丈夫说这人还伶俐，他便放了心，早计划将来结婚以后，新夫妇就住在自己的房子里，反正有一间空着，可是得正式立张租契，否则门户不分，方家养了孩子要把刘家孩子的运气和聪明抢掉的。到汪太太答应做媒，夫妇俩欢喜得向刘小姐流露消息，满以为她会羞怯地高兴。谁知道她只飞红了脸，一言不发。刘太太嘴快，说：“这个姓方的你见过没有？你哥哥说比昆明——”她丈夫急得在饭桌下狠命踢她的腿。刘小姐说话了，说得非常之多。先说：她不原意嫁，谁教汪太太做媒的？再说：女人就那么贱！什么“做媒”、“介绍”，多好听！还不是市场卖鸡卖鸭似的，打扮了让男人去挑？不中他们的意，一顿饭之后，下文都没有，真丢人！还说：她也没有白吃了哥嫂的，她在家里做的事，抵得一个用人，为什么要撵她出去？愈说愈气，连大家没毕业的事都牵出来了。事后，刘先生怪太太不该提起昆明做媒的事，触动她一肚子的怨气。刘太太气冲冲道：“你们刘家人的死脾气！谁娶了她，也是倒霉！”明天一早，跟刘小姐同睡的大女孩子来报告父母，说姑母哭了半个晚上。那天刘小姐没吃早饭和午饭，一个人在屋后的河边走来走去。刘氏夫妇吓坏了，以为她临清流而萌短见，即使不致送命，闹得全校知道，总不大好，忙差大女孩子跟着她。幸亏她晚饭回来吃的，并且吃了两碗。这事从此不提起。汪家帖子来了，她接着不作声。哥嫂俩也不敢探她口气；私下商量，到吃饭的那天早晨，还不见动静，就去求汪太太来劝驾。那天早晨，刘小姐叫老妈子准备炭熨斗，说要熨衣服。哥嫂俩相视偷笑。
　　范小姐发现心里有秘密，跟喉咙里有咳嗽一样的痒得难熬。要人知道自己有个秘密，而不让人知道是个什么秘密，等他们问，要他们猜，这是人性的虚荣。范小姐就缺少这样一个切切私语的盘问者。她跟孙小姐是同房，照例不会要好，她好好地一个人住一间大屋子，平空给孙小姐分去一半。假如孙小姐漂亮阔绰，也许可以原谅，偏偏又只是那么平常的女孩子。倒算上海的来的，除掉旗袍短一些，就看不出有什么地方比自己时髦。所以两人虽然常常同上街买东西，并不推心置腹。自从汪太太说要为她跟赵辛楣介绍，她对孙小姐更起了戒心，因为孙小姐常说到教授宿舍看辛楣去的。当然孙小姐千诉过，一向叫辛楣“赵叔叔”，可是现在的女孩子很容易忘掉尊卑之分。汪家来的帖子，她讳莫如深。她平时有个嗜好，爱看话剧，尤其是悲剧。这儿的地方戏院不演话剧，她就把现代本国剧作家的名剧尽量买来细读。对话里的句子像：“咱们要勇敢！勇敢！勇敢！”“活要活得痛快，死要死得干脆！”“黑夜已经这么深了，光明还会遥远么？”她全在旁边打了红铅笔的重杠，默诵或朗诵着，好像人生之迹有了解答。只在不快活的时候，譬如好月亮引起了身世之感，或者执行“女生指导”的职责，而女生不受指导，反叽咕：“大不了也是个大家毕业生，赁什么资格来指指导我们？只好管老妈子，发厕所里的手纸！”——在这种时候，她才发现这些富于哲理的警句没有什么邦助。活诚然不痛快，死可也不容易；黑夜似乎够深了，光明依然看不见。悲剧里的恋爱大多数是崇高的浪漫，她也觉得结婚以前，非有伟大的心灵波折不可。就有一件事。她决不下。她听说女人恋爱经验愈多，对男人的魔力愈大；又听说男人只肯娶一颗心还是童贞纯洁的女人。假如赵辛楣求爱，自己二者之间，何去何从呢？请客前一天，她福至心灵，想出一个两面兼顾的态度，表示有好多人发狂地爱过自己，但是自己并未爱过谁，所以这一次还是初恋。恰好那天她上街买东西，店里的女掌柜问她：“小姐，是不是在学堂里念书？”这一问减轻了她心理上的年龄负担六七岁，她高兴得走路像脚心装置了弹簧。回校把这话告诉孙小姐，孙小姐说：“我也会这样问，您本来就像个学生。”范小姐骂她不老实。
　　范小姐眼睛稍微近视。她不知道美国人的名言——Mannevermakepasses Atgirlswearingglasses——可是她不戴眼镜。在学生时代，上课抄黑板，非戴眼镜不可；因为她所认识的男同学，都够不上借笔记转抄的交情。有男生帮忙的女同学，决不轻易把这种同心协力、增订校补的真本或足本笔记借人；至于都些没有男生效劳的女同学，哼！范小姐虽然自己也是个女人，对于同性者的记录本领，估计并不过高。像一切好学而又爱美的女人，她戴白金脚无边眼镜；无边眼镜仿佛不着边际，多少和脸蛋儿融化为一，戴了可算没戴，不比有边眼镜，界域分明，一戴上就从此挂了女学究的招牌。这副眼镜，她现在只有看戏的时候必须用到。此外像今天要赴盛会；不但梳头化妆需要它，可以观察周密；到打扮完了，换上衣服，在半身着衣镜前远眺自己的“概观”，更需要它。她自嫌眼睛没有神，这是昨夜兴奋太过没睡好的缘故。汪太太有涂眼睫毛的油膏，不妨早去借用，衬托出眼里一种烟水迷茫的幽梦表情。周身的服装也可请她批评，及早修正——范小姐是“女生指导”，她把汪太太奉为“女生指导”的指导的。她五点钟才过就到汪家，说早些来可以帮忙。汪先生说今天客人不多，菜是向镇上第一家馆子叫的，无需帮忙，又叹惜家里的好厨子逃难死了，现在的用人烧的菜不能请客。汪太太说：“你相信她！她不是帮忙来的，她今天来显显本领，让赵辛楣知道她不但学问好、相貌好，还会管家呢。”范小姐禁止她胡说，低声请她批判自己。汪太太还嫌她擦得不够红，说应当添点喜色，就跟美洲印第安人上战场擦的颜色同样胜利地红。她又问汪太太借睫毛油膏，还声明自己不是痧眼，断无传染的危险。汪处厚在外面只听得笑声不绝；真是“有鸡鸭的地方，粪多；有年轻女人的地方，笑多。”刘小姐最后一个到。坦白可亲的脸，身体很丰满，衣服颇紧，一动衣服上就起波纹。辛楣和鸿渐看见介绍的是这两位，失望得要笑。彼此都曾见面，只没有讲过话。范小姐像画了个无形的圈子，把自己跟辛楣围在里面，谈话密切得泼水不入。辛楣先说这儿闷得很，没有玩儿的地方。范小姐说：“可不是么？我也觉得很少谈得来的人，待在这儿真闷！”辛楣问她怎样消遣，她说爱看话剧，问辛楣爱看不爱看。辛楣说：“我很喜欢话剧，可惜我没有看过——呃——多少。”范小姐问曹禺如何。辛楣瞎猜道：“我认为他是最——呃——最伟大的戏剧家。”范小姐快乐地拍手掌道：“赵先生，我真高兴，你的意见跟我完全相同。你觉得他什么一个戏最好？”辛楣没料到毕业考试以后，会有这一次的考试。十几年小考大考训练成一套虚虚实实、模棱两可的回答本领，现在全荒疏了，冒失地说：“他是不是写过一本——呃——”这不过是“——”范小姐的惊骇表情阴止他说出来是“春天”、“夏天”、“秋天”还是“冬天”。惊骇像牙医生用的口撑，教她张着嘴，好一会上下腭合不拢来。假使丈夫这样愚昧无知，岂不活活气死人！幸亏离结婚还远，有时间来教导他。她在天然的惊骇表情里，立刻放些艺术。辛楣承认无知胡说，她向他讲解说“李健吾”并非曹禺用的化名，真有其人，更说辛楣要看剧本，她那儿有。辛楣忙谢她。她忽然笑说：“我的剧本不能借给你，你要看，我另外想方法弄来给你看。”辛楣问不能借的理由。范小姐说她的剧本有好几种是作者送的，辛楣担保不会损坏或遗失这种名贵东西。范小姐娇痴地说：“那倒不是。他们那些剧作家无聊得很，在送给我的书上胡写了些东西，不能给你看——当然，给你看也没有关系。”这么一来，辛楣有责任说非看不可了。
　　刘小姐不多说话，鸿渐今天专为吃饭而来，也只泛泛应酬几句。倒是汪太太谈锋甚健，向刘小姐问长问短。汪处厚到里面去了一会，出来对太太说：“我巡查过了。”鸿渐问他查些什么。汪先生笑说：“讲起来真笑话。我用两个女用人。这个丫头，我一来就用，有半年多了。此外一个老妈子，换了好几次，始终不满意。最初用的一个天天要请假回家过夜，晚饭吃完，就找不见她影子，饭碗都堆着不洗。我想这怎么成，换了一个，很安静，来了十几天，没回过家。我和我内人正高兴，哈，一天晚上，半夜三更，大门都给人家打下来了。这女人原来有个姘头，常常溜到我这儿来幽会，所以她不回去。她丈夫得了风声，就来捉奸，真气得我要死。最后换了现在这一个，人还伶俐，教会她做几样粗菜，也过得去。有时她做的菜似乎量太少，我想，也许她买菜扣了钱。人全贪小利的：”不痴不聋，不作阿家翁，“就算了罢。常换用人，也麻烦！和内人训她几句完事。有一次，高校长的朋友远道带给他三十只禾花雀，校长托我替他烧了，他来吃晚饭——你知道，校长喜欢到舍间来吃晚饭的。我内人说禾花雀炸了吃没有味道，照她家乡的办法，把肉末填在禾花雀肚子里，然后红烧。那天晚饭没有几个人，高校长，我们夫妇俩，还有数学系的王先生——这个人很有意思。高先生王先生都说禾花雀这样烧法最好。吃完了，王先生忽然问禾花雀是不是一共三十只，我们以为他没有吃够，他说不是，据他计算，大家只吃了二十——娴，二十几？——二十五只，应该剩五只。我说难道我打过偏手，高校长也说岂有此理。我内人到厨房去细问，果然看见半碗汁，四只——不是五只——禾花雀！你知道老妈子怎么说？她说她留下来给我明天早晨下面吃的。我们又气又笑。这四只多余的禾花雀谁都不肯吃——”“可惜！为什么不送给我吃！”辛楣像要窒息的人，突然冲出了煤气的笼罩，吸口新鲜空气，横插进这句话。
　　汪太太笑道：“谁教你那时候不来呀？结果下了面给高校长的。”鸿渐道：“这样说来，你们这一位女用人是个愚忠，虽然做事欠斟酌，心倒很好。”汪先生抚髭仰面大笑，汪太太道：“”愚忠“？她才不愚不忠呢！我们一开头也上了她的当。最近一次，上来的鸡汤淡得像白开水，我跟汪先生说：”这不是煮过鸡的汤，只像鸡在里面洗过一次澡。“他听错了，以为我说”鸡在这水里洗过脚“，还跟我开玩笑说什么”饶你奸似鬼，喝了洗脚水“——”大家都笑，汪先生欣然领略自己的妙语——“我叫她来问，她直赖。后来我把这丫头带哄带吓，算弄清楚了。这老妈子有个儿子，每逢我这儿请客，她就叫他来，挑好的给他躲在米间里吃。我问这丫头为什么不早告诉我，是不是偷嘴她也有分。她不肯说，到临了才漏出来这老妈子要她做媳妇，允许把儿子配给她。你们想妙不妙？所以每次请客，我们先满屋子巡查一下。我看这两个全用不下去了，有机会要换掉她们。”客人同时开口，辛楣鸿渐说：“用人真成问题。”范小姐说：“我听了怕死人了，亏得我是一个人，不要用人。”刘小姐说：“我们家里的老妈子，也常常作怪。”汪太太笑对范小姐说：“你快要不是一个人了——刘小姐，你哥哥嫂嫂真亏了你。”用人上了菜，大家抢坐。主人说，圆桌子坐位不分上下，可是乱不得。又劝大家多吃菜，因为没有几个菜。客人当然说，菜太丰了，就只几个人，怕吃不下许多。汪先生说：“咦，今天倒忘了把范小姐同房的孙小姐找来，她从没来过。”范小姐斜眼望身旁的辛楣。鸿渐听人说起孙小姐，心直跳，脸上发热，自觉可笑，孙小姐跟自己有什么关系。汪太太道：“最初赵先生带了这么一位小姐来，我们都猜是赵先生的情人呢，后来才知道不相干。”辛楣对鸿渐笑道：“你瞧谣言多可怕！”范小姐道：“孙小姐现在有情人了——这可不是谣言，我跟她同房，知道得很清楚。”辛楣问谁，鸿渐满以为要说到自己，强作安详。范小姐道：“我不能漏泄她的秘密。”鸿渐慌得拚命吃菜，不让脸部肌肉平定下来有正确的表情。辛楣掠了鸿渐一眼，微笑说：“也许我知道是谁，不用你说。”鸿渐含着一口菜，险的说出来：“别胡闹。”范小姐误会辛楣的微笑，心安虑得地说：“你也知道了？消息好灵通！陆子潇追求她还是这次寒假里的事呢，天天通信，要好得很。你们那时候在桂林，怎么会知道？”鸿渐情感像个漩涡。自己没牵到，可以放心。但听说孙小姐和旁人好，又剌心难受。自己并未爱上孙小姐，何以不愿她跟陆子潇要好？孙小姐有她的可爱，不过她妩媚得不稳固，妩媚得勉强，不是真实的美丽。脾气当然讨人喜欢——这全是辛楣不好，开玩笑开得自己心里种了根。像陆子潇那样人，她决不会看中的。可是范小姐说他们天天通信，也决不会凭空撒谎。忽然减了兴致。
　　汪氏夫妇和刘小姐听了都惊奇。辛楣采取大政治家听取情报的态度，仿佛早有所知似的，沉着脸回答：“我有我的报道。陆子潇曾经请方先生替他介绍孙小姐，我不赞成。子潇年纪太大——”汪太太道：“你少管闲事罢。你又不是她真的”叔叔“，就是真”叔叔“又怎么样——早知如此，咱们今天倒没有请他们那一对也来。不过子潇有点小鬼样子，我不大喜欢。”汪先生摇头道：“那不行。历史系的人，少来往为妙。子潇是历史系的台柱教授，当然不算小鬼。可是他比小鬼都坏，他是个小人，哈哈！他这个人爱搬嘴。韩学愈多心得很，你请他手下人吃饭而不请他，他就疑心你有阴谋要勾结人。学校里已经什么”粤派“，”少壮派“，”留日派“闹得乌烟瘴气了。赵先生，方先生，你们两位在我这儿吃饭，不怕人家说你们是”汪派“么？刘小姐的哥哥已经有人说他是”汪派“了。”辛楣道：“我知道同事里有好几个小组织，常常聚餐，我跟鸿渐一个都不参加，随他们编派我们什么。”汪先生道：“你们是高校长嫡系里的”从龙派“——高先生的亲戚或者门生故交。方先生当然跟高先生原来不认识，可是因为赵先生间接的关系，算”从龙派“的外围或者龙身上的晴蜓，呵呵！方先生，我和你开玩笑——我知道这全是捕风捉影，否则我决不敢请二位到舍间来玩儿了。”范小姐对学校派别毫无兴趣，只觉得对孙小姐还有攻击的义务：“学校里闹党派，真没有意思。孙小姐人是顶好的，就是太邋遢，满房间都是她的东西——呃，赵先生，对不住，我忘掉她是你的”侄女儿“，”羞缩无以自容地笑。
　　辛楣道：“那有什么关系。可是，鸿渐，咱们同路来并不觉得她邋遢。”鸿渐因为人家说他是“从龙派”外围，又惊又气，给辛楣一问，随口说声“是”。汪太太道：“听说方先生很能说话，为什么今天不讲话。”方鸿渐忙说，菜太好了，吃菜连舌头都吃下去了。
　　吃到一半，又谈起没法消遣。汪太太说，她有一副牌，可是家跟学校住得近——汪先生没让她说完，插嘴说：“内人神经衰弱，打牌的声音太闹，所以不打——这时候打门，有谁会来？”“哈，汪太太，请客为什么不请我？汪先生，我是闻着香味寻来的，”高松年一路说着话进来。
　　大家肃然起立，出位恭接，只有汪太太懒洋洋扶着椅背，半起半坐道：“吃过晚饭没有？还来吃一点，”一壁叫用人添椅子碗筷。辛楣忙把自己坐的首位让出来，和范小姐不再连席。高校长虚让一下，泰然坐下，正拿起筷，眼睛绕桌一转，嚷道：“这位子不成！你们这坐位有意思的，我真糊涂！怎么把你们俩拆开了；辛楣，你来坐。”辛楣不肯。高校长让范小姐，范小姐只是笑，身子像一条饧糖粘在椅子里。校长没法，说：“好，好！天下大势，合久必分，分久必合，”呵呵大笑，又恭维范小姐漂亮，喝了一口酒，刮得光滑的黄脸发亮像擦过油的黄皮鞋。
　　鸿渐为了副教授的事，心里对高松年老不痛快，因此接触极少，没想到他这样的和易近人。高松年研究生物学，知道“适者生存”是天经地义。他自负最能适应环境，对什么人，在什么场合，说什么话。旧小说里提起“二十万禁军教头”，总说他“十八般武艺，件件都精”；高松年身为校长，对学校里三院十系的学问，样样都通——这个“通”就像“火车畅通”，“肠胃通顺”的“通”，几句门面话从耳朵里进去直通到嘴里出来，一点不在脑子里停留。今天政治学会开成立会，恭请演讲，他会畅论国际关系，把法西斯主义跟共产主义比较，归根结底是中国现行的政制最好。明天文学研究会举行联欢会，他训话里除掉说诗歌是“民族的灵魂”，文学是“心理建设的工具”以外，还要勉励在坐诸位做“印度的泰戈尔，英国的莎士比亚，法国的——呃——法国的——罗索（声音又像”噜口苏“，意思是卢梭），德国的歌德，美国的——美国的文学家太多了。”后天物理学会迎新会上，他那时候没有原子弹可讲，只可以呼唤几声相对论，害得隔了大海洋的爱因斯坦右耳朵发烧，连打喷嚏。此外他还会跟军事教官闲谈，说一两个“他妈的”！那教官惊喜得刮目相看，引为同道。今天是几个熟人吃便饭，并且有女人，他当然谑浪笑傲，另有适应。汪太太说：“我们正在怪你，为什么办学校挑这个鬼地方，人都闷得死的。”“闷死了我可偿不起命哪！偿旁人的命，我勉强可以。汪太太的命，宝贵得很，我偿不起。汪先生，是不是？”上司如此幽默，大家奉公尽职，敬笑两声或一声不等。
　　赵辛楣道：“有无线电听听就好了。”范小姐也说她喜欢听无线电。
　　汪处厚道：“地方僻陋也有好处。大家没法消遣，只能彼此来往，关系就亲密了。朋友是这样结交起来的，也许从朋友而更进一层——赵先生，方先生，两位小姐，唔？”高校长用唱党歌、校歌、带头喊口的声音叫“好”！敬大家一杯。
　　鸿渐道：“刚才汪太太说打牌消——”校长斩截地说：“谁打牌？”汪太太道：“我们那副牌不是王先生借去天天打么？”不管高松年警告的眼色。
　　鸿渐道：“反正辛楣和我对麻将牌不感兴趣。想买副纸牌来打bridge，找遍了镇上没有，结果买了一副象棋。辛楣输了就把棋子拍桌子，木头做的棋子经不起他的气力，迸碎了好几个，这两天棋都下不成了。”范小姐隔着高校长身辛楣笑，说想不到他这样孩子气。刘小姐请辛楣讲鸿渐输了棋的情状。高校长道：“下象棋很好。纸牌幸亏没买到，总是一种赌具，虽然没有声音，给学生知道了不大好。李梅亭禁止学生玩纸牌，照师生共同生活的原则——”鸿渐想高松年像个人不到几分钟，怎么又变成校长面目了，恨不能说：“把王家的麻将公开，请学生也去赌，这就是共同生活了。”汪太太不耐烦地打断高校长道：“我听了”共同生活“这四个字就头痛。都是李梅亭的花样，反正他自己家不在这儿，苦的是有家的人。我本来的确因为怕闹，所以不打牌。现在偏要打。校长你要办我就办得了，轮不到李梅亭来管。”高校长看汪太太请自己办她，大有恃宠撒娇之意，心颤身热，说：“哪里的话！不过办学校有办学校的困难——你只要问汪先生——同事之间应当相忍相安。”汪太太冷笑道：“我又不是李梅亭同事。校长，你什么时候雇我到贵校当——当老妈子来了？当教员是没有资格的——”高松年喉间连作抚慰的声音——“今天星期三，星期六晚上我把牌要回来打它个通宵，看李梅亭又怎么样。赵先生，方先生，你们有没有胆量来？”高松年叹气说：“我本来是不说的。汪太太，你这么一来，我只能告诉各位了。我今天闯席做不速之客，就为了李梅亭的事，要来跟汪先生商量，不知道你们在请客。”客人都说：“校长来得好，请都请不来呢。”汪先生镇静地问：“李梅亭什么事？”汪太太满脸厌倦不爱听的表情。
　　校长道：“我一下办公室，他就来，问我下星期一纪念周找谁演讲，我说我还没有想到人呢。他说他愿意在”训导长报告“里，顺便谈谈抗战时期大学师生的正当娱乐——”汪太太“哼”了一声——“我说很好。他说假如他讲了之后，学生问他像王先生家的打牌赌钱算不算正当娱乐，他应当怎样回答——”大家恍然大司地说“哦”——“我当然替你们掩饰，说不会有这种事。他说：”同事们全知道了，只瞒你校长一个人“——”辛楣和鸿渐道：“胡说！我们就不知道。”——“他说他调查得很清楚，输赢很大，这副牌就是你的，常打的是什么几个人，也有你汪先生——”汪先生的脸开始发红，客人都局促地注视各自的碗筷。好几秒钟，屋子里静寂得应该听见蚂蚁在地下爬——可是当时没有蚂蚁。
　　校长不自然地笑，继续说：“还有笑话，汪太太，你听了准笑。他不知道什么地方听来的，说你们这副牌是美国货，橡皮做的，打起来没有声音——”哄堂大笑，解除适才的紧张。鸿渐问汪太太是不是真没有声音，汪太太笑他和李梅亭一样都是乡下人，还说：“李瞎子怎么变成聋子了，哪里有美国货的无声麻将！”高校长深不以这种轻薄为然，紧闭着嘴不笑，聊示反对。
　　汪先生道：“他想怎么办呢？向学生宣布？”汪太太道：“索性闹穿了，大家正大光明地打牌，免得鬼鬼祟祟，桌子上盖毯子，毯子上盖漆布——”范小姐聪明地注解：“这就是”无声麻将“了！”——“我待得腻了，让李梅亭去闹，学生撵你走，高校长停你职，离开这地方，真是求之不得。”校长一连声tut！tut！tut！
　　汪先生道：“他无非为了做不到中国文学系主任，跟我过不去。我倒真不想当这个差使，向校长辞了好几次，高先生，是不是？不过，我辞职是自动的，谁要逼我走，那可不行，我偏不走。李梅亭，他看错了人。他的所作所为，哼！我也知道，譬如在镇上嫖土娼。”汪先生富于戏剧性地收住，余人惊厅得叫起来，辛楣鸿渐立刻想到王美玉。高校长顿一顿说：“那不至于罢？”鸿渐见校长这样偏袒，按不下愤怒，说：“我想汪先生所讲的话很可能，李先生跟我们同路来，闹了许多笑话，不信只要问辛楣。”校长满脸透着不然道：“君子隐恶而扬善。这种男女间的私事，最好别管！”范小姐正要问辛楣什么笑话，吓得拿匙舀口鸡汤和着这问题咽了下去。高校长省悟自己的话要得罪汪处厚，忙补充说：“鸿渐兄，你不要误会。梅亭和我是老同事，他的为人，我当然知道。不过，汪先生犯不着和他计较。回头我有办法劝他。”汪太太宽宏大量地说：“总而言之，是我不好。处厚倒很想敷衍他，我看见他的脸就讨厌，从没请他上我们这儿来。我们不像韩学愈和他的洋太太，对历史系的先生和学生，三日一小宴，五日一大宴的款待；而且妙得很请学生吃饭，请同事只喝——”鸿渐想起那位一夜泻肚子四五次的历史系学生——“破费还是小事，我就没有那个精神，也不像那位洋太太能干。人家是洋派，什么交际、招待、联络，都有工夫，还会唱歌儿呢。咱们是中国乡下婆婆，就安了分罢，别出丑啦。我常说：有本领来当教授，没有本领就滚蛋，别教家里的丑婆娘做学生和同事的女招待——”鸿渐忍不住叫“痛快”！汪处厚明知太太并非说自己，可是通身发热——“高先生不用劝李梅亭，处厚也不必跟他拚，只要想个方法引诱他到王家也去打一次牌，这不就完了么？”“汪太太，你真——真聪明！”高校长钦佩地拍桌子，因为不能拍汪太太的头或户背，“这计策只有你想得出来！你怎么知道李梅亭爱打牌的？”汪太太那句话是说着玩儿的，给校长当了真，便神出鬼没地说：“我知道。”汪先生也摸着胡子，反复援引苏东坡的名言道：“”想当然耳“，”想当然耳“哦！”赵辛楣的眼像胶在汪太太的脸上。刘小姐冷落在一边，满肚子的气愤，恨汪太太，恨哥嫂，鄙视范小姐，懊悔自己今天的来，又上了当，忽见辛楣的表情，眼稍微瞥范小姐，心里冷笑一声舒服了好些。范小姐也注意到了，唤醒辛楣道：“赵先生，汪太太真利害呀！”辛楣脸一红，喃喃道：“真利害！”眼睛躲避着范小姐。鸿渐说：“这办法好得很。不过李梅亭最贪小利，只能让他赢；他输了还要闹的。”同桌全笑了。高松年想这年轻人多嘴，好不知趣，只说：“今天所讲的话，希望各位严守秘密。”吃完饭，主人请宽坐。女人涂脂抹粉的脸，经不起酒饭蒸出来的汗气，和咬嚼运动的震掀，不免像黄梅时节的墙壁。范小姐虽然斯文，精致得恨不能吃肉都吐渣，但多喝了半杯酒，脸上没涂胭脂的地方都作粉红色，仿佛外国肉庄里陈列的小牛肉。汪太太问女客人：“要不要到我房里去洗手？”两位小姐跟她去了。高松年汪处厚两人低声密谈。辛楣对鸿渐道：“等一会咱们同走，记牢。”鸿渐笑道：“也许我愿意一个人送刘小姐回去呢？”辛楣严肃地说：“无论如何，这一次让我陪着你送她——汪太太不是存心跟我们开玩笑么？”鸿渐道：“其实谁也不必送谁，咱们俩走咱们的路，她们走她们的路。”辛楣道：“这倒做不出。咱们是留学生，好像这一点社交礼节总应该知道。”两人慨叹不幸身为青年未婚留学生的麻烦。
　　刘小姐勉强再坐一会，说要回家。辛楣忙站起来说：“鸿渐，咱们也该走了，顺便送她们两位小姐回去。”刘小姐说她一个人回去，不必人送。辛楣连声说：“不，不，不！先送范小姐到女生宿舍，然后送你回家，我还没有到你府上去过呢。”鸿渐喑笑辛楣要撇开范小姐，所以跟刘小姐亲热，难保不引起另一种误会。汪太太在咬着范小姐耳朵说话，范小姐含笑带怒推开她。汪先生说：“好了，好了。”出门不管“，两位小姐的安全要你们负责了。”高校长说他还要坐一会，同时表示非常艳羡：因为天气这样好，正是散步的春宵，他们四个人又年轻，正是春宵散步的好伴侣。
　　四人并肩而行，范刘在中间，赵方各靠一边。走近板桥，范小姐说这桥只容两个人走，她愿意走河底。鸿渐和刘小姐走到桥心，忽听范小姐尖声叫：“啊呀！”忙借机止步，问怎么一回事。范小姐又笑了，辛楣含着谴责，劝她还是上桥走，河底石子滑得很。才知道范小姐险的摔一跤，亏辛楣扶住了。刘小姐早过桥，不耐烦地等着他们，鸿渐等范小姐也过了岸，殷勤问扭了筋没有。范小姐谢他，说没有扭筋——扭了一点儿——可是没有关系，就会好的——不过走路不能快，请刘小姐不必等。刘小姐鼻子里应一声，鸿渐说刘小姐和自己都愿意慢慢地走。走不上十几步，范小姐第二次叫：“啊呀！”手提袋不知何处去了。大家问她是不是摔跤的时候，失手掉在溪底。她说也许。辛楣道：“这时候不会给人捡去先回宿舍，拿了手电来照。”范小姐记起来了，手提袋忘在汪太太家里，自骂糊涂，要赶回去取，说：“怎么好意思叫你们等呢？你们先走罢，反正有赵先生陪我——赵先生，你要骂我了。”女人出门，照例忘掉东西，所以一次出门事实上等于两次。安娜说：“啊呀，糟糕！我忘掉带手帕！”这么一说，同走的玛丽也想起没有带口红，裘丽叶给两人提醒，说：“我更糊涂！没有带钱——”于是三人笑得仿佛这是天地间最幽默的事，手搀手回去取手帕、口红和钱。可是这遗忘东西的传染病并没有上刘小姐的身，急得赵辛楣心里直怨，“难道今天是命里注定的？”忽然鸿渐摸着头问：“辛楣，我今天戴帽子来没有？”辛楣愣了愣，恍有所司：“好像你戴了来的，我记不清了——是的，你戴帽子来的，我——我没有戴。”鸿渐说范小姐找手提袋，使他想到自己的帽子；范小姐既然走路不便，反正他要回汪家取帽子，替她把手提袋带来得了，“我快得很你们在这儿等我一等，”说着，三脚两步跑去。他回来，手里只有手提袋，头上并无帽子，说：“我是没有戴帽子，辛楣，上了你的当。”辛楣气愤道：“刘小姐，范小姐，你们瞧这个人真不讲理。自己糊涂，倒好像我应该替他管帽子的！”黑暗中感激地紧拉鸿渐的手。刘小姐的笑短得刺耳。范小姐对鸿渐的道谢冷淡得不应该，直到女宿舍，也再没有多话。
　　不管刘小姐的拒绝，鸿渐和辛楣送她到家。她当然请他们进去坐一下。跟她同睡的大侄女还坐在饭桌边，要等她回来才肯去睡，呵欠连连，两只小手握着拳头擦眼睛。这女孩子看见姑母带了客人来，跳进去一路嚷：“爸爸！妈妈！”把生下来才百日的兄弟吵醒了。刘东方忙出来招待，刘太太跟着也抱了小孩子出来。鸿渐和辛楣照例说这小孩子长得好，养得胖，讨论他像父亲还是像母亲。这些话在父母的耳朵里是听不厌的。鸿渐凑近他脸捺指作声，这是他唯一娱乐孩子的本领。刘太太道：“咱们跟方——呃——伯伯亲热，叫方伯伯抱——”她恨不能说“方姑夫”——“咱们刚换了尿布，不会出乱子。”鸿渐无可奈何，苦笑接过来。那小孩子正在吃自己的手，换了一个人抱，四肢乱动，手上的腻唾沫，抹了鸿渐一鼻子半脸，鸿渐蒙刘太太托孤，只好心里厌恶。辛楣因为摆脱了范小姐，分外高兴，瞧小孩子露出的一方大腿还干净，嘴凑上去吻了一吻，看得刘家老小四个人莫莫不欢笑，以为这赵先生真好。鸿渐气不过他这样做面子，问他要不要抱。刘太太看小孩子给鸿渐抱得不舒服，想辛楣地位高，又是生客，不能亵渎他，便伸手说：“咱们重得很方伯伯抱得累了。”鸿渐把孩交还，乘人不注意，掏手帕擦脸上已干的唾沫。辛楣道：“这孩子真好，他不怕生。”刘太太一连串地赞美这孩子如何懂事，如何乖，如何一觉睡到天亮。孩子的大姊姊因为没人理自己，圆睁眼睛，听得不耐烦，插口道：“他也哭，晚上把我都哭醒了。”刘小姐道：“不知道谁会哭！谁长得这么大了，抢东西吃，打不过二弟，就直着嗓子哭，羞不羞！”女孩子发急，指着刘小姐道：“姑姑是大人，姑姑也哭，我知道，那天——”父母喝住她，骂她这时候还不睡。刘小姐把她拉进去了，自信没给客人瞧见脸色。以后的谈话，只像用人工呼吸来圹淹死的人，挽回不来生气。刘小姐也没再露脸。辞别出门，辛楣道：“孩子们真可怕，他们嘴里全说得出。刘小姐表面上很平静快乐，谁想到她会哭，真是各有各的苦处，唉！”鸿渐道：“你跟范小姐是无所谓的。我承刘东方帮过忙，可是我无意在此地结婚。汪太太真是多此一举，将来为了这件事，刘东方准对我误会。”辛楣轻描淡写道：“那不至于。”接着就问鸿渐对汪太太的印象，要他帮自己推测她年龄有多少。
　　孙小姐和陆子潇通信这一件事，在鸿渐心里，仿佛在复壁里咬东西的老鼠，拢乱了一晚上，赶也赶不出去。他险的写住给孙小姐，以朋友的立场忠告她交友审慎。最后算把自己劝相信了，让她去跟陆子潇好，自己并没爱上她，吃什么隔壁醋，多管人家闲事？全是赵辛楣不好，开玩笑开得自己心里有了鬼，仿佛在催眠中的人受了暗示。这种事大半是旁人说笑话，说到当局者认真恋爱起来，自己见得多了，决不至于这样傻。虽然如此，总觉得吃了亏似的，恨孙小姐而且鄙视她。不料下午打门进来的就是她，鸿渐见了她面，心里的怨气像宿雾见了朝阳，消散净尽。她来过好几次，从未能使他像这次的欢喜。鸿渐说，桂林回来以后，还没见过面呢，问她怎样消遣这寒假的。她说，承鸿渐和辛楣送桂林带回的东西，早想过来谢，可是自己发了两次烧，今天是陪范小姐送书来的。鸿渐笑问是不是送剧本给辛楣，孙小姐笑答是。鸿渐道：“你上去见到赵叔叔没有？”孙小姐道：“我才不讨人厌呢！我根本没上楼。她要来看赵先生，问我他住的是楼上楼下，第几号房间，又不要我做向导。我跟她讲好，我决不陪她上楼，我也有事到这儿来。”“辛楣未必感谢你这位向导。”“那太难了！”孙小姐说话时的笑容，表示她并不以为做很难——“她昨天晚上回来，我才知道汪太太请客——”这句原是平常的话，可是她多了心自觉太着边际，忙扯开问：“这位有名的美人儿汪太太你总见过了？”“昨天的事是汪氏夫妇胡闹——见过两次了，风度还好，她是有名美人儿么？我今天第一次听到这句话。”鸿渐见了她面，不大自然，手不停弄着书桌上他自德国带回的Supernorma牌四色铅笔。孙小姐要过笔来，把红色铅捺出来，在吸墨水纸板的空白上，画一张红嘴，相去一寸许画十个尖而长的红点，五个一组，代表指甲，此外的面目身体全没有。她画完了，说：“这就是汪太太的——的提纲。”鸿渐想一想，忍不住笑道：“真有点像，亏你想得出！”一句话的意义，在听者心里，常像一只陌生的猫到屋里来，声息全无，过一会儿“喵”一叫，你才发觉它的存在。孙小姐最初说有事到教授宿舍来，鸿渐听了并未留意。这时候，这句话在他意识里如睡方醒。也许她是看陆子潇来的，带便到自己这儿坐下。心里一阵嫉妒，像火上烤的栗子，热极要迸破了壳。急欲探出究竟，又怕落了关切盘问的痕迹，扯淡说：“范小姐这人妙得很，我昨天还是第一次跟她接近。你们是同房，要好不要好？”“她眼睛里只有汪太太，现在当然又添了赵叔叔了——方先生，你昨天得罪范小姐没有？”“我没有呀，为什么？”“她回来骂你——唉，该死！我搬嘴了。”“怪事！她骂我什么呢？”孙小姐笑道：“没有什么。她说你话也不说，人也不理，只知道吃。”鸿渐脸红道：“胡说，这不对。我也说话的，不过没有多说。昨天我压根儿是去凑数，没有我的分儿，当然只管吃了。”孙小姐很快看他一眼，弄着铅笔说：“范小姐的话，本来不算数的。她还骂你是木头，说你头上戴不戴帽子都不知道。”鸿渐哈哈大笑道：“我是该骂！这事说来话长，我将来讲给你听。不过你们这位范小姐——”孙小姐抗议说范小姐不是她的——“好，好。你们这位同屋，我看不大行，专门背后骂人，辛楣真娶了她，老朋全要断的。她昨天也提起你。”“她不会有好话。她说什么？”鸿渐踌躇，录小姐说：“我一定要知道。方先生，你告诉我，”笑意全收，甜蜜地执拗。
　　鸿渐见过一次她这种神情，所有温柔的保护心全给她引起来了，说：“她没有多说。她并没骂你，我也记不清，好像说有人跟通信。那是很平常的事，她就喜欢大惊小怪。”孙小姐的怒容使鸿渐不敢看她，脸爆炸似的发红，又像一星火落在一盆汽油面上。她把铅笔在桌子上顿，说：“混帐！我正恨得要死呢，她还替人家在外面宣传！我非跟她算账不可。”鸿渐心里的结忽然解松了，忙说：“这是我不好了，你不要理她。让她去造谣言得了，反正没有人会相信，我就不相信。”“这事真讨厌，我想不出一个对付的办法。那个陆子潇——”孙小姐对这三个字厌恶得仿佛不肯让它们进嘴——“他去年近大考的时候忽然写信给我，我一个字没理他，他一封一封的信来。寒假里，他上女生宿舍来找我，硬要请我出去吃饭——”鸿渐紧张的问句：“你没有去罢？”使她不自主低了头——“我当然不会去。他这人真是神经病，还是来信，愈写愈不成话。先一封信说，省得我回信麻烦，附一张纸，纸头上写着一个问题——”她脸又红晕——“这个问题不用管它，他说假使我对这问题答案是——是肯定的，写个算学里的加号，把纸寄还他，否则写个减号。最近一封信，他索性把加减号都写好，我只要划掉一个就行。你瞧，不是又好气又好笑么？”说时，她眼睛里含笑，嘴撅着。
　　鸿渐妨不住笑道：“这地道是教授的情——教授写的信了。我们在初中考”常识“这门功课，先生出的题目全是这样的。不过他对你总是一片诚意。”孙小姐怫然瞪眼道：“谁要他对我诚意！他这种信写个不了，给从家知道，把我也显得可笑了。”鸿渐老谋深算似的说：“孙小姐，我替你出个主意。他前前后后给你的信，你没有掷掉罢？没有掷掉最好。你一股脑儿包起来，叫用人送还他。一个字儿不要写。”“包裹外面要不要写他姓名等等呢？”“也不要写，他拆开来当然心里明白——”心理分析学者一听这话知道潜意识在捣鬼，鸿渐把唐晓芙退回自己信的方法报复在旁人身上——“你干脆把信撕碎了再包——不，不要了，这太使他难堪。”孙小姐感激道：“我照方先生的话去做，不会错的。我真要谢谢你。我什么事都不懂，也没有一个人可以商量，只怕做错了事。我太不知道臬做人，做人麻烦死了！方先生，你肯教教我么？”这太像个无知可怜的弱小女孩儿了，辛楣说她装傻也许是真的。鸿渐的猜疑像燕子掠过水，没有停留。孙小姐不但向他求计，并且对他言听计从，这使他够满意了，心里容不下猜疑。又讲了几句话，孙小姐说，辛楣处她今天不去了，她要先回宿舍。教鸿渐别送。鸿渐原怕招摇，不想送，给她这么一说，只能说：“我要送送你，送你一半路，到校门口。”孙小姐站着，眼睛注视地坂道：“也好，不过，方先生不必客气罢，外面——呃——闲话很多，真讨厌！”鸿渐吓得跳道：“什么闲话！”问完就自悔多此一问。孙小姐讷讷道：“你——你没听见，就不用管了。再见，我照方先生教我的话去做，”拉拉手，一笑走了。鸿渐颓然倒在椅子里，身上又冷又热，像发疟疾。想糟糕！糟糕！这“闲话”不知道是什么内容。两个人在一起，人家就要造谣言，正如两根树枝相接近，蜘蛛就要挂网。今天又多嘴，说了许多不必说、不该说的话。这不是把“闲话”坐实么？也许是自己的错觉，孙小姐临走一句话说得好像很着重。她的终身大事，全该自己负责了，这怎么了得！鸿渐急得坐立不安，满屋子的转。假使不爱孙小姐，管什么闲事？是不是爱她——有一点点爱她呢？
　　楼梯上一阵女人笑声，一片片脆得像养花的玻璃房子塌了，把鸿渐的反省打断。紧跟着辛楣的声音：“走好，别又像昨天摔了一跤！”又是一阵女人的笑声，楼上楼下好几个房间忽然开门又轻轻关门的响息。鸿渐想，范小姐真做得出，这两阵笑就等于在校长布告板上向全校员生宣示她和赵辛楣是情人了。可怜的辛楣！不知道怎么生气呢。鸿渐虽然觉得辛楣可怜，同时心境宽舒，似乎关于自己的“闲话”因此减少了严重性。他正拿起一支烟，辛楣没打门就进屋，抢了过去。鸿渐问他：“没有送范小姐回去？”他不理会，点烟狂吸了几口，嚷：“Damn孙柔嘉这小浑蛋，她跟陆子潇有约会，为什么带了范懿来！我碰见她，要骂她个臭死。”鸿渐道：“你别瞎冤枉人。你记得么？你在船上不是说，借书是男女恋爱的初步么？现在怎么样？哈哈，天理昭彰。”辛楣忍不住笑道：“我船上说过这话么？反正她拿来的两本什么话剧，我一个字都不要看。”鸿渐问谁写的剧本。辛楣道：“你要看，你自己去取，两本书在我桌子上。请你顺便替我把窗子打开。我是怕冷的，今天还生着炭盆。她一进来，满屋子是她的脂粉香，我简直受不了。我想抽烟，她表示她怕闻烟味儿，我开了一路窗。她立刻打喷嚏，吓得我忙把窗关上。我正担心，她不要着了凉，我就没有清净了。”鸿渐笑道：“我也怕晕倒，我不去了。”便叫工友上去开窗子，把书带下来。工友为万无一失起见，把辛楣桌上六七本中西文书全搬下来了，居然没漏掉那两本话剧。翻开一本，扉面上写：“给懿——作者”，下面盖着图章。鸿渐道：“好亲热的称呼！”随手翻开第二本的扉页，大叫道：“辛楣，你看见这个没有？”辛楣道：“她不许我当时看，我现在也不要看，”说时，伸手拿过书，只见两行英文：
　　ToMypreciousdarling.
　　Fromtheauthor辛楣“咦”了一声，合上封面，看作者的名字，问鸿渐道：“你知道这个人么？”鸿渐道：“我没听说过，可能还是一位名作家呢。你是不是要找他决斗？”辛楣鼻子里出冷气，自言自语道：“可笑！可鄙！可恨！”鸿渐道：“你是跟我说话，还是在骂范懿？她也真怪，为什么把人家写了这许多话的书给你看？”辛楣的美国乡谈又流出来了：“Youbaby！你真不懂她的用意？”鸿渐道：“她用意太显然了，反教人疑心她不会这样浅薄。”辛楣道：“不管她。这都是汪太太生出来的事，”解铃还须系铃人，“我明天去找她。”鸿渐道：“请你也替我的事声明一下罢。”辛楣道：“你不同去么？”鸿渐道：“我不去了。我看你对汪太太有点儿迷，我劝你少去。咱们这批人，关在这山谷里，生活枯燥，没有正常的消遣，情感一触即发，要避免剌激它。”辛楣脸红道：“你别胡说。这是你自己的口供，也许你看中了什么人。”鸿渐也给他道中心病，支吾道：“你去，你去，这两本戏是不是交汪太太转给范小姐呢？”辛楣道：“那倒不行。今天就还她，不好意思。她明天不会来，总希望我去回看她，我当然不去。后天下午，我差校工直接送还她。”鸿渐想今天日子不好，这是第二个人退回东西了，一壁拿张纸包好了两本书，郑重交给辛楣：“我牺牲纸一张。这书上面有名手迹，教校工当心，别遗失了。”辛楣道：“名人！他们这些文人没有一个不自以为有名的，只怕一个的我各气太大，负担不起了，还化了好几个笔名来分。今天虽然没做什么事，苦可受够了，该自己慰劳一下。同出去吃晚饭，好不好！”鸿渐道：“今天轮到我跟学生同吃晚饭。不过，那没有关系，你先上馆子点好了菜，我敷衍了一碗，就赶来。”鸿渐自觉这一学期上课，驾轻就熟，渐渐得法。学生对他的印象也像好了些。训导处分发给他训导的四个学生，偶来聊天，给他许多启示。他发现自己毕业了没几年，可是一做了先生，就属于前一辈，跟现在这些学生不再能心同理同。第一，他没有他们的兴致。第二，他自信比他们知趣。他只是奇怪那些跟年轻人混的同事们，不感到老一辈的隔膜。是否他们感到了而不露出来？年龄是个自然历程里不能超越的事实，就像饮食男女，像死亡。有时，这种年辈意识比阶级意识更鲜明。随你政见、学说或趣味如何相同，年辈的老少总替你隐隐分了界限，仿佛磁器上的裂纹，平时一点没有什么，一旦受着震动，这条裂纹先扩大成裂缝。也许自己更老了十几年，会要跟青年人混在一起，借他们的生气来温暖自己的衰朽，就像物理系的吕老先生，凡有学生活动，无不参加，或者像汪处厚娶这样一位年轻的太太。无论如何，这些学生一方面盲目得可怜，一方面眼光准确得可怕。他们的赞美，未必尽然，有竟上人家的当；但是他们的毁骂，那简直至公至确，等于世界末日的“最后审判”，毫无上诉重审的余地。他们对李梅亭的厌恶不用说，甚至韩学愈也并非真正得到他们的爱戴。鸿渐身为先生，才知道古代中国人瞧不起蛮夷，近代西洋人瞧不起东方人，上司瞧不起下属——不，下属瞧不起上司，全没有学生要瞧不起先生时那样利害。他们的美德是公道，不是慈悲。他们不肯原谅，也许因为他们自己不需要人原谅，不知道也需要人原谅，鸿渐这样想。
　　第八章西洋赶驴子的人，每逢驴子不肯走，鞭子没有用，就把一串胡萝卜挂在驴子眼睛之前、唇吻之上。这笨驴子以为走前一步，萝卜就能到嘴，于是一步再一步继续向前，嘴愈要咬，脚愈会赶，不知不觉中又走了一站。那时候它是否吃得到这串萝卜，得看驴夫的高兴。一切机关里，上司驾驭下属，全用这种技巧；譬如高松年就允许鸿渐到下学期升他为教授。自从辛楣一走，鸿渐对于升级这胡萝卜，眼睛也看饱了，嘴忽然不馋了，想暑假以后另找出路。他只准备聘约送来的时候，原物退还，附一封信，痛痛快快批评校政一下，算是临别赠言，借此发泄这一年来的气愤。这封信的措词，他还没有详细决定，因为他不知道校长室送给他怎样的聘约。有时他希望聘约依然是副教授，回信可以理直气壮，责备高松年失信。有时他希望聘约升他做教授，这么一来，他的信可以更漂亮了，表示他的不满意并非出于私怨，完全为了公事。不料高松年省他起稿子写信的麻烦，干脆不送聘约给他。孙小姐倒有聘约的，薪水还升了一级。有人说这是高松年开的玩笑，存心拆开他们俩。高松年自己说，这是他的秉公办理，决不为未婚夫而使未婚妻牵累——“别说他们还没有结婚，就是结了婚生了小孩子，丈夫的思想有问题，也不能”罪及妻孥“，在二十世纪中华民国办高等教育，这一点民主作风应该具备。”鸿渐知道孙小姐收到聘书，忙仔细打听其他同事，才发现下学期聘约已经普遍发出，连韩学愈的洋太太都在敬聘之列，只有自己像伊索寓言里那只没尾巴的狐狸。这气得他头脑发烧，身体发冷。计划好的行动和说话，全用不着，闷在心里发酵。这比学生念熟了书，到时忽然考试延期，更不痛快。高松年见了面，总是笑容可掬，若无其事。办行政的人有他们的社交方式。自己人之间，什么臭架子、坏脾气都行；笑容愈亲密，礼貌愈周到，彼此的猜忌或怨恨愈深。高松年的工夫还没到家，他的笑容和客气仿佛劣手仿造的古董，破绽百出，一望而知是假的。鸿渐几次想质问他，一转念又忍住了。在吵架的时候，先开口的未必占上风，后闭口的才算胜利。高松年神色不动，准是成算在胸，自己冒失寻衅，万一下不来台，反给他笑，闹了出去，人家总说姓方的饭碗打破，老羞成怒。还他一个满不在乎，表示饭碗并不关心，这倒是挽回面子的妙法。吃不消的是那些同事的态度。他们仿佛全知道自己解聘，但因为这事并未公开，他们的同情也只好加上封套包裹，遮遮掩掩地奉送。往往平日很疏远的人，忽然拜访。他知道他们来意是探口气，便一字不提，可是他们精神和说话里包含的惋惜，总像圣诞老人放在袜子里的礼物，送了才肯走。这种同情比笑骂还难受，客人一转背，鸿渐咬牙来个中西合璧的咒骂：“ToHell滚你妈的蛋！”孙柔嘉在订婚以前，常来看鸿渐；订了婚，只有鸿渐去看她，她轻易不肯来。鸿渐最初以为她只是个女孩子，事事要请教自己；订婚以后，他渐渐发现她不但很有主见，而且主见很牢固。她听他说准备退还聘约，不以为然，说找事不容易，除非他另有打算，别逞一时的意气。鸿渐问道：“难道你喜欢留在这地方？你不是一来就说要回家么？”她说：“现在不同了。只要咱们两个人在一起，什么地方都好。”鸿渐看未婚妻又有道理，又有情感，自然欢喜，可是并不想照她的话做。他觉得虽然已经订婚，和她还是陌生得很。过去没有订婚经验——跟周家那一回事不算数的——不知道订婚以后的情绪，是否应当像现在这样平淡。他对自己解释，热烈的爱情到订婚早已是顶点，婚一结一切了结。现在订了婚，彼此间还留着情感发展的余地，这是桩好事。他想起在伦敦上道德哲学一课，那位山羊胡子的哲学家讲的话：“天下只有两种人。譬如一串葡萄到手，一种人挑最好的先吃，另一种人把最好的留在最后吃。照例第一种人应该乐观，因为他每吃一颗都是吃剩的葡萄里最好的；第二种应该悲观，因为他每吃一颗都是吃剩的葡萄里最坏的。不过事实上适得其反，缘故是第二种人还有希望，第一种人只有回忆。”从恋爱到白头偕老，好比一串葡萄，总有最好的一颗，最好的只有一颗，留着做希望，多么好？他嘴快把这些话告诉她，她不作声。他和她讲话，她回答的都是些“唔”，“哦”。他问她为什么不高兴，她说并未不高兴。他说：“你瞒不过我。”她说：“你知道就好了。我要回宿舍了。”鸿渐道：“不成，你非讲明白了不许走。”她说：“我偏要走。”鸿渐一路上哄她，求她，她才说：“你希望的好葡萄在后面呢，我们是坏葡萄，别倒了你的胃口。”他急得跳脚，说她胡闹。她说：“我早知道你不是真的爱我，否则你不会有那种离奇的思想。”他赔小心解释了半天，她脸色和下来，甜甜一笑道：“我是个死心眼儿，将来你讨厌——”鸿渐吻她，把这句话有效地截断，然后说：“你今天真是颗酸葡萄。”她强迫鸿渐说出来他过去的恋爱。他不肯讲，经不起她一再而三的逼，讲了一点。她嫌不够，鸿渐像被强盗拷打招供资产的财主，又陆续吐露些。她还嫌不详细，说：“你这人真不爽快！我会吃这种隔了年的陈醋么？我听着好玩儿。”鸿渐瞧她脸颊微红，嘴边强笑，自幸见机得早，隐匿了一大部分的情节。她要看苏文纨和唐晓芙的照相，好容易才相信鸿渐处真没有她们的相片，她说：“你那时候总记日记的，一定有趣等得很，带在身边没有？”鸿渐直嚷道：“岂有此理！我又不是范懿认识的那些作家、文人，为什么恋爱的时候要记日记？你不信，到我卧室里去搜。”孙小姐道：“声音放低一点，人家全听见了，有话好好的说。只有我哪！受得了你这样粗野，你倒请什么苏小姐呀、唐小姐呀来试试看。”鸿渐生气不响，她注视着他的脸，笑说：“跟我生气了？为什么眼晴望着别处？是我不好，逗你。道歉！道歉！”所以，订婚一个月，鸿渐仿佛有了个女主人，虽然自己没给她训练得驯服，而对她训练的技巧甚为佩服。他想起赵辛楣说这女孩子利害，一点不错。自己比她大了六岁，世事的经验多得多，已经是前一辈的人，只觉得她好玩儿，一切都纵容她，不跟她认真计较。到聘书的事发生，孙小姐慷慨地说：“我当然把我的聘书退还——不过你何妨直接问一问高松年，也许他无心漏掉你一张。你自己不好意思，托旁人转问一下也行。”鸿渐不听她的话，她后来知道聘书并非无心遗漏，也就不勉强他。鸿渐开玩笑说：“下半年我失了业，咱们结不成婚了。你嫁了我要挨饿的。”她说：“我本来也不要你养活。回家见了爸爸，请他替你想个办法。”他主张索性不要回家，到重庆找赵辛楣——辛楣进了国防委员会，来信颇为得意，比起出走时的狼狈，像换了一个人。不料她大反对，说辛楣和他不过是同样地位的人，求他荐事，太丢脸了；又说三闾大学的事，就是辛楣荐的，“替各系打杂，教授都没爬到，连副教授也保不住，辛楣荐的事好不好？”鸿渐局促道：“给你这么一说，我的地位更不堪了。请你说话留点体面，好不好？”孙小姐说，无论如何，她要回去看她父亲母亲一次，他也应该见见未来的丈人丈母。鸿渐说，就在此地结了婚罢，一来省事，二来旅行方便些。孙小姐沉吟说：“这次订婚已经没得到爸爸妈妈的同意，幸亏他们喜欢我，一点儿不为难。结婚总不能这样草率了，要让他们作主。你别害怕，爸爸不凶的，他会喜欢你。”鸿渐忽然想起一件事，说：“咱们这次订婚，是你父亲那封信促成的。我很想看看，你什么时候把它拣出来。”孙小姐愣愣的眼睛里发问。鸿渐轻轻拧她鼻子道：“怎么忘了？就是那封讲起匿名信的信。”孙小姐扭头抖开他的手道：“讨厌！鼻子都给你拧红了。那封信？那封信我当时看了，一生气，就把它撕了——唔，我倒真应该保存它，现在咱们不怕谣言了，”说完紧握着他的手。辛楣在重庆得到鸿渐订婚的消息，就寄航空快信道贺。鸿渐把这信给孙小姐看，她看到最后半行：“弟在船上之言验矣，呵呵。又及，”就问他在船上讲的什么话。鸿渐现在新订婚，朋友自然疏了一层，把辛楣批评的话一一告诉。她听得怒形于色，可是不发作，只说：“你们这些男人全不要脸，动不动就说女人看中你们，自己不照照镜子，真无耻！也许陆子潇逢人告诉我怎样看中他呢！我也算倒霉，辛楣一定还有讲我的坏话，你说出来。”鸿渐忙扯淡完事。她反对托辛楣谋事，这可能是理由。鸿渐说这次回去，不走原路了，干脆从桂林坐飞机到香港，省吃许多苦，托辛楣设法飞机票。孙小姐极赞成。辛楣回信道：他母亲七月底自天津去香港，他要迎接她到重庆，那时候他们凑巧可以在香港小叙。孙小姐看了信，皱眉道：“我不愿意看见他，他要开玩笑的。你不许他开玩笑。”鸿渐笑道：“第一次见面少不了要开玩笑的，以后就没有了。现在你还怕他什么？你升了一辈，他该叫你世嫂了。”鸿渐这次走，没有一个同事替他饯行。既然校长不高兴他，大家也懒跟他联络。他不像能够飞黄腾达的人——“孙柔嘉嫁给他，真是瞎了眼睛，有后悔的一天”——请他吃的饭未必像扔在尼罗河里的面包，过些日子会加了倍浮回原主。并且，请吃饭好比播种子：来的客人里有几个是吃了不还请的，例如最高上司和低级小职员；有几个一定还席的，例如地位和收入相等的同僚，这样，种一顿饭可以收获几顿饭。鸿渐地位不高，又不属于任何系，平时无人结交他，他也只跟辛楣要好，在同事里没撒播饭种子。不过，鸿渐饭虽没到嘴，谢饭倒谢了好几次。人家问了他的行期，就惋惜说：“怎么？走得那么匆促！饯行都来不及。糟糕！偏偏这几天又碰到大考，忙得没有工夫，孙小姐，劝他迟几天走，大家从从容容叙一叙——好，好，遵命，那么就欠礼了。你们回去办喜事，早点来个通知，别瞒人哪！两个人新婚快乐，把这儿的老朋友全忘了，那不行！哈哈。”高校长给省政府请到省城去开会，大考的时候才回校，始终没正式谈起聘书的事。鸿渐动身前一天，到校长室秘书处去请发旅行证件，免得路上军警麻烦，顺便见校长辞行，高松年还没到办公室呢。他下午再到秘书处领取证件，一问校长早已走了。一切机关的首长上办公室，本来像隆冬的太阳或者一生里的好运气，来得很迟，去得很早。可是高松年一向勤敏，鸿渐猜想他怕自己、躲避自己，气愤里又有点得意。他训导的几个学生，因为当天考试完了，晚上有工夫到他房里来话别。他感激地喜欢，才明白贪官下任，还要地方挽留，献万民伞、立德政碑的心理。离开一个地方就等于死一次，自知免不了一死，总希望人家表示愿意自己活下去。去后的毁誉，正跟死后的哀荣一样关心而无法知道，深怕一走或一死，像洋蜡烛一灭，留下的只是臭味。有人送别，仿佛临死的人有孝子顺孙送终，死也安心闭眼。这些学生来了又去，暂时的热闹更增加他的孤寂，辗转半夜睡不着。虽然厌恶这地方，临走时偏有以后不能再来的怅恋，人心就是这样捉摸不定的。去年来的时候，多少同伴，现在只两个人回去，幸而有柔嘉，否则自己失了业，一个人走这条长路，真没有那勇气。想到此地，鸿渐心理像冬夜缩成一团的身体稍觉温暖，只恨她不在身畔。天没亮，轿夫和挑夫都来了；已是夏天，趁早凉，好赶路。服侍鸿渐的校工，穿件汗衫，睡眼XX送到大门外看他们上轿，一手紧握着鸿渐的赏钱，准备轿子走了再数。范小姐近视的眼睛因睡眠不足而愈加迷离，以为会碰见送行的男同事，脸上胡乱涂些胭脂，勾了孙小姐的手，从女生宿舍送她过来。孙小姐也依依惜别，舍不下她。范小姐看她上轿子，祝她们俩一路平安，说一定把人家寄给孙小姐的信转到上海，“不过，这地址怎么写法？要开方先生府上的地址了，”说时格格地笑。孙小姐也说一定有信给她。鸿渐暗笑女人真是天生的政治家，她们俩背后彼此诽谤，面子上这样多情，两个政敌在香槟酒会上碰杯的一套工夫，怕也不过如此。假使不是亲耳朵听见她们的互相刻薄，自己也以为她们真是好朋友了。轿夫到镇上打完早尖，抬轿正要上路，高松年的亲随赶来，满额是汗，把大信封一个交给鸿渐，说奉校长命送来的。鸿渐以为是聘书，心跳得要冲出胸膛，忙拆信封，里面只是一张信笺，一个红纸袋。信上说，这一月来校务纷繁，没机会与鸿渐细谈，前天刚自省城回来，百端待理，鸿渐又行色匆匆，未能饯别，抱歉之至；本校暂行缓办哲学系，留他在此，实属有屈，所以写信给某某两个有名学术机关，推荐他去做事，一有消息，决打电报到上海；礼券一张，是结婚的贺仪，尚乞哂纳。鸿渐没看完，就气得要下轿子跳骂，忍耐到轿夫走了十里路休息，把一个纸团交给孙小姐，说：“高松年的信，你看！谁希罕他送礼。到了衡阳，我挂号退还去。好得很！我正要写信骂他，只恨没有因头，他这封来信给我一个回信痛骂的好机会。”孙小姐道：“我看他这封信也是一片好意。你何必空做冤家？骂了他于你有什么好处？也许他真把你介绍给人了呢？”鸿渐怒道：“你总是一片大道理，就不许人称心傻干一下。你愈有道理，我偏不讲道理。”孙小姐道：“天气热得很，我已经口渴了，你别跟我吵架。到衡阳还有四天呢，到那时候你还要写信骂高松年，我决不阻止你。”鸿渐深知到那时候自己保不住给她感化得回信道谢，所以愈加悻悻然，不替她倒水，只把行军热水瓶搡给她，一壁说：“他这个礼也送得岂有此理。咱们还没挑定结婚的日子，他为什么信上说我跟你”嘉礼完成“，他有用意的，我告诉你。因为你我同路走，他想——”孙小姐道：“别说了！你这人最多心，多的全是邪心！”说时把高松年的信仍团作球形，扔在田岸旁的水潭里。她刚喝了热水，脸上的红到上轿还没褪。为了飞机票，他们在桂林一住十几天，快乐得不像人在过日子，倒像日子溜过了他们两个人。两件大行李都交给辛楣介绍的运输公司，据说一个多月可运到上海。身边旅费充足，多住几天，满不在乎。上飞机前一天还是好晴天，当夜忽然下雨，早晨雨停了，有点阴雾。两人第一次坐飞机，很不舒服，吐得像害病的猫。到香港降落，辛楣在机场迎接，鸿渐俩的精力都吐完了，表示不出久别重逢的欢喜。辛楣瞧他们脸色灰白，说：“吐了么？没有关系的。第一次坐飞机总要纳点税。我陪你们去找旅馆好好休息一下，晚上我替你们接风。”到了旅馆，鸿渐和柔嘉急于休息。辛楣看他们只定一间房，偷偷别着脸对墙壁伸伸舌头，上山回亲戚家里的路上，一个人微笑，然后皱眉叹口气。鸿渐睡了一会，精力恢复，换好衣服，等辛楣来。孙小姐给邻室的打牌声，街上的木屐声吵得没睡熟，还觉得恶心要吐，靠在沙发里，说今天不想出去了。鸿渐发急，劝她勉强振作一下，别辜负辛楣的盛意。她教鸿渐一个人去，还说：“你们两个人有话说，我又插不进嘴，在旁边做傻子。他没有请旁的女客，今天多我一个人，少我一个人，全无关系。告诉你罢，他请客的馆子准阔得很，我衣服都没有，去了丢脸。”鸿渐道：“我不知道你那么虚荣！那件花绸的旗袍还可以穿。”孙小姐笑道：“我还没花你的钱做衣服，已经挨你骂虚荣了，将来好好的要你替我付裁缝账呢！那件旗袍太老式了，我到旅馆来的时候，一路上看见街上女人的旗袍，袖口跟下襟又短了许多。我白皮鞋也没有，这时候去买一双，我又怕动，胃里还不舒服得很。”辛楣来了，知道孙小姐有病，忙说吃饭改期。她不许，硬要他们两人出去吃。辛楣释然道：“方——呃——孙小姐，你真好！将来一定是大贤大德的好太太，换了旁的女人，要把鸿渐看守得牢牢的，决不让他行动自由。鸿渐，你暂时舍得下她么？老实说，别背后怨我老赵把你们俩分开。”鸿渐恳求地望着孙小姐道：“你真的不需要我陪你？”孙小姐瞧他的神情，强笑道：“你尽管去，我又不生什么大病——赵先生，我真抱歉——”辛楣道：“哪里的话！今天我是虚邀，等你身体恢复了，过天好好的请你。那么，我带他走了。一个半钟头以后，我把他送回来，原物奉还，决无损失，哈哈！鸿渐，走！不对，你们也许还有个情人分别的简单仪式，我先在电梯边等你——”鸿渐拉他走，说“别胡闹”。辛楣在美国大学政治系当学生的时候，旁听过一门“外交心理学”的功课。那位先生做过好几任公使馆参赞，课堂上说：美国人办交涉请吃饭，一坐下去，菜还没上，就开门见山谈正经；欧洲人吃饭时只谈不相干的废话，到吃完饭喝咖啡，才言归正传。他问辛楣，中国人怎样，辛楣傻笑回答不来。辛楣也有正经话跟鸿渐讲，可是今天的饭是两个好朋友的欢聚，假使把正经话留在席上讲，杀尽了风景。他出了旅馆，说：“你有大半年没吃西菜了，我请你吃奥国馆子。路不算远，时间还早，咱们慢慢走去，可以多谈几句。”鸿渐只说出：“其实你何必破费，”正待说：“你气色比那时候更好了，是要做官的！”辛楣咳声干嗽，目不斜视，说：“你们为什么不结了婚再旅行？”　鸿渐忽然想起一路住旅馆都是用“方先生与夫人”名义的，今天下了飞机，头晕脑胀，没理会到这一点，只私幸辛楣在走路，不会看见自己发烧的脸，忙说：“我也这样要求过，她死不肯，一定要回上海结婚，说她父亲——”“那么，你太weak，”辛楣自以为这个英文字嵌得非常妙，不愧外交词令：假使鸿渐跟孙小姐并无关系，这个字就说他拿不定主意，结婚与否，全听她摆布；假使他们俩不出自己所料，butthefleshisweak①，这个字不用说是含蓄浑成，最好没有了。①（注：太不够坚强。给肉欲摆布了——下一句是成语。）
　　鸿渐像已判罪的犯人，无从抵赖，索性死了心让脸稳定地去红罢，嗫嚅道：“我也在后悔。不过，反正总要回家的。礼节手续麻烦得很，交给家里去办罢。”“孙小姐是不是呕吐，吃不下东西？”鸿渐听他说话转换方向，又放了心，说：“是呀！今天飞机震荡得利害。不过，我这时候倒全好了。也许她累了，今天起得太早，昨天晚上我们两人的东西都是她理的。辛楣，你记得么？那一次在汪家吃饭，范懿造她谣言，说她不会收拾东西——”“飞机震荡应该过了。去年我们同路走，汽车那样颠簸，她从没吐过。也许有旁的原因罢？我听说要吐的——”跟着一句又轻又快的话——“当然我并没有经验，”毫无幽默地强笑一声。鸿渐没料到辛楣又回到那个问题，仿佛躲空袭的人以为飞机去远了，不料已经转到头上，轰隆隆投弹，吓得忘了羞愤，只说：“那不会！那不会！”同时心里害怕，知道那很会。
　　辛楣咀嚼着烟斗柄道：“鸿渐，我和你是好朋友，我虽然不是孙小姐法律上的保护人，总算受了她父亲的委托——我劝你们两位赶快用最简单的手续结婚，不必到上海举行仪式。反正你们的船票要一个星期以后才买得到，索性多住四五天，就算度蜜月，乘更下一条船回去。旁的不说，回家结婚，免不了许多亲戚朋友来吃喜酒，这笔开稍就不小。孙家的景况，我知道的，你老太爷手里也未必宽裕，可省为什么不省？何必要他们主办你们的婚事？”除掉经济的理由以外，他还历举其他利害，证明结婚愈快愈妙。鸿渐给他说得服服帖帖，仿佛一重难关打破了，说：“回头我把这个意思对柔嘉说。费你心打听一下，这儿有没有注册结婚，手续繁不繁。”辛楣自觉使命完成，非常高兴。吃饭时，他要了一瓶酒，说：“记得那一次你给我灌醉的事么？哈哈！今天灌醉了你，对不住孙小姐的。”他问了许多学校里的事，叹口气道：“好比做了一场梦——她怎么样？”鸿渐道：“谁？汪太太？听说她病好了，我没到汪家去过。”辛楣道：“她也真可怜——”瞧见鸿渐脸上酝酿着笑容，忙说——“我觉得谁都可怜，汪处厚也可怜，我也可怜，孙小姐可怜，你也可怜。”鸿渐大笑道：“汪氏夫妇可怜，这道理我明白。他们的婚姻不会到头的，除非汪处厚快死，准闹离婚。你有什么可怜？家里有钱，本身做事很得意，不结婚是你自己不好，别说范懿，就是汪太太——”辛楣喝了酒，脸红已到极点，听了这话，并不更红，只眼睛躲闪似的眨了一眨——“好，我不说下去。我失了业，当然可怜；孙小姐可怜，是不是因为她错配了我？”辛楣道：“不是不是。你不懂。”鸿渐道：“你何妨说。”辛楣道：“我不说。”鸿渐道：“我想你新近有了女朋友了。”辛楣道：“这是什么意思？”鸿渐道：“因为你说话全是小妞儿撒娇的作风，准是受了什么人的熏陶。”辛楣道：“混帐！那么，我就说啦，啊？我不是跟你讲过，孙小姐这人很深心么？你们这一次，照我第三者看起来，她煞费苦心——”鸿渐意识底一个朦胧睡熟的思想像给辛楣这句话惊醒——“不对，不对，我喝醉了，信口胡说，鸿渐，你不许告诉你太太。我真糊涂，忘了现在的你不比从前的你了，以后老朋友说话也得分个界限，”说时，把手里的刀在距桌寸许的空气里划一划。鸿渐道：“给你说得结婚那么可怕，真是众叛亲离了。”辛楣笑道：“不是众叛亲离，是你们自己离亲叛众。这些话不再谈了。我问你，你暑假以后有什么计划？”鸿渐告诉他准备找事。辛楣说，国际局势很糟，欧洲免不了一打，日本是轴心国，早晚要牵进去的，上海天津香港全不稳，所以他把母亲接到重庆去，“不过你这一次怕要在上海待些时候了。你愿意不愿意到我从前那个报馆去做几个月的事？有个资料室主任要到内地去，我介绍你顶他的缺，酬报虽然不好，你可以兼个差。”鸿渐真心感谢。辛楣问他身边钱够不够。鸿渐说结婚总要花点钱，不知道够不够。辛楣说，他肯借。鸿渐道：“借了要还的。”辛楣道：“后天我交一笔款子给你，算是我送的贺仪，你非受不可。”鸿渐正热烈抗议，辛楣截住他道：“我劝你别推。假使我也结了婚，那时候，要借钱给朋友都没有自由了。”鸿渐感动得眼睛一阵潮润，心里鄙夷自己，想要感激辛楣的地方不知多少，倒是为了这几个钱下眼泪，知道辛楣不愿意受谢，便说：“听你言外之意，你也要结婚了，别瞒我。”辛楣不理会，叫西崽把他的西装上衣取来，掏出皮夹，开矿似的发掘了半天，郑重拣出一张小相片，上面一个两目炯炯的女孩子，表情非常严肃。鸿渐看了嚷道：“太好了！太好了！是什么人？”辛楣取过相片，端详着，笑道：“你别称赞得太热心，我听了要吃醋的，咱们从前有过误会。看朋友情人的照相，客气就够了，用不到热心。”鸿渐道：“岂有此理！她是什么人？”辛楣道：“她父亲是先父的一位四川朋友，这次我去，最初就住在他家里。”鸿渐道：“照你这样，上代是朋友，下代结成亲眷，交情一辈子没有完的时候。好，咱们将来的儿女——”孙小姐的病征冒上心来，自觉说错了话——“唔——我看她年轻得很，是不是在念书？”辛楣道：“好好的文科不念，要学时髦，去念什么电机工程，念得叫苦连天。放了暑假，报告单来了，倒有两门功课不及格，不能升班，这孩子又要面子，不肯转系转学。这么一来，不念书了，愿意跟我结婚了。哈哈，真是个傻孩子。我倒要谢谢那两位给她不及格的先生。我不会再教书了，你假如教书，对女学生的分数批得紧一点，这可以促成无数好事，造福无量。”鸿渐笑说，怪不得他要接老太太进去。辛楣又把相片看一看，放进皮夹，看手表，嚷道：“不得了，过了时候，孙小姐要生气了！”手忙脚乱算了账，一壁说：“快走！要不要我送你回去，当面点交？”他们进饭馆，薄暮未昏，还是试探性的夜色，出来的时候，早已妥妥帖帖地是夜了。可是这是亚热带好天气的夏夜，夜得坦白浅显，没有深沉不可测的城府，就仿佛让导演莎士比亚《仲夏夜之梦》的人有一个背景的榜样。辛楣看看天道：“好天气！不知道重庆今天晚上有没有空袭，母亲要吓得不敢去了。我回去开无线电，听听消息。”鸿渐吃得很饱，不会讲广东话，怕跟洋车夫纠缠，一个人慢慢地踱回旅馆。辛楣这一席谈，引起他许多思绪。一个人应该得意，得意的人谈话都有精彩，譬如辛楣。自己这一年来，牢骚满腹，一触即发；因为一向不爱听人家发牢骚，料想人家也未必爱听自己的牢骚，留心管制，像狗戴了嘴罩，谈话都不痛快。照辛楣讲，这战事只会扩大拖长，又新添了家累，假使柔嘉的病真给辛楣猜着了——鸿渐愧怕得遍身微汗，念头想到别处——辛楣很喜欢那个女孩子，这一望而知的，但是好像并非热烈的爱，否则，他讲她的语气，不会那样幽默。他对她也许不过像自己对柔嘉，可见结婚无需太伟大的爱情，彼此不讨厌已经够结婚资本了。是不是都因为男女年龄的距离相去太远？但是去年对唐晓芙呢？可能就为了唐晓芙，情感都消耗完了，不会再摆布自己了。那种情感，追想起来也可怕，把人扰乱得做事吃饭睡觉都没有心思，一刻都不饶人，简直就是神经病，真要不得！不过，生这种病有它的快乐，有时宁可再生一次病。鸿渐叹口气，想一年来，心境老了许多，要心灵壮健的人才会生这种病，譬如大胖子才会脑充血和中风，贫血营养不足的瘦子是不配的。假如再大十几岁，到了回光返照的年龄，也许又会爱得如傻如狂了，老头子恋爱听说像老房子着了火，烧起来没有救的。像现在平平淡淡，情感在心上不成为负担，这也是顶好的，至少是顶舒服的。快快行了结婚手续完事。辛楣说柔嘉“煞费苦心”，也承她瞧得起这自己，应当更怜惜她。鸿渐才理会，撇下她孤单单一个人太长久了，赶快跑回旅馆。经过水果店，买了些鲜荔枝和龙眼。鸿渐推开房门，里面电灯灭了，只有走廊里的灯射进来一条光。他带上门，听柔嘉不作声，以为她睡熟了，放轻脚步，想把水果搁在桌子上，没留神到当时自己坐的一张椅子，孤零零地离桌几尺，并未搬回原处。一脚撞翻了椅子，撞痛了脚背和膝盖，嘴里骂：“浑蛋，谁坐了椅子没搬好！”同时想糟糕，把她吵醒了。柔嘉自从鸿渐去后，不舒服加上寂寞，一肚子的怨气，等等他不来，这怨气放印子钱似的本上生利，只等他回来了算账。她听见鸿渐开门，赌气不肯先开口。鸿渐撞翻椅子，她险的笑出声，但一笑气就泄了，幸亏忍住并不难。她刹那间还打不定主意：一个是说自己眼巴巴等他到这时候，另一个是说自己好容易睡着又给他闹醒——两者之中，哪一个更理直气壮呢？鸿渐翻了椅子，不见动静，胆小起来，想柔嘉不要晕过去了，忙开电灯。柔嘉在黑暗里睡了一个多钟点，骤见灯光，张不开眼，抬一抬眼皮又闭上了，侧身背着灯，呼口长气。鸿渐放了心，才发现丝衬衫给汗湿透了，一壁脱外衣，关切地说：“对不住，把你闹醒了。睡得好不好？身体觉得怎么样？”“我朦胧要睡，就给你乒乒乓乓吓醒了。这椅子是你自己坐的，还要骂人！”她这几句话是面着壁说的，鸿渐正在挂衣服，没听清楚，回头问：“什么？”她翻身向外道：“唉！我累得很，要我提高了嗓子跟你讲话，实在没有那股劲，你省省我的气力罢——”可是事实上她把声音提高了一个音键——“这张椅子，是你搬在那儿的。辛楣一来，就像阎王派来的勾魂使者，你什么都不管了。这时候自己冒失，倒怪人呢。”鸿渐听语气不对，抱歉道：“是我不好，我腿上的皮都擦破了一点——”这“苦肉计”并未产生效力——“我出去好半天了，你真的没有睡熟？吃过东西没有？这鲜荔枝——”“你也知道出去了好半天么？反正好朋友在一起，吃喝玩乐，整夜不回来也由得你，我一个人死在旅馆里都没人来理会，”她说时嗓子哽咽起来，又回脸向里睡了。鸿渐急得坐在床边，伸手要把她头回过来，说：“我出去得太久了，请你原谅，哙，别生气。我也是你教我出去，才出去的——”柔嘉掀开他手道：“我现在教你不要把汗手碰我，听不听我的话？吓，我叫你出去！你心上不是要出去么？我留得住你？留住你也没有意思，你留在旅馆里准跟我找岔子生气。”鸿渐放手，气鼓鼓坐在那张椅子里道：“现在还不是一样的吵嘴！你要我留在旅馆里陪你，为什么那时候不老实说，我又不是你肚子里的蛔虫，知道你存什么心思！”柔嘉回过脸来，幽远地说：“你真是爱我，不用我说，就会知道。唉！这是勉强不来的。要等我说了，你才体贴到，那就算了！一个陌生人跟我一路同来，看见我今天身体不舒服，也不肯撇下我一个人好半天。哼，你还算是爱我的人呢！”鸿渐冷笑道：“一个陌生人肯对你这样，早已不陌生了，至少也是你的情人。”“你别捉我的错字，也许她是个女人呢？我宁可跟女人在一起的，你们男人全不是好人，只要哄得我们让你们称了心，就不在乎了。”这几句话触起鸿渐的心事，他走近床畔，说：“好了，别吵了。以后打我撵我，我也不出去，寸步不离的跟着你，这样总好了。”
　　柔嘉脸上微透笑影，说：“别说得那样可怜。你的好朋友已经说我把你钩住了，我再不让你跟他出去，我的名气更不知怎样坏呢。告诉你罢，这是第一次，我还对你发脾气，以后我知趣不开口了，随你出去了半夜三更不回来。免得讨你们的厌。”“你对辛楣的偏见太深。他倒一片好意，很关心咱们俩的事。你现在气平了没有？我有几句正经话跟你讲，肯听不肯听？”“你说罢，听不听由我——是什么正经话，要把脸板得那个样子？”她忍不住笑了。“你会不会有了孩子，所以身体这样不舒服？”　“什么？胡说！”她脆快地回答——“假如真有了孩子，我不饶你！我不饶你！我不要孩子。”“饶我不饶我是另外一件事，咱们不得不有个准备，所以辛楣劝我和你快结婚——”柔嘉霍的坐起，睁大眼睛，脸全青了：“你把咱们的事告诉了赵辛楣？你不是人！你不是人！你一定向他吹——”说时手使劲拍着床。鸿渐吓得倒退几步道：“柔嘉，你别误会，你听我解释——”“我不要听你解释。你欺负我，我从此没有脸见人，你欺负我！”说时又倒下去，两手按眼，胸脯一耸一耸的哭。鸿渐的心不是雨衣的材料做的，给她的眼泪浸透了，忙坐在她头边，拉开她手，替她拭泪，带哄带劝。她哭得累了，才收泪让他把这件事说明白。她听完了，哑声说：“咱们的事，不要他来管，他又不是我的保护人。只有你不争气把他的话当圣旨，你要听他的话，你一个人去结婚得了，别勉强我。”鸿渐道：“这些话不必谈了，我不听他的话，一切随你作主——我买给你吃的荔枝，你还没有吃呢，要吃么？好，你睡着不要动，我剥给你吃——”说时把茶几跟字纸篓移近床前——“我今天出去回来都没坐车，这东西是我省下来的车钱买的。当然我有钱买水果，可是省下钱来买，好像那才算得真正是我给你的。”柔嘉泪渍的脸温柔一笑道：“那几个钱何必去省它，自己走累了犯不着。省下来几个车钱也不够买这许多东西。”鸿渐道：“这东西讨价也并不算贵，我还了价，居然买成了。”柔嘉道：“你这人从来不会买东西。买了贵东西还自以为便宜——你自己吃呢，不要尽给我吃。”鸿渐道：“因为我不能干，所以娶你这一位贤内助呀！”柔嘉眼瞟他道：“内助没有朋友好。”鸿渐道：“啊哟，你又来了！朋友只好绝交。你既然不肯结婚，连内助也没有，真是”赔了夫人又折朋“。”柔嘉道：“别胡说。时候不早了，我下午没睡着，晚上又等你——我眼睛哭肿了没有？明天见不得人了！给我面镜子。”鸿渐瞧她眼皮果然肿了，不肯老实告诉，只说：“只肿了一点点，全没有关系，好好睡一觉肿就消了——咦，何必起来照镜子呢！”柔嘉道：“我总要洗脸漱口的。”鸿渐洗澡回室，柔嘉已经躺下。鸿渐问：“你睡的是不是刚才的枕头？上面都是你的眼泪，潮湿得很，枕了不舒服。你睡我的枕头，你的湿枕头让我睡。”柔嘉感激道：“傻孩子，枕头不用换的。我早把它翻过来，换一面睡了——你腿上擦破皮的地方这时候痛不痛？我起来替你包好它。”鸿渐洗澡时，腿浸在肥皂水里，现在伤处星星作痛，可是他说：“早好了，一点儿不痛。你放心快睡罢。”柔嘉说：“鸿渐，我给你说得很担心，结婚的事随你去办罢。”鸿渐冲洗过头发，正在梳理，听见这话，放下梳子，弯身吻她额道：“我知道你是最讲理、最听话的。”柔嘉快乐地叹口气，转脸向里，沉沉睡熟了。以后这一星期，两人忙得失魂落魄，这件事做到一半，又想起那件事该做。承辛楣的亲戚设法帮忙，注册结婚没发生问题。此外写信通知家里要钱，打结婚戒指，做一身新衣服，进行注册手续，到照相馆借现成的礼服照相，请客，搬到较好的旅馆，临了还要寄相片到家里，催款子。虽然很省事，两人身边的钱全花完了，亏得辛楣送的厚礼。鸿渐因为下半年职业尚无着落，暑假里又没有进款，最初不肯用钱，衣服就主张不做新的，做新的也不必太好。柔嘉说她不是虚荣浪费的女人，可是终身大典，一生只一次，该像个样子，已经简陋得无可简陋了，做了质料好的衣服明年也可以穿的。两人忙碌坏了脾气，不免争执。柔嘉发怒道：“我本来不肯在这儿结婚，这是你的主意，你要我那天打扮得像叫花子么？这儿举目无亲，一切事都要自己去办，商量的人都没有，别说帮忙！我麻烦死了！家里人手多，钱也总有办法。爸爸妈妈为我的事，准备一笔款子。你也可以写信问你父亲要钱。假如咱们在上海结婚，你家里就一个钱不花么？咱们那次订婚已经替家里省了不少事了。”鸿渐是留学生，知道西洋流行的三P运动①；做儿子的平时呐喊着“独立自主”，到花钱的时候，逼老头子掏腰包。他听从她的话，写信给方「辶豚」翁。柔嘉看了信稿子，嫌措词不够明白恳挚，要他重写，还说：“怎么你们父子间这样客气，一点不亲热的？我跟我爸爸写信从不起稿子！”他像初次发表作品的文人给人批评了一顿，气得要投笔焚稿，不肯再写。柔嘉说：“你不写就不写，我不希罕你家的钱，我会写信给我爸爸。”她写完信，问他要不要审查，他拿过来看，果然语气亲热，纸上的“爸爸”“妈妈”写得如闻其声。结果他也把信发了，没给柔嘉看。后来她知道是虚惊，埋怨鸿渐说，都是他偏听辛楣的话，这样草草结婚，反而惹家里的疑心。可是家信早发出去，一切都预备好，不能临时取消。结婚以后的几天，天天盼望家里回信，远不及在桂林时的无忧无虑。方家孙家陆续电汇了钱来，回上海的船票辛楣替他们定好。赵老太太也到了香港，不日飞重庆。开船前两天，鸿渐夫妇上山去看辛楣，一来拜见赵老太太，二来送行，三来辞行，四来还船票等等的账。①（PoorPopPays注：可怜的爸爸为孩子们付账。）他们到了辛楣所住的亲戚家里，送进名片，辛楣跑出来，看门的跟在后面。辛楣满口的“嫂夫人劳步，不敢当”。柔嘉微笑抗议说：“赵叔叔别那样称呼，我当不起。”辛楣道：“没有这个道理——鸿渐，你来得不巧。苏文纨在里面。她这两天在香港，知道我母亲来了，今天刚来看她。你也许不愿意看见苏文纨，所以我赶出来向你打招呼。不过，她知道你在外面。”鸿渐涨红脸，望着柔嘉说：“那么咱们不进去罢，就托辛楣替咱们向老伯母说一声。辛楣，买船票的钱还给你。”辛楣正推辞，柔嘉说：“既然来了，总要见见老伯母的——”她今天穿了新衣服来的，胆气大壮，并且有点好奇。鸿渐虽然怕见苏文纨，也触动了好奇心。辛楣领他们进去。进客堂以前，鸿渐把草帽挂在架子上的时候，柔嘉打开手提袋，照了照镜子。苏文纨比去年更时髦了，脸也丰腴得多。旗袍搀合西式，紧俏伶俐，袍上的花纹是淡红浅绿横条子间着白条子，花得像欧洲大陆上小国的国旗。手边茶几上搁一顶阔边大草帽，当然是她的，衬得柔嘉手里的小阳伞落伍了一个时代。鸿渐一进门，老远就深深鞠躬。赵老太太站起来招呼，文纨安坐着轻快地说：“方先生，好久不见，你好啊？”辛楣说：“这位是方太太。”文纨早看见柔嘉，这时候仿佛听了辛楣的话才发现她似的，对她点头时，眼光从头到脚瞥过。柔嘉经不起她这样看一遍，局促不安。文纨问辛楣道：“这位方太太是不是还是那家什么银行？钱庄？唉！我记性真坏——经理的小姐？”鸿渐夫妇全听清了，脸同时发红，可是不便驳答，因为文纨问的声音低得似乎不准备给他们听见。辛楣一时候不明白，只说：“这是我一位同事的小姐，上礼拜在香港结婚的。”文纨如梦方觉，自惊自叹道：“原来又是一位——方太太，你一向在香港的，还是这一次从外国回来经过香港？”鸿渐紧握椅子的靠手，防自己跳起来。辛楣暗暗摇头。柔嘉只能承认，并非从外国进口，而是从内地出口。文纨对她的兴趣顿时消灭，跟赵老太太继续谈她们的话。赵老太太说她有生以来，第一次坐飞机，预想着就害怕。文纨笑道：“伯母，你有辛楣陪你，怕些什么！我一个人飞来飞去就五六次了。”赵老太太说：“怎么你们先生就放心你一个人来来去去么？”文纨道：“他在这儿有公事分不开身呀！他陪我飞到重庆去过两次，第一次是刚结了婚去见家父——他本来今天要同我一起来拜见伯母的，带便看看辛楣——”辛楣道：“不敢当。我还是你们结婚这一天见过曹先生的。他现在没有更胖罢？他好像比我矮一个头，容易见得胖。在香港没有关系，要是在重庆，管理物资粮食的公务员发了胖，人家就开他玩笑了。”鸿渐今天来了第一次要笑，文纨脸色微红，赵老太太没等她开口，就说：“辛楣，你这孩子，三十多岁的人了，还爱胡说。这个年头儿，发胖不好么？我就嫌你太瘦。文纨小姐，做母亲的人总觉得儿子不够胖的。你气色好得很，看着你，我眼睛都舒服。你家老太太看见你准心里喜欢。你回去替我们问候曹先生，他公事忙，千万不要劳步。”文纨道：“他偶尔半天不到办公室，也没有关系。不过今天他向办公室也请了假，昨天喝醉了。”赵老太太婆婆妈妈地说：“酒这个东西伤身得很，你以后劝他少喝。”文纨眼锋掠过辛楣脸上，回答说：“他不会喝的，不像辛楣那样洪量，威斯忌一喝就是一瓶——”辛楣听了上一句，向鸿渐偷偷做个鬼脸，要对下一句抗议都来不及——“他是给人家灌醉的。昨天我们大学同班在此地做事的人开聚餐会，帖子上写明”携眷“；他算是我的”眷“，我带了他去，人家把他灌醉了。”鸿渐忍不住问：“咱们一班有多少人在香港？”文纨道：“哟！方先生，我忘了你也是我们同班，他们没发帖子给你罢？昨天只有我一个人是文科的，其余都是理工法商的同学。”辛楣道：“你瞧，你多神气！现在只有学理工法商的人走运，学文科的人穷得都没有脸见人，不敢认同学了。亏得有你，撑撑文科的场面。”文纨道：“我就不信老同学会那么势利——你不是法科么？要讲走运，你也走运，”说时胜利地笑。辛楣道：“我比你们的曹先生，就差得太远了。开同学会都是些吃饱了饭没事干的人跟阔同学拉手去的。看见不得意的同学，问一声”你在什么地方做事“，不等回答，就伸长耳朵收听阔同学的谈话了。做学生的时候，开联欢会还有点男女社交的作用，我在美国，人家就把留学生的夏令会，说是”三头会议“：出风头，充冤大头，还有——呃——情人做花头——”大家都笑了，赵老太太笑得带呛，不许辛楣胡说。文纨笑得比人家短促，说：“你自己也参加夏令会的，你别赖，我看见过那张照相，你是三头里什么头？”辛楣回答不出。文纨拍手道：“好！你说不出来了。伯母，我看辛楣近来没有从前老实，心眼也小了许多，恐怕他这一年来结交的朋友有关系——”柔嘉注视鸿渐，鸿渐又紧握着椅子的靠手——“伯母，我明天不送你上飞机了，下个月在重庆见面。那一包小东西，我回头派用人送来；假如伯母不方便带，让他原物带转得了。”她站起来，提了大草帽的缨，仿佛希腊的打猎女神提着盾牌，叮嘱赵老太太不要送，对辛楣说：“我要罚你，罚你替我拿那两个纸盒子，送我到门口。”辛楣瞧鸿渐夫妇站着，防她无礼不理他们，说：“方先生也在招呼你呢，”文纨才对鸿渐点点头，伸手让柔嘉拉一拉，姿态就仿佛伸指头到热水里去试试烫不烫，脸上的神情仿佛跟比柔嘉高出一个头的人拉手，眼光超越柔嘉头上。然后她亲热地说：“伯母再见，”对辛楣似喜似嗔望一眼，辛楣忙抱了那个盒子跟她出去。鸿渐夫妇跟赵老太太敷衍，等辛楣进来了，起身告辞。赵老太太留他们多坐一会，一壁埋怨辛楣道：“你这孩子又发傻劲，何苦去损她的先生？”鸿渐暗想，苏文纨也许得意，以为辛楣未能忘情、发醋劲呢。辛楣道：“你放心，她决不生气，只要咱们替她带私货就行了。”辛楣要送他们到车站，出了门，说：“苏文纨今天太岂有此理，对你们无礼得很。”鸿渐故作豁达道：“没有什么。人家是阔小姐阔太太，这点点神气应该有的——”他没留心柔嘉看他一眼——“你说”带私货“，是怎么一回事？”辛楣道：“她每次飞到重庆，总带些新出的化装品、药品、高跟鞋、自来水笔之类去送人，也许是卖钱，我不清楚。”鸿渐惊异得要叫起来，才知道高高荡荡这片青天，不是上帝和天堂的所在了，只供给投炸弹、走单帮的方便，一壁说：“怪事！我真想不到！她还要做生意么？我以为只有李梅亭这种人带私货！她不是女诗人么？白话诗还做不做？”辛楣笑道：“不知道。她真会经纪呢！她刚才就劝我母亲快买外汇，我看女人全工于心计的。”柔嘉沉着脸，只当没听见。鸿渐道：“我胡说一句，她好像跟你很——唔——很亲密。”辛楣脸红道：“她知道我也在重庆，每次来总找我。她现在对我只有比她结婚以前对我好。”鸿渐鼻子里出冷气，想说：“怪不得你要有张护身照片，”可是没有说。辛楣顿一顿，眼望远处，说：“方才我送她出门，她说她那儿还保存我许多信——那些信我全忘了，上面不知道胡写些什么——她说她下个月到重庆来，要把信带还我。可是，她又不肯把信全数还给我，她说信上有一部分的话，她现在还可以接受。她要当我的面，一封一封的检，挑她现在不能接受的信还给我。你说可笑不可笑？”说完，不自然地笑。柔嘉冷静地问：“她不知道赵叔叔要订婚了罢？”辛楣道：“我没告诉她，我对她泛泛得很。”送鸿渐夫妇上了下山的缆车，辛楣回家路上，忽然明白了，叹气：“只有女人会看透女人。”鸿渐闷闷上车。他知道自己从前对不住苏文纨，今天应当受她的怠慢，可气的是连累柔嘉也遭了欺负。当时为什么不讽刺苏文纨几句，倒低头忍气尽她放肆？事后追想，真不甘心。不过，受她冷落还在其次，只是这今昔之比使人伤心。两年前，不，一年前跟她完全是平等的。现在呢，她高高在上，跟自己的地位简直是云泥之别。就像辛楣罢，承他瞧得起，把自己当朋友，可是他也一步一步高上去，自己要仰攀他，不比从前那样分庭抗礼了。鸿渐郁勃得心情像关在黑屋里的野兽，把墙壁狠命的撞、抓、打，但找不着出路。柔嘉见他不开口，忍住也不讲话。回到旅馆，茶房开了房门，鸿渐脱外衣、开电扇，张臂当风说：“回来了，唉！”“身体是回来了，灵魂早给情人带走了，”柔嘉毫无表情地加上两句按语。鸿渐当然说她“胡说”。她冷笑道：“我才不胡说呢。上了缆车，就像木头人似的，一句话也不说，全忘了旁边还有个我。我知趣得很，决不打搅你，看你什么时候跟我说话。”“现在我不是跟你说话了？我对今天的事一点不气——”“你怎么会气？你只有称心。”“那也未必，我有什么称心？”“看见你从前的情人糟蹋你现在的老婆，而且当着你那位好朋友的面，还不称心么！”柔嘉放弃了嘲讽的口吻，坦白地愤恨说——“我早告诉你，我不喜欢跟赵辛楣来往。可是我说的话有什么用？你要去，我敢说”不“么？去了就给人家瞧不起，给人家笑——”“你这人真蛮不讲理。不是你自己要进去么？事后倒推在我身上？并且人家并没有糟蹋你，临走还跟你拉手——”柔嘉怒极而笑道：“我太荣幸了！承贵夫人的玉手碰了我一碰，我这只贱手就一辈子的香，从此不敢洗了！”没有糟蹋我！“哼，人家打到我头上来，你也会好像没看见的，反正老婆是该受野女人欺负的。我看见自己的丈夫给人家笑骂，倒实在受不住，觉得我的脸都剥光了。她说辛楣的朋友不好，不是指的你么？”“让她去骂。我要回敬她几句，她才受不了呢。”“你为什么不回敬她？”“何必跟她计较？我只觉得她可笑。”“好宽宏大量！你的好脾气、大度量，为什么不留点在家里，给我享受享受？见了外面人，低头陪笑；回家对我，一句话不投机，就翻脸吵架。人家看方鸿渐又客气，又有耐心，不知道我受你多少气。只有我哪，换了那位贵小姐，你对她发发脾气看——”她顿一顿，说：“当然娶了那种称心如意的好太太，脾气也不至于发了。”她的话一部分是真的，加上许多调味的作料。鸿渐没法回驳，气「口牛」「口牛」望着窗外。柔嘉瞧他说不出话，以为最后一句话刺中他的隐情，嫉妒得坐立不安，管制了自己声音里的激动，冷笑着自言自语道：“我看破了，全是吹牛，全——是——吹——牛。”鸿渐回身问：“谁吹牛？”“你呀。你说她从前如何爱你，要嫁给你，今天她明明和赵辛楣好，正眼都没瞧你一下。是你追求她没追到罢！男人全这样吹的。”鸿渐对这种“古史辩”式的疑古论，提不出反证，只能反复说：“就算我吹牛，你看破好了，就算我吹牛。”柔嘉道：“人家多少好！又美，父亲又阔，又有钱，又是女留学生，假如我是你，她不看中我，我还要跪着求呢，何况她居然垂青——”鸿渐眼睛都红了，粗暴地截断她话：“是的！是的！人家的确不要我。不过，也居然有你这样的女人千方百计要嫁我。”柔嘉圆睁两眼，下唇咬得起一条血痕，颤声说：“我瞎了眼睛！我瞎了眼睛！”此后四五个钟点里，柔嘉并未变成瞎子，而两人同变成哑子，吃饭做事，谁都不理谁。鸿渐自知说话太重，心里懊悔，但一时上不愿屈服。下午他忽然想起明天要到船公司凭收据去领船票，这张收据是前天辛楣交给自己的，忘掉搁在什么地方了，又不肯问柔嘉。忙翻箱子，掏口袋，找不见那张收条，急得一身身的汗像长江里前浪没过、后浪又滚上来。柔嘉瞧他搔汗湿的头发，摸涨红的耳朵，便问：“找什么？是不是船公司的收据？”鸿渐惊骇地看她，希望顿生，和颜悦色道：“你怎么猜到的？你看见没有？”柔嘉道：“你放在那件白西装的口袋里的——”鸿渐顿脚道：“该死该死！那套西装我昨天交给茶房送到干洗作去的，怎么办呢？我快赶出去。”柔嘉打开手提袋，道：“衣服拿出去洗，自己也不先理一理，随手交给茶房！亏得我替你检了出来，还有一张烂钞票呢。”鸿渐感激不尽道：“谢谢你，谢谢你——”柔嘉道：“好容易千方百计嫁到你这样一位丈夫，还敢不小心伺候么？”说时，眼圈微红。鸿渐打拱作揖，自认不是，要拉她出去吃冰。柔嘉道：“我又不是小孩子，你别把吃东西来哄我。”千方百计“那四个字，我到死都忘不了的。”鸿渐把手按她嘴，不许她叹气。结果，柔嘉陪他出去吃冰。柔嘉吸着橘子水，问苏文纨从前是不是那样打扮。鸿渐说：“三十岁的奶奶了，衣服愈来愈花，谁都要笑的，我看她远不如你可爱。”柔嘉摇头微笑，表示不能相信而很愿意相信她丈夫的话。鸿渐道：“你听辛楣说她现在变得多么俗，从前的风雅不知哪里去了，想不到一年工夫会变得惟利是图，全不像个大家闺秀。”柔嘉道：“也许她并没有变，她父亲知道是什么贪官，女儿当然有遗传的。一向她的本性潜伏在里面，现在她嫁了人，心理发展完全，就本相毕现了。俗没有关系，我觉得她太贱。自己有了丈夫，还要跟辛楣勾搭，什么大家闺秀！我猜是小老婆的女儿罢。像我这样一个又丑又穷的老婆，虽然讨你的厌，可是安安分分，不会出你的丑的；你娶了那一位小姐，保不住只替赵辛楣养个外室了。”鸿渐明知她说话太刻毒，只能唯唯附和。这样作践着苏文纨，他们俩言归于好。这次吵架像夏天的暴风雨，吵的时候很利害，过得很快。可是从此以后，两人全存了心，管制自己，避免说话冲突。船上第一夜，两人在甲板上乘凉。鸿渐道：“去年咱们第一次同船到内地去，想不到今年同船回来，已经是夫妇了。”柔嘉拉他手代替回答。鸿渐道：“那一次我跟辛楣在甲板上讲的话，你听了多少？说老实话。”柔嘉撒手道：“谁有心思来听你们的话！你们男人在一起讲的话全不中听的。后来忽然听见我的名字，我害怕得直想逃走——”鸿渐笑道：“你为什么不逃呢？”柔嘉道：“名字是我的，我当然有权利听下去。”鸿渐道：“我们那天没讲你的坏话罢？”柔嘉瞥他一眼道：“所以我上了你的当。我以为你是好人，谁知道你是最坏的坏人。”鸿渐拉她手代替回答。柔嘉问今天是八月几号，鸿渐说二号。柔嘉叹息道：“再过五天，就是一周年了！”鸿渐问什么一周年，柔嘉失望道：“你怎么忘了！咱们不是去年八月七号的早晨赵辛楣请客认识的么？”鸿渐惭愧得比忘了国庆日和国耻日都利害，忙说：“我记得。你那天穿的什么衣服我都记得。”柔嘉心慰道：“我那天穿一件蓝花白底子的衣服，是不是？我倒不记得你那天是什么样子，没有留下印象，不过那个日子当然记得的。这是不是所谓”缘分“，两个陌生人偶然见面，慢慢地要好？”鸿渐发议论道：“譬如咱们这次同船的许多人，没有一个认识的。不知道他们的来头，为什么不先不后也乘这条船，以为这次和他们聚在一起是出于偶然。假使咱们熟悉了他们的情形和目的，就知道他们乘这只船并非偶然，和咱们一样有非乘不可的理由。这好像开无线电。你把针在面上转一圈，听见东一个电台半句京戏，西一个电台半句报告，忽然又是半句外国歌啦，半句昆曲啦，鸡零狗碎，凑在一起，莫名其妙。可是每一个破碎的片段，在它本电台广播的节目里，有上文下文并非胡闹。你只要认定一个电台听下去，就了解它的意义。我们彼此往来也如此，相知不深的陌生人——”柔嘉打个面积一寸见方的大呵欠。像一切人，鸿渐恨旁人听自己说话的时候打呵欠，一年来在课堂上变相催眠的经验更增加了他的恨，他立刻闭嘴。柔嘉道歉道：“我累了，你讲下去呢。”鸿渐道：“累了快去睡，我不讲了。”柔嘉怨道：“好好的讲咱们两个人的事，为什么要扯到全船的人，整个人类？”鸿渐恨恨道：“跟你们女人讲话只有讲你们自己，此外什么都不懂！你先去睡罢，我还要坐一会呢。”柔嘉佯佯不睬地走了。鸿渐抽了一支烟，气平下来，开始自觉可笑。那一段议论真像在台上的演讲；教书不到一年，这习惯倒养成了，以后要留心矫正自己，怪不得陆子潇做了许多年的教授，求婚也像考试学生了。不过，柔嘉也太任性。她常怪自己对别人有讲有说，回来对她倒没有话讲，今天跟她长篇大章的谈论，她又打呵欠，自己家信里还赞美她如何柔顺呢！鸿渐这两天近乡情怯，心事重重。他觉得回家并不像理想那样的简单。远别虽非等于暂死，至少变得陌生。回家只像半生的东西回锅，要煮一会才会熟。这次带了柔嘉回去，更要费好多时候来和家里适应。他想得心烦，怕去睡觉——睡眠这东西脾气怪得很，不要它，它偏会来，请它，哄它，千方百计勾引它，它拿身分躲得影子都不见。与其热枕头上翻来覆去，还是甲板上坐坐罢。柔嘉等丈夫来讲和，等好半天他不来，也收拾起怨气睡了。";
    }
}